{-# LANGUAGE DeriveDataTypeable, ScopedTypeVariables #-}
module Curry.DebugModule.XML where
import qualified Prelude
import qualified Curry.Debugger.DebugMonad as DM
import qualified Curry.Debugger.DebugInfo as DI
import qualified Curry.Debugger.PartCalls as PC
import qualified Data.Generics
import qualified Curry.DebugModule.Char
import qualified Curry.DebugModule.List
import qualified Curry.DebugModule.Prelude
import qualified Curry.DebugModule.Read
 
instance DI.GenTerm XmlExp where
        genTerm (XText x1)
          = DI.Term "XText" (DI.SrcID "XML" 0) [DI.genTerm x1]
        genTerm (XElem x1 x2 x3)
          = DI.Term "XElem" (DI.SrcID "XML" 0)
              [DI.genTerm x1, DI.genTerm x2, DI.genTerm x3]
        genTerm x1 = DM.genericTerm (DI.SrcID "XML" 0) x1
 
instance DI.GenTerm Encoding where
        genTerm (StandardEnc) = DI.Term "StandardEnc" (DI.SrcID "XML" 0) []
        genTerm (Iso88591Enc) = DI.Term "Iso88591Enc" (DI.SrcID "XML" 0) []
        genTerm x1 = DM.genericTerm (DI.SrcID "XML" 0) x1
 
instance DI.GenTerm XmlDocParams where
        genTerm (Enc x1) = DI.Term "Enc" (DI.SrcID "XML" 0) [DI.genTerm x1]
        genTerm (DtdUrl x1)
          = DI.Term "DtdUrl" (DI.SrcID "XML" 0) [DI.genTerm x1]
        genTerm x1 = DM.genericTerm (DI.SrcID "XML" 0) x1
 
data XmlExp = XmlExpFail
            | XmlExpOr DM.OrRef [XmlExp]
            | XmlExpUnderscore
            | XText (Curry.DebugModule.Prelude.List
                       Curry.DebugModule.Prelude.Char)
            | XElem (Curry.DebugModule.Prelude.List
                       Curry.DebugModule.Prelude.Char)
                    (Curry.DebugModule.Prelude.List
                       (Curry.DebugModule.Prelude.Tuple2
                          (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char)
                          (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char)))
                    (Curry.DebugModule.Prelude.List XmlExp)
            deriving (Data.Generics.Typeable, Data.Generics.Data)
 
data Encoding = EncodingFail
              | EncodingOr DM.OrRef [Encoding]
              | EncodingUnderscore
              | StandardEnc
              | Iso88591Enc
              deriving (Data.Generics.Typeable, Data.Generics.Data)
 
data XmlDocParams = XmlDocParamsFail
                  | XmlDocParamsOr DM.OrRef [XmlDocParams]
                  | XmlDocParamsUnderscore
                  | Enc Encoding
                  | DtdUrl (Curry.DebugModule.Prelude.List
                              Curry.DebugModule.Prelude.Char)
                  deriving (Data.Generics.Typeable, Data.Generics.Data)
 
strict_encoding2Attribute ::
                          (DM.DM dm) =>
                            Encoding ->
                              dm (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char)
strict_encoding2Attribute x1
  = DM.eval
      (DM.funcDeclHook "encoding2Attribute"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_121"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_121 x2)))
term_strict_encoding2Attribute x1
  = DI.Term "encoding2Attribute" (DI.SrcID "XML" 0) x1
 
strict_encoding2EncFunc ::
                        (DM.DM dm) =>
                          Encoding ->
                            dm
                              (DM.Func dm
                                 (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char)
                                 (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char))
strict_encoding2EncFunc x1
  = DM.eval
      (DM.funcDeclHook "encoding2EncFunc"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_120"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_120 x2)))
term_strict_encoding2EncFunc x1
  = DI.Term "encoding2EncFunc" (DI.SrcID "XML" 0) x1
 
strict_standardEncoding ::
                        (DM.DM dm) =>
                          Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char ->
                            dm (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char)
strict_standardEncoding x1
  = DM.eval
      (DM.funcDeclHook "standardEncoding"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_119"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_119 x2)))
term_strict_standardEncoding x1
  = DI.Term "standardEncoding" (DI.SrcID "XML" 0) x1
 
strict_iso88591Encoding ::
                        (DM.DM dm) =>
                          Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char ->
                            dm (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char)
strict_iso88591Encoding x1
  = DM.eval
      (DM.funcDeclHook "iso88591Encoding"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_110"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_110 x2)))
term_strict_iso88591Encoding x1
  = DI.Term "iso88591Encoding" (DI.SrcID "XML" 0) x1
 
strict_iso88591list ::
                    (DM.DM dm) =>
                      dm (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Int)
strict_iso88591list
  = DM.eval
      (DM.funcDeclHook "iso88591list"
         (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
         (do x110 <- DM.litHook
                       (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                       (Prelude.return
                          (Curry.DebugModule.Prelude.Pos
                             (Curry.DebugModule.Prelude.O
                                (Curry.DebugModule.Prelude.O
                                   (Curry.DebugModule.Prelude.O
                                      (Curry.DebugModule.Prelude.O
                                         (Curry.DebugModule.Prelude.O
                                            (Curry.DebugModule.Prelude.O
                                               (Curry.DebugModule.Prelude.I
                                                  Curry.DebugModule.Prelude.IHi)))))))))
             x111 <- do x108 <- DM.litHook
                                  (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                  (Prelude.return
                                     (Curry.DebugModule.Prelude.Pos
                                        (Curry.DebugModule.Prelude.I
                                           (Curry.DebugModule.Prelude.O
                                              (Curry.DebugModule.Prelude.O
                                                 (Curry.DebugModule.Prelude.O
                                                    (Curry.DebugModule.Prelude.O
                                                       (Curry.DebugModule.Prelude.O
                                                          (Curry.DebugModule.Prelude.I
                                                             Curry.DebugModule.Prelude.IHi)))))))))
                        x109 <- do x106 <- DM.litHook
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] []))
                                             (Prelude.return
                                                (Curry.DebugModule.Prelude.Pos
                                                   (Curry.DebugModule.Prelude.O
                                                      (Curry.DebugModule.Prelude.I
                                                         (Curry.DebugModule.Prelude.O
                                                            (Curry.DebugModule.Prelude.O
                                                               (Curry.DebugModule.Prelude.O
                                                                  (Curry.DebugModule.Prelude.O
                                                                     (Curry.DebugModule.Prelude.I
                                                                        Curry.DebugModule.Prelude.IHi)))))))))
                                   x107 <- do x104 <- DM.litHook
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo [] []))
                                                        (Prelude.return
                                                           (Curry.DebugModule.Prelude.Pos
                                                              (Curry.DebugModule.Prelude.I
                                                                 (Curry.DebugModule.Prelude.I
                                                                    (Curry.DebugModule.Prelude.O
                                                                       (Curry.DebugModule.Prelude.O
                                                                          (Curry.DebugModule.Prelude.O
                                                                             (Curry.DebugModule.Prelude.O
                                                                                (Curry.DebugModule.Prelude.I
                                                                                   Curry.DebugModule.Prelude.IHi)))))))))
                                              x105 <- do x102 <- DM.litHook
                                                                   (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                      (DI.DynamicInfo [] []))
                                                                   (Prelude.return
                                                                      (Curry.DebugModule.Prelude.Pos
                                                                         (Curry.DebugModule.Prelude.O
                                                                            (Curry.DebugModule.Prelude.O
                                                                               (Curry.DebugModule.Prelude.I
                                                                                  (Curry.DebugModule.Prelude.O
                                                                                     (Curry.DebugModule.Prelude.O
                                                                                        (Curry.DebugModule.Prelude.O
                                                                                           (Curry.DebugModule.Prelude.I
                                                                                              Curry.DebugModule.Prelude.IHi)))))))))
                                                         x103 <- do x100 <- DM.litHook
                                                                              (DI.DebugInfo
                                                                                 (DI.SrcID "XML" 0)
                                                                                 (DI.DynamicInfo []
                                                                                    []))
                                                                              (Prelude.return
                                                                                 (Curry.DebugModule.Prelude.Pos
                                                                                    (Curry.DebugModule.Prelude.I
                                                                                       (Curry.DebugModule.Prelude.O
                                                                                          (Curry.DebugModule.Prelude.I
                                                                                             (Curry.DebugModule.Prelude.O
                                                                                                (Curry.DebugModule.Prelude.O
                                                                                                   (Curry.DebugModule.Prelude.O
                                                                                                      (Curry.DebugModule.Prelude.I
                                                                                                         Curry.DebugModule.Prelude.IHi)))))))))
                                                                    x101 <- do x98 <- DM.litHook
                                                                                        (DI.DebugInfo
                                                                                           (DI.SrcID
                                                                                              "XML"
                                                                                              0)
                                                                                           (DI.DynamicInfo
                                                                                              []
                                                                                              []))
                                                                                        (Prelude.return
                                                                                           (Curry.DebugModule.Prelude.Pos
                                                                                              (Curry.DebugModule.Prelude.O
                                                                                                 (Curry.DebugModule.Prelude.I
                                                                                                    (Curry.DebugModule.Prelude.I
                                                                                                       (Curry.DebugModule.Prelude.O
                                                                                                          (Curry.DebugModule.Prelude.O
                                                                                                             (Curry.DebugModule.Prelude.O
                                                                                                                (Curry.DebugModule.Prelude.I
                                                                                                                   Curry.DebugModule.Prelude.IHi)))))))))
                                                                               x99 <- do x96 <- DM.litHook
                                                                                                  (DI.DebugInfo
                                                                                                     (DI.SrcID
                                                                                                        "XML"
                                                                                                        0)
                                                                                                     (DI.DynamicInfo
                                                                                                        []
                                                                                                        []))
                                                                                                  (Prelude.return
                                                                                                     (Curry.DebugModule.Prelude.Pos
                                                                                                        (Curry.DebugModule.Prelude.I
                                                                                                           (Curry.DebugModule.Prelude.I
                                                                                                              (Curry.DebugModule.Prelude.I
                                                                                                                 (Curry.DebugModule.Prelude.O
                                                                                                                    (Curry.DebugModule.Prelude.O
                                                                                                                       (Curry.DebugModule.Prelude.O
                                                                                                                          (Curry.DebugModule.Prelude.I
                                                                                                                             Curry.DebugModule.Prelude.IHi)))))))))
                                                                                         x97 <- do x94 <- DM.litHook
                                                                                                            (DI.DebugInfo
                                                                                                               (DI.SrcID
                                                                                                                  "XML"
                                                                                                                  0)
                                                                                                               (DI.DynamicInfo
                                                                                                                  []
                                                                                                                  []))
                                                                                                            (Prelude.return
                                                                                                               (Curry.DebugModule.Prelude.Pos
                                                                                                                  (Curry.DebugModule.Prelude.O
                                                                                                                     (Curry.DebugModule.Prelude.O
                                                                                                                        (Curry.DebugModule.Prelude.O
                                                                                                                           (Curry.DebugModule.Prelude.I
                                                                                                                              (Curry.DebugModule.Prelude.O
                                                                                                                                 (Curry.DebugModule.Prelude.O
                                                                                                                                    (Curry.DebugModule.Prelude.I
                                                                                                                                       Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                   x95 <- do x92 <- DM.litHook
                                                                                                                      (DI.DebugInfo
                                                                                                                         (DI.SrcID
                                                                                                                            "XML"
                                                                                                                            0)
                                                                                                                         (DI.DynamicInfo
                                                                                                                            []
                                                                                                                            []))
                                                                                                                      (Prelude.return
                                                                                                                         (Curry.DebugModule.Prelude.Pos
                                                                                                                            (Curry.DebugModule.Prelude.I
                                                                                                                               (Curry.DebugModule.Prelude.O
                                                                                                                                  (Curry.DebugModule.Prelude.O
                                                                                                                                     (Curry.DebugModule.Prelude.I
                                                                                                                                        (Curry.DebugModule.Prelude.O
                                                                                                                                           (Curry.DebugModule.Prelude.O
                                                                                                                                              (Curry.DebugModule.Prelude.I
                                                                                                                                                 Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                             x93 <- do x90 <- DM.litHook
                                                                                                                                (DI.DebugInfo
                                                                                                                                   (DI.SrcID
                                                                                                                                      "XML"
                                                                                                                                      0)
                                                                                                                                   (DI.DynamicInfo
                                                                                                                                      []
                                                                                                                                      []))
                                                                                                                                (Prelude.return
                                                                                                                                   (Curry.DebugModule.Prelude.Pos
                                                                                                                                      (Curry.DebugModule.Prelude.O
                                                                                                                                         (Curry.DebugModule.Prelude.I
                                                                                                                                            (Curry.DebugModule.Prelude.O
                                                                                                                                               (Curry.DebugModule.Prelude.I
                                                                                                                                                  (Curry.DebugModule.Prelude.O
                                                                                                                                                     (Curry.DebugModule.Prelude.O
                                                                                                                                                        (Curry.DebugModule.Prelude.I
                                                                                                                                                           Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                       x91 <- do x88 <- DM.litHook
                                                                                                                                          (DI.DebugInfo
                                                                                                                                             (DI.SrcID
                                                                                                                                                "XML"
                                                                                                                                                0)
                                                                                                                                             (DI.DynamicInfo
                                                                                                                                                []
                                                                                                                                                []))
                                                                                                                                          (Prelude.return
                                                                                                                                             (Curry.DebugModule.Prelude.Pos
                                                                                                                                                (Curry.DebugModule.Prelude.I
                                                                                                                                                   (Curry.DebugModule.Prelude.I
                                                                                                                                                      (Curry.DebugModule.Prelude.O
                                                                                                                                                         (Curry.DebugModule.Prelude.I
                                                                                                                                                            (Curry.DebugModule.Prelude.O
                                                                                                                                                               (Curry.DebugModule.Prelude.O
                                                                                                                                                                  (Curry.DebugModule.Prelude.I
                                                                                                                                                                     Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                 x89 <- do x86 <- DM.litHook
                                                                                                                                                    (DI.DebugInfo
                                                                                                                                                       (DI.SrcID
                                                                                                                                                          "XML"
                                                                                                                                                          0)
                                                                                                                                                       (DI.DynamicInfo
                                                                                                                                                          []
                                                                                                                                                          []))
                                                                                                                                                    (Prelude.return
                                                                                                                                                       (Curry.DebugModule.Prelude.Pos
                                                                                                                                                          (Curry.DebugModule.Prelude.O
                                                                                                                                                             (Curry.DebugModule.Prelude.O
                                                                                                                                                                (Curry.DebugModule.Prelude.I
                                                                                                                                                                   (Curry.DebugModule.Prelude.I
                                                                                                                                                                      (Curry.DebugModule.Prelude.O
                                                                                                                                                                         (Curry.DebugModule.Prelude.O
                                                                                                                                                                            (Curry.DebugModule.Prelude.I
                                                                                                                                                                               Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                           x87 <- do x84 <- DM.litHook
                                                                                                                                                              (DI.DebugInfo
                                                                                                                                                                 (DI.SrcID
                                                                                                                                                                    "XML"
                                                                                                                                                                    0)
                                                                                                                                                                 (DI.DynamicInfo
                                                                                                                                                                    []
                                                                                                                                                                    []))
                                                                                                                                                              (Prelude.return
                                                                                                                                                                 (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                    (Curry.DebugModule.Prelude.I
                                                                                                                                                                       (Curry.DebugModule.Prelude.O
                                                                                                                                                                          (Curry.DebugModule.Prelude.I
                                                                                                                                                                             (Curry.DebugModule.Prelude.I
                                                                                                                                                                                (Curry.DebugModule.Prelude.O
                                                                                                                                                                                   (Curry.DebugModule.Prelude.O
                                                                                                                                                                                      (Curry.DebugModule.Prelude.I
                                                                                                                                                                                         Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                     x85 <- do x82 <- DM.litHook
                                                                                                                                                                        (DI.DebugInfo
                                                                                                                                                                           (DI.SrcID
                                                                                                                                                                              "XML"
                                                                                                                                                                              0)
                                                                                                                                                                           (DI.DynamicInfo
                                                                                                                                                                              []
                                                                                                                                                                              []))
                                                                                                                                                                        (Prelude.return
                                                                                                                                                                           (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                              (Curry.DebugModule.Prelude.I
                                                                                                                                                                                 (Curry.DebugModule.Prelude.I
                                                                                                                                                                                    (Curry.DebugModule.Prelude.I
                                                                                                                                                                                       (Curry.DebugModule.Prelude.I
                                                                                                                                                                                          (Curry.DebugModule.Prelude.O
                                                                                                                                                                                             (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                   Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                               x83 <- do x80 <- DM.litHook
                                                                                                                                                                                  (DI.DebugInfo
                                                                                                                                                                                     (DI.SrcID
                                                                                                                                                                                        "XML"
                                                                                                                                                                                        0)
                                                                                                                                                                                     (DI.DynamicInfo
                                                                                                                                                                                        []
                                                                                                                                                                                        []))
                                                                                                                                                                                  (Prelude.return
                                                                                                                                                                                     (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                        (Curry.DebugModule.Prelude.O
                                                                                                                                                                                           (Curry.DebugModule.Prelude.O
                                                                                                                                                                                              (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                 (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                    (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                       (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                          (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                             Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                         x81 <- do x78 <- DM.litHook
                                                                                                                                                                                            (DI.DebugInfo
                                                                                                                                                                                               (DI.SrcID
                                                                                                                                                                                                  "XML"
                                                                                                                                                                                                  0)
                                                                                                                                                                                               (DI.DynamicInfo
                                                                                                                                                                                                  []
                                                                                                                                                                                                  []))
                                                                                                                                                                                            (Prelude.return
                                                                                                                                                                                               (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                  (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                     (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                        (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                           (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                              (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                 (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                    (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                       Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                   x79 <- do x76 <- DM.litHook
                                                                                                                                                                                                      (DI.DebugInfo
                                                                                                                                                                                                         (DI.SrcID
                                                                                                                                                                                                            "XML"
                                                                                                                                                                                                            0)
                                                                                                                                                                                                         (DI.DynamicInfo
                                                                                                                                                                                                            []
                                                                                                                                                                                                            []))
                                                                                                                                                                                                      (Prelude.return
                                                                                                                                                                                                         (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                            (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                               (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                  (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                     (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                        (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                           (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                              (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                 Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                             x77 <- do x74 <- DM.litHook
                                                                                                                                                                                                                (DI.DebugInfo
                                                                                                                                                                                                                   (DI.SrcID
                                                                                                                                                                                                                      "XML"
                                                                                                                                                                                                                      0)
                                                                                                                                                                                                                   (DI.DynamicInfo
                                                                                                                                                                                                                      []
                                                                                                                                                                                                                      []))
                                                                                                                                                                                                                (Prelude.return
                                                                                                                                                                                                                   (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                      (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                         (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                            (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                               (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                  (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                     (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                        (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                           Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                       x75 <- do x72 <- DM.litHook
                                                                                                                                                                                                                          (DI.DebugInfo
                                                                                                                                                                                                                             (DI.SrcID
                                                                                                                                                                                                                                "XML"
                                                                                                                                                                                                                                0)
                                                                                                                                                                                                                             (DI.DynamicInfo
                                                                                                                                                                                                                                []
                                                                                                                                                                                                                                []))
                                                                                                                                                                                                                          (Prelude.return
                                                                                                                                                                                                                             (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                   (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                      (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                         (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                            (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                               (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                  (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                     Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                 x73 <- do x70 <- DM.litHook
                                                                                                                                                                                                                                    (DI.DebugInfo
                                                                                                                                                                                                                                       (DI.SrcID
                                                                                                                                                                                                                                          "XML"
                                                                                                                                                                                                                                          0)
                                                                                                                                                                                                                                       (DI.DynamicInfo
                                                                                                                                                                                                                                          []
                                                                                                                                                                                                                                          []))
                                                                                                                                                                                                                                    (Prelude.return
                                                                                                                                                                                                                                       (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                          (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                             (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                   (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                      (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                         (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                            (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                               Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                           x71 <- do x68 <- DM.litHook
                                                                                                                                                                                                                                              (DI.DebugInfo
                                                                                                                                                                                                                                                 (DI.SrcID
                                                                                                                                                                                                                                                    "XML"
                                                                                                                                                                                                                                                    0)
                                                                                                                                                                                                                                                 (DI.DynamicInfo
                                                                                                                                                                                                                                                    []
                                                                                                                                                                                                                                                    []))
                                                                                                                                                                                                                                              (Prelude.return
                                                                                                                                                                                                                                                 (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                    (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                       (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                          (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                             (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                   (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                      (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                         Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                     x69 <- do x66 <- DM.litHook
                                                                                                                                                                                                                                                        (DI.DebugInfo
                                                                                                                                                                                                                                                           (DI.SrcID
                                                                                                                                                                                                                                                              "XML"
                                                                                                                                                                                                                                                              0)
                                                                                                                                                                                                                                                           (DI.DynamicInfo
                                                                                                                                                                                                                                                              []
                                                                                                                                                                                                                                                              []))
                                                                                                                                                                                                                                                        (Prelude.return
                                                                                                                                                                                                                                                           (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                              (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                 (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                    (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                       (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                          (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                             (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                   Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                               x67 <- do x64 <- DM.litHook
                                                                                                                                                                                                                                                                  (DI.DebugInfo
                                                                                                                                                                                                                                                                     (DI.SrcID
                                                                                                                                                                                                                                                                        "XML"
                                                                                                                                                                                                                                                                        0)
                                                                                                                                                                                                                                                                     (DI.DynamicInfo
                                                                                                                                                                                                                                                                        []
                                                                                                                                                                                                                                                                        []))
                                                                                                                                                                                                                                                                  (Prelude.return
                                                                                                                                                                                                                                                                     (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                        (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                           (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                              (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                 (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                    (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                       (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                          (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                             Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                         x65 <- do x62 <- DM.litHook
                                                                                                                                                                                                                                                                            (DI.DebugInfo
                                                                                                                                                                                                                                                                               (DI.SrcID
                                                                                                                                                                                                                                                                                  "XML"
                                                                                                                                                                                                                                                                                  0)
                                                                                                                                                                                                                                                                               (DI.DynamicInfo
                                                                                                                                                                                                                                                                                  []
                                                                                                                                                                                                                                                                                  []))
                                                                                                                                                                                                                                                                            (Prelude.return
                                                                                                                                                                                                                                                                               (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                                  (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                     (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                        (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                           (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                              (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                 (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                    (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                       Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                                   x63 <- do x60 <- DM.litHook
                                                                                                                                                                                                                                                                                      (DI.DebugInfo
                                                                                                                                                                                                                                                                                         (DI.SrcID
                                                                                                                                                                                                                                                                                            "XML"
                                                                                                                                                                                                                                                                                            0)
                                                                                                                                                                                                                                                                                         (DI.DynamicInfo
                                                                                                                                                                                                                                                                                            []
                                                                                                                                                                                                                                                                                            []))
                                                                                                                                                                                                                                                                                      (Prelude.return
                                                                                                                                                                                                                                                                                         (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                                            (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                               (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                  (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                     (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                        (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                           (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                              (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                 Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                                             x61 <- do x58 <- DM.litHook
                                                                                                                                                                                                                                                                                                (DI.DebugInfo
                                                                                                                                                                                                                                                                                                   (DI.SrcID
                                                                                                                                                                                                                                                                                                      "XML"
                                                                                                                                                                                                                                                                                                      0)
                                                                                                                                                                                                                                                                                                   (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                      []
                                                                                                                                                                                                                                                                                                      []))
                                                                                                                                                                                                                                                                                                (Prelude.return
                                                                                                                                                                                                                                                                                                   (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                                                      (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                         (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                            (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                               (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                  (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                     (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                        (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                           Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                                                       x59 <- do x56 <- DM.litHook
                                                                                                                                                                                                                                                                                                          (DI.DebugInfo
                                                                                                                                                                                                                                                                                                             (DI.SrcID
                                                                                                                                                                                                                                                                                                                "XML"
                                                                                                                                                                                                                                                                                                                0)
                                                                                                                                                                                                                                                                                                             (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                []
                                                                                                                                                                                                                                                                                                                []))
                                                                                                                                                                                                                                                                                                          (Prelude.return
                                                                                                                                                                                                                                                                                                             (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                                                                (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                   (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                      (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                         (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                            (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                               (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                  (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                     Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                                                                 x57 <- do x54 <- DM.litHook
                                                                                                                                                                                                                                                                                                                    (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                       (DI.SrcID
                                                                                                                                                                                                                                                                                                                          "XML"
                                                                                                                                                                                                                                                                                                                          0)
                                                                                                                                                                                                                                                                                                                       (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                          []
                                                                                                                                                                                                                                                                                                                          []))
                                                                                                                                                                                                                                                                                                                    (Prelude.return
                                                                                                                                                                                                                                                                                                                       (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                                                                          (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                             (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                   (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                      (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                         (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                            (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                               Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                                                                           x55 <- do x52 <- DM.litHook
                                                                                                                                                                                                                                                                                                                              (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                 (DI.SrcID
                                                                                                                                                                                                                                                                                                                                    "XML"
                                                                                                                                                                                                                                                                                                                                    0)
                                                                                                                                                                                                                                                                                                                                 (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                    []
                                                                                                                                                                                                                                                                                                                                    []))
                                                                                                                                                                                                                                                                                                                              (Prelude.return
                                                                                                                                                                                                                                                                                                                                 (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                                                                                    (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                       (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                          (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                             (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                   (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                      (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                         Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                                                                                     x53 <- do x50 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                        (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                           (DI.SrcID
                                                                                                                                                                                                                                                                                                                                              "XML"
                                                                                                                                                                                                                                                                                                                                              0)
                                                                                                                                                                                                                                                                                                                                           (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                              []
                                                                                                                                                                                                                                                                                                                                              []))
                                                                                                                                                                                                                                                                                                                                        (Prelude.return
                                                                                                                                                                                                                                                                                                                                           (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                                                                                              (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                 (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                    (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                       (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                          (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                             (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                   Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                                                                                               x51 <- do x48 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                  (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                     (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                        "XML"
                                                                                                                                                                                                                                                                                                                                                        0)
                                                                                                                                                                                                                                                                                                                                                     (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                        []
                                                                                                                                                                                                                                                                                                                                                        []))
                                                                                                                                                                                                                                                                                                                                                  (Prelude.return
                                                                                                                                                                                                                                                                                                                                                     (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                                                                                                        (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                           (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                              (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                 (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                    (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                       (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                          (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                             Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                                                                                                         x49 <- do x46 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                            (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                               (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                  "XML"
                                                                                                                                                                                                                                                                                                                                                                  0)
                                                                                                                                                                                                                                                                                                                                                               (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                  []
                                                                                                                                                                                                                                                                                                                                                                  []))
                                                                                                                                                                                                                                                                                                                                                            (Prelude.return
                                                                                                                                                                                                                                                                                                                                                               (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                                                                                                                  (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                     (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                        (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                           (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                              (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                 (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                    (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                       Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                                                                                                                   x47 <- do x44 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                                      (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                         (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                            "XML"
                                                                                                                                                                                                                                                                                                                                                                            0)
                                                                                                                                                                                                                                                                                                                                                                         (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                            []
                                                                                                                                                                                                                                                                                                                                                                            []))
                                                                                                                                                                                                                                                                                                                                                                      (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                         (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                                                                                                                            (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                               (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                  (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                     (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                        (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                           (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                              (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                 Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                                                                                                                             x45 <- do x42 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                                                (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                   (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                      "XML"
                                                                                                                                                                                                                                                                                                                                                                                      0)
                                                                                                                                                                                                                                                                                                                                                                                   (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                      []
                                                                                                                                                                                                                                                                                                                                                                                      []))
                                                                                                                                                                                                                                                                                                                                                                                (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                   (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                                                                                                                                      (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                         (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                            (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                               (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                  (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                     (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                        (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                           Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                                                                                                                                       x43 <- do x40 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                                                          (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                             (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                "XML"
                                                                                                                                                                                                                                                                                                                                                                                                0)
                                                                                                                                                                                                                                                                                                                                                                                             (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                []
                                                                                                                                                                                                                                                                                                                                                                                                []))
                                                                                                                                                                                                                                                                                                                                                                                          (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                             (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                                                                                                                                                (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                   (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                      (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                         (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                            (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                               (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                  (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                     Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                                                                                                                                                 x41 <- do x38 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                                                                    (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                       (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                          "XML"
                                                                                                                                                                                                                                                                                                                                                                                                          0)
                                                                                                                                                                                                                                                                                                                                                                                                       (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                          []
                                                                                                                                                                                                                                                                                                                                                                                                          []))
                                                                                                                                                                                                                                                                                                                                                                                                    (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                       (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                                                                                                                                                          (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                             (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                   (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                      (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                         (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                            (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                               Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                                                                                                                                                           x39 <- do x36 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                                                                              (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                 (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                    "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                    0)
                                                                                                                                                                                                                                                                                                                                                                                                                 (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                    []
                                                                                                                                                                                                                                                                                                                                                                                                                    []))
                                                                                                                                                                                                                                                                                                                                                                                                              (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                 (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                                                                                                                                                                    (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                       (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                          (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                             (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                   (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                      (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                         Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                                                                                                                                                                     x37 <- do x34 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                                                                                        (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                           (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                              "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                              0)
                                                                                                                                                                                                                                                                                                                                                                                                                           (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                              []
                                                                                                                                                                                                                                                                                                                                                                                                                              []))
                                                                                                                                                                                                                                                                                                                                                                                                                        (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                           (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                                                                                                                                                                              (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                 (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                    (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                       (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                          (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                             (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                   Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                                                                                                                                                                               x35 <- do x32 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                                                                                                  (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                     (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                        "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                        0)
                                                                                                                                                                                                                                                                                                                                                                                                                                     (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                        []
                                                                                                                                                                                                                                                                                                                                                                                                                                        []))
                                                                                                                                                                                                                                                                                                                                                                                                                                  (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                     (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                                                                                                                                                                                        (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                           (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                              (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                 (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                    (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                       (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                          (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                             Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                                                                                                                                                                                         x33 <- do x30 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                                                                                                            (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                               (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                  "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                  0)
                                                                                                                                                                                                                                                                                                                                                                                                                                               (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                  []
                                                                                                                                                                                                                                                                                                                                                                                                                                                  []))
                                                                                                                                                                                                                                                                                                                                                                                                                                            (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                               (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                                                                                                                                                                                                  (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                     (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                        (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                           (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                              (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                                 (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                       Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                                                                                                                                                                                                   x31 <- do x28 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                                                                                                                      (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                         (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                            "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                            0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                         (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                            []
                                                                                                                                                                                                                                                                                                                                                                                                                                                            []))
                                                                                                                                                                                                                                                                                                                                                                                                                                                      (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                         (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                                                                                                                                                                                                            (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                               (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                  (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                     (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                                           (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                              (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                                                                                                                                                                                                             x29 <- do x26 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                                                                                                                                (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                   (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                                      "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                                      0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                   (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                      []
                                                                                                                                                                                                                                                                                                                                                                                                                                                                      []))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                                   (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                                                                                                                                                                                                                      (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                                         (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                                               (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                                                                                                                                                                                                                       x27 <- do x24 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                                                                                                                                          (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                             (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                             (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                []
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                []))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                          (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                                             (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                 x25 <- do x22 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          []
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          []))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                           x23 <- do x20 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    []
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    []))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     x21 <- do x18 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              []
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              []))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               x19 <- do x16 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        []
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        []))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         x17 <- do x14 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  []
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  []))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   x15 <- do x12 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            []
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            []))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             x13 <- do x10 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      []
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      []))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       x11 <- do x8 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               []
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               []))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 x9 <- do x6 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        []
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        []))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          x7 <- do x4 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 []
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 []))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   x5 <- do x2 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          []
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          []))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             (Curry.DebugModule.Prelude.O
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            x3 <- do x0 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   []
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   []))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (Curry.DebugModule.Prelude.Pos
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     (Curry.DebugModule.Prelude.I
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        Curry.DebugModule.Prelude.IHi)))))))))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     x1 <- DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   []
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   []))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                Curry.DebugModule.Prelude.Nil)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             []
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                x0,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                x1]))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             x0
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             x1))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    []
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       x2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       x3]))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    x2
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    x3))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           []
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              x4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              x5]))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           x4
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           x5))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  []
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     x6,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     x7]))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  x6
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  x7))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         []
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            x8,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            x9]))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         x8
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         x9))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               []
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  x10,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  x11]))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               x10
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               x11))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     []
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        x12,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        x13]))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     x12
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     x13))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           []
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              x14,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              x15]))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           x14
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           x15))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 []
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    x16,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    x17]))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 x16
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 x17))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       []
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          x18,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          x19]))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       x18
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       x19))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             []
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                x20,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                x21]))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             x20
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             x21))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                           DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                                                                                                                                             (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   []
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      x22,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      x23]))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                             (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   x22
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   x23))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                 DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                                                                                                                                   (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                      (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                                         "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                                         0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                      (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                         []
                                                                                                                                                                                                                                                                                                                                                                                                                                                                         [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            x24,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                          DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            x25]))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                   (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                                      (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                                                                                                                                         x24
                                                                                                                                                                                                                                                                                                                                                                                                                                                                         x25))
                                                                                                                                                                                                                                                                                                                                                                                                                                                       DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                                                                                                                         (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                            (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                               "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                               0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                            (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                               []
                                                                                                                                                                                                                                                                                                                                                                                                                                                               [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                                                  x26,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                                                  x27]))
                                                                                                                                                                                                                                                                                                                                                                                                                                                         (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                            (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                                                                                                                               x26
                                                                                                                                                                                                                                                                                                                                                                                                                                                               x27))
                                                                                                                                                                                                                                                                                                                                                                                                                                             DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                                                                                                               (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                  (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                     "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                     0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                  (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                     []
                                                                                                                                                                                                                                                                                                                                                                                                                                                     [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                                        x28,
                                                                                                                                                                                                                                                                                                                                                                                                                                                      DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                                        x29]))
                                                                                                                                                                                                                                                                                                                                                                                                                                               (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                  (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                                                                                                                     x28
                                                                                                                                                                                                                                                                                                                                                                                                                                                     x29))
                                                                                                                                                                                                                                                                                                                                                                                                                                   DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                                                                                                     (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                        (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                           "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                           0)
                                                                                                                                                                                                                                                                                                                                                                                                                                        (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                           []
                                                                                                                                                                                                                                                                                                                                                                                                                                           [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                              x30,
                                                                                                                                                                                                                                                                                                                                                                                                                                            DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                              x31]))
                                                                                                                                                                                                                                                                                                                                                                                                                                     (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                        (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                                                                                                           x30
                                                                                                                                                                                                                                                                                                                                                                                                                                           x31))
                                                                                                                                                                                                                                                                                                                                                                                                                         DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                                                                                           (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                              (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                 "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                 0)
                                                                                                                                                                                                                                                                                                                                                                                                                              (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                 []
                                                                                                                                                                                                                                                                                                                                                                                                                                 [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                    x32,
                                                                                                                                                                                                                                                                                                                                                                                                                                  DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                    x33]))
                                                                                                                                                                                                                                                                                                                                                                                                                           (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                              (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                                                                                                 x32
                                                                                                                                                                                                                                                                                                                                                                                                                                 x33))
                                                                                                                                                                                                                                                                                                                                                                                                               DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                                                                                 (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                    (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                       "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                       0)
                                                                                                                                                                                                                                                                                                                                                                                                                    (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                       []
                                                                                                                                                                                                                                                                                                                                                                                                                       [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                          x34,
                                                                                                                                                                                                                                                                                                                                                                                                                        DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                          x35]))
                                                                                                                                                                                                                                                                                                                                                                                                                 (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                    (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                                                                                       x34
                                                                                                                                                                                                                                                                                                                                                                                                                       x35))
                                                                                                                                                                                                                                                                                                                                                                                                     DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                                                                       (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                          (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                             "XML"
                                                                                                                                                                                                                                                                                                                                                                                                             0)
                                                                                                                                                                                                                                                                                                                                                                                                          (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                             []
                                                                                                                                                                                                                                                                                                                                                                                                             [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                x36,
                                                                                                                                                                                                                                                                                                                                                                                                              DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                x37]))
                                                                                                                                                                                                                                                                                                                                                                                                       (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                          (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                                                                             x36
                                                                                                                                                                                                                                                                                                                                                                                                             x37))
                                                                                                                                                                                                                                                                                                                                                                                           DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                                                             (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                   "XML"
                                                                                                                                                                                                                                                                                                                                                                                                   0)
                                                                                                                                                                                                                                                                                                                                                                                                (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                   []
                                                                                                                                                                                                                                                                                                                                                                                                   [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                      x38,
                                                                                                                                                                                                                                                                                                                                                                                                    DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                      x39]))
                                                                                                                                                                                                                                                                                                                                                                                             (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                                                                   x38
                                                                                                                                                                                                                                                                                                                                                                                                   x39))
                                                                                                                                                                                                                                                                                                                                                                                 DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                                                   (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                      (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                         "XML"
                                                                                                                                                                                                                                                                                                                                                                                         0)
                                                                                                                                                                                                                                                                                                                                                                                      (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                         []
                                                                                                                                                                                                                                                                                                                                                                                         [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                            x40,
                                                                                                                                                                                                                                                                                                                                                                                          DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                            x41]))
                                                                                                                                                                                                                                                                                                                                                                                   (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                      (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                                                         x40
                                                                                                                                                                                                                                                                                                                                                                                         x41))
                                                                                                                                                                                                                                                                                                                                                                       DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                                         (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                            (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                               "XML"
                                                                                                                                                                                                                                                                                                                                                                               0)
                                                                                                                                                                                                                                                                                                                                                                            (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                               []
                                                                                                                                                                                                                                                                                                                                                                               [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                  x42,
                                                                                                                                                                                                                                                                                                                                                                                DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                  x43]))
                                                                                                                                                                                                                                                                                                                                                                         (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                            (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                                               x42
                                                                                                                                                                                                                                                                                                                                                                               x43))
                                                                                                                                                                                                                                                                                                                                                             DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                               (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                  (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                     "XML"
                                                                                                                                                                                                                                                                                                                                                                     0)
                                                                                                                                                                                                                                                                                                                                                                  (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                     []
                                                                                                                                                                                                                                                                                                                                                                     [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                        x44,
                                                                                                                                                                                                                                                                                                                                                                      DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                        x45]))
                                                                                                                                                                                                                                                                                                                                                               (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                  (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                                     x44
                                                                                                                                                                                                                                                                                                                                                                     x45))
                                                                                                                                                                                                                                                                                                                                                   DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                     (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                        (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                           "XML"
                                                                                                                                                                                                                                                                                                                                                           0)
                                                                                                                                                                                                                                                                                                                                                        (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                           []
                                                                                                                                                                                                                                                                                                                                                           [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                              x46,
                                                                                                                                                                                                                                                                                                                                                            DI.genTerm
                                                                                                                                                                                                                                                                                                                                                              x47]))
                                                                                                                                                                                                                                                                                                                                                     (Prelude.return
                                                                                                                                                                                                                                                                                                                                                        (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                           x46
                                                                                                                                                                                                                                                                                                                                                           x47))
                                                                                                                                                                                                                                                                                                                                         DM.constructorHook
                                                                                                                                                                                                                                                                                                                                           (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                              (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                 "XML"
                                                                                                                                                                                                                                                                                                                                                 0)
                                                                                                                                                                                                                                                                                                                                              (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                 []
                                                                                                                                                                                                                                                                                                                                                 [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                    x48,
                                                                                                                                                                                                                                                                                                                                                  DI.genTerm
                                                                                                                                                                                                                                                                                                                                                    x49]))
                                                                                                                                                                                                                                                                                                                                           (Prelude.return
                                                                                                                                                                                                                                                                                                                                              (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                 x48
                                                                                                                                                                                                                                                                                                                                                 x49))
                                                                                                                                                                                                                                                                                                                               DM.constructorHook
                                                                                                                                                                                                                                                                                                                                 (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                    (DI.SrcID
                                                                                                                                                                                                                                                                                                                                       "XML"
                                                                                                                                                                                                                                                                                                                                       0)
                                                                                                                                                                                                                                                                                                                                    (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                       []
                                                                                                                                                                                                                                                                                                                                       [DI.genTerm
                                                                                                                                                                                                                                                                                                                                          x50,
                                                                                                                                                                                                                                                                                                                                        DI.genTerm
                                                                                                                                                                                                                                                                                                                                          x51]))
                                                                                                                                                                                                                                                                                                                                 (Prelude.return
                                                                                                                                                                                                                                                                                                                                    (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                       x50
                                                                                                                                                                                                                                                                                                                                       x51))
                                                                                                                                                                                                                                                                                                                     DM.constructorHook
                                                                                                                                                                                                                                                                                                                       (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                          (DI.SrcID
                                                                                                                                                                                                                                                                                                                             "XML"
                                                                                                                                                                                                                                                                                                                             0)
                                                                                                                                                                                                                                                                                                                          (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                             []
                                                                                                                                                                                                                                                                                                                             [DI.genTerm
                                                                                                                                                                                                                                                                                                                                x52,
                                                                                                                                                                                                                                                                                                                              DI.genTerm
                                                                                                                                                                                                                                                                                                                                x53]))
                                                                                                                                                                                                                                                                                                                       (Prelude.return
                                                                                                                                                                                                                                                                                                                          (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                             x52
                                                                                                                                                                                                                                                                                                                             x53))
                                                                                                                                                                                                                                                                                                           DM.constructorHook
                                                                                                                                                                                                                                                                                                             (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                (DI.SrcID
                                                                                                                                                                                                                                                                                                                   "XML"
                                                                                                                                                                                                                                                                                                                   0)
                                                                                                                                                                                                                                                                                                                (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                   []
                                                                                                                                                                                                                                                                                                                   [DI.genTerm
                                                                                                                                                                                                                                                                                                                      x54,
                                                                                                                                                                                                                                                                                                                    DI.genTerm
                                                                                                                                                                                                                                                                                                                      x55]))
                                                                                                                                                                                                                                                                                                             (Prelude.return
                                                                                                                                                                                                                                                                                                                (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                   x54
                                                                                                                                                                                                                                                                                                                   x55))
                                                                                                                                                                                                                                                                                                 DM.constructorHook
                                                                                                                                                                                                                                                                                                   (DI.DebugInfo
                                                                                                                                                                                                                                                                                                      (DI.SrcID
                                                                                                                                                                                                                                                                                                         "XML"
                                                                                                                                                                                                                                                                                                         0)
                                                                                                                                                                                                                                                                                                      (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                         []
                                                                                                                                                                                                                                                                                                         [DI.genTerm
                                                                                                                                                                                                                                                                                                            x56,
                                                                                                                                                                                                                                                                                                          DI.genTerm
                                                                                                                                                                                                                                                                                                            x57]))
                                                                                                                                                                                                                                                                                                   (Prelude.return
                                                                                                                                                                                                                                                                                                      (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                         x56
                                                                                                                                                                                                                                                                                                         x57))
                                                                                                                                                                                                                                                                                       DM.constructorHook
                                                                                                                                                                                                                                                                                         (DI.DebugInfo
                                                                                                                                                                                                                                                                                            (DI.SrcID
                                                                                                                                                                                                                                                                                               "XML"
                                                                                                                                                                                                                                                                                               0)
                                                                                                                                                                                                                                                                                            (DI.DynamicInfo
                                                                                                                                                                                                                                                                                               []
                                                                                                                                                                                                                                                                                               [DI.genTerm
                                                                                                                                                                                                                                                                                                  x58,
                                                                                                                                                                                                                                                                                                DI.genTerm
                                                                                                                                                                                                                                                                                                  x59]))
                                                                                                                                                                                                                                                                                         (Prelude.return
                                                                                                                                                                                                                                                                                            (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                               x58
                                                                                                                                                                                                                                                                                               x59))
                                                                                                                                                                                                                                                                             DM.constructorHook
                                                                                                                                                                                                                                                                               (DI.DebugInfo
                                                                                                                                                                                                                                                                                  (DI.SrcID
                                                                                                                                                                                                                                                                                     "XML"
                                                                                                                                                                                                                                                                                     0)
                                                                                                                                                                                                                                                                                  (DI.DynamicInfo
                                                                                                                                                                                                                                                                                     []
                                                                                                                                                                                                                                                                                     [DI.genTerm
                                                                                                                                                                                                                                                                                        x60,
                                                                                                                                                                                                                                                                                      DI.genTerm
                                                                                                                                                                                                                                                                                        x61]))
                                                                                                                                                                                                                                                                               (Prelude.return
                                                                                                                                                                                                                                                                                  (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                     x60
                                                                                                                                                                                                                                                                                     x61))
                                                                                                                                                                                                                                                                   DM.constructorHook
                                                                                                                                                                                                                                                                     (DI.DebugInfo
                                                                                                                                                                                                                                                                        (DI.SrcID
                                                                                                                                                                                                                                                                           "XML"
                                                                                                                                                                                                                                                                           0)
                                                                                                                                                                                                                                                                        (DI.DynamicInfo
                                                                                                                                                                                                                                                                           []
                                                                                                                                                                                                                                                                           [DI.genTerm
                                                                                                                                                                                                                                                                              x62,
                                                                                                                                                                                                                                                                            DI.genTerm
                                                                                                                                                                                                                                                                              x63]))
                                                                                                                                                                                                                                                                     (Prelude.return
                                                                                                                                                                                                                                                                        (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                           x62
                                                                                                                                                                                                                                                                           x63))
                                                                                                                                                                                                                                                         DM.constructorHook
                                                                                                                                                                                                                                                           (DI.DebugInfo
                                                                                                                                                                                                                                                              (DI.SrcID
                                                                                                                                                                                                                                                                 "XML"
                                                                                                                                                                                                                                                                 0)
                                                                                                                                                                                                                                                              (DI.DynamicInfo
                                                                                                                                                                                                                                                                 []
                                                                                                                                                                                                                                                                 [DI.genTerm
                                                                                                                                                                                                                                                                    x64,
                                                                                                                                                                                                                                                                  DI.genTerm
                                                                                                                                                                                                                                                                    x65]))
                                                                                                                                                                                                                                                           (Prelude.return
                                                                                                                                                                                                                                                              (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                 x64
                                                                                                                                                                                                                                                                 x65))
                                                                                                                                                                                                                                               DM.constructorHook
                                                                                                                                                                                                                                                 (DI.DebugInfo
                                                                                                                                                                                                                                                    (DI.SrcID
                                                                                                                                                                                                                                                       "XML"
                                                                                                                                                                                                                                                       0)
                                                                                                                                                                                                                                                    (DI.DynamicInfo
                                                                                                                                                                                                                                                       []
                                                                                                                                                                                                                                                       [DI.genTerm
                                                                                                                                                                                                                                                          x66,
                                                                                                                                                                                                                                                        DI.genTerm
                                                                                                                                                                                                                                                          x67]))
                                                                                                                                                                                                                                                 (Prelude.return
                                                                                                                                                                                                                                                    (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                       x66
                                                                                                                                                                                                                                                       x67))
                                                                                                                                                                                                                                     DM.constructorHook
                                                                                                                                                                                                                                       (DI.DebugInfo
                                                                                                                                                                                                                                          (DI.SrcID
                                                                                                                                                                                                                                             "XML"
                                                                                                                                                                                                                                             0)
                                                                                                                                                                                                                                          (DI.DynamicInfo
                                                                                                                                                                                                                                             []
                                                                                                                                                                                                                                             [DI.genTerm
                                                                                                                                                                                                                                                x68,
                                                                                                                                                                                                                                              DI.genTerm
                                                                                                                                                                                                                                                x69]))
                                                                                                                                                                                                                                       (Prelude.return
                                                                                                                                                                                                                                          (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                             x68
                                                                                                                                                                                                                                             x69))
                                                                                                                                                                                                                           DM.constructorHook
                                                                                                                                                                                                                             (DI.DebugInfo
                                                                                                                                                                                                                                (DI.SrcID
                                                                                                                                                                                                                                   "XML"
                                                                                                                                                                                                                                   0)
                                                                                                                                                                                                                                (DI.DynamicInfo
                                                                                                                                                                                                                                   []
                                                                                                                                                                                                                                   [DI.genTerm
                                                                                                                                                                                                                                      x70,
                                                                                                                                                                                                                                    DI.genTerm
                                                                                                                                                                                                                                      x71]))
                                                                                                                                                                                                                             (Prelude.return
                                                                                                                                                                                                                                (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                   x70
                                                                                                                                                                                                                                   x71))
                                                                                                                                                                                                                 DM.constructorHook
                                                                                                                                                                                                                   (DI.DebugInfo
                                                                                                                                                                                                                      (DI.SrcID
                                                                                                                                                                                                                         "XML"
                                                                                                                                                                                                                         0)
                                                                                                                                                                                                                      (DI.DynamicInfo
                                                                                                                                                                                                                         []
                                                                                                                                                                                                                         [DI.genTerm
                                                                                                                                                                                                                            x72,
                                                                                                                                                                                                                          DI.genTerm
                                                                                                                                                                                                                            x73]))
                                                                                                                                                                                                                   (Prelude.return
                                                                                                                                                                                                                      (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                         x72
                                                                                                                                                                                                                         x73))
                                                                                                                                                                                                       DM.constructorHook
                                                                                                                                                                                                         (DI.DebugInfo
                                                                                                                                                                                                            (DI.SrcID
                                                                                                                                                                                                               "XML"
                                                                                                                                                                                                               0)
                                                                                                                                                                                                            (DI.DynamicInfo
                                                                                                                                                                                                               []
                                                                                                                                                                                                               [DI.genTerm
                                                                                                                                                                                                                  x74,
                                                                                                                                                                                                                DI.genTerm
                                                                                                                                                                                                                  x75]))
                                                                                                                                                                                                         (Prelude.return
                                                                                                                                                                                                            (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                               x74
                                                                                                                                                                                                               x75))
                                                                                                                                                                                             DM.constructorHook
                                                                                                                                                                                               (DI.DebugInfo
                                                                                                                                                                                                  (DI.SrcID
                                                                                                                                                                                                     "XML"
                                                                                                                                                                                                     0)
                                                                                                                                                                                                  (DI.DynamicInfo
                                                                                                                                                                                                     []
                                                                                                                                                                                                     [DI.genTerm
                                                                                                                                                                                                        x76,
                                                                                                                                                                                                      DI.genTerm
                                                                                                                                                                                                        x77]))
                                                                                                                                                                                               (Prelude.return
                                                                                                                                                                                                  (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                     x76
                                                                                                                                                                                                     x77))
                                                                                                                                                                                   DM.constructorHook
                                                                                                                                                                                     (DI.DebugInfo
                                                                                                                                                                                        (DI.SrcID
                                                                                                                                                                                           "XML"
                                                                                                                                                                                           0)
                                                                                                                                                                                        (DI.DynamicInfo
                                                                                                                                                                                           []
                                                                                                                                                                                           [DI.genTerm
                                                                                                                                                                                              x78,
                                                                                                                                                                                            DI.genTerm
                                                                                                                                                                                              x79]))
                                                                                                                                                                                     (Prelude.return
                                                                                                                                                                                        (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                           x78
                                                                                                                                                                                           x79))
                                                                                                                                                                         DM.constructorHook
                                                                                                                                                                           (DI.DebugInfo
                                                                                                                                                                              (DI.SrcID
                                                                                                                                                                                 "XML"
                                                                                                                                                                                 0)
                                                                                                                                                                              (DI.DynamicInfo
                                                                                                                                                                                 []
                                                                                                                                                                                 [DI.genTerm
                                                                                                                                                                                    x80,
                                                                                                                                                                                  DI.genTerm
                                                                                                                                                                                    x81]))
                                                                                                                                                                           (Prelude.return
                                                                                                                                                                              (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                 x80
                                                                                                                                                                                 x81))
                                                                                                                                                               DM.constructorHook
                                                                                                                                                                 (DI.DebugInfo
                                                                                                                                                                    (DI.SrcID
                                                                                                                                                                       "XML"
                                                                                                                                                                       0)
                                                                                                                                                                    (DI.DynamicInfo
                                                                                                                                                                       []
                                                                                                                                                                       [DI.genTerm
                                                                                                                                                                          x82,
                                                                                                                                                                        DI.genTerm
                                                                                                                                                                          x83]))
                                                                                                                                                                 (Prelude.return
                                                                                                                                                                    (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                       x82
                                                                                                                                                                       x83))
                                                                                                                                                     DM.constructorHook
                                                                                                                                                       (DI.DebugInfo
                                                                                                                                                          (DI.SrcID
                                                                                                                                                             "XML"
                                                                                                                                                             0)
                                                                                                                                                          (DI.DynamicInfo
                                                                                                                                                             []
                                                                                                                                                             [DI.genTerm
                                                                                                                                                                x84,
                                                                                                                                                              DI.genTerm
                                                                                                                                                                x85]))
                                                                                                                                                       (Prelude.return
                                                                                                                                                          (Curry.DebugModule.Prelude.Cons
                                                                                                                                                             x84
                                                                                                                                                             x85))
                                                                                                                                           DM.constructorHook
                                                                                                                                             (DI.DebugInfo
                                                                                                                                                (DI.SrcID
                                                                                                                                                   "XML"
                                                                                                                                                   0)
                                                                                                                                                (DI.DynamicInfo
                                                                                                                                                   []
                                                                                                                                                   [DI.genTerm
                                                                                                                                                      x86,
                                                                                                                                                    DI.genTerm
                                                                                                                                                      x87]))
                                                                                                                                             (Prelude.return
                                                                                                                                                (Curry.DebugModule.Prelude.Cons
                                                                                                                                                   x86
                                                                                                                                                   x87))
                                                                                                                                 DM.constructorHook
                                                                                                                                   (DI.DebugInfo
                                                                                                                                      (DI.SrcID
                                                                                                                                         "XML"
                                                                                                                                         0)
                                                                                                                                      (DI.DynamicInfo
                                                                                                                                         []
                                                                                                                                         [DI.genTerm
                                                                                                                                            x88,
                                                                                                                                          DI.genTerm
                                                                                                                                            x89]))
                                                                                                                                   (Prelude.return
                                                                                                                                      (Curry.DebugModule.Prelude.Cons
                                                                                                                                         x88
                                                                                                                                         x89))
                                                                                                                       DM.constructorHook
                                                                                                                         (DI.DebugInfo
                                                                                                                            (DI.SrcID
                                                                                                                               "XML"
                                                                                                                               0)
                                                                                                                            (DI.DynamicInfo
                                                                                                                               []
                                                                                                                               [DI.genTerm
                                                                                                                                  x90,
                                                                                                                                DI.genTerm
                                                                                                                                  x91]))
                                                                                                                         (Prelude.return
                                                                                                                            (Curry.DebugModule.Prelude.Cons
                                                                                                                               x90
                                                                                                                               x91))
                                                                                                             DM.constructorHook
                                                                                                               (DI.DebugInfo
                                                                                                                  (DI.SrcID
                                                                                                                     "XML"
                                                                                                                     0)
                                                                                                                  (DI.DynamicInfo
                                                                                                                     []
                                                                                                                     [DI.genTerm
                                                                                                                        x92,
                                                                                                                      DI.genTerm
                                                                                                                        x93]))
                                                                                                               (Prelude.return
                                                                                                                  (Curry.DebugModule.Prelude.Cons
                                                                                                                     x92
                                                                                                                     x93))
                                                                                                   DM.constructorHook
                                                                                                     (DI.DebugInfo
                                                                                                        (DI.SrcID
                                                                                                           "XML"
                                                                                                           0)
                                                                                                        (DI.DynamicInfo
                                                                                                           []
                                                                                                           [DI.genTerm
                                                                                                              x94,
                                                                                                            DI.genTerm
                                                                                                              x95]))
                                                                                                     (Prelude.return
                                                                                                        (Curry.DebugModule.Prelude.Cons
                                                                                                           x94
                                                                                                           x95))
                                                                                         DM.constructorHook
                                                                                           (DI.DebugInfo
                                                                                              (DI.SrcID
                                                                                                 "XML"
                                                                                                 0)
                                                                                              (DI.DynamicInfo
                                                                                                 []
                                                                                                 [DI.genTerm
                                                                                                    x96,
                                                                                                  DI.genTerm
                                                                                                    x97]))
                                                                                           (Prelude.return
                                                                                              (Curry.DebugModule.Prelude.Cons
                                                                                                 x96
                                                                                                 x97))
                                                                               DM.constructorHook
                                                                                 (DI.DebugInfo
                                                                                    (DI.SrcID "XML"
                                                                                       0)
                                                                                    (DI.DynamicInfo
                                                                                       []
                                                                                       [DI.genTerm
                                                                                          x98,
                                                                                        DI.genTerm
                                                                                          x99]))
                                                                                 (Prelude.return
                                                                                    (Curry.DebugModule.Prelude.Cons
                                                                                       x98
                                                                                       x99))
                                                                    DM.constructorHook
                                                                      (DI.DebugInfo
                                                                         (DI.SrcID "XML" 0)
                                                                         (DI.DynamicInfo []
                                                                            [DI.genTerm x100,
                                                                             DI.genTerm x101]))
                                                                      (Prelude.return
                                                                         (Curry.DebugModule.Prelude.Cons
                                                                            x100
                                                                            x101))
                                                         DM.constructorHook
                                                           (DI.DebugInfo (DI.SrcID "XML" 0)
                                                              (DI.DynamicInfo []
                                                                 [DI.genTerm x102,
                                                                  DI.genTerm x103]))
                                                           (Prelude.return
                                                              (Curry.DebugModule.Prelude.Cons x102
                                                                 x103))
                                              DM.constructorHook
                                                (DI.DebugInfo (DI.SrcID "XML" 0)
                                                   (DI.DynamicInfo []
                                                      [DI.genTerm x104, DI.genTerm x105]))
                                                (Prelude.return
                                                   (Curry.DebugModule.Prelude.Cons x104 x105))
                                   DM.constructorHook
                                     (DI.DebugInfo (DI.SrcID "XML" 0)
                                        (DI.DynamicInfo [] [DI.genTerm x106, DI.genTerm x107]))
                                     (Prelude.return (Curry.DebugModule.Prelude.Cons x106 x107))
                        DM.constructorHook
                          (DI.DebugInfo (DI.SrcID "XML" 0)
                             (DI.DynamicInfo [] [DI.genTerm x108, DI.genTerm x109]))
                          (Prelude.return (Curry.DebugModule.Prelude.Cons x108 x109))
             DM.constructorHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x110, DI.genTerm x111]))
               (Prelude.return (Curry.DebugModule.Prelude.Cons x110 x111))))
 
strict_lookupEncoding ::
                      (DM.DM dm) =>
                        Curry.DebugModule.Prelude.List XmlDocParams -> dm Encoding
strict_lookupEncoding x1
  = DM.eval
      (DM.funcDeclHook "lookupEncoding"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_108"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_108 x2)))
term_strict_lookupEncoding x1
  = DI.Term "lookupEncoding" (DI.SrcID "XML" 0) x1
 
strict_lookupDtdUrl ::
                    (DM.DM dm) =>
                      Curry.DebugModule.Prelude.List XmlDocParams ->
                        dm (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char)
strict_lookupDtdUrl x1
  = DM.eval
      (DM.funcDeclHook "lookupDtdUrl"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_106"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_106 x2)))
term_strict_lookupDtdUrl x1
  = DI.Term "lookupDtdUrl" (DI.SrcID "XML" 0) x1
 
strict_hasDtdUrl ::
                 (DM.DM dm) =>
                   Curry.DebugModule.Prelude.List XmlDocParams ->
                     dm Curry.DebugModule.Prelude.Bool
strict_hasDtdUrl x1
  = DM.eval
      (DM.funcDeclHook "hasDtdUrl"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_104"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_104 x2)))
term_strict_hasDtdUrl x1
  = DI.Term "hasDtdUrl" (DI.SrcID "XML" 0) x1
 
strict_xtxt ::
            (DM.DM dm) =>
              Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char ->
                dm XmlExp
strict_xtxt x1
  = DM.eval
      (DM.funcDeclHook "xtxt"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.constructorHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (Prelude.return (XText x2))))
term_strict_xtxt x1 = DI.Term "xtxt" (DI.SrcID "XML" 0) x1
 
strict_xml ::
           (DM.DM dm) =>
             Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char ->
               Curry.DebugModule.Prelude.List XmlExp -> dm XmlExp
strict_xml x1 x2
  = DM.eval
      (DM.funcDeclHook "xml"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x2]))
         (do x3 <- Prelude.return x1
             x4 <- DM.constructorHook
                     (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                     (Prelude.return Curry.DebugModule.Prelude.Nil)
             x5 <- Prelude.return x2
             DM.constructorHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x3, DI.genTerm x4, DI.genTerm x5]))
               (Prelude.return (XElem x3 x4 x5))))
term_strict_xml x1 = DI.Term "xml" (DI.SrcID "XML" 0) x1
 
strict_writeXmlFile ::
                    (DM.DM dm) =>
                      Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char ->
                        XmlExp ->
                          dm (Curry.DebugModule.Prelude.IO dm Curry.DebugModule.Prelude.Unit)
strict_writeXmlFile x1 x2
  = DM.eval
      (DM.funcDeclHook "writeXmlFile"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x2]))
         (do x6 <- Prelude.return x1
             x7 <- do x4 <- do x3 <- DM.constructorHook
                                       (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                       (Prelude.return StandardEnc)
                               DM.constructorHook
                                 (DI.DebugInfo (DI.SrcID "XML" 0)
                                    (DI.DynamicInfo [] [DI.genTerm x3]))
                                 (Prelude.return (Enc x3))
                      x5 <- DM.constructorHook
                              (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                              (Prelude.return Curry.DebugModule.Prelude.Nil)
                      DM.constructorHook
                        (DI.DebugInfo (DI.SrcID "XML" 0)
                           (DI.DynamicInfo [] [DI.genTerm x4, DI.genTerm x5]))
                        (Prelude.return (Curry.DebugModule.Prelude.Cons x4 x5))
             x8 <- Prelude.return x2
             DM.funcCallHook "writeXmlFileWithParams"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x6, DI.genTerm x7, DI.genTerm x8]))
               (strict_writeXmlFileWithParams x6 x7 x8)))
term_strict_writeXmlFile x1
  = DI.Term "writeXmlFile" (DI.SrcID "XML" 0) x1
 
strict_writeXmlFileWithParams ::
                              (DM.DM dm) =>
                                Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char ->
                                  Curry.DebugModule.Prelude.List XmlDocParams ->
                                    XmlExp ->
                                      dm
                                        (Curry.DebugModule.Prelude.IO dm
                                           Curry.DebugModule.Prelude.Unit)
strict_writeXmlFileWithParams x1 x2 x3
  = DM.eval
      (DM.funcDeclHook "writeXmlFileWithParams"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x2, DI.genTerm x3]))
         (do x6 <- Prelude.return x1
             x7 <- do x4 <- Prelude.return x2
                      x5 <- Prelude.return x3
                      DM.funcCallHook "showXmlDocWithParams"
                        (DI.DebugInfo (DI.SrcID "XML" 0)
                           (DI.DynamicInfo [] [DI.genTerm x4, DI.genTerm x5]))
                        (strict_showXmlDocWithParams x4 x5)
             DM.funcCallHook "writeFile"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x6, DI.genTerm x7]))
               (Curry.DebugModule.Prelude.strict_writeFile x6 x7)))
term_strict_writeXmlFileWithParams x1
  = DI.Term "writeXmlFileWithParams" (DI.SrcID "XML" 0) x1
 
strict_showXmlDoc ::
                  (DM.DM dm) =>
                    XmlExp ->
                      dm (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char)
strict_showXmlDoc x1
  = DM.eval
      (DM.funcDeclHook "showXmlDoc"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- DM.constructorHook
                     (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                     (Prelude.return Curry.DebugModule.Prelude.Nil)
             x3 <- Prelude.return x1
             DM.funcCallHook "showXmlDocWithParams"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2, DI.genTerm x3]))
               (strict_showXmlDocWithParams x2 x3)))
term_strict_showXmlDoc x1
  = DI.Term "showXmlDoc" (DI.SrcID "XML" 0) x1
 
strict_showXmlDocWithParams ::
                            (DM.DM dm) =>
                              Curry.DebugModule.Prelude.List XmlDocParams ->
                                XmlExp ->
                                  dm (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char)
strict_showXmlDocWithParams x1 x2
  = DM.eval
      (DM.funcDeclHook "showXmlDocWithParams"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x2]))
         (do x3 <- Prelude.return x1
             x4 <- Prelude.return x2
             DM.funcCallHook "_case_102"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x3, DI.genTerm x4]))
               (strict__case_102 x3 x4)))
term_strict_showXmlDocWithParams x1
  = DI.Term "showXmlDocWithParams" (DI.SrcID "XML" 0) x1
 
strict_showXmlExp ::
                  (DM.DM dm) =>
                    Curry.DebugModule.Prelude.Int ->
                      DM.Func dm
                        (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char)
                        (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char)
                        ->
                        XmlExp ->
                          dm (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char)
strict_showXmlExp x1 x2 x3
  = DM.eval
      (DM.funcDeclHook "showXmlExp"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x2, DI.genTerm x3]))
         (do x4 <- Prelude.return x1
             x5 <- Prelude.return x2
             x6 <- Prelude.return x3
             DM.funcCallHook "_case_99"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x4, DI.genTerm x5, DI.genTerm x6]))
               (strict__case_99 x4 x5 x6)))
term_strict_showXmlExp x1
  = DI.Term "showXmlExp" (DI.SrcID "XML" 0) x1
 
x'xstrict_showXmlExp46_35selFP335s ::
                                   (DM.DM dm) =>
                                     Curry.DebugModule.Prelude.List XmlExp ->
                                       dm
                                         (Curry.DebugModule.Prelude.List
                                            Curry.DebugModule.Prelude.Char)
x'xstrict_showXmlExp46_35selFP335s x1
  = DM.eval
      (DM.funcDeclHook "showXmlExp._#selFP3#s"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_96"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_96 x2)))
x'xterm_strict_showXmlExp46_35selFP335s x1
  = DI.Term "showXmlExp._#selFP3#s" (DI.SrcID "XML" 0) x1
 
strict_xtab ::
            (DM.DM dm) =>
              Curry.DebugModule.Prelude.Int ->
                dm (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char)
strict_xtab x1
  = DM.eval
      (DM.funcDeclHook "xtab"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x3 <- Prelude.return x1
             x4 <- do x2 <- DM.litHook
                              (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                              (Prelude.return (Curry.DebugModule.Prelude.Char ' '))
                      DM.funcCallHook "repeat"
                        (DI.DebugInfo (DI.SrcID "XML" 0)
                           (DI.DynamicInfo [] [DI.genTerm x2]))
                        (Curry.DebugModule.Prelude.strict_repeat x2)
             DM.funcCallHook "take"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x3, DI.genTerm x4]))
               (Curry.DebugModule.Prelude.strict_take x3 x4)))
term_strict_xtab x1 = DI.Term "xtab" (DI.SrcID "XML" 0) x1
 
strict_showXmlOpenTag ::
                      (DM.DM dm, DI.GenTerm a) =>
                        Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char ->
                          Curry.DebugModule.Prelude.List
                            (Curry.DebugModule.Prelude.Tuple2
                               (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char)
                               a)
                            ->
                            DM.Func dm a
                              (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char)
                              ->
                              dm (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char)
strict_showXmlOpenTag x1 x2 x3
  = DM.eval
      (DM.funcDeclHook "showXmlOpenTag"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x2, DI.genTerm x3]))
         (do x17 <- do x4 <- DM.litHook
                               (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                               (Prelude.return (Curry.DebugModule.Prelude.Char '<'))
                       x5 <- DM.constructorHook
                               (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                               (Prelude.return Curry.DebugModule.Prelude.Nil)
                       DM.constructorHook
                         (DI.DebugInfo (DI.SrcID "XML" 0)
                            (DI.DynamicInfo [] [DI.genTerm x4, DI.genTerm x5]))
                         (Prelude.return (Curry.DebugModule.Prelude.Cons x4 x5))
             x18 <- do x15 <- Prelude.return x1
                       x16 <- do x14 <- do x12 <- do x10 <- do x8 <- do x6 <- DM.litHook
                                                                                (DI.DebugInfo
                                                                                   (DI.SrcID "XML"
                                                                                      0)
                                                                                   (DI.DynamicInfo
                                                                                      []
                                                                                      []))
                                                                                (Prelude.return
                                                                                   (Curry.DebugModule.Prelude.Char
                                                                                      ' '))
                                                                        x7 <- DM.constructorHook
                                                                                (DI.DebugInfo
                                                                                   (DI.SrcID "XML"
                                                                                      0)
                                                                                   (DI.DynamicInfo
                                                                                      []
                                                                                      []))
                                                                                (Prelude.return
                                                                                   Curry.DebugModule.Prelude.Nil)
                                                                        DM.constructorHook
                                                                          (DI.DebugInfo
                                                                             (DI.SrcID "XML" 0)
                                                                             (DI.DynamicInfo []
                                                                                [DI.genTerm x6,
                                                                                 DI.genTerm x7]))
                                                                          (Prelude.return
                                                                             (Curry.DebugModule.Prelude.Cons
                                                                                x6
                                                                                x7))
                                                               Prelude.return
                                                                 (PC.partCall1
                                                                    (Curry.DebugModule.Prelude.term_op_PlusPlus
                                                                       [DI.genTerm x8])
                                                                    (Curry.DebugModule.Prelude.op_PlusPlus
                                                                       x8))
                                                     x11 <- do x9 <- Prelude.return x3
                                                               Prelude.return
                                                                 (PC.partCall1
                                                                    (x'xterm_strict_showXmlOpenTag46attr2string46125
                                                                       [DI.genTerm x9])
                                                                    (x'xstrict_showXmlOpenTag46attr2string46125
                                                                       x9))
                                                     DM.funcCallHook "."
                                                       (DI.DebugInfo (DI.SrcID "XML" 0)
                                                          (DI.DynamicInfo []
                                                             [DI.genTerm x10, DI.genTerm x11]))
                                                       (Curry.DebugModule.Prelude.op_Point x10 x11)
                                           x13 <- Prelude.return x2
                                           DM.funcCallHook "map"
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo []
                                                   [DI.genTerm x12, DI.genTerm x13]))
                                             (Curry.DebugModule.Prelude.strict_map x12 x13)
                                 DM.funcCallHook "concat"
                                   (DI.DebugInfo (DI.SrcID "XML" 0)
                                      (DI.DynamicInfo [] [DI.genTerm x14]))
                                   (Curry.DebugModule.Prelude.strict_concat x14)
                       DM.funcCallHook "++"
                         (DI.DebugInfo (DI.SrcID "XML" 0)
                            (DI.DynamicInfo [] [DI.genTerm x15, DI.genTerm x16]))
                         (Curry.DebugModule.Prelude.op_PlusPlus x15 x16)
             DM.funcCallHook "++"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x17, DI.genTerm x18]))
               (Curry.DebugModule.Prelude.op_PlusPlus x17 x18)))
term_strict_showXmlOpenTag x1
  = DI.Term "showXmlOpenTag" (DI.SrcID "XML" 0) x1
 
x'xstrict_showXmlOpenTag46attr2string46125 ::
                                           (DM.DM dm, DI.GenTerm x130) =>
                                             DM.Func dm x130
                                               (Curry.DebugModule.Prelude.List
                                                  Curry.DebugModule.Prelude.Char)
                                               ->
                                               Curry.DebugModule.Prelude.Tuple2
                                                 (Curry.DebugModule.Prelude.List
                                                    Curry.DebugModule.Prelude.Char)
                                                 x130
                                                 ->
                                                 dm
                                                   (Curry.DebugModule.Prelude.List
                                                      Curry.DebugModule.Prelude.Char)
x'xstrict_showXmlOpenTag46attr2string46125 x1 x2
  = DM.eval
      (DM.funcDeclHook "showXmlOpenTag.attr2string.125"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x2]))
         (do x3 <- Prelude.return x1
             x4 <- Prelude.return x2
             DM.funcCallHook "_case_93"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x3, DI.genTerm x4]))
               (strict__case_93 x3 x4)))
x'xterm_strict_showXmlOpenTag46attr2string46125 x1
  = DI.Term "showXmlOpenTag.attr2string.125" (DI.SrcID "XML" 0) x1
 
strict_showXmlExps ::
                   (DM.DM dm) =>
                     Curry.DebugModule.Prelude.Int ->
                       Curry.DebugModule.Prelude.List XmlExp ->
                         DM.Func dm
                           (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char)
                           (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char)
                           ->
                           dm (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char)
strict_showXmlExps x1 x2 x3
  = DM.eval
      (DM.funcDeclHook "showXmlExps"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x2, DI.genTerm x3]))
         (do x7 <- do x6 <- do x4 <- Prelude.return x1
                               x5 <- Prelude.return x3
                               Prelude.return
                                 (PC.partCall1
                                    (term_strict_showXmlExp [DI.genTerm x4, DI.genTerm x5])
                                    (strict_showXmlExp x4 x5))
                      DM.funcCallHook "concatMap"
                        (DI.DebugInfo (DI.SrcID "XML" 0)
                           (DI.DynamicInfo [] [DI.genTerm x6]))
                        (Curry.DebugModule.Prelude.strict_concatMap x6)
             x8 <- Prelude.return x2
             DM.funcCallHook "apply"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x7, DI.genTerm x8]))
               (Curry.DebugModule.Prelude.strict_apply x7 x8)))
term_strict_showXmlExps x1
  = DI.Term "showXmlExps" (DI.SrcID "XML" 0) x1
 
strict_isXText ::
               (DM.DM dm) => XmlExp -> dm Curry.DebugModule.Prelude.Bool
strict_isXText x1
  = DM.eval
      (DM.funcDeclHook "isXText"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_92"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_92 x2)))
term_strict_isXText x1 = DI.Term "isXText" (DI.SrcID "XML" 0) x1
 
strict_xmlUnquoteSpecials ::
                          (DM.DM dm) =>
                            Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char ->
                              dm (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char)
strict_xmlUnquoteSpecials x1
  = DM.eval
      (DM.funcDeclHook "xmlUnquoteSpecials"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_91"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_91 x2)))
term_strict_xmlUnquoteSpecials x1
  = DI.Term "xmlUnquoteSpecials" (DI.SrcID "XML" 0) x1
 
x'xstrict_xmlUnquoteSpecials46_35selFP535special ::
                                                 (DM.DM dm) =>
                                                   Curry.DebugModule.Prelude.Tuple2
                                                     (Curry.DebugModule.Prelude.List
                                                        Curry.DebugModule.Prelude.Char)
                                                     (Curry.DebugModule.Prelude.List
                                                        Curry.DebugModule.Prelude.Char)
                                                     ->
                                                     dm
                                                       (Curry.DebugModule.Prelude.List
                                                          Curry.DebugModule.Prelude.Char)
x'xstrict_xmlUnquoteSpecials46_35selFP535special x1
  = DM.eval
      (DM.funcDeclHook "xmlUnquoteSpecials._#selFP5#special"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_88"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_88 x2)))
x'xterm_strict_xmlUnquoteSpecials46_35selFP535special x1
  = DI.Term "xmlUnquoteSpecials._#selFP5#special" (DI.SrcID "XML" 0)
      x1
 
x'xstrict_xmlUnquoteSpecials46_35selFP635rest ::
                                              (DM.DM dm) =>
                                                Curry.DebugModule.Prelude.Tuple2
                                                  (Curry.DebugModule.Prelude.List
                                                     Curry.DebugModule.Prelude.Char)
                                                  (Curry.DebugModule.Prelude.List
                                                     Curry.DebugModule.Prelude.Char)
                                                  ->
                                                  dm
                                                    (Curry.DebugModule.Prelude.List
                                                       Curry.DebugModule.Prelude.Char)
x'xstrict_xmlUnquoteSpecials46_35selFP635rest x1
  = DM.eval
      (DM.funcDeclHook "xmlUnquoteSpecials._#selFP6#rest"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_87"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_87 x2)))
x'xterm_strict_xmlUnquoteSpecials46_35selFP635rest x1
  = DI.Term "xmlUnquoteSpecials._#selFP6#rest" (DI.SrcID "XML" 0) x1
 
strict_xmlUnquoteSpecial ::
                         (DM.DM dm) =>
                           Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char ->
                             Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char ->
                               dm (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char)
strict_xmlUnquoteSpecial x1 x2
  = DM.eval
      (DM.funcDeclHook "xmlUnquoteSpecial"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x2]))
         (do x9 <- Prelude.return x1
             x10 <- Prelude.return x2
             x11 <- do x7 <- Prelude.return x1
                       x8 <- do x5 <- DM.litHook
                                        (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                        (Prelude.return (Curry.DebugModule.Prelude.Char 'l'))
                                x6 <- do x3 <- DM.litHook
                                                 (DI.DebugInfo (DI.SrcID "XML" 0)
                                                    (DI.DynamicInfo [] []))
                                                 (Prelude.return
                                                    (Curry.DebugModule.Prelude.Char 't'))
                                         x4 <- DM.constructorHook
                                                 (DI.DebugInfo (DI.SrcID "XML" 0)
                                                    (DI.DynamicInfo [] []))
                                                 (Prelude.return Curry.DebugModule.Prelude.Nil)
                                         DM.constructorHook
                                           (DI.DebugInfo (DI.SrcID "XML" 0)
                                              (DI.DynamicInfo [] [DI.genTerm x3, DI.genTerm x4]))
                                           (Prelude.return (Curry.DebugModule.Prelude.Cons x3 x4))
                                DM.constructorHook
                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                     (DI.DynamicInfo [] [DI.genTerm x5, DI.genTerm x6]))
                                  (Prelude.return (Curry.DebugModule.Prelude.Cons x5 x6))
                       DM.funcCallHook "=="
                         (DI.DebugInfo (DI.SrcID "XML" 0)
                            (DI.DynamicInfo [] [DI.genTerm x7, DI.genTerm x8]))
                         (Curry.DebugModule.Prelude.op_EqEq x7 x8)
             DM.funcCallHook "_case_86"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo []
                     [DI.genTerm x9, DI.genTerm x10, DI.genTerm x11]))
               (strict__case_86 x9 x10 x11)))
term_strict_xmlUnquoteSpecial x1
  = DI.Term "xmlUnquoteSpecial" (DI.SrcID "XML" 0) x1
 
strict_unquoteUnicode ::
                      (DM.DM dm) =>
                        Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char ->
                          dm (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char)
strict_unquoteUnicode x1
  = DM.eval
      (DM.funcDeclHook "unquoteUnicode"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_73"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_73 x2)))
term_strict_unquoteUnicode x1
  = DI.Term "unquoteUnicode" (DI.SrcID "XML" 0) x1
 
strict_readXmlFile ::
                   (DM.DM dm) =>
                     Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char ->
                       dm (Curry.DebugModule.Prelude.IO dm XmlExp)
strict_readXmlFile x1
  = DM.eval
      (DM.funcDeclHook "readXmlFile"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x4 <- do x2 <- Prelude.return x1
                      DM.funcCallHook "readFile"
                        (DI.DebugInfo (DI.SrcID "XML" 0)
                           (DI.DynamicInfo [] [DI.genTerm x2]))
                        (Curry.DebugModule.Prelude.strict_readFile x2)
             x5 <- do x3 <- Prelude.return x1
                      Prelude.return
                        (PC.partCall1
                           (x'xterm_strict_readXmlFile46_35lambda3 [DI.genTerm x3])
                           (x'xstrict_readXmlFile46_35lambda3 x3))
             DM.funcCallHook ">>="
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x4, DI.genTerm x5]))
               (Curry.DebugModule.Prelude.op_GtGtEq x4 x5)))
term_strict_readXmlFile x1
  = DI.Term "readXmlFile" (DI.SrcID "XML" 0) x1
 
x'xstrict_readXmlFile46_35lambda3 ::
                                  (DM.DM dm) =>
                                    Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char ->
                                      Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char
                                        -> dm (Curry.DebugModule.Prelude.IO dm XmlExp)
x'xstrict_readXmlFile46_35lambda3 x1 x2
  = DM.eval
      (DM.funcDeclHook "readXmlFile._#lambda3"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x2]))
         (DM.letHook
            (DI.DebugInfo (DI.SrcID "DummyModule" 42) (DI.DynamicInfo [] []))
            (do x3 <- do x4 <- Prelude.return x2
                         DM.funcCallHook "parseXmlString"
                           (DI.DebugInfo (DI.SrcID "XML" 0)
                              (DI.DynamicInfo [] [DI.genTerm x4]))
                           (strict_parseXmlString x4)
                DM.eval
                  (do x7 <- Prelude.return x1
                      x8 <- Prelude.return x3
                      x9 <- do x5 <- Prelude.return x3
                               x6 <- DM.constructorHook
                                       (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                       (Prelude.return Curry.DebugModule.Prelude.Nil)
                               DM.funcCallHook "=="
                                 (DI.DebugInfo (DI.SrcID "XML" 0)
                                    (DI.DynamicInfo [] [DI.genTerm x5, DI.genTerm x6]))
                                 (Curry.DebugModule.Prelude.op_EqEq x5 x6)
                      DM.funcCallHook "_case_68"
                        (DI.DebugInfo (DI.SrcID "XML" 0)
                           (DI.DynamicInfo [] [DI.genTerm x7, DI.genTerm x8, DI.genTerm x9]))
                        (strict__case_68 x7 x8 x9)))))
x'xterm_strict_readXmlFile46_35lambda3 x1
  = DI.Term "readXmlFile._#lambda3" (DI.SrcID "XML" 0) x1
 
strict_readUnsafeXmlFile ::
                         (DM.DM dm) =>
                           Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char ->
                             dm
                               (Curry.DebugModule.Prelude.IO dm
                                  (Curry.DebugModule.Prelude.Maybe XmlExp))
strict_readUnsafeXmlFile x1
  = DM.eval
      (DM.funcDeclHook "readUnsafeXmlFile"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x8 <- do x5 <- do x2 <- Prelude.return x1
                               DM.funcCallHook "readXmlFile"
                                 (DI.DebugInfo (DI.SrcID "XML" 0)
                                    (DI.DynamicInfo [] [DI.genTerm x2]))
                                 (strict_readXmlFile x2)
                      x6 <- do x3 <- Prelude.return
                                       (PC.partCall1
                                          (Curry.DebugModule.Prelude.term_strict_return [])
                                          Curry.DebugModule.Prelude.strict_return)
                               x4 <- Prelude.return
                                       (PC.partCall1 (Curry.DebugModule.Prelude.term_Just [])
                                          (\ x0 ->
                                             Prelude.return (Curry.DebugModule.Prelude.Just x0)))
                               DM.funcCallHook "."
                                 (DI.DebugInfo (DI.SrcID "XML" 0)
                                    (DI.DynamicInfo [] [DI.genTerm x3, DI.genTerm x4]))
                                 (Curry.DebugModule.Prelude.op_Point x3 x4)
                      DM.funcCallHook ">>="
                        (DI.DebugInfo (DI.SrcID "XML" 0)
                           (DI.DynamicInfo [] [DI.genTerm x5, DI.genTerm x6]))
                        (Curry.DebugModule.Prelude.op_GtGtEq x5 x6)
             x9 <- do x7 <- DM.constructorHook
                              (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                              (Prelude.return Curry.DebugModule.Prelude.Nothing)
                      DM.funcCallHook "return"
                        (DI.DebugInfo (DI.SrcID "XML" 0)
                           (DI.DynamicInfo [] [DI.genTerm x7]))
                        (Curry.DebugModule.Prelude.strict_return x7)
             DM.funcCallHook "catchFail"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x8, DI.genTerm x9]))
               (Curry.DebugModule.Prelude.strict_catchFail x8 x9)))
term_strict_readUnsafeXmlFile x1
  = DI.Term "readUnsafeXmlFile" (DI.SrcID "XML" 0) x1
 
strict_showXmlFile ::
                   (DM.DM dm) =>
                     Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char ->
                       dm (Curry.DebugModule.Prelude.IO dm Curry.DebugModule.Prelude.Unit)
strict_showXmlFile x1
  = DM.eval
      (DM.funcDeclHook "showXmlFile"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x5 <- do x2 <- Prelude.return x1
                      DM.funcCallHook "readXmlFile"
                        (DI.DebugInfo (DI.SrcID "XML" 0)
                           (DI.DynamicInfo [] [DI.genTerm x2]))
                        (strict_readXmlFile x2)
             x6 <- do x3 <- Prelude.return
                              (PC.partCall1 (Curry.DebugModule.Prelude.term_strict_putStr [])
                                 Curry.DebugModule.Prelude.strict_putStr)
                      x4 <- Prelude.return
                              (PC.partCall1 (term_strict_showXmlDoc []) strict_showXmlDoc)
                      DM.funcCallHook "."
                        (DI.DebugInfo (DI.SrcID "XML" 0)
                           (DI.DynamicInfo [] [DI.genTerm x3, DI.genTerm x4]))
                        (Curry.DebugModule.Prelude.op_Point x3 x4)
             DM.funcCallHook ">>="
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x5, DI.genTerm x6]))
               (Curry.DebugModule.Prelude.op_GtGtEq x5 x6)))
term_strict_showXmlFile x1
  = DI.Term "showXmlFile" (DI.SrcID "XML" 0) x1
 
strict_readFileWithXmlDocs ::
                           (DM.DM dm) =>
                             Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char ->
                               dm
                                 (Curry.DebugModule.Prelude.IO dm
                                    (Curry.DebugModule.Prelude.List XmlExp))
strict_readFileWithXmlDocs x1
  = DM.eval
      (DM.funcDeclHook "readFileWithXmlDocs"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x5 <- do x2 <- Prelude.return x1
                      DM.funcCallHook "readFile"
                        (DI.DebugInfo (DI.SrcID "XML" 0)
                           (DI.DynamicInfo [] [DI.genTerm x2]))
                        (Curry.DebugModule.Prelude.strict_readFile x2)
             x6 <- do x3 <- Prelude.return
                              (PC.partCall1 (Curry.DebugModule.Prelude.term_strict_return [])
                                 Curry.DebugModule.Prelude.strict_return)
                      x4 <- Prelude.return
                              (PC.partCall1 (term_strict_parseXmlString [])
                                 strict_parseXmlString)
                      DM.funcCallHook "."
                        (DI.DebugInfo (DI.SrcID "XML" 0)
                           (DI.DynamicInfo [] [DI.genTerm x3, DI.genTerm x4]))
                        (Curry.DebugModule.Prelude.op_Point x3 x4)
             DM.funcCallHook ">>="
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x5, DI.genTerm x6]))
               (Curry.DebugModule.Prelude.op_GtGtEq x5 x6)))
term_strict_readFileWithXmlDocs x1
  = DI.Term "readFileWithXmlDocs" (DI.SrcID "XML" 0) x1
 
strict_parseXmlString ::
                      (DM.DM dm) =>
                        Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char ->
                          dm (Curry.DebugModule.Prelude.List XmlExp)
strict_parseXmlString x1
  = DM.eval
      (DM.funcDeclHook "parseXmlString"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x5 <- do x3 <- do x2 <- Prelude.return x1
                               DM.funcCallHook "scanXmlString"
                                 (DI.DebugInfo (DI.SrcID "XML" 0)
                                    (DI.DynamicInfo [] [DI.genTerm x2]))
                                 (strict_scanXmlString x2)
                      x4 <- DM.constructorHook
                              (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                              (Prelude.return Curry.DebugModule.Prelude.Nothing)
                      DM.funcCallHook "parseXmlTokens"
                        (DI.DebugInfo (DI.SrcID "XML" 0)
                           (DI.DynamicInfo [] [DI.genTerm x3, DI.genTerm x4]))
                        (strict_parseXmlTokens x3 x4)
             DM.funcCallHook "fst"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x5]))
               (Curry.DebugModule.Prelude.strict_fst x5)))
term_strict_parseXmlString x1
  = DI.Term "parseXmlString" (DI.SrcID "XML" 0) x1
 
strict_parseXmlTokens ::
                      (DM.DM dm) =>
                        Curry.DebugModule.Prelude.List XmlExp ->
                          Curry.DebugModule.Prelude.Maybe
                            (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char)
                            ->
                            dm
                              (Curry.DebugModule.Prelude.Tuple2
                                 (Curry.DebugModule.Prelude.List XmlExp)
                                 (Curry.DebugModule.Prelude.List XmlExp))
strict_parseXmlTokens x1 x2
  = DM.eval
      (DM.funcDeclHook "parseXmlTokens"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x2]))
         (do x3 <- Prelude.return x2
             x4 <- Prelude.return x1
             DM.funcCallHook "_case_66"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x3, DI.genTerm x4]))
               (strict__case_66 x3 x4)))
term_strict_parseXmlTokens x1
  = DI.Term "parseXmlTokens" (DI.SrcID "XML" 0) x1
 
x'xstrict_parseXmlTokens46_35selFP835xexps ::
                                           (DM.DM dm) =>
                                             Curry.DebugModule.Prelude.Tuple2
                                               (Curry.DebugModule.Prelude.List XmlExp)
                                               (Curry.DebugModule.Prelude.List XmlExp)
                                               -> dm (Curry.DebugModule.Prelude.List XmlExp)
x'xstrict_parseXmlTokens46_35selFP835xexps x1
  = DM.eval
      (DM.funcDeclHook "parseXmlTokens._#selFP8#xexps"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_58"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_58 x2)))
x'xterm_strict_parseXmlTokens46_35selFP835xexps x1
  = DI.Term "parseXmlTokens._#selFP8#xexps" (DI.SrcID "XML" 0) x1
 
x'xstrict_parseXmlTokens46_35selFP935rem_xtokens ::
                                                 (DM.DM dm) =>
                                                   Curry.DebugModule.Prelude.Tuple2
                                                     (Curry.DebugModule.Prelude.List XmlExp)
                                                     (Curry.DebugModule.Prelude.List XmlExp)
                                                     -> dm (Curry.DebugModule.Prelude.List XmlExp)
x'xstrict_parseXmlTokens46_35selFP935rem_xtokens x1
  = DM.eval
      (DM.funcDeclHook "parseXmlTokens._#selFP9#rem_xtokens"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_57"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_57 x2)))
x'xterm_strict_parseXmlTokens46_35selFP935rem_xtokens x1
  = DI.Term "parseXmlTokens._#selFP9#rem_xtokens" (DI.SrcID "XML" 0)
      x1
 
x'xstrict_parseXmlTokens46_35selFP1435xexps1 ::
                                             (DM.DM dm) =>
                                               Curry.DebugModule.Prelude.Tuple2
                                                 (Curry.DebugModule.Prelude.List XmlExp)
                                                 (Curry.DebugModule.Prelude.List XmlExp)
                                                 -> dm (Curry.DebugModule.Prelude.List XmlExp)
x'xstrict_parseXmlTokens46_35selFP1435xexps1 x1
  = DM.eval
      (DM.funcDeclHook "parseXmlTokens._#selFP14#xexps1"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_56"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_56 x2)))
x'xterm_strict_parseXmlTokens46_35selFP1435xexps1 x1
  = DI.Term "parseXmlTokens._#selFP14#xexps1" (DI.SrcID "XML" 0) x1
 
x'xstrict_parseXmlTokens46_35selFP1535xtokens1 ::
                                               (DM.DM dm) =>
                                                 Curry.DebugModule.Prelude.Tuple2
                                                   (Curry.DebugModule.Prelude.List XmlExp)
                                                   (Curry.DebugModule.Prelude.List XmlExp)
                                                   -> dm (Curry.DebugModule.Prelude.List XmlExp)
x'xstrict_parseXmlTokens46_35selFP1535xtokens1 x1
  = DM.eval
      (DM.funcDeclHook "parseXmlTokens._#selFP15#xtokens1"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_55"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_55 x2)))
x'xterm_strict_parseXmlTokens46_35selFP1535xtokens1 x1
  = DI.Term "parseXmlTokens._#selFP15#xtokens1" (DI.SrcID "XML" 0) x1
 
x'xstrict_parseXmlTokens46_35selFP1235xexps ::
                                            (DM.DM dm) =>
                                              Curry.DebugModule.Prelude.Tuple2
                                                (Curry.DebugModule.Prelude.List XmlExp)
                                                (Curry.DebugModule.Prelude.List XmlExp)
                                                -> dm (Curry.DebugModule.Prelude.List XmlExp)
x'xstrict_parseXmlTokens46_35selFP1235xexps x1
  = DM.eval
      (DM.funcDeclHook "parseXmlTokens._#selFP12#xexps"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_54"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_54 x2)))
x'xterm_strict_parseXmlTokens46_35selFP1235xexps x1
  = DI.Term "parseXmlTokens._#selFP12#xexps" (DI.SrcID "XML" 0) x1
 
x'xstrict_parseXmlTokens46_35selFP1335rem_xtokens ::
                                                  (DM.DM dm) =>
                                                    Curry.DebugModule.Prelude.Tuple2
                                                      (Curry.DebugModule.Prelude.List XmlExp)
                                                      (Curry.DebugModule.Prelude.List XmlExp)
                                                      -> dm (Curry.DebugModule.Prelude.List XmlExp)
x'xstrict_parseXmlTokens46_35selFP1335rem_xtokens x1
  = DM.eval
      (DM.funcDeclHook "parseXmlTokens._#selFP13#rem_xtokens"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_53"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_53 x2)))
x'xterm_strict_parseXmlTokens46_35selFP1335rem_xtokens x1
  = DI.Term "parseXmlTokens._#selFP13#rem_xtokens" (DI.SrcID "XML" 0)
      x1
 
x'xstrict_parseXmlTokens46_35selFP1735xexps ::
                                            (DM.DM dm) =>
                                              Curry.DebugModule.Prelude.Tuple2
                                                (Curry.DebugModule.Prelude.List XmlExp)
                                                (Curry.DebugModule.Prelude.List XmlExp)
                                                -> dm (Curry.DebugModule.Prelude.List XmlExp)
x'xstrict_parseXmlTokens46_35selFP1735xexps x1
  = DM.eval
      (DM.funcDeclHook "parseXmlTokens._#selFP17#xexps"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_52"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_52 x2)))
x'xterm_strict_parseXmlTokens46_35selFP1735xexps x1
  = DI.Term "parseXmlTokens._#selFP17#xexps" (DI.SrcID "XML" 0) x1
 
x'xstrict_parseXmlTokens46_35selFP1835rem_xtokens ::
                                                  (DM.DM dm) =>
                                                    Curry.DebugModule.Prelude.Tuple2
                                                      (Curry.DebugModule.Prelude.List XmlExp)
                                                      (Curry.DebugModule.Prelude.List XmlExp)
                                                      -> dm (Curry.DebugModule.Prelude.List XmlExp)
x'xstrict_parseXmlTokens46_35selFP1835rem_xtokens x1
  = DM.eval
      (DM.funcDeclHook "parseXmlTokens._#selFP18#rem_xtokens"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_51"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_51 x2)))
x'xterm_strict_parseXmlTokens46_35selFP1835rem_xtokens x1
  = DI.Term "parseXmlTokens._#selFP18#rem_xtokens" (DI.SrcID "XML" 0)
      x1
 
x'xstrict_parseXmlTokens46_35selFP2035xexps ::
                                            (DM.DM dm) =>
                                              Curry.DebugModule.Prelude.Tuple2
                                                (Curry.DebugModule.Prelude.List XmlExp)
                                                (Curry.DebugModule.Prelude.List XmlExp)
                                                -> dm (Curry.DebugModule.Prelude.List XmlExp)
x'xstrict_parseXmlTokens46_35selFP2035xexps x1
  = DM.eval
      (DM.funcDeclHook "parseXmlTokens._#selFP20#xexps"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_50"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_50 x2)))
x'xterm_strict_parseXmlTokens46_35selFP2035xexps x1
  = DI.Term "parseXmlTokens._#selFP20#xexps" (DI.SrcID "XML" 0) x1
 
x'xstrict_parseXmlTokens46_35selFP2135rem_xtokens ::
                                                  (DM.DM dm) =>
                                                    Curry.DebugModule.Prelude.Tuple2
                                                      (Curry.DebugModule.Prelude.List XmlExp)
                                                      (Curry.DebugModule.Prelude.List XmlExp)
                                                      -> dm (Curry.DebugModule.Prelude.List XmlExp)
x'xstrict_parseXmlTokens46_35selFP2135rem_xtokens x1
  = DM.eval
      (DM.funcDeclHook "parseXmlTokens._#selFP21#rem_xtokens"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_49"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_49 x2)))
x'xterm_strict_parseXmlTokens46_35selFP2135rem_xtokens x1
  = DI.Term "parseXmlTokens._#selFP21#rem_xtokens" (DI.SrcID "XML" 0)
      x1
 
strict_scanXmlString ::
                     (DM.DM dm) =>
                       Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char ->
                         dm (Curry.DebugModule.Prelude.List XmlExp)
strict_scanXmlString x1
  = DM.eval
      (DM.funcDeclHook "scanXmlString"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x4 <- do x2 <- DM.funcCallHook "dropBlanks"
                              (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                              strict_dropBlanks
                      x3 <- Prelude.return x1
                      DM.funcCallHook "apply"
                        (DI.DebugInfo (DI.SrcID "XML" 0)
                           (DI.DynamicInfo [] [DI.genTerm x2, DI.genTerm x3]))
                        (Curry.DebugModule.Prelude.strict_apply x2 x3)
             DM.funcCallHook "scanXmlString.scanXml.191"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x4]))
               (x'xstrict_scanXmlString46scanXml46191 x4)))
term_strict_scanXmlString x1
  = DI.Term "scanXmlString" (DI.SrcID "XML" 0) x1
 
x'xstrict_scanXmlString46scanXml46191 ::
                                      (DM.DM dm) =>
                                        Curry.DebugModule.Prelude.List
                                          Curry.DebugModule.Prelude.Char
                                          -> dm (Curry.DebugModule.Prelude.List XmlExp)
x'xstrict_scanXmlString46scanXml46191 x1
  = DM.eval
      (DM.funcDeclHook "scanXmlString.scanXml.191"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_48"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_48 x2)))
x'xterm_strict_scanXmlString46scanXml46191 x1
  = DI.Term "scanXmlString.scanXml.191" (DI.SrcID "XML" 0) x1
 
x'xstrict_scanXmlString46scanXml4619146_35selFP2335initxt ::
                                                          (DM.DM dm) =>
                                                            Curry.DebugModule.Prelude.Tuple2
                                                              (Curry.DebugModule.Prelude.List
                                                                 Curry.DebugModule.Prelude.Char)
                                                              (Curry.DebugModule.Prelude.List
                                                                 Curry.DebugModule.Prelude.Char)
                                                              ->
                                                              dm
                                                                (Curry.DebugModule.Prelude.List
                                                                   Curry.DebugModule.Prelude.Char)
x'xstrict_scanXmlString46scanXml4619146_35selFP2335initxt x1
  = DM.eval
      (DM.funcDeclHook "scanXmlString.scanXml.191._#selFP23#initxt"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_46"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_46 x2)))
x'xterm_strict_scanXmlString46scanXml4619146_35selFP2335initxt x1
  = DI.Term "scanXmlString.scanXml.191._#selFP23#initxt"
      (DI.SrcID "XML" 0)
      x1
 
x'xstrict_scanXmlString46scanXml4619146_35selFP2435remtag ::
                                                          (DM.DM dm) =>
                                                            Curry.DebugModule.Prelude.Tuple2
                                                              (Curry.DebugModule.Prelude.List
                                                                 Curry.DebugModule.Prelude.Char)
                                                              (Curry.DebugModule.Prelude.List
                                                                 Curry.DebugModule.Prelude.Char)
                                                              ->
                                                              dm
                                                                (Curry.DebugModule.Prelude.List
                                                                   Curry.DebugModule.Prelude.Char)
x'xstrict_scanXmlString46scanXml4619146_35selFP2435remtag x1
  = DM.eval
      (DM.funcDeclHook "scanXmlString.scanXml.191._#selFP24#remtag"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_45"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_45 x2)))
x'xterm_strict_scanXmlString46scanXml4619146_35selFP2435remtag x1
  = DI.Term "scanXmlString.scanXml.191._#selFP24#remtag"
      (DI.SrcID "XML" 0)
      x1
 
strict_scanXmlText ::
                   (DM.DM dm) =>
                     Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char ->
                       dm
                         (Curry.DebugModule.Prelude.Tuple2
                            (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char)
                            (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char))
strict_scanXmlText x1
  = DM.eval
      (DM.funcDeclHook "scanXmlText"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_44"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_44 x2)))
term_strict_scanXmlText x1
  = DI.Term "scanXmlText" (DI.SrcID "XML" 0) x1
 
x'xstrict_scanXmlText46_35selFP2635txt ::
                                       (DM.DM dm) =>
                                         Curry.DebugModule.Prelude.Tuple2
                                           (Curry.DebugModule.Prelude.List
                                              Curry.DebugModule.Prelude.Char)
                                           (Curry.DebugModule.Prelude.List
                                              Curry.DebugModule.Prelude.Char)
                                           ->
                                           dm
                                             (Curry.DebugModule.Prelude.List
                                                Curry.DebugModule.Prelude.Char)
x'xstrict_scanXmlText46_35selFP2635txt x1
  = DM.eval
      (DM.funcDeclHook "scanXmlText._#selFP26#txt"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_39"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_39 x2)))
x'xterm_strict_scanXmlText46_35selFP2635txt x1
  = DI.Term "scanXmlText._#selFP26#txt" (DI.SrcID "XML" 0) x1
 
x'xstrict_scanXmlText46_35selFP2735rem ::
                                       (DM.DM dm) =>
                                         Curry.DebugModule.Prelude.Tuple2
                                           (Curry.DebugModule.Prelude.List
                                              Curry.DebugModule.Prelude.Char)
                                           (Curry.DebugModule.Prelude.List
                                              Curry.DebugModule.Prelude.Char)
                                           ->
                                           dm
                                             (Curry.DebugModule.Prelude.List
                                                Curry.DebugModule.Prelude.Char)
x'xstrict_scanXmlText46_35selFP2735rem x1
  = DM.eval
      (DM.funcDeclHook "scanXmlText._#selFP27#rem"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_38"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_38 x2)))
x'xterm_strict_scanXmlText46_35selFP2735rem x1
  = DI.Term "scanXmlText._#selFP27#rem" (DI.SrcID "XML" 0) x1
 
x'xstrict_scanXmlText46_35selFP2935txt ::
                                       (DM.DM dm) =>
                                         Curry.DebugModule.Prelude.Tuple2
                                           (Curry.DebugModule.Prelude.List
                                              Curry.DebugModule.Prelude.Char)
                                           (Curry.DebugModule.Prelude.List
                                              Curry.DebugModule.Prelude.Char)
                                           ->
                                           dm
                                             (Curry.DebugModule.Prelude.List
                                                Curry.DebugModule.Prelude.Char)
x'xstrict_scanXmlText46_35selFP2935txt x1
  = DM.eval
      (DM.funcDeclHook "scanXmlText._#selFP29#txt"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_37"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_37 x2)))
x'xterm_strict_scanXmlText46_35selFP2935txt x1
  = DI.Term "scanXmlText._#selFP29#txt" (DI.SrcID "XML" 0) x1
 
x'xstrict_scanXmlText46_35selFP3035rem ::
                                       (DM.DM dm) =>
                                         Curry.DebugModule.Prelude.Tuple2
                                           (Curry.DebugModule.Prelude.List
                                              Curry.DebugModule.Prelude.Char)
                                           (Curry.DebugModule.Prelude.List
                                              Curry.DebugModule.Prelude.Char)
                                           ->
                                           dm
                                             (Curry.DebugModule.Prelude.List
                                                Curry.DebugModule.Prelude.Char)
x'xstrict_scanXmlText46_35selFP3035rem x1
  = DM.eval
      (DM.funcDeclHook "scanXmlText._#selFP30#rem"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_36"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_36 x2)))
x'xterm_strict_scanXmlText46_35selFP3035rem x1
  = DI.Term "scanXmlText._#selFP30#rem" (DI.SrcID "XML" 0) x1
 
strict_scanXmlElem ::
                   (DM.DM dm) =>
                     Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char ->
                       dm (Curry.DebugModule.Prelude.List XmlExp)
strict_scanXmlElem x1
  = DM.eval
      (DM.funcDeclHook "scanXmlElem"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_35"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_35 x2)))
term_strict_scanXmlElem x1
  = DI.Term "scanXmlElem" (DI.SrcID "XML" 0) x1
 
strict_scanXmlElemName ::
                       (DM.DM dm) =>
                         Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char ->
                           Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char ->
                             dm (Curry.DebugModule.Prelude.List XmlExp)
strict_scanXmlElemName x1 x2
  = DM.eval
      (DM.funcDeclHook "scanXmlElemName"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x2]))
         (do x3 <- Prelude.return x1
             x4 <- Prelude.return x2
             DM.funcCallHook "_case_30"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x3, DI.genTerm x4]))
               (strict__case_30 x3 x4)))
term_strict_scanXmlElemName x1
  = DI.Term "scanXmlElemName" (DI.SrcID "XML" 0) x1
 
x'xstrict_scanXmlElemName46_35selFP3235attrs ::
                                             (DM.DM dm) =>
                                               Curry.DebugModule.Prelude.Tuple2
                                                 (Curry.DebugModule.Prelude.List
                                                    (Curry.DebugModule.Prelude.Tuple2
                                                       (Curry.DebugModule.Prelude.List
                                                          Curry.DebugModule.Prelude.Char)
                                                       (Curry.DebugModule.Prelude.List
                                                          Curry.DebugModule.Prelude.Char)))
                                                 (Curry.DebugModule.Prelude.List
                                                    Curry.DebugModule.Prelude.Char)
                                                 ->
                                                 dm
                                                   (Curry.DebugModule.Prelude.List
                                                      (Curry.DebugModule.Prelude.Tuple2
                                                         (Curry.DebugModule.Prelude.List
                                                            Curry.DebugModule.Prelude.Char)
                                                         (Curry.DebugModule.Prelude.List
                                                            Curry.DebugModule.Prelude.Char)))
x'xstrict_scanXmlElemName46_35selFP3235attrs x1
  = DM.eval
      (DM.funcDeclHook "scanXmlElemName._#selFP32#attrs"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_24"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_24 x2)))
x'xterm_strict_scanXmlElemName46_35selFP3235attrs x1
  = DI.Term "scanXmlElemName._#selFP32#attrs" (DI.SrcID "XML" 0) x1
 
x'xstrict_scanXmlElemName46_35selFP3335rest ::
                                            (DM.DM dm) =>
                                              Curry.DebugModule.Prelude.Tuple2
                                                (Curry.DebugModule.Prelude.List
                                                   (Curry.DebugModule.Prelude.Tuple2
                                                      (Curry.DebugModule.Prelude.List
                                                         Curry.DebugModule.Prelude.Char)
                                                      (Curry.DebugModule.Prelude.List
                                                         Curry.DebugModule.Prelude.Char)))
                                                (Curry.DebugModule.Prelude.List
                                                   Curry.DebugModule.Prelude.Char)
                                                ->
                                                dm
                                                  (Curry.DebugModule.Prelude.List
                                                     Curry.DebugModule.Prelude.Char)
x'xstrict_scanXmlElemName46_35selFP3335rest x1
  = DM.eval
      (DM.funcDeclHook "scanXmlElemName._#selFP33#rest"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_23"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_23 x2)))
x'xterm_strict_scanXmlElemName46_35selFP3335rest x1
  = DI.Term "scanXmlElemName._#selFP33#rest" (DI.SrcID "XML" 0) x1
 
strict_scanXmlComment ::
                      (DM.DM dm) =>
                        Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char ->
                          dm (Curry.DebugModule.Prelude.List XmlExp)
strict_scanXmlComment x1
  = DM.eval
      (DM.funcDeclHook "scanXmlComment"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_22"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_22 x2)))
term_strict_scanXmlComment x1
  = DI.Term "scanXmlComment" (DI.SrcID "XML" 0) x1
 
strict_scanXmlCData ::
                    (DM.DM dm) =>
                      Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char ->
                        dm (Curry.DebugModule.Prelude.List XmlExp)
strict_scanXmlCData x1
  = DM.eval
      (DM.funcDeclHook "scanXmlCData"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (DM.letHook
            (DI.DebugInfo (DI.SrcID "DummyModule" 42) (DI.DynamicInfo [] []))
            (do x2 <- do x3 <- Prelude.return x1
                         DM.funcCallHook "dropCData"
                           (DI.DebugInfo (DI.SrcID "XML" 0)
                              (DI.DynamicInfo [] [DI.genTerm x3]))
                           (strict_dropCData x3)
                DM.eval
                  (do x7 <- Prelude.return x2
                      x8 <- do x5 <- do x4 <- Prelude.return x2
                                        DM.funcCallHook "head"
                                          (DI.DebugInfo (DI.SrcID "XML" 0)
                                             (DI.DynamicInfo [] [DI.genTerm x4]))
                                          (Curry.DebugModule.Prelude.strict_head x4)
                               x6 <- DM.litHook
                                       (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                       (Prelude.return (Curry.DebugModule.Prelude.Char '>'))
                               DM.funcCallHook "=="
                                 (DI.DebugInfo (DI.SrcID "XML" 0)
                                    (DI.DynamicInfo [] [DI.genTerm x5, DI.genTerm x6]))
                                 (Curry.DebugModule.Prelude.op_EqEq x5 x6)
                      DM.funcCallHook "_case_20"
                        (DI.DebugInfo (DI.SrcID "XML" 0)
                           (DI.DynamicInfo [] [DI.genTerm x7, DI.genTerm x8]))
                        (strict__case_20 x7 x8)))))
term_strict_scanXmlCData x1
  = DI.Term "scanXmlCData" (DI.SrcID "XML" 0) x1
 
strict_dropCData ::
                 (DM.DM dm) =>
                   Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char ->
                     dm (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char)
strict_dropCData x1
  = DM.eval
      (DM.funcDeclHook "dropCData"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_19"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_19 x2)))
term_strict_dropCData x1
  = DI.Term "dropCData" (DI.SrcID "XML" 0) x1
 
strict_scanXmlProcInstr ::
                        (DM.DM dm) =>
                          Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char ->
                            dm (Curry.DebugModule.Prelude.List XmlExp)
strict_scanXmlProcInstr x1
  = DM.eval
      (DM.funcDeclHook "scanXmlProcInstr"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_15"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_15 x2)))
term_strict_scanXmlProcInstr x1
  = DI.Term "scanXmlProcInstr" (DI.SrcID "XML" 0) x1
 
strict_parseAttrs ::
                  (DM.DM dm) =>
                    Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char ->
                      dm
                        (Curry.DebugModule.Prelude.Tuple2
                           (Curry.DebugModule.Prelude.List
                              (Curry.DebugModule.Prelude.Tuple2
                                 (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char)
                                 (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char)))
                           (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char))
strict_parseAttrs x1
  = DM.eval
      (DM.funcDeclHook "parseAttrs"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_13"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_13 x2)))
term_strict_parseAttrs x1
  = DI.Term "parseAttrs" (DI.SrcID "XML" 0) x1
 
x'xstrict_parseAttrs46_35selFP4135name ::
                                       (DM.DM dm) =>
                                         Curry.DebugModule.Prelude.Tuple2
                                           (Curry.DebugModule.Prelude.List
                                              Curry.DebugModule.Prelude.Char)
                                           (Curry.DebugModule.Prelude.List
                                              Curry.DebugModule.Prelude.Char)
                                           ->
                                           dm
                                             (Curry.DebugModule.Prelude.List
                                                Curry.DebugModule.Prelude.Char)
x'xstrict_parseAttrs46_35selFP4135name x1
  = DM.eval
      (DM.funcDeclHook "parseAttrs._#selFP41#name"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_10"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_10 x2)))
x'xterm_strict_parseAttrs46_35selFP4135name x1
  = DI.Term "parseAttrs._#selFP41#name" (DI.SrcID "XML" 0) x1
 
x'xstrict_parseAttrs46_35selFP4235rest1 ::
                                        (DM.DM dm) =>
                                          Curry.DebugModule.Prelude.Tuple2
                                            (Curry.DebugModule.Prelude.List
                                               Curry.DebugModule.Prelude.Char)
                                            (Curry.DebugModule.Prelude.List
                                               Curry.DebugModule.Prelude.Char)
                                            ->
                                            dm
                                              (Curry.DebugModule.Prelude.List
                                                 Curry.DebugModule.Prelude.Char)
x'xstrict_parseAttrs46_35selFP4235rest1 x1
  = DM.eval
      (DM.funcDeclHook "parseAttrs._#selFP42#rest1"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_9"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_9 x2)))
x'xterm_strict_parseAttrs46_35selFP4235rest1 x1
  = DI.Term "parseAttrs._#selFP42#rest1" (DI.SrcID "XML" 0) x1
 
x'xstrict_parseAttrs46_35selFP3935value ::
                                        (DM.DM dm) =>
                                          Curry.DebugModule.Prelude.Tuple2
                                            (Curry.DebugModule.Prelude.List
                                               Curry.DebugModule.Prelude.Char)
                                            (Curry.DebugModule.Prelude.List
                                               Curry.DebugModule.Prelude.Char)
                                            ->
                                            dm
                                              (Curry.DebugModule.Prelude.List
                                                 Curry.DebugModule.Prelude.Char)
x'xstrict_parseAttrs46_35selFP3935value x1
  = DM.eval
      (DM.funcDeclHook "parseAttrs._#selFP39#value"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_8"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_8 x2)))
x'xterm_strict_parseAttrs46_35selFP3935value x1
  = DI.Term "parseAttrs._#selFP39#value" (DI.SrcID "XML" 0) x1
 
x'xstrict_parseAttrs46_35selFP4035rest2 ::
                                        (DM.DM dm) =>
                                          Curry.DebugModule.Prelude.Tuple2
                                            (Curry.DebugModule.Prelude.List
                                               Curry.DebugModule.Prelude.Char)
                                            (Curry.DebugModule.Prelude.List
                                               Curry.DebugModule.Prelude.Char)
                                            ->
                                            dm
                                              (Curry.DebugModule.Prelude.List
                                                 Curry.DebugModule.Prelude.Char)
x'xstrict_parseAttrs46_35selFP4035rest2 x1
  = DM.eval
      (DM.funcDeclHook "parseAttrs._#selFP40#rest2"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_7"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_7 x2)))
x'xterm_strict_parseAttrs46_35selFP4035rest2 x1
  = DI.Term "parseAttrs._#selFP40#rest2" (DI.SrcID "XML" 0) x1
 
x'xstrict_parseAttrs46_35selFP3735rem_attrs ::
                                            (DM.DM dm) =>
                                              Curry.DebugModule.Prelude.Tuple2
                                                (Curry.DebugModule.Prelude.List
                                                   (Curry.DebugModule.Prelude.Tuple2
                                                      (Curry.DebugModule.Prelude.List
                                                         Curry.DebugModule.Prelude.Char)
                                                      (Curry.DebugModule.Prelude.List
                                                         Curry.DebugModule.Prelude.Char)))
                                                (Curry.DebugModule.Prelude.List
                                                   Curry.DebugModule.Prelude.Char)
                                                ->
                                                dm
                                                  (Curry.DebugModule.Prelude.List
                                                     (Curry.DebugModule.Prelude.Tuple2
                                                        (Curry.DebugModule.Prelude.List
                                                           Curry.DebugModule.Prelude.Char)
                                                        (Curry.DebugModule.Prelude.List
                                                           Curry.DebugModule.Prelude.Char)))
x'xstrict_parseAttrs46_35selFP3735rem_attrs x1
  = DM.eval
      (DM.funcDeclHook "parseAttrs._#selFP37#rem_attrs"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_6"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_6 x2)))
x'xterm_strict_parseAttrs46_35selFP3735rem_attrs x1
  = DI.Term "parseAttrs._#selFP37#rem_attrs" (DI.SrcID "XML" 0) x1
 
x'xstrict_parseAttrs46_35selFP3835rem_inp ::
                                          (DM.DM dm) =>
                                            Curry.DebugModule.Prelude.Tuple2
                                              (Curry.DebugModule.Prelude.List
                                                 (Curry.DebugModule.Prelude.Tuple2
                                                    (Curry.DebugModule.Prelude.List
                                                       Curry.DebugModule.Prelude.Char)
                                                    (Curry.DebugModule.Prelude.List
                                                       Curry.DebugModule.Prelude.Char)))
                                              (Curry.DebugModule.Prelude.List
                                                 Curry.DebugModule.Prelude.Char)
                                              ->
                                              dm
                                                (Curry.DebugModule.Prelude.List
                                                   Curry.DebugModule.Prelude.Char)
x'xstrict_parseAttrs46_35selFP3835rem_inp x1
  = DM.eval
      (DM.funcDeclHook "parseAttrs._#selFP38#rem_inp"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_5"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_5 x2)))
x'xterm_strict_parseAttrs46_35selFP3835rem_inp x1
  = DI.Term "parseAttrs._#selFP38#rem_inp" (DI.SrcID "XML" 0) x1
 
strict_dropBlanks ::
                  (DM.DM dm) =>
                    dm
                      (DM.Func dm
                         (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char)
                         (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char))
strict_dropBlanks
  = DM.eval
      (DM.funcDeclHook "dropBlanks"
         (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
         (do x0 <- Prelude.return
                     (PC.partCall1 (Curry.DebugModule.Char.term_strict_isSpace [])
                        Curry.DebugModule.Char.strict_isSpace)
             Prelude.return
               (PC.partCall1
                  (Curry.DebugModule.Prelude.term_strict_dropWhile [DI.genTerm x0])
                  (Curry.DebugModule.Prelude.strict_dropWhile x0))))
 
strict_splitAtChar ::
                   (DM.DM dm, DI.GenTerm a) =>
                     a ->
                       Curry.DebugModule.Prelude.List a ->
                         dm
                           (Curry.DebugModule.Prelude.Tuple2
                              (Curry.DebugModule.Prelude.List a)
                              (Curry.DebugModule.Prelude.List a))
strict_splitAtChar x1 x2
  = DM.eval
      (DM.funcDeclHook "splitAtChar"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x2]))
         (do x3 <- Prelude.return x1
             x4 <- Prelude.return x2
             DM.funcCallHook "_case_4"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x3, DI.genTerm x4]))
               (strict__case_4 x3 x4)))
term_strict_splitAtChar x1
  = DI.Term "splitAtChar" (DI.SrcID "XML" 0) x1
 
x'xstrict_splitAtChar46_35selFP4435first ::
                                         (DM.DM dm, DI.GenTerm x231) =>
                                           Curry.DebugModule.Prelude.Tuple2
                                             (Curry.DebugModule.Prelude.List x231)
                                             (Curry.DebugModule.Prelude.List x231)
                                             -> dm (Curry.DebugModule.Prelude.List x231)
x'xstrict_splitAtChar46_35selFP4435first x1
  = DM.eval
      (DM.funcDeclHook "splitAtChar._#selFP44#first"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_2"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_2 x2)))
x'xterm_strict_splitAtChar46_35selFP4435first x1
  = DI.Term "splitAtChar._#selFP44#first" (DI.SrcID "XML" 0) x1
 
x'xstrict_splitAtChar46_35selFP4535rest ::
                                        (DM.DM dm, DI.GenTerm x231) =>
                                          Curry.DebugModule.Prelude.Tuple2
                                            (Curry.DebugModule.Prelude.List x231)
                                            (Curry.DebugModule.Prelude.List x231)
                                            -> dm (Curry.DebugModule.Prelude.List x231)
x'xstrict_splitAtChar46_35selFP4535rest x1
  = DM.eval
      (DM.funcDeclHook "splitAtChar._#selFP45#rest"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_1"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_1 x2)))
x'xterm_strict_splitAtChar46_35selFP4535rest x1
  = DI.Term "splitAtChar._#selFP45#rest" (DI.SrcID "XML" 0) x1
 
strict_textOfXml ::
                 (DM.DM dm) =>
                   Curry.DebugModule.Prelude.List XmlExp ->
                     dm (Curry.DebugModule.Prelude.List Curry.DebugModule.Prelude.Char)
strict_textOfXml x1
  = DM.eval
      (DM.funcDeclHook "textOfXml"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x12 <- do x10 <- do x2 <- DM.litHook
                                         (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                         (Prelude.return (Curry.DebugModule.Prelude.Char ' '))
                                 x3 <- DM.constructorHook
                                         (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                         (Prelude.return Curry.DebugModule.Prelude.Nil)
                                 DM.constructorHook
                                   (DI.DebugInfo (DI.SrcID "XML" 0)
                                      (DI.DynamicInfo [] [DI.genTerm x2, DI.genTerm x3]))
                                   (Prelude.return (Curry.DebugModule.Prelude.Cons x2 x3))
                       x11 <- do x8 <- do x4 <- Prelude.return
                                                  (PC.partCall1
                                                     (Curry.DebugModule.Prelude.term_strict_not [])
                                                     Curry.DebugModule.Prelude.strict_not)
                                          x5 <- Prelude.return
                                                  (PC.partCall1
                                                     (Curry.DebugModule.Prelude.term_strict_null [])
                                                     Curry.DebugModule.Prelude.strict_null)
                                          DM.funcCallHook "."
                                            (DI.DebugInfo (DI.SrcID "XML" 0)
                                               (DI.DynamicInfo [] [DI.genTerm x4, DI.genTerm x5]))
                                            (Curry.DebugModule.Prelude.op_Point x4 x5)
                                 x9 <- do x6 <- Prelude.return
                                                  (PC.partCall1
                                                     (x'xterm_strict_textOfXml46textOfXmlItem46255
                                                        [])
                                                     x'xstrict_textOfXml46textOfXmlItem46255)
                                          x7 <- Prelude.return x1
                                          DM.funcCallHook "map"
                                            (DI.DebugInfo (DI.SrcID "XML" 0)
                                               (DI.DynamicInfo [] [DI.genTerm x6, DI.genTerm x7]))
                                            (Curry.DebugModule.Prelude.strict_map x6 x7)
                                 DM.funcCallHook "filter"
                                   (DI.DebugInfo (DI.SrcID "XML" 0)
                                      (DI.DynamicInfo [] [DI.genTerm x8, DI.genTerm x9]))
                                   (Curry.DebugModule.Prelude.strict_filter x8 x9)
                       DM.funcCallHook "intersperse"
                         (DI.DebugInfo (DI.SrcID "XML" 0)
                            (DI.DynamicInfo [] [DI.genTerm x10, DI.genTerm x11]))
                         (Curry.DebugModule.List.strict_intersperse x10 x11)
             DM.funcCallHook "concat"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x12]))
               (Curry.DebugModule.Prelude.strict_concat x12)))
term_strict_textOfXml x1
  = DI.Term "textOfXml" (DI.SrcID "XML" 0) x1
 
x'xstrict_textOfXml46textOfXmlItem46255 ::
                                        (DM.DM dm) =>
                                          XmlExp ->
                                            dm
                                              (Curry.DebugModule.Prelude.List
                                                 Curry.DebugModule.Prelude.Char)
x'xstrict_textOfXml46textOfXmlItem46255 x1
  = DM.eval
      (DM.funcDeclHook "textOfXml.textOfXmlItem.255"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.funcCallHook "_case_0"
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (strict__case_0 x2)))
x'xterm_strict_textOfXml46textOfXmlItem46255 x1
  = DI.Term "textOfXml.textOfXmlItem.255" (DI.SrcID "XML" 0) x1
strict__case_0 x1
  = DM.eval
      (DM.funcDeclHook "_case_0"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x7 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x7]))
               (case x7 of
                    XText x2
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x2))
                    XElem x3 x4 x5
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x6 <- Prelude.return x5
                                  DM.funcCallHook "textOfXml"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x6]))
                                    (strict_textOfXml x6)))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x7])))
                           strict__case_0
                           x7)))
term_strict__case_0 x1 = DI.Term "_case_0" (DI.SrcID "XML" 0) x1
strict__case_1 x1
  = DM.eval
      (DM.funcDeclHook "_case_1"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x4 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x4]))
               (case x4 of
                    Curry.DebugModule.Prelude.Tuple2 x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x3))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x4])))
                           strict__case_1
                           x4)))
term_strict__case_1 x1 = DI.Term "_case_1" (DI.SrcID "XML" 0) x1
strict__case_2 x1
  = DM.eval
      (DM.funcDeclHook "_case_2"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x4 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x4]))
               (case x4 of
                    Curry.DebugModule.Prelude.Tuple2 x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x2))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x4])))
                           strict__case_2
                           x4)))
term_strict__case_2 x1 = DI.Term "_case_2" (DI.SrcID "XML" 0) x1
strict__case_4 x1 x2
  = DM.eval
      (DM.funcDeclHook "_case_4"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x2]))
         (do x13 <- Prelude.return x2
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x13]))
               (case x13 of
                    Curry.DebugModule.Prelude.Nil
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x5 <- DM.constructorHook
                                          (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                          (Prelude.return Curry.DebugModule.Prelude.Nil)
                                  x6 <- DM.constructorHook
                                          (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                          (Prelude.return Curry.DebugModule.Prelude.Nil)
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x5, DI.genTerm x6]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Tuple2 x5 x6))))
                    Curry.DebugModule.Prelude.Cons x3 x4
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x9 <- Prelude.return x1
                                  x10 <- Prelude.return x3
                                  x11 <- Prelude.return x4
                                  x12 <- do x7 <- Prelude.return x3
                                            x8 <- Prelude.return x1
                                            DM.funcCallHook "=="
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo [] [DI.genTerm x7, DI.genTerm x8]))
                                              (Curry.DebugModule.Prelude.op_EqEq x7 x8)
                                  DM.funcCallHook "_case_3"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x9, DI.genTerm x10, DI.genTerm x11,
                                           DI.genTerm x12]))
                                    (strict__case_3 x9 x10 x11 x12)))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x13])))
                           (strict__case_4 x1)
                           x13)))
term_strict__case_4 x1 = DI.Term "_case_4" (DI.SrcID "XML" 0) x1
strict__case_3 x1 x3 x4 x8
  = DM.eval
      (DM.funcDeclHook "_case_3"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo []
               [DI.genTerm x1, DI.genTerm x3, DI.genTerm x4, DI.genTerm x8]))
         (do x19 <- Prelude.return x8
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x19]))
               (case x19 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x9 <- DM.constructorHook
                                          (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                          (Prelude.return Curry.DebugModule.Prelude.Nil)
                                  x10 <- Prelude.return x4
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x9, DI.genTerm x10]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Tuple2 x9 x10))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.letHook
                                 (DI.DebugInfo (DI.SrcID "DummyModule" 42) (DI.DynamicInfo [] []))
                                 (do x5 <- do x11 <- Prelude.return x1
                                              x12 <- Prelude.return x4
                                              DM.funcCallHook "splitAtChar"
                                                (DI.DebugInfo (DI.SrcID "XML" 0)
                                                   (DI.DynamicInfo []
                                                      [DI.genTerm x11, DI.genTerm x12]))
                                                (strict_splitAtChar x11 x12)
                                     DM.eval
                                       (DM.letHook
                                          (DI.DebugInfo (DI.SrcID "DummyModule" 42)
                                             (DI.DynamicInfo [] []))
                                          (do x6 <- do x13 <- Prelude.return x5
                                                       DM.funcCallHook "splitAtChar._#selFP44#first"
                                                         (DI.DebugInfo (DI.SrcID "XML" 0)
                                                            (DI.DynamicInfo [] [DI.genTerm x13]))
                                                         (x'xstrict_splitAtChar46_35selFP4435first
                                                            x13)
                                              DM.eval
                                                (DM.letHook
                                                   (DI.DebugInfo (DI.SrcID "DummyModule" 42)
                                                      (DI.DynamicInfo [] []))
                                                   (do x7 <- do x14 <- Prelude.return x5
                                                                DM.funcCallHook
                                                                  "splitAtChar._#selFP45#rest"
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x14]))
                                                                  (x'xstrict_splitAtChar46_35selFP4535rest
                                                                     x14)
                                                       DM.eval
                                                         (do x17 <- do x15 <- Prelude.return x3
                                                                       x16 <- Prelude.return x6
                                                                       DM.constructorHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo []
                                                                               [DI.genTerm x15,
                                                                                DI.genTerm x16]))
                                                                         (Prelude.return
                                                                            (Curry.DebugModule.Prelude.Cons
                                                                               x15
                                                                               x16))
                                                             x18 <- Prelude.return x7
                                                             DM.constructorHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo []
                                                                     [DI.genTerm x17,
                                                                      DI.genTerm x18]))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Tuple2
                                                                     x17
                                                                     x18))))))))))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x19])))
                           (strict__case_3 x1 x3 x4)
                           x19)))
term_strict__case_3 x1 = DI.Term "_case_3" (DI.SrcID "XML" 0) x1
strict__case_5 x1
  = DM.eval
      (DM.funcDeclHook "_case_5"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x4 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x4]))
               (case x4 of
                    Curry.DebugModule.Prelude.Tuple2 x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x3))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x4])))
                           strict__case_5
                           x4)))
term_strict__case_5 x1 = DI.Term "_case_5" (DI.SrcID "XML" 0) x1
strict__case_6 x1
  = DM.eval
      (DM.funcDeclHook "_case_6"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x4 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x4]))
               (case x4 of
                    Curry.DebugModule.Prelude.Tuple2 x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x2))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x4])))
                           strict__case_6
                           x4)))
term_strict__case_6 x1 = DI.Term "_case_6" (DI.SrcID "XML" 0) x1
strict__case_7 x1
  = DM.eval
      (DM.funcDeclHook "_case_7"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x4 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x4]))
               (case x4 of
                    Curry.DebugModule.Prelude.Tuple2 x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x3))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x4])))
                           strict__case_7
                           x4)))
term_strict__case_7 x1 = DI.Term "_case_7" (DI.SrcID "XML" 0) x1
strict__case_8 x1
  = DM.eval
      (DM.funcDeclHook "_case_8"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x4 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x4]))
               (case x4 of
                    Curry.DebugModule.Prelude.Tuple2 x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x2))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x4])))
                           strict__case_8
                           x4)))
term_strict__case_8 x1 = DI.Term "_case_8" (DI.SrcID "XML" 0) x1
strict__case_9 x1
  = DM.eval
      (DM.funcDeclHook "_case_9"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x4 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x4]))
               (case x4 of
                    Curry.DebugModule.Prelude.Tuple2 x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x3))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x4])))
                           strict__case_9
                           x4)))
term_strict__case_9 x1 = DI.Term "_case_9" (DI.SrcID "XML" 0) x1
strict__case_10 x1
  = DM.eval
      (DM.funcDeclHook "_case_10"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x4 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x4]))
               (case x4 of
                    Curry.DebugModule.Prelude.Tuple2 x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x2))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x4])))
                           strict__case_10
                           x4)))
term_strict__case_10 x1 = DI.Term "_case_10" (DI.SrcID "XML" 0) x1
strict__case_13 x1
  = DM.eval
      (DM.funcDeclHook "_case_13"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x10 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x10]))
               (case x10 of
                    Curry.DebugModule.Prelude.Nil
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x4 <- DM.constructorHook
                                          (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                          (Prelude.return Curry.DebugModule.Prelude.Nil)
                                  x5 <- DM.constructorHook
                                          (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                          (Prelude.return Curry.DebugModule.Prelude.Nil)
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x4, DI.genTerm x5]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Tuple2 x4 x5))))
                    Curry.DebugModule.Prelude.Cons x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x7 <- Prelude.return x2
                                  x8 <- Prelude.return x3
                                  x9 <- do x6 <- Prelude.return x2
                                           DM.funcCallHook "isAlpha"
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x6]))
                                             (Curry.DebugModule.Char.strict_isAlpha x6)
                                  DM.funcCallHook "_case_12"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x7, DI.genTerm x8, DI.genTerm x9]))
                                    (strict__case_12 x7 x8 x9)))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x10])))
                           strict__case_13
                           x10)))
term_strict__case_13 x1 = DI.Term "_case_13" (DI.SrcID "XML" 0) x1
strict__case_12 x2 x3 x13
  = DM.eval
      (DM.funcDeclHook "_case_12"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x2, DI.genTerm x3, DI.genTerm x13]))
         (do x40 <- Prelude.return x13
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x40]))
               (case x40 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.letHook
                                 (DI.DebugInfo (DI.SrcID "DummyModule" 42) (DI.DynamicInfo [] []))
                                 (do x4 <- do x16 <- DM.litHook
                                                       (DI.DebugInfo (DI.SrcID "XML" 0)
                                                          (DI.DynamicInfo [] []))
                                                       (Prelude.return
                                                          (Curry.DebugModule.Prelude.Char '='))
                                              x17 <- do x14 <- Prelude.return x2
                                                        x15 <- Prelude.return x3
                                                        DM.constructorHook
                                                          (DI.DebugInfo (DI.SrcID "XML" 0)
                                                             (DI.DynamicInfo []
                                                                [DI.genTerm x14, DI.genTerm x15]))
                                                          (Prelude.return
                                                             (Curry.DebugModule.Prelude.Cons x14
                                                                x15))
                                              DM.funcCallHook "splitAtChar"
                                                (DI.DebugInfo (DI.SrcID "XML" 0)
                                                   (DI.DynamicInfo []
                                                      [DI.genTerm x16, DI.genTerm x17]))
                                                (strict_splitAtChar x16 x17)
                                     DM.eval
                                       (DM.letHook
                                          (DI.DebugInfo (DI.SrcID "DummyModule" 42)
                                             (DI.DynamicInfo [] []))
                                          (do x5 <- do x18 <- Prelude.return x4
                                                       DM.funcCallHook "parseAttrs._#selFP41#name"
                                                         (DI.DebugInfo (DI.SrcID "XML" 0)
                                                            (DI.DynamicInfo [] [DI.genTerm x18]))
                                                         (x'xstrict_parseAttrs46_35selFP4135name
                                                            x18)
                                              DM.eval
                                                (DM.letHook
                                                   (DI.DebugInfo (DI.SrcID "DummyModule" 42)
                                                      (DI.DynamicInfo [] []))
                                                   (do x6 <- do x19 <- Prelude.return x4
                                                                DM.funcCallHook
                                                                  "parseAttrs._#selFP42#rest1"
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x19]))
                                                                  (x'xstrict_parseAttrs46_35selFP4235rest1
                                                                     x19)
                                                       DM.eval
                                                         (DM.letHook
                                                            (DI.DebugInfo
                                                               (DI.SrcID "DummyModule" 42)
                                                               (DI.DynamicInfo [] []))
                                                            (do x7 <- do x21 <- DM.litHook
                                                                                  (DI.DebugInfo
                                                                                     (DI.SrcID "XML"
                                                                                        0)
                                                                                     (DI.DynamicInfo
                                                                                        []
                                                                                        []))
                                                                                  (Prelude.return
                                                                                     (Curry.DebugModule.Prelude.Char
                                                                                        '"'))
                                                                         x22 <- do x20 <- Prelude.return
                                                                                            x6
                                                                                   DM.funcCallHook
                                                                                     "tail"
                                                                                     (DI.DebugInfo
                                                                                        (DI.SrcID
                                                                                           "XML"
                                                                                           0)
                                                                                        (DI.DynamicInfo
                                                                                           []
                                                                                           [DI.genTerm
                                                                                              x20]))
                                                                                     (Curry.DebugModule.Prelude.strict_tail
                                                                                        x20)
                                                                         DM.funcCallHook
                                                                           "splitAtChar"
                                                                           (DI.DebugInfo
                                                                              (DI.SrcID "XML" 0)
                                                                              (DI.DynamicInfo []
                                                                                 [DI.genTerm x21,
                                                                                  DI.genTerm x22]))
                                                                           (strict_splitAtChar x21
                                                                              x22)
                                                                DM.eval
                                                                  (DM.letHook
                                                                     (DI.DebugInfo
                                                                        (DI.SrcID "DummyModule" 42)
                                                                        (DI.DynamicInfo [] []))
                                                                     (do x8 <- do x23 <- Prelude.return
                                                                                           x7
                                                                                  DM.funcCallHook
                                                                                    "parseAttrs._#selFP39#value"
                                                                                    (DI.DebugInfo
                                                                                       (DI.SrcID
                                                                                          "XML"
                                                                                          0)
                                                                                       (DI.DynamicInfo
                                                                                          []
                                                                                          [DI.genTerm
                                                                                             x23]))
                                                                                    (x'xstrict_parseAttrs46_35selFP3935value
                                                                                       x23)
                                                                         DM.eval
                                                                           (DM.letHook
                                                                              (DI.DebugInfo
                                                                                 (DI.SrcID
                                                                                    "DummyModule"
                                                                                    42)
                                                                                 (DI.DynamicInfo []
                                                                                    []))
                                                                              (do x9 <- do x24 <- Prelude.return
                                                                                                    x7
                                                                                           DM.funcCallHook
                                                                                             "parseAttrs._#selFP40#rest2"
                                                                                             (DI.DebugInfo
                                                                                                (DI.SrcID
                                                                                                   "XML"
                                                                                                   0)
                                                                                                (DI.DynamicInfo
                                                                                                   []
                                                                                                   [DI.genTerm
                                                                                                      x24]))
                                                                                             (x'xstrict_parseAttrs46_35selFP4035rest2
                                                                                                x24)
                                                                                  DM.eval
                                                                                    (DM.letHook
                                                                                       (DI.DebugInfo
                                                                                          (DI.SrcID
                                                                                             "DummyModule"
                                                                                             42)
                                                                                          (DI.DynamicInfo
                                                                                             []
                                                                                             []))
                                                                                       (do x10 <- do x27 <- do x25 <- DM.funcCallHook
                                                                                                                        "dropBlanks"
                                                                                                                        (DI.DebugInfo
                                                                                                                           (DI.SrcID
                                                                                                                              "XML"
                                                                                                                              0)
                                                                                                                           (DI.DynamicInfo
                                                                                                                              []
                                                                                                                              []))
                                                                                                                        strict_dropBlanks
                                                                                                               x26 <- Prelude.return
                                                                                                                        x9
                                                                                                               DM.funcCallHook
                                                                                                                 "apply"
                                                                                                                 (DI.DebugInfo
                                                                                                                    (DI.SrcID
                                                                                                                       "XML"
                                                                                                                       0)
                                                                                                                    (DI.DynamicInfo
                                                                                                                       []
                                                                                                                       [DI.genTerm
                                                                                                                          x25,
                                                                                                                        DI.genTerm
                                                                                                                          x26]))
                                                                                                                 (Curry.DebugModule.Prelude.strict_apply
                                                                                                                    x25
                                                                                                                    x26)
                                                                                                     DM.funcCallHook
                                                                                                       "parseAttrs"
                                                                                                       (DI.DebugInfo
                                                                                                          (DI.SrcID
                                                                                                             "XML"
                                                                                                             0)
                                                                                                          (DI.DynamicInfo
                                                                                                             []
                                                                                                             [DI.genTerm
                                                                                                                x27]))
                                                                                                       (strict_parseAttrs
                                                                                                          x27)
                                                                                           DM.eval
                                                                                             (DM.letHook
                                                                                                (DI.DebugInfo
                                                                                                   (DI.SrcID
                                                                                                      "DummyModule"
                                                                                                      42)
                                                                                                   (DI.DynamicInfo
                                                                                                      []
                                                                                                      []))
                                                                                                (do x11 <- do x28 <- Prelude.return
                                                                                                                       x10
                                                                                                              DM.funcCallHook
                                                                                                                "parseAttrs._#selFP37#rem_attrs"
                                                                                                                (DI.DebugInfo
                                                                                                                   (DI.SrcID
                                                                                                                      "XML"
                                                                                                                      0)
                                                                                                                   (DI.DynamicInfo
                                                                                                                      []
                                                                                                                      [DI.genTerm
                                                                                                                         x28]))
                                                                                                                (x'xstrict_parseAttrs46_35selFP3735rem_attrs
                                                                                                                   x28)
                                                                                                    DM.eval
                                                                                                      (DM.letHook
                                                                                                         (DI.DebugInfo
                                                                                                            (DI.SrcID
                                                                                                               "DummyModule"
                                                                                                               42)
                                                                                                            (DI.DynamicInfo
                                                                                                               []
                                                                                                               []))
                                                                                                         (do x12 <- do x29 <- Prelude.return
                                                                                                                                x10
                                                                                                                       DM.funcCallHook
                                                                                                                         "parseAttrs._#selFP38#rem_inp"
                                                                                                                         (DI.DebugInfo
                                                                                                                            (DI.SrcID
                                                                                                                               "XML"
                                                                                                                               0)
                                                                                                                            (DI.DynamicInfo
                                                                                                                               []
                                                                                                                               [DI.genTerm
                                                                                                                                  x29]))
                                                                                                                         (x'xstrict_parseAttrs46_35selFP3835rem_inp
                                                                                                                            x29)
                                                                                                             DM.eval
                                                                                                               (do x35 <- do x33 <- do x31 <- Prelude.return
                                                                                                                                                x5
                                                                                                                                       x32 <- do x30 <- Prelude.return
                                                                                                                                                          x8
                                                                                                                                                 DM.funcCallHook
                                                                                                                                                   "xmlUnquoteSpecials"
                                                                                                                                                   (DI.DebugInfo
                                                                                                                                                      (DI.SrcID
                                                                                                                                                         "XML"
                                                                                                                                                         0)
                                                                                                                                                      (DI.DynamicInfo
                                                                                                                                                         []
                                                                                                                                                         [DI.genTerm
                                                                                                                                                            x30]))
                                                                                                                                                   (strict_xmlUnquoteSpecials
                                                                                                                                                      x30)
                                                                                                                                       DM.constructorHook
                                                                                                                                         (DI.DebugInfo
                                                                                                                                            (DI.SrcID
                                                                                                                                               "XML"
                                                                                                                                               0)
                                                                                                                                            (DI.DynamicInfo
                                                                                                                                               []
                                                                                                                                               [DI.genTerm
                                                                                                                                                  x31,
                                                                                                                                                DI.genTerm
                                                                                                                                                  x32]))
                                                                                                                                         (Prelude.return
                                                                                                                                            (Curry.DebugModule.Prelude.Tuple2
                                                                                                                                               x31
                                                                                                                                               x32))
                                                                                                                             x34 <- Prelude.return
                                                                                                                                      x11
                                                                                                                             DM.constructorHook
                                                                                                                               (DI.DebugInfo
                                                                                                                                  (DI.SrcID
                                                                                                                                     "XML"
                                                                                                                                     0)
                                                                                                                                  (DI.DynamicInfo
                                                                                                                                     []
                                                                                                                                     [DI.genTerm
                                                                                                                                        x33,
                                                                                                                                      DI.genTerm
                                                                                                                                        x34]))
                                                                                                                               (Prelude.return
                                                                                                                                  (Curry.DebugModule.Prelude.Cons
                                                                                                                                     x33
                                                                                                                                     x34))
                                                                                                                   x36 <- Prelude.return
                                                                                                                            x12
                                                                                                                   DM.constructorHook
                                                                                                                     (DI.DebugInfo
                                                                                                                        (DI.SrcID
                                                                                                                           "XML"
                                                                                                                           0)
                                                                                                                        (DI.DynamicInfo
                                                                                                                           []
                                                                                                                           [DI.genTerm
                                                                                                                              x35,
                                                                                                                            DI.genTerm
                                                                                                                              x36]))
                                                                                                                     (Prelude.return
                                                                                                                        (Curry.DebugModule.Prelude.Tuple2
                                                                                                                           x35
                                                                                                                           x36))))))))))))))))))))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x37 <- Prelude.return x2
                                  x38 <- Prelude.return x3
                                  x39 <- DM.funcCallHook "otherwise"
                                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                           Curry.DebugModule.Prelude.strict_otherwise
                                  DM.funcCallHook "_case_11"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x37, DI.genTerm x38, DI.genTerm x39]))
                                    (strict__case_11 x37 x38 x39)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x40])))
                           (strict__case_12 x2 x3)
                           x40)))
term_strict__case_12 x1 = DI.Term "_case_12" (DI.SrcID "XML" 0) x1
strict__case_11 x2 x3 x4
  = DM.eval
      (DM.funcDeclHook "_case_11"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x2, DI.genTerm x3, DI.genTerm x4]))
         (do x9 <- Prelude.return x4
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x9]))
               (case x9 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x7 <- DM.constructorHook
                                          (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                          (Prelude.return Curry.DebugModule.Prelude.Nil)
                                  x8 <- do x5 <- Prelude.return x2
                                           x6 <- Prelude.return x3
                                           DM.constructorHook
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x5, DI.genTerm x6]))
                                             (Prelude.return (Curry.DebugModule.Prelude.Cons x5 x6))
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x7, DI.genTerm x8]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Tuple2 x7 x8))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.funcCallHook "failed"
                                 (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                 Curry.DebugModule.Prelude.strict_failed))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x9])))
                           (strict__case_11 x2 x3)
                           x9)))
term_strict__case_11 x1 = DI.Term "_case_11" (DI.SrcID "XML" 0) x1
strict__case_15 x1
  = DM.eval
      (DM.funcDeclHook "_case_15"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x14 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x14]))
               (case x14 of
                    Curry.DebugModule.Prelude.Nil
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.constructorHook
                                 (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                 (Prelude.return Curry.DebugModule.Prelude.Nil)))
                    Curry.DebugModule.Prelude.Cons x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x11 <- Prelude.return x2
                                  x12 <- Prelude.return x3
                                  x13 <- do x9 <- do x4 <- Prelude.return x2
                                                     x5 <- DM.litHook
                                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                (DI.DynamicInfo [] []))
                                                             (Prelude.return
                                                                (Curry.DebugModule.Prelude.Char
                                                                   '?'))
                                                     DM.funcCallHook "=="
                                                       (DI.DebugInfo (DI.SrcID "XML" 0)
                                                          (DI.DynamicInfo []
                                                             [DI.genTerm x4, DI.genTerm x5]))
                                                       (Curry.DebugModule.Prelude.op_EqEq x4 x5)
                                            x10 <- do x7 <- do x6 <- Prelude.return x3
                                                               DM.funcCallHook "head"
                                                                 (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                    (DI.DynamicInfo []
                                                                       [DI.genTerm x6]))
                                                                 (Curry.DebugModule.Prelude.strict_head
                                                                    x6)
                                                      x8 <- DM.litHook
                                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                 (DI.DynamicInfo [] []))
                                                              (Prelude.return
                                                                 (Curry.DebugModule.Prelude.Char
                                                                    '>'))
                                                      DM.funcCallHook "=="
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x7, DI.genTerm x8]))
                                                        (Curry.DebugModule.Prelude.op_EqEq x7 x8)
                                            DM.funcCallHook "&&"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x9, DI.genTerm x10]))
                                              (Curry.DebugModule.Prelude.op_AndAnd x9 x10)
                                  DM.funcCallHook "_case_14"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x11, DI.genTerm x12, DI.genTerm x13]))
                                    (strict__case_14 x11 x12 x13)))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x14])))
                           strict__case_15
                           x14)))
term_strict__case_15 x1 = DI.Term "_case_15" (DI.SrcID "XML" 0) x1
strict__case_14 x2 x3 x4
  = DM.eval
      (DM.funcDeclHook "_case_14"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x2, DI.genTerm x3, DI.genTerm x4]))
         (do x8 <- Prelude.return x4
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x8]))
               (case x8 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x6 <- do x5 <- Prelude.return x3
                                           DM.funcCallHook "tail"
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x5]))
                                             (Curry.DebugModule.Prelude.strict_tail x5)
                                  DM.funcCallHook "scanXmlString"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x6]))
                                    (strict_scanXmlString x6)))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x7 <- Prelude.return x3
                                  DM.funcCallHook "scanXmlProcInstr"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x7]))
                                    (strict_scanXmlProcInstr x7)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x8])))
                           (strict__case_14 x2 x3)
                           x8)))
term_strict__case_14 x1 = DI.Term "_case_14" (DI.SrcID "XML" 0) x1
strict__case_19 x1
  = DM.eval
      (DM.funcDeclHook "_case_19"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x9 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x9]))
               (case x9 of
                    Curry.DebugModule.Prelude.Nil
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.constructorHook
                                 (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                 (Prelude.return Curry.DebugModule.Prelude.Nil)))
                    Curry.DebugModule.Prelude.Cons x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x6 <- Prelude.return x2
                                  x7 <- Prelude.return x3
                                  x8 <- do x4 <- Prelude.return x2
                                           x5 <- DM.litHook
                                                   (DI.DebugInfo (DI.SrcID "XML" 0)
                                                      (DI.DynamicInfo [] []))
                                                   (Prelude.return
                                                      (Curry.DebugModule.Prelude.Char '['))
                                           DM.funcCallHook "=="
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x4, DI.genTerm x5]))
                                             (Curry.DebugModule.Prelude.op_EqEq x4 x5)
                                  DM.funcCallHook "_case_18"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x6, DI.genTerm x7, DI.genTerm x8]))
                                    (strict__case_18 x6 x7 x8)))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x9])))
                           strict__case_19
                           x9)))
term_strict__case_19 x1 = DI.Term "_case_19" (DI.SrcID "XML" 0) x1
strict__case_18 x2 x3 x4
  = DM.eval
      (DM.funcDeclHook "_case_18"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x2, DI.genTerm x3, DI.genTerm x4]))
         (do x15 <- Prelude.return x4
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x15]))
               (case x15 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x9 <- do x7 <- do x5 <- Prelude.return
                                                            (PC.partCall2
                                                               (Curry.DebugModule.Prelude.term_op_SlashEq
                                                                  [])
                                                               Curry.DebugModule.Prelude.op_SlashEq)
                                                    x6 <- DM.litHook
                                                            (DI.DebugInfo (DI.SrcID "XML" 0)
                                                               (DI.DynamicInfo [] []))
                                                            (Prelude.return
                                                               (Curry.DebugModule.Prelude.Char ']'))
                                                    Prelude.return
                                                      (PC.partCall1
                                                         (Curry.DebugModule.Prelude.term_strict_flip
                                                            [DI.genTerm x5, DI.genTerm x6])
                                                         (Curry.DebugModule.Prelude.strict_flip x5
                                                            x6))
                                           x8 <- Prelude.return x3
                                           DM.funcCallHook "dropWhile"
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x7, DI.genTerm x8]))
                                             (Curry.DebugModule.Prelude.strict_dropWhile x7 x8)
                                  DM.funcCallHook "tail"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x9]))
                                    (Curry.DebugModule.Prelude.strict_tail x9)))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x12 <- Prelude.return x2
                                  x13 <- Prelude.return x3
                                  x14 <- do x10 <- Prelude.return x2
                                            x11 <- DM.litHook
                                                     (DI.DebugInfo (DI.SrcID "XML" 0)
                                                        (DI.DynamicInfo [] []))
                                                     (Prelude.return
                                                        (Curry.DebugModule.Prelude.Char '>'))
                                            DM.funcCallHook "=="
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x10, DI.genTerm x11]))
                                              (Curry.DebugModule.Prelude.op_EqEq x10 x11)
                                  DM.funcCallHook "_case_17"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x12, DI.genTerm x13, DI.genTerm x14]))
                                    (strict__case_17 x12 x13 x14)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x15])))
                           (strict__case_18 x2 x3)
                           x15)))
term_strict__case_18 x1 = DI.Term "_case_18" (DI.SrcID "XML" 0) x1
strict__case_17 x2 x3 x4
  = DM.eval
      (DM.funcDeclHook "_case_17"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x2, DI.genTerm x3, DI.genTerm x4]))
         (do x9 <- Prelude.return x4
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x9]))
               (case x9 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x5 <- Prelude.return x2
                                  x6 <- Prelude.return x3
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x5, DI.genTerm x6]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Cons x5 x6))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x7 <- Prelude.return x3
                                  x8 <- DM.funcCallHook "otherwise"
                                          (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                          Curry.DebugModule.Prelude.strict_otherwise
                                  DM.funcCallHook "_case_16"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x7, DI.genTerm x8]))
                                    (strict__case_16 x7 x8)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x9])))
                           (strict__case_17 x2 x3)
                           x9)))
term_strict__case_17 x1 = DI.Term "_case_17" (DI.SrcID "XML" 0) x1
strict__case_16 x3 x4
  = DM.eval
      (DM.funcDeclHook "_case_16"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x3, DI.genTerm x4]))
         (do x6 <- Prelude.return x4
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x6]))
               (case x6 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x5 <- Prelude.return x3
                                  DM.funcCallHook "dropCData"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x5]))
                                    (strict_dropCData x5)))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.funcCallHook "failed"
                                 (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                 Curry.DebugModule.Prelude.strict_failed))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x6])))
                           (strict__case_16 x3)
                           x6)))
term_strict__case_16 x1 = DI.Term "_case_16" (DI.SrcID "XML" 0) x1
strict__case_20 x2 x3
  = DM.eval
      (DM.funcDeclHook "_case_20"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x2, DI.genTerm x3]))
         (do x7 <- Prelude.return x3
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x7]))
               (case x7 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x5 <- do x4 <- Prelude.return x2
                                           DM.funcCallHook "tail"
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x4]))
                                             (Curry.DebugModule.Prelude.strict_tail x4)
                                  DM.funcCallHook "scanXmlString"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x5]))
                                    (strict_scanXmlString x5)))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x6 <- Prelude.return x2
                                  DM.funcCallHook "scanXmlCData"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x6]))
                                    (strict_scanXmlCData x6)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x7])))
                           (strict__case_20 x2)
                           x7)))
term_strict__case_20 x1 = DI.Term "_case_20" (DI.SrcID "XML" 0) x1
strict__case_22 x1
  = DM.eval
      (DM.funcDeclHook "_case_22"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x19 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x19]))
               (case x19 of
                    Curry.DebugModule.Prelude.Nil
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.constructorHook
                                 (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                 (Prelude.return Curry.DebugModule.Prelude.Nil)))
                    Curry.DebugModule.Prelude.Cons x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x16 <- Prelude.return x2
                                  x17 <- Prelude.return x3
                                  x18 <- do x14 <- do x4 <- Prelude.return x2
                                                      x5 <- DM.litHook
                                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                 (DI.DynamicInfo [] []))
                                                              (Prelude.return
                                                                 (Curry.DebugModule.Prelude.Char
                                                                    '-'))
                                                      DM.funcCallHook "=="
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x4, DI.genTerm x5]))
                                                        (Curry.DebugModule.Prelude.op_EqEq x4 x5)
                                            x15 <- do x12 <- do x6 <- DM.litHook
                                                                        (DI.DebugInfo
                                                                           (DI.SrcID "XML" 0)
                                                                           (DI.DynamicInfo [] []))
                                                                        (Prelude.return
                                                                           (Curry.DebugModule.Prelude.Pos
                                                                              (Curry.DebugModule.Prelude.O
                                                                                 Curry.DebugModule.Prelude.IHi)))
                                                                x7 <- Prelude.return x3
                                                                DM.funcCallHook "take"
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x6,
                                                                         DI.genTerm x7]))
                                                                  (Curry.DebugModule.Prelude.strict_take
                                                                     x6
                                                                     x7)
                                                      x13 <- do x10 <- DM.litHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo [] []))
                                                                         (Prelude.return
                                                                            (Curry.DebugModule.Prelude.Char
                                                                               '-'))
                                                                x11 <- do x8 <- DM.litHook
                                                                                  (DI.DebugInfo
                                                                                     (DI.SrcID "XML"
                                                                                        0)
                                                                                     (DI.DynamicInfo
                                                                                        []
                                                                                        []))
                                                                                  (Prelude.return
                                                                                     (Curry.DebugModule.Prelude.Char
                                                                                        '>'))
                                                                          x9 <- DM.constructorHook
                                                                                  (DI.DebugInfo
                                                                                     (DI.SrcID "XML"
                                                                                        0)
                                                                                     (DI.DynamicInfo
                                                                                        []
                                                                                        []))
                                                                                  (Prelude.return
                                                                                     Curry.DebugModule.Prelude.Nil)
                                                                          DM.constructorHook
                                                                            (DI.DebugInfo
                                                                               (DI.SrcID "XML" 0)
                                                                               (DI.DynamicInfo []
                                                                                  [DI.genTerm x8,
                                                                                   DI.genTerm x9]))
                                                                            (Prelude.return
                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                  x8
                                                                                  x9))
                                                                DM.constructorHook
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x10,
                                                                         DI.genTerm x11]))
                                                                  (Prelude.return
                                                                     (Curry.DebugModule.Prelude.Cons
                                                                        x10
                                                                        x11))
                                                      DM.funcCallHook "=="
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x12, DI.genTerm x13]))
                                                        (Curry.DebugModule.Prelude.op_EqEq x12 x13)
                                            DM.funcCallHook "&&"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x14, DI.genTerm x15]))
                                              (Curry.DebugModule.Prelude.op_AndAnd x14 x15)
                                  DM.funcCallHook "_case_21"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x16, DI.genTerm x17, DI.genTerm x18]))
                                    (strict__case_21 x16 x17 x18)))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x19])))
                           strict__case_22
                           x19)))
term_strict__case_22 x1 = DI.Term "_case_22" (DI.SrcID "XML" 0) x1
strict__case_21 x2 x3 x4
  = DM.eval
      (DM.funcDeclHook "_case_21"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x2, DI.genTerm x3, DI.genTerm x4]))
         (do x9 <- Prelude.return x4
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x9]))
               (case x9 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x7 <- do x5 <- DM.litHook
                                                   (DI.DebugInfo (DI.SrcID "XML" 0)
                                                      (DI.DynamicInfo [] []))
                                                   (Prelude.return
                                                      (Curry.DebugModule.Prelude.Pos
                                                         (Curry.DebugModule.Prelude.O
                                                            Curry.DebugModule.Prelude.IHi)))
                                           x6 <- Prelude.return x3
                                           DM.funcCallHook "drop"
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x5, DI.genTerm x6]))
                                             (Curry.DebugModule.Prelude.strict_drop x5 x6)
                                  DM.funcCallHook "scanXmlString"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x7]))
                                    (strict_scanXmlString x7)))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x8 <- Prelude.return x3
                                  DM.funcCallHook "scanXmlComment"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x8]))
                                    (strict_scanXmlComment x8)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x9])))
                           (strict__case_21 x2 x3)
                           x9)))
term_strict__case_21 x1 = DI.Term "_case_21" (DI.SrcID "XML" 0) x1
strict__case_23 x1
  = DM.eval
      (DM.funcDeclHook "_case_23"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x4 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x4]))
               (case x4 of
                    Curry.DebugModule.Prelude.Tuple2 x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x3))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x4])))
                           strict__case_23
                           x4)))
term_strict__case_23 x1 = DI.Term "_case_23" (DI.SrcID "XML" 0) x1
strict__case_24 x1
  = DM.eval
      (DM.funcDeclHook "_case_24"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x4 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x4]))
               (case x4 of
                    Curry.DebugModule.Prelude.Tuple2 x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x2))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x4])))
                           strict__case_24
                           x4)))
term_strict__case_24 x1 = DI.Term "_case_24" (DI.SrcID "XML" 0) x1
strict__case_30 x1 x2
  = DM.eval
      (DM.funcDeclHook "_case_30"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x2]))
         (do x18 <- Prelude.return x2
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x18]))
               (case x18 of
                    Curry.DebugModule.Prelude.Nil
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x10 <- do x7 <- do x5 <- DM.litHook
                                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                (DI.DynamicInfo [] []))
                                                             (Prelude.return
                                                                (Curry.DebugModule.Prelude.Char
                                                                   '<'))
                                                     x6 <- Prelude.return x1
                                                     DM.constructorHook
                                                       (DI.DebugInfo (DI.SrcID "XML" 0)
                                                          (DI.DynamicInfo []
                                                             [DI.genTerm x5, DI.genTerm x6]))
                                                       (Prelude.return
                                                          (Curry.DebugModule.Prelude.Cons x5 x6))
                                            x8 <- DM.constructorHook
                                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                                       (DI.DynamicInfo [] []))
                                                    (Prelude.return Curry.DebugModule.Prelude.Nil)
                                            x9 <- DM.constructorHook
                                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                                       (DI.DynamicInfo [] []))
                                                    (Prelude.return Curry.DebugModule.Prelude.Nil)
                                            DM.constructorHook
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x7, DI.genTerm x8, DI.genTerm x9]))
                                              (Prelude.return (XElem x7 x8 x9))
                                  x11 <- DM.constructorHook
                                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                           (Prelude.return Curry.DebugModule.Prelude.Nil)
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x10, DI.genTerm x11]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Cons x10 x11))))
                    Curry.DebugModule.Prelude.Cons x3 x4
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x14 <- Prelude.return x1
                                  x15 <- Prelude.return x3
                                  x16 <- Prelude.return x4
                                  x17 <- do x12 <- Prelude.return x3
                                            x13 <- DM.litHook
                                                     (DI.DebugInfo (DI.SrcID "XML" 0)
                                                        (DI.DynamicInfo [] []))
                                                     (Prelude.return
                                                        (Curry.DebugModule.Prelude.Char '>'))
                                            DM.funcCallHook "=="
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x12, DI.genTerm x13]))
                                              (Curry.DebugModule.Prelude.op_EqEq x12 x13)
                                  DM.funcCallHook "_case_29"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x14, DI.genTerm x15, DI.genTerm x16,
                                           DI.genTerm x17]))
                                    (strict__case_29 x14 x15 x16 x17)))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x18])))
                           (strict__case_30 x1)
                           x18)))
term_strict__case_30 x1 = DI.Term "_case_30" (DI.SrcID "XML" 0) x1
strict__case_29 x1 x3 x4 x5
  = DM.eval
      (DM.funcDeclHook "_case_29"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo []
               [DI.genTerm x1, DI.genTerm x3, DI.genTerm x4, DI.genTerm x5]))
         (do x19 <- Prelude.return x5
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x19]))
               (case x19 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x12 <- do x8 <- do x6 <- DM.litHook
                                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                (DI.DynamicInfo [] []))
                                                             (Prelude.return
                                                                (Curry.DebugModule.Prelude.Char
                                                                   '<'))
                                                     x7 <- Prelude.return x1
                                                     DM.constructorHook
                                                       (DI.DebugInfo (DI.SrcID "XML" 0)
                                                          (DI.DynamicInfo []
                                                             [DI.genTerm x6, DI.genTerm x7]))
                                                       (Prelude.return
                                                          (Curry.DebugModule.Prelude.Cons x6 x7))
                                            x9 <- DM.constructorHook
                                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                                       (DI.DynamicInfo [] []))
                                                    (Prelude.return Curry.DebugModule.Prelude.Nil)
                                            x10 <- DM.constructorHook
                                                     (DI.DebugInfo (DI.SrcID "XML" 0)
                                                        (DI.DynamicInfo [] []))
                                                     (Prelude.return Curry.DebugModule.Prelude.Nil)
                                            DM.constructorHook
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x8, DI.genTerm x9, DI.genTerm x10]))
                                              (Prelude.return (XElem x8 x9 x10))
                                  x13 <- do x11 <- Prelude.return x4
                                            DM.funcCallHook "scanXmlString"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo [] [DI.genTerm x11]))
                                              (strict_scanXmlString x11)
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x12, DI.genTerm x13]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Cons x12 x13))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x15 <- Prelude.return x1
                                  x16 <- Prelude.return x3
                                  x17 <- Prelude.return x4
                                  x18 <- do x14 <- Prelude.return x3
                                            DM.funcCallHook "isSpace"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo [] [DI.genTerm x14]))
                                              (Curry.DebugModule.Char.strict_isSpace x14)
                                  DM.funcCallHook "_case_28"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x15, DI.genTerm x16, DI.genTerm x17,
                                           DI.genTerm x18]))
                                    (strict__case_28 x15 x16 x17 x18)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x19])))
                           (strict__case_29 x1 x3 x4)
                           x19)))
term_strict__case_29 x1 = DI.Term "_case_29" (DI.SrcID "XML" 0) x1
strict__case_28 x1 x3 x4 x8
  = DM.eval
      (DM.funcDeclHook "_case_28"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo []
               [DI.genTerm x1, DI.genTerm x3, DI.genTerm x4, DI.genTerm x8]))
         (do x32 <- Prelude.return x8
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x32]))
               (case x32 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.letHook
                                 (DI.DebugInfo (DI.SrcID "DummyModule" 42) (DI.DynamicInfo [] []))
                                 (do x5 <- do x11 <- do x9 <- DM.funcCallHook "dropBlanks"
                                                                (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                   (DI.DynamicInfo [] []))
                                                                strict_dropBlanks
                                                        x10 <- Prelude.return x4
                                                        DM.funcCallHook "apply"
                                                          (DI.DebugInfo (DI.SrcID "XML" 0)
                                                             (DI.DynamicInfo []
                                                                [DI.genTerm x9, DI.genTerm x10]))
                                                          (Curry.DebugModule.Prelude.strict_apply x9
                                                             x10)
                                              DM.funcCallHook "parseAttrs"
                                                (DI.DebugInfo (DI.SrcID "XML" 0)
                                                   (DI.DynamicInfo [] [DI.genTerm x11]))
                                                (strict_parseAttrs x11)
                                     DM.eval
                                       (DM.letHook
                                          (DI.DebugInfo (DI.SrcID "DummyModule" 42)
                                             (DI.DynamicInfo [] []))
                                          (do x6 <- do x12 <- Prelude.return x5
                                                       DM.funcCallHook
                                                         "scanXmlElemName._#selFP32#attrs"
                                                         (DI.DebugInfo (DI.SrcID "XML" 0)
                                                            (DI.DynamicInfo [] [DI.genTerm x12]))
                                                         (x'xstrict_scanXmlElemName46_35selFP3235attrs
                                                            x12)
                                              DM.eval
                                                (DM.letHook
                                                   (DI.DebugInfo (DI.SrcID "DummyModule" 42)
                                                      (DI.DynamicInfo [] []))
                                                   (do x7 <- do x13 <- Prelude.return x5
                                                                DM.funcCallHook
                                                                  "scanXmlElemName._#selFP33#rest"
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x13]))
                                                                  (x'xstrict_scanXmlElemName46_35selFP3335rest
                                                                     x13)
                                                       DM.eval
                                                         (do x17 <- Prelude.return x1
                                                             x18 <- Prelude.return x6
                                                             x19 <- Prelude.return x7
                                                             x20 <- do x15 <- do x14 <- Prelude.return
                                                                                          x7
                                                                                 DM.funcCallHook
                                                                                   "head"
                                                                                   (DI.DebugInfo
                                                                                      (DI.SrcID
                                                                                         "XML"
                                                                                         0)
                                                                                      (DI.DynamicInfo
                                                                                         []
                                                                                         [DI.genTerm
                                                                                            x14]))
                                                                                   (Curry.DebugModule.Prelude.strict_head
                                                                                      x14)
                                                                       x16 <- DM.litHook
                                                                                (DI.DebugInfo
                                                                                   (DI.SrcID "XML"
                                                                                      0)
                                                                                   (DI.DynamicInfo
                                                                                      []
                                                                                      []))
                                                                                (Prelude.return
                                                                                   (Curry.DebugModule.Prelude.Char
                                                                                      '/'))
                                                                       DM.funcCallHook "=="
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo []
                                                                               [DI.genTerm x15,
                                                                                DI.genTerm x16]))
                                                                         (Curry.DebugModule.Prelude.op_EqEq
                                                                            x15
                                                                            x16)
                                                             DM.funcCallHook "_case_27"
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo []
                                                                     [DI.genTerm x17,
                                                                      DI.genTerm x18,
                                                                      DI.genTerm x19,
                                                                      DI.genTerm x20]))
                                                               (strict__case_27 x17 x18 x19
                                                                  x20)))))))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x28 <- Prelude.return x1
                                  x29 <- Prelude.return x3
                                  x30 <- Prelude.return x4
                                  x31 <- do x26 <- do x21 <- Prelude.return x3
                                                      x22 <- DM.litHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo [] []))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Char
                                                                     '/'))
                                                      DM.funcCallHook "=="
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x21, DI.genTerm x22]))
                                                        (Curry.DebugModule.Prelude.op_EqEq x21 x22)
                                            x27 <- do x24 <- do x23 <- Prelude.return x4
                                                                DM.funcCallHook "head"
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x23]))
                                                                  (Curry.DebugModule.Prelude.strict_head
                                                                     x23)
                                                      x25 <- DM.litHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo [] []))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Char
                                                                     '>'))
                                                      DM.funcCallHook "=="
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x24, DI.genTerm x25]))
                                                        (Curry.DebugModule.Prelude.op_EqEq x24 x25)
                                            DM.funcCallHook "&&"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x26, DI.genTerm x27]))
                                              (Curry.DebugModule.Prelude.op_AndAnd x26 x27)
                                  DM.funcCallHook "_case_26"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x28, DI.genTerm x29, DI.genTerm x30,
                                           DI.genTerm x31]))
                                    (strict__case_26 x28 x29 x30 x31)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x32])))
                           (strict__case_28 x1 x3 x4)
                           x32)))
term_strict__case_28 x1 = DI.Term "_case_28" (DI.SrcID "XML" 0) x1
strict__case_26 x1 x3 x4 x5
  = DM.eval
      (DM.funcDeclHook "_case_26"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo []
               [DI.genTerm x1, DI.genTerm x3, DI.genTerm x4, DI.genTerm x5]))
         (do x17 <- Prelude.return x5
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x17]))
               (case x17 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x11 <- do x6 <- Prelude.return x1
                                            x7 <- DM.constructorHook
                                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                                       (DI.DynamicInfo [] []))
                                                    (Prelude.return Curry.DebugModule.Prelude.Nil)
                                            x8 <- DM.constructorHook
                                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                                       (DI.DynamicInfo [] []))
                                                    (Prelude.return Curry.DebugModule.Prelude.Nil)
                                            DM.constructorHook
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x6, DI.genTerm x7, DI.genTerm x8]))
                                              (Prelude.return (XElem x6 x7 x8))
                                  x12 <- do x10 <- do x9 <- Prelude.return x4
                                                      DM.funcCallHook "tail"
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo [] [DI.genTerm x9]))
                                                        (Curry.DebugModule.Prelude.strict_tail x9)
                                            DM.funcCallHook "scanXmlString"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo [] [DI.genTerm x10]))
                                              (strict_scanXmlString x10)
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x11, DI.genTerm x12]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Cons x11 x12))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x13 <- Prelude.return x1
                                  x14 <- Prelude.return x3
                                  x15 <- Prelude.return x4
                                  x16 <- DM.funcCallHook "otherwise"
                                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                           Curry.DebugModule.Prelude.strict_otherwise
                                  DM.funcCallHook "_case_25"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x13, DI.genTerm x14, DI.genTerm x15,
                                           DI.genTerm x16]))
                                    (strict__case_25 x13 x14 x15 x16)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x17])))
                           (strict__case_26 x1 x3 x4)
                           x17)))
term_strict__case_26 x1 = DI.Term "_case_26" (DI.SrcID "XML" 0) x1
strict__case_25 x1 x3 x4 x5
  = DM.eval
      (DM.funcDeclHook "_case_25"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo []
               [DI.genTerm x1, DI.genTerm x3, DI.genTerm x4, DI.genTerm x5]))
         (do x12 <- Prelude.return x5
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x12]))
               (case x12 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x10 <- do x8 <- Prelude.return x1
                                            x9 <- do x6 <- Prelude.return x3
                                                     x7 <- DM.constructorHook
                                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                (DI.DynamicInfo [] []))
                                                             (Prelude.return
                                                                Curry.DebugModule.Prelude.Nil)
                                                     DM.constructorHook
                                                       (DI.DebugInfo (DI.SrcID "XML" 0)
                                                          (DI.DynamicInfo []
                                                             [DI.genTerm x6, DI.genTerm x7]))
                                                       (Prelude.return
                                                          (Curry.DebugModule.Prelude.Cons x6 x7))
                                            DM.funcCallHook "++"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo [] [DI.genTerm x8, DI.genTerm x9]))
                                              (Curry.DebugModule.Prelude.op_PlusPlus x8 x9)
                                  x11 <- Prelude.return x4
                                  DM.funcCallHook "scanXmlElemName"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x10, DI.genTerm x11]))
                                    (strict_scanXmlElemName x10 x11)))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.funcCallHook "failed"
                                 (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                 Curry.DebugModule.Prelude.strict_failed))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x12])))
                           (strict__case_25 x1 x3 x4)
                           x12)))
term_strict__case_25 x1 = DI.Term "_case_25" (DI.SrcID "XML" 0) x1
strict__case_27 x1 x6 x7 x8
  = DM.eval
      (DM.funcDeclHook "_case_27"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo []
               [DI.genTerm x1, DI.genTerm x6, DI.genTerm x7, DI.genTerm x8]))
         (do x26 <- Prelude.return x8
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x26]))
               (case x26 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x15 <- do x9 <- Prelude.return x1
                                            x10 <- Prelude.return x6
                                            x11 <- DM.constructorHook
                                                     (DI.DebugInfo (DI.SrcID "XML" 0)
                                                        (DI.DynamicInfo [] []))
                                                     (Prelude.return Curry.DebugModule.Prelude.Nil)
                                            DM.constructorHook
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x9, DI.genTerm x10,
                                                     DI.genTerm x11]))
                                              (Prelude.return (XElem x9 x10 x11))
                                  x16 <- do x14 <- do x12 <- DM.litHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo [] []))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Pos
                                                                     (Curry.DebugModule.Prelude.O
                                                                        Curry.DebugModule.Prelude.IHi)))
                                                      x13 <- Prelude.return x7
                                                      DM.funcCallHook "drop"
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x12, DI.genTerm x13]))
                                                        (Curry.DebugModule.Prelude.strict_drop x12
                                                           x13)
                                            DM.funcCallHook "scanXmlString"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo [] [DI.genTerm x14]))
                                              (strict_scanXmlString x14)
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x15, DI.genTerm x16]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Cons x15 x16))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x24 <- do x19 <- do x17 <- DM.litHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo [] []))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Char
                                                                     '<'))
                                                      x18 <- Prelude.return x1
                                                      DM.constructorHook
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x17, DI.genTerm x18]))
                                                        (Prelude.return
                                                           (Curry.DebugModule.Prelude.Cons x17 x18))
                                            x20 <- Prelude.return x6
                                            x21 <- DM.constructorHook
                                                     (DI.DebugInfo (DI.SrcID "XML" 0)
                                                        (DI.DynamicInfo [] []))
                                                     (Prelude.return Curry.DebugModule.Prelude.Nil)
                                            DM.constructorHook
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x19, DI.genTerm x20,
                                                     DI.genTerm x21]))
                                              (Prelude.return (XElem x19 x20 x21))
                                  x25 <- do x23 <- do x22 <- Prelude.return x7
                                                      DM.funcCallHook "tail"
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo [] [DI.genTerm x22]))
                                                        (Curry.DebugModule.Prelude.strict_tail x22)
                                            DM.funcCallHook "scanXmlString"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo [] [DI.genTerm x23]))
                                              (strict_scanXmlString x23)
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x24, DI.genTerm x25]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Cons x24 x25))))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x26])))
                           (strict__case_27 x1 x6 x7)
                           x26)))
term_strict__case_27 x1 = DI.Term "_case_27" (DI.SrcID "XML" 0) x1
strict__case_35 x1
  = DM.eval
      (DM.funcDeclHook "_case_35"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x9 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x9]))
               (case x9 of
                    Curry.DebugModule.Prelude.Nil
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.constructorHook
                                 (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                 (Prelude.return Curry.DebugModule.Prelude.Nil)))
                    Curry.DebugModule.Prelude.Cons x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x6 <- Prelude.return x2
                                  x7 <- Prelude.return x3
                                  x8 <- do x4 <- Prelude.return x2
                                           x5 <- DM.litHook
                                                   (DI.DebugInfo (DI.SrcID "XML" 0)
                                                      (DI.DynamicInfo [] []))
                                                   (Prelude.return
                                                      (Curry.DebugModule.Prelude.Char '!'))
                                           DM.funcCallHook "=="
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x4, DI.genTerm x5]))
                                             (Curry.DebugModule.Prelude.op_EqEq x4 x5)
                                  DM.funcCallHook "_case_34"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x6, DI.genTerm x7, DI.genTerm x8]))
                                    (strict__case_34 x6 x7 x8)))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x9])))
                           strict__case_35
                           x9)))
term_strict__case_35 x1 = DI.Term "_case_35" (DI.SrcID "XML" 0) x1
strict__case_34 x2 x3 x4
  = DM.eval
      (DM.funcDeclHook "_case_34"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x2, DI.genTerm x3, DI.genTerm x4]))
         (do x20 <- Prelude.return x4
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x20]))
               (case x20 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x13 <- Prelude.return x3
                                  x14 <- do x11 <- do x5 <- DM.litHook
                                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                 (DI.DynamicInfo [] []))
                                                              (Prelude.return
                                                                 (Curry.DebugModule.Prelude.Pos
                                                                    (Curry.DebugModule.Prelude.O
                                                                       Curry.DebugModule.Prelude.IHi)))
                                                      x6 <- Prelude.return x3
                                                      DM.funcCallHook "take"
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x5, DI.genTerm x6]))
                                                        (Curry.DebugModule.Prelude.strict_take x5
                                                           x6)
                                            x12 <- do x9 <- DM.litHook
                                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                 (DI.DynamicInfo [] []))
                                                              (Prelude.return
                                                                 (Curry.DebugModule.Prelude.Char
                                                                    '-'))
                                                      x10 <- do x7 <- DM.litHook
                                                                        (DI.DebugInfo
                                                                           (DI.SrcID "XML" 0)
                                                                           (DI.DynamicInfo [] []))
                                                                        (Prelude.return
                                                                           (Curry.DebugModule.Prelude.Char
                                                                              '-'))
                                                                x8 <- DM.constructorHook
                                                                        (DI.DebugInfo
                                                                           (DI.SrcID "XML" 0)
                                                                           (DI.DynamicInfo [] []))
                                                                        (Prelude.return
                                                                           Curry.DebugModule.Prelude.Nil)
                                                                DM.constructorHook
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x7,
                                                                         DI.genTerm x8]))
                                                                  (Prelude.return
                                                                     (Curry.DebugModule.Prelude.Cons
                                                                        x7
                                                                        x8))
                                                      DM.constructorHook
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x9, DI.genTerm x10]))
                                                        (Prelude.return
                                                           (Curry.DebugModule.Prelude.Cons x9 x10))
                                            DM.funcCallHook "=="
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x11, DI.genTerm x12]))
                                              (Curry.DebugModule.Prelude.op_EqEq x11 x12)
                                  DM.funcCallHook "_case_33"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x13, DI.genTerm x14]))
                                    (strict__case_33 x13 x14)))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x17 <- Prelude.return x2
                                  x18 <- Prelude.return x3
                                  x19 <- do x15 <- Prelude.return x2
                                            x16 <- DM.litHook
                                                     (DI.DebugInfo (DI.SrcID "XML" 0)
                                                        (DI.DynamicInfo [] []))
                                                     (Prelude.return
                                                        (Curry.DebugModule.Prelude.Char '?'))
                                            DM.funcCallHook "=="
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x15, DI.genTerm x16]))
                                              (Curry.DebugModule.Prelude.op_EqEq x15 x16)
                                  DM.funcCallHook "_case_32"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x17, DI.genTerm x18, DI.genTerm x19]))
                                    (strict__case_32 x17 x18 x19)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x20])))
                           (strict__case_34 x2 x3)
                           x20)))
term_strict__case_34 x1 = DI.Term "_case_34" (DI.SrcID "XML" 0) x1
strict__case_32 x2 x3 x4
  = DM.eval
      (DM.funcDeclHook "_case_32"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x2, DI.genTerm x3, DI.genTerm x4]))
         (do x9 <- Prelude.return x4
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x9]))
               (case x9 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x5 <- Prelude.return x3
                                  DM.funcCallHook "scanXmlProcInstr"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x5]))
                                    (strict_scanXmlProcInstr x5)))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x6 <- Prelude.return x2
                                  x7 <- Prelude.return x3
                                  x8 <- DM.funcCallHook "otherwise"
                                          (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                          Curry.DebugModule.Prelude.strict_otherwise
                                  DM.funcCallHook "_case_31"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x6, DI.genTerm x7, DI.genTerm x8]))
                                    (strict__case_31 x6 x7 x8)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x9])))
                           (strict__case_32 x2 x3)
                           x9)))
term_strict__case_32 x1 = DI.Term "_case_32" (DI.SrcID "XML" 0) x1
strict__case_31 x2 x3 x4
  = DM.eval
      (DM.funcDeclHook "_case_31"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x2, DI.genTerm x3, DI.genTerm x4]))
         (do x9 <- Prelude.return x4
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x9]))
               (case x9 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x7 <- do x5 <- Prelude.return x2
                                           x6 <- DM.constructorHook
                                                   (DI.DebugInfo (DI.SrcID "XML" 0)
                                                      (DI.DynamicInfo [] []))
                                                   (Prelude.return Curry.DebugModule.Prelude.Nil)
                                           DM.constructorHook
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x5, DI.genTerm x6]))
                                             (Prelude.return (Curry.DebugModule.Prelude.Cons x5 x6))
                                  x8 <- Prelude.return x3
                                  DM.funcCallHook "scanXmlElemName"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x7, DI.genTerm x8]))
                                    (strict_scanXmlElemName x7 x8)))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.funcCallHook "failed"
                                 (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                 Curry.DebugModule.Prelude.strict_failed))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x9])))
                           (strict__case_31 x2 x3)
                           x9)))
term_strict__case_31 x1 = DI.Term "_case_31" (DI.SrcID "XML" 0) x1
strict__case_33 x3 x4
  = DM.eval
      (DM.funcDeclHook "_case_33"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x3, DI.genTerm x4]))
         (do x9 <- Prelude.return x4
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x9]))
               (case x9 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x7 <- do x5 <- DM.litHook
                                                   (DI.DebugInfo (DI.SrcID "XML" 0)
                                                      (DI.DynamicInfo [] []))
                                                   (Prelude.return
                                                      (Curry.DebugModule.Prelude.Pos
                                                         (Curry.DebugModule.Prelude.O
                                                            Curry.DebugModule.Prelude.IHi)))
                                           x6 <- Prelude.return x3
                                           DM.funcCallHook "drop"
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x5, DI.genTerm x6]))
                                             (Curry.DebugModule.Prelude.strict_drop x5 x6)
                                  DM.funcCallHook "scanXmlComment"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x7]))
                                    (strict_scanXmlComment x7)))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x8 <- Prelude.return x3
                                  DM.funcCallHook "scanXmlCData"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x8]))
                                    (strict_scanXmlCData x8)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x9])))
                           (strict__case_33 x3)
                           x9)))
term_strict__case_33 x1 = DI.Term "_case_33" (DI.SrcID "XML" 0) x1
strict__case_36 x1
  = DM.eval
      (DM.funcDeclHook "_case_36"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x4 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x4]))
               (case x4 of
                    Curry.DebugModule.Prelude.Tuple2 x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x3))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x4])))
                           strict__case_36
                           x4)))
term_strict__case_36 x1 = DI.Term "_case_36" (DI.SrcID "XML" 0) x1
strict__case_37 x1
  = DM.eval
      (DM.funcDeclHook "_case_37"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x4 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x4]))
               (case x4 of
                    Curry.DebugModule.Prelude.Tuple2 x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x2))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x4])))
                           strict__case_37
                           x4)))
term_strict__case_37 x1 = DI.Term "_case_37" (DI.SrcID "XML" 0) x1
strict__case_38 x1
  = DM.eval
      (DM.funcDeclHook "_case_38"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x4 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x4]))
               (case x4 of
                    Curry.DebugModule.Prelude.Tuple2 x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x3))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x4])))
                           strict__case_38
                           x4)))
term_strict__case_38 x1 = DI.Term "_case_38" (DI.SrcID "XML" 0) x1
strict__case_39 x1
  = DM.eval
      (DM.funcDeclHook "_case_39"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x4 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x4]))
               (case x4 of
                    Curry.DebugModule.Prelude.Tuple2 x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x2))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x4])))
                           strict__case_39
                           x4)))
term_strict__case_39 x1 = DI.Term "_case_39" (DI.SrcID "XML" 0) x1
strict__case_44 x1
  = DM.eval
      (DM.funcDeclHook "_case_44"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x11 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x11]))
               (case x11 of
                    Curry.DebugModule.Prelude.Nil
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x4 <- DM.constructorHook
                                          (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                          (Prelude.return Curry.DebugModule.Prelude.Nil)
                                  x5 <- DM.constructorHook
                                          (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                          (Prelude.return Curry.DebugModule.Prelude.Nil)
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x4, DI.genTerm x5]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Tuple2 x4 x5))))
                    Curry.DebugModule.Prelude.Cons x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x8 <- Prelude.return x2
                                  x9 <- Prelude.return x3
                                  x10 <- do x6 <- Prelude.return x2
                                            x7 <- DM.litHook
                                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                                       (DI.DynamicInfo [] []))
                                                    (Prelude.return
                                                       (Curry.DebugModule.Prelude.Char '<'))
                                            DM.funcCallHook "=="
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo [] [DI.genTerm x6, DI.genTerm x7]))
                                              (Curry.DebugModule.Prelude.op_EqEq x6 x7)
                                  DM.funcCallHook "_case_43"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x8, DI.genTerm x9, DI.genTerm x10]))
                                    (strict__case_43 x8 x9 x10)))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x11])))
                           strict__case_44
                           x11)))
term_strict__case_44 x1 = DI.Term "_case_44" (DI.SrcID "XML" 0) x1
strict__case_43 x2 x3 x4
  = DM.eval
      (DM.funcDeclHook "_case_43"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x2, DI.genTerm x3, DI.genTerm x4]))
         (do x13 <- Prelude.return x4
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x13]))
               (case x13 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x7 <- DM.constructorHook
                                          (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                          (Prelude.return Curry.DebugModule.Prelude.Nil)
                                  x8 <- do x5 <- Prelude.return x2
                                           x6 <- Prelude.return x3
                                           DM.constructorHook
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x5, DI.genTerm x6]))
                                             (Prelude.return (Curry.DebugModule.Prelude.Cons x5 x6))
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x7, DI.genTerm x8]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Tuple2 x7 x8))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x10 <- Prelude.return x2
                                  x11 <- Prelude.return x3
                                  x12 <- do x9 <- Prelude.return x2
                                            DM.funcCallHook "isSpace"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo [] [DI.genTerm x9]))
                                              (Curry.DebugModule.Char.strict_isSpace x9)
                                  DM.funcCallHook "_case_42"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x10, DI.genTerm x11, DI.genTerm x12]))
                                    (strict__case_42 x10 x11 x12)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x13])))
                           (strict__case_43 x2 x3)
                           x13)))
term_strict__case_43 x1 = DI.Term "_case_43" (DI.SrcID "XML" 0) x1
strict__case_42 x2 x3 x7
  = DM.eval
      (DM.funcDeclHook "_case_42"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x2, DI.genTerm x3, DI.genTerm x7]))
         (do x21 <- Prelude.return x7
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x21]))
               (case x21 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.letHook
                                 (DI.DebugInfo (DI.SrcID "DummyModule" 42) (DI.DynamicInfo [] []))
                                 (do x4 <- do x10 <- do x8 <- DM.funcCallHook "dropBlanks"
                                                                (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                   (DI.DynamicInfo [] []))
                                                                strict_dropBlanks
                                                        x9 <- Prelude.return x3
                                                        DM.funcCallHook "apply"
                                                          (DI.DebugInfo (DI.SrcID "XML" 0)
                                                             (DI.DynamicInfo []
                                                                [DI.genTerm x8, DI.genTerm x9]))
                                                          (Curry.DebugModule.Prelude.strict_apply x8
                                                             x9)
                                              DM.funcCallHook "scanXmlText"
                                                (DI.DebugInfo (DI.SrcID "XML" 0)
                                                   (DI.DynamicInfo [] [DI.genTerm x10]))
                                                (strict_scanXmlText x10)
                                     DM.eval
                                       (DM.letHook
                                          (DI.DebugInfo (DI.SrcID "DummyModule" 42)
                                             (DI.DynamicInfo [] []))
                                          (do x5 <- do x11 <- Prelude.return x4
                                                       DM.funcCallHook "scanXmlText._#selFP26#txt"
                                                         (DI.DebugInfo (DI.SrcID "XML" 0)
                                                            (DI.DynamicInfo [] [DI.genTerm x11]))
                                                         (x'xstrict_scanXmlText46_35selFP2635txt
                                                            x11)
                                              DM.eval
                                                (DM.letHook
                                                   (DI.DebugInfo (DI.SrcID "DummyModule" 42)
                                                      (DI.DynamicInfo [] []))
                                                   (do x6 <- do x12 <- Prelude.return x4
                                                                DM.funcCallHook
                                                                  "scanXmlText._#selFP27#rem"
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x12]))
                                                                  (x'xstrict_scanXmlText46_35selFP2735rem
                                                                     x12)
                                                       DM.eval
                                                         (do x16 <- do x14 <- Prelude.return x5
                                                                       x15 <- do x13 <- Prelude.return
                                                                                          x5
                                                                                 DM.funcCallHook
                                                                                   "null"
                                                                                   (DI.DebugInfo
                                                                                      (DI.SrcID
                                                                                         "XML"
                                                                                         0)
                                                                                      (DI.DynamicInfo
                                                                                         []
                                                                                         [DI.genTerm
                                                                                            x13]))
                                                                                   (Curry.DebugModule.Prelude.strict_null
                                                                                      x13)
                                                                       DM.funcCallHook "_case_41"
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo []
                                                                               [DI.genTerm x14,
                                                                                DI.genTerm x15]))
                                                                         (strict__case_41 x14 x15)
                                                             x17 <- Prelude.return x6
                                                             DM.constructorHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo []
                                                                     [DI.genTerm x16,
                                                                      DI.genTerm x17]))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Tuple2
                                                                     x16
                                                                     x17))))))))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x18 <- Prelude.return x2
                                  x19 <- Prelude.return x3
                                  x20 <- DM.funcCallHook "otherwise"
                                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                           Curry.DebugModule.Prelude.strict_otherwise
                                  DM.funcCallHook "_case_40"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x18, DI.genTerm x19, DI.genTerm x20]))
                                    (strict__case_40 x18 x19 x20)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x21])))
                           (strict__case_42 x2 x3)
                           x21)))
term_strict__case_42 x1 = DI.Term "_case_42" (DI.SrcID "XML" 0) x1
strict__case_40 x2 x3 x10
  = DM.eval
      (DM.funcDeclHook "_case_40"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x2, DI.genTerm x3, DI.genTerm x10]))
         (do x18 <- Prelude.return x10
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x18]))
               (case x18 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.letHook
                                 (DI.DebugInfo (DI.SrcID "DummyModule" 42) (DI.DynamicInfo [] []))
                                 (do x7 <- do x11 <- Prelude.return x3
                                              DM.funcCallHook "scanXmlText"
                                                (DI.DebugInfo (DI.SrcID "XML" 0)
                                                   (DI.DynamicInfo [] [DI.genTerm x11]))
                                                (strict_scanXmlText x11)
                                     DM.eval
                                       (DM.letHook
                                          (DI.DebugInfo (DI.SrcID "DummyModule" 42)
                                             (DI.DynamicInfo [] []))
                                          (do x8 <- do x12 <- Prelude.return x7
                                                       DM.funcCallHook "scanXmlText._#selFP29#txt"
                                                         (DI.DebugInfo (DI.SrcID "XML" 0)
                                                            (DI.DynamicInfo [] [DI.genTerm x12]))
                                                         (x'xstrict_scanXmlText46_35selFP2935txt
                                                            x12)
                                              DM.eval
                                                (DM.letHook
                                                   (DI.DebugInfo (DI.SrcID "DummyModule" 42)
                                                      (DI.DynamicInfo [] []))
                                                   (do x9 <- do x13 <- Prelude.return x7
                                                                DM.funcCallHook
                                                                  "scanXmlText._#selFP30#rem"
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x13]))
                                                                  (x'xstrict_scanXmlText46_35selFP3035rem
                                                                     x13)
                                                       DM.eval
                                                         (do x16 <- do x14 <- Prelude.return x2
                                                                       x15 <- Prelude.return x8
                                                                       DM.constructorHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo []
                                                                               [DI.genTerm x14,
                                                                                DI.genTerm x15]))
                                                                         (Prelude.return
                                                                            (Curry.DebugModule.Prelude.Cons
                                                                               x14
                                                                               x15))
                                                             x17 <- Prelude.return x9
                                                             DM.constructorHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo []
                                                                     [DI.genTerm x16,
                                                                      DI.genTerm x17]))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Tuple2
                                                                     x16
                                                                     x17))))))))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.funcCallHook "failed"
                                 (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                 Curry.DebugModule.Prelude.strict_failed))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x18])))
                           (strict__case_40 x2 x3)
                           x18)))
term_strict__case_40 x1 = DI.Term "_case_40" (DI.SrcID "XML" 0) x1
strict__case_41 x5 x6
  = DM.eval
      (DM.funcDeclHook "_case_41"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x5, DI.genTerm x6]))
         (do x9 <- Prelude.return x6
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x9]))
               (case x9 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x5))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x7 <- DM.litHook
                                          (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                          (Prelude.return (Curry.DebugModule.Prelude.Char ' '))
                                  x8 <- Prelude.return x5
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x7, DI.genTerm x8]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Cons x7 x8))))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x9])))
                           (strict__case_41 x5)
                           x9)))
term_strict__case_41 x1 = DI.Term "_case_41" (DI.SrcID "XML" 0) x1
strict__case_45 x1
  = DM.eval
      (DM.funcDeclHook "_case_45"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x4 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x4]))
               (case x4 of
                    Curry.DebugModule.Prelude.Tuple2 x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x3))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x4])))
                           strict__case_45
                           x4)))
term_strict__case_45 x1 = DI.Term "_case_45" (DI.SrcID "XML" 0) x1
strict__case_46 x1
  = DM.eval
      (DM.funcDeclHook "_case_46"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x4 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x4]))
               (case x4 of
                    Curry.DebugModule.Prelude.Tuple2 x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x2))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x4])))
                           strict__case_46
                           x4)))
term_strict__case_46 x1 = DI.Term "_case_46" (DI.SrcID "XML" 0) x1
strict__case_48 x1
  = DM.eval
      (DM.funcDeclHook "_case_48"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x9 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x9]))
               (case x9 of
                    Curry.DebugModule.Prelude.Nil
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.constructorHook
                                 (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                 (Prelude.return Curry.DebugModule.Prelude.Nil)))
                    Curry.DebugModule.Prelude.Cons x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x6 <- Prelude.return x2
                                  x7 <- Prelude.return x3
                                  x8 <- do x4 <- Prelude.return x2
                                           x5 <- DM.litHook
                                                   (DI.DebugInfo (DI.SrcID "XML" 0)
                                                      (DI.DynamicInfo [] []))
                                                   (Prelude.return
                                                      (Curry.DebugModule.Prelude.Char '<'))
                                           DM.funcCallHook "=="
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x4, DI.genTerm x5]))
                                             (Curry.DebugModule.Prelude.op_EqEq x4 x5)
                                  DM.funcCallHook "_case_47"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x6, DI.genTerm x7, DI.genTerm x8]))
                                    (strict__case_47 x6 x7 x8)))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x9])))
                           strict__case_48
                           x9)))
term_strict__case_48 x1 = DI.Term "_case_48" (DI.SrcID "XML" 0) x1
strict__case_47 x2 x3 x7
  = DM.eval
      (DM.funcDeclHook "_case_47"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x2, DI.genTerm x3, DI.genTerm x7]))
         (do x18 <- Prelude.return x7
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x18]))
               (case x18 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x8 <- Prelude.return x3
                                  DM.funcCallHook "scanXmlElem"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x8]))
                                    (strict_scanXmlElem x8)))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.letHook
                                 (DI.DebugInfo (DI.SrcID "DummyModule" 42) (DI.DynamicInfo [] []))
                                 (do x4 <- do x11 <- do x9 <- Prelude.return x2
                                                        x10 <- Prelude.return x3
                                                        DM.constructorHook
                                                          (DI.DebugInfo (DI.SrcID "XML" 0)
                                                             (DI.DynamicInfo []
                                                                [DI.genTerm x9, DI.genTerm x10]))
                                                          (Prelude.return
                                                             (Curry.DebugModule.Prelude.Cons x9
                                                                x10))
                                              DM.funcCallHook "scanXmlText"
                                                (DI.DebugInfo (DI.SrcID "XML" 0)
                                                   (DI.DynamicInfo [] [DI.genTerm x11]))
                                                (strict_scanXmlText x11)
                                     DM.eval
                                       (DM.letHook
                                          (DI.DebugInfo (DI.SrcID "DummyModule" 42)
                                             (DI.DynamicInfo [] []))
                                          (do x5 <- do x12 <- Prelude.return x4
                                                       DM.funcCallHook
                                                         "scanXmlString.scanXml.191._#selFP23#initxt"
                                                         (DI.DebugInfo (DI.SrcID "XML" 0)
                                                            (DI.DynamicInfo [] [DI.genTerm x12]))
                                                         (x'xstrict_scanXmlString46scanXml4619146_35selFP2335initxt
                                                            x12)
                                              DM.eval
                                                (DM.letHook
                                                   (DI.DebugInfo (DI.SrcID "DummyModule" 42)
                                                      (DI.DynamicInfo [] []))
                                                   (do x6 <- do x13 <- Prelude.return x4
                                                                DM.funcCallHook
                                                                  "scanXmlString.scanXml.191._#selFP24#remtag"
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x13]))
                                                                  (x'xstrict_scanXmlString46scanXml4619146_35selFP2435remtag
                                                                     x13)
                                                       DM.eval
                                                         (do x16 <- do x14 <- Prelude.return x5
                                                                       DM.constructorHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo []
                                                                               [DI.genTerm x14]))
                                                                         (Prelude.return
                                                                            (XText x14))
                                                             x17 <- do x15 <- Prelude.return x6
                                                                       DM.funcCallHook
                                                                         "scanXmlString.scanXml.191"
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo []
                                                                               [DI.genTerm x15]))
                                                                         (x'xstrict_scanXmlString46scanXml46191
                                                                            x15)
                                                             DM.constructorHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo []
                                                                     [DI.genTerm x16,
                                                                      DI.genTerm x17]))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Cons
                                                                     x16
                                                                     x17))))))))))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x18])))
                           (strict__case_47 x2 x3)
                           x18)))
term_strict__case_47 x1 = DI.Term "_case_47" (DI.SrcID "XML" 0) x1
strict__case_49 x1
  = DM.eval
      (DM.funcDeclHook "_case_49"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x4 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x4]))
               (case x4 of
                    Curry.DebugModule.Prelude.Tuple2 x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x3))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x4])))
                           strict__case_49
                           x4)))
term_strict__case_49 x1 = DI.Term "_case_49" (DI.SrcID "XML" 0) x1
strict__case_50 x1
  = DM.eval
      (DM.funcDeclHook "_case_50"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x4 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x4]))
               (case x4 of
                    Curry.DebugModule.Prelude.Tuple2 x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x2))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x4])))
                           strict__case_50
                           x4)))
term_strict__case_50 x1 = DI.Term "_case_50" (DI.SrcID "XML" 0) x1
strict__case_51 x1
  = DM.eval
      (DM.funcDeclHook "_case_51"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x4 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x4]))
               (case x4 of
                    Curry.DebugModule.Prelude.Tuple2 x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x3))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x4])))
                           strict__case_51
                           x4)))
term_strict__case_51 x1 = DI.Term "_case_51" (DI.SrcID "XML" 0) x1
strict__case_52 x1
  = DM.eval
      (DM.funcDeclHook "_case_52"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x4 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x4]))
               (case x4 of
                    Curry.DebugModule.Prelude.Tuple2 x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x2))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x4])))
                           strict__case_52
                           x4)))
term_strict__case_52 x1 = DI.Term "_case_52" (DI.SrcID "XML" 0) x1
strict__case_53 x1
  = DM.eval
      (DM.funcDeclHook "_case_53"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x4 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x4]))
               (case x4 of
                    Curry.DebugModule.Prelude.Tuple2 x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x3))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x4])))
                           strict__case_53
                           x4)))
term_strict__case_53 x1 = DI.Term "_case_53" (DI.SrcID "XML" 0) x1
strict__case_54 x1
  = DM.eval
      (DM.funcDeclHook "_case_54"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x4 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x4]))
               (case x4 of
                    Curry.DebugModule.Prelude.Tuple2 x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x2))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x4])))
                           strict__case_54
                           x4)))
term_strict__case_54 x1 = DI.Term "_case_54" (DI.SrcID "XML" 0) x1
strict__case_55 x1
  = DM.eval
      (DM.funcDeclHook "_case_55"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x4 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x4]))
               (case x4 of
                    Curry.DebugModule.Prelude.Tuple2 x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x3))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x4])))
                           strict__case_55
                           x4)))
term_strict__case_55 x1 = DI.Term "_case_55" (DI.SrcID "XML" 0) x1
strict__case_56 x1
  = DM.eval
      (DM.funcDeclHook "_case_56"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x4 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x4]))
               (case x4 of
                    Curry.DebugModule.Prelude.Tuple2 x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x2))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x4])))
                           strict__case_56
                           x4)))
term_strict__case_56 x1 = DI.Term "_case_56" (DI.SrcID "XML" 0) x1
strict__case_57 x1
  = DM.eval
      (DM.funcDeclHook "_case_57"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x4 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x4]))
               (case x4 of
                    Curry.DebugModule.Prelude.Tuple2 x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x3))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x4])))
                           strict__case_57
                           x4)))
term_strict__case_57 x1 = DI.Term "_case_57" (DI.SrcID "XML" 0) x1
strict__case_58 x1
  = DM.eval
      (DM.funcDeclHook "_case_58"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x4 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x4]))
               (case x4 of
                    Curry.DebugModule.Prelude.Tuple2 x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x2))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x4])))
                           strict__case_58
                           x4)))
term_strict__case_58 x1 = DI.Term "_case_58" (DI.SrcID "XML" 0) x1
strict__case_66 x2 x1
  = DM.eval
      (DM.funcDeclHook "_case_66"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x2, DI.genTerm x1]))
         (do x9 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x9]))
               (case x9 of
                    Curry.DebugModule.Prelude.Nil
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x5 <- Prelude.return x2
                                  DM.funcCallHook "_case_65"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x5]))
                                    (strict__case_65 x5)))
                    Curry.DebugModule.Prelude.Cons x3 x4
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x6 <- Prelude.return x2
                                  x7 <- Prelude.return x4
                                  x8 <- Prelude.return x3
                                  DM.funcCallHook "_case_64"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x6, DI.genTerm x7, DI.genTerm x8]))
                                    (strict__case_64 x6 x7 x8)))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x9])))
                           (strict__case_66 x2)
                           x9)))
term_strict__case_66 x1 = DI.Term "_case_66" (DI.SrcID "XML" 0) x1
strict__case_64 x2 x4 x3
  = DM.eval
      (DM.funcDeclHook "_case_64"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x2, DI.genTerm x4, DI.genTerm x3]))
         (do x27 <- Prelude.return x3
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x27]))
               (case x27 of
                    XText x5
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.letHook
                                 (DI.DebugInfo (DI.SrcID "DummyModule" 42) (DI.DynamicInfo [] []))
                                 (do x6 <- do x12 <- Prelude.return x4
                                              x13 <- Prelude.return x2
                                              DM.funcCallHook "parseXmlTokens"
                                                (DI.DebugInfo (DI.SrcID "XML" 0)
                                                   (DI.DynamicInfo []
                                                      [DI.genTerm x12, DI.genTerm x13]))
                                                (strict_parseXmlTokens x12 x13)
                                     DM.eval
                                       (DM.letHook
                                          (DI.DebugInfo (DI.SrcID "DummyModule" 42)
                                             (DI.DynamicInfo [] []))
                                          (do x7 <- do x14 <- Prelude.return x6
                                                       DM.funcCallHook
                                                         "parseXmlTokens._#selFP8#xexps"
                                                         (DI.DebugInfo (DI.SrcID "XML" 0)
                                                            (DI.DynamicInfo [] [DI.genTerm x14]))
                                                         (x'xstrict_parseXmlTokens46_35selFP835xexps
                                                            x14)
                                              DM.eval
                                                (DM.letHook
                                                   (DI.DebugInfo (DI.SrcID "DummyModule" 42)
                                                      (DI.DynamicInfo [] []))
                                                   (do x8 <- do x15 <- Prelude.return x6
                                                                DM.funcCallHook
                                                                  "parseXmlTokens._#selFP9#rem_xtokens"
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x15]))
                                                                  (x'xstrict_parseXmlTokens46_35selFP935rem_xtokens
                                                                     x15)
                                                       DM.eval
                                                         (do x20 <- do x18 <- do x17 <- do x16 <- Prelude.return
                                                                                                    x5
                                                                                           DM.funcCallHook
                                                                                             "xmlUnquoteSpecials"
                                                                                             (DI.DebugInfo
                                                                                                (DI.SrcID
                                                                                                   "XML"
                                                                                                   0)
                                                                                                (DI.DynamicInfo
                                                                                                   []
                                                                                                   [DI.genTerm
                                                                                                      x16]))
                                                                                             (strict_xmlUnquoteSpecials
                                                                                                x16)
                                                                                 DM.constructorHook
                                                                                   (DI.DebugInfo
                                                                                      (DI.SrcID
                                                                                         "XML"
                                                                                         0)
                                                                                      (DI.DynamicInfo
                                                                                         []
                                                                                         [DI.genTerm
                                                                                            x17]))
                                                                                   (Prelude.return
                                                                                      (XText x17))
                                                                       x19 <- Prelude.return x7
                                                                       DM.constructorHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo []
                                                                               [DI.genTerm x18,
                                                                                DI.genTerm x19]))
                                                                         (Prelude.return
                                                                            (Curry.DebugModule.Prelude.Cons
                                                                               x18
                                                                               x19))
                                                             x21 <- Prelude.return x8
                                                             DM.constructorHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo []
                                                                     [DI.genTerm x20,
                                                                      DI.genTerm x21]))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Tuple2
                                                                     x20
                                                                     x21))))))))))
                    XElem x9 x10 x11
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x22 <- Prelude.return x2
                                  x23 <- Prelude.return x4
                                  x24 <- Prelude.return x10
                                  x25 <- Prelude.return x11
                                  x26 <- Prelude.return x9
                                  DM.funcCallHook "_case_63"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x22, DI.genTerm x23, DI.genTerm x24,
                                           DI.genTerm x25, DI.genTerm x26]))
                                    (strict__case_63 x22 x23 x24 x25 x26)))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x27])))
                           (strict__case_64 x2 x4)
                           x27)))
term_strict__case_64 x1 = DI.Term "_case_64" (DI.SrcID "XML" 0) x1
strict__case_63 x2 x4 x10 x11 x9
  = DM.eval
      (DM.funcDeclHook "_case_63"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo []
               [DI.genTerm x2, DI.genTerm x4, DI.genTerm x10, DI.genTerm x11,
                DI.genTerm x9]))
         (do x28 <- Prelude.return x9
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x28]))
               (case x28 of
                    Curry.DebugModule.Prelude.Cons x12 x13
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x21 <- Prelude.return x2
                                  x22 <- Prelude.return x4
                                  x23 <- Prelude.return x10
                                  x24 <- Prelude.return x11
                                  x25 <- Prelude.return x12
                                  x26 <- Prelude.return x13
                                  x27 <- do x19 <- do x14 <- Prelude.return x12
                                                      x15 <- DM.litHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo [] []))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Char
                                                                     '<'))
                                                      DM.funcCallHook "=="
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x14, DI.genTerm x15]))
                                                        (Curry.DebugModule.Prelude.op_EqEq x14 x15)
                                            x20 <- do x17 <- do x16 <- Prelude.return x13
                                                                DM.funcCallHook "head"
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x16]))
                                                                  (Curry.DebugModule.Prelude.strict_head
                                                                     x16)
                                                      x18 <- DM.litHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo [] []))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Char
                                                                     '/'))
                                                      DM.funcCallHook "/="
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x17, DI.genTerm x18]))
                                                        (Curry.DebugModule.Prelude.op_SlashEq x17
                                                           x18)
                                            DM.funcCallHook "&&"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x19, DI.genTerm x20]))
                                              (Curry.DebugModule.Prelude.op_AndAnd x19 x20)
                                  DM.funcCallHook "_case_62"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x21, DI.genTerm x22, DI.genTerm x23,
                                           DI.genTerm x24, DI.genTerm x25, DI.genTerm x26,
                                           DI.genTerm x27]))
                                    (strict__case_62 x21 x22 x23 x24 x25 x26 x27)))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x28])))
                           (strict__case_63 x2 x4 x10 x11)
                           x28)))
term_strict__case_63 x1 = DI.Term "_case_63" (DI.SrcID "XML" 0) x1
strict__case_62 x2 x4 x10 x11 x12 x13 x20
  = DM.eval
      (DM.funcDeclHook "_case_62"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo []
               [DI.genTerm x2, DI.genTerm x4, DI.genTerm x10, DI.genTerm x11,
                DI.genTerm x12, DI.genTerm x13, DI.genTerm x20]))
         (do x51 <- Prelude.return x20
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x51]))
               (case x51 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.letHook
                                 (DI.DebugInfo (DI.SrcID "DummyModule" 42) (DI.DynamicInfo [] []))
                                 (do x14 <- do x22 <- Prelude.return x4
                                               x23 <- do x21 <- Prelude.return x13
                                                         DM.constructorHook
                                                           (DI.DebugInfo (DI.SrcID "XML" 0)
                                                              (DI.DynamicInfo [] [DI.genTerm x21]))
                                                           (Prelude.return
                                                              (Curry.DebugModule.Prelude.Just x21))
                                               DM.funcCallHook "parseXmlTokens"
                                                 (DI.DebugInfo (DI.SrcID "XML" 0)
                                                    (DI.DynamicInfo []
                                                       [DI.genTerm x22, DI.genTerm x23]))
                                                 (strict_parseXmlTokens x22 x23)
                                     DM.eval
                                       (DM.letHook
                                          (DI.DebugInfo (DI.SrcID "DummyModule" 42)
                                             (DI.DynamicInfo [] []))
                                          (do x15 <- do x24 <- Prelude.return x14
                                                        DM.funcCallHook
                                                          "parseXmlTokens._#selFP14#xexps1"
                                                          (DI.DebugInfo (DI.SrcID "XML" 0)
                                                             (DI.DynamicInfo [] [DI.genTerm x24]))
                                                          (x'xstrict_parseXmlTokens46_35selFP1435xexps1
                                                             x24)
                                              DM.eval
                                                (DM.letHook
                                                   (DI.DebugInfo (DI.SrcID "DummyModule" 42)
                                                      (DI.DynamicInfo [] []))
                                                   (do x16 <- do x25 <- Prelude.return x14
                                                                 DM.funcCallHook
                                                                   "parseXmlTokens._#selFP15#xtokens1"
                                                                   (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                      (DI.DynamicInfo []
                                                                         [DI.genTerm x25]))
                                                                   (x'xstrict_parseXmlTokens46_35selFP1535xtokens1
                                                                      x25)
                                                       DM.eval
                                                         (DM.letHook
                                                            (DI.DebugInfo
                                                               (DI.SrcID "DummyModule" 42)
                                                               (DI.DynamicInfo [] []))
                                                            (do x17 <- do x26 <- Prelude.return x16
                                                                          x27 <- Prelude.return x2
                                                                          DM.funcCallHook
                                                                            "parseXmlTokens"
                                                                            (DI.DebugInfo
                                                                               (DI.SrcID "XML" 0)
                                                                               (DI.DynamicInfo []
                                                                                  [DI.genTerm x26,
                                                                                   DI.genTerm x27]))
                                                                            (strict_parseXmlTokens
                                                                               x26
                                                                               x27)
                                                                DM.eval
                                                                  (DM.letHook
                                                                     (DI.DebugInfo
                                                                        (DI.SrcID "DummyModule" 42)
                                                                        (DI.DynamicInfo [] []))
                                                                     (do x18 <- do x28 <- Prelude.return
                                                                                            x17
                                                                                   DM.funcCallHook
                                                                                     "parseXmlTokens._#selFP12#xexps"
                                                                                     (DI.DebugInfo
                                                                                        (DI.SrcID
                                                                                           "XML"
                                                                                           0)
                                                                                        (DI.DynamicInfo
                                                                                           []
                                                                                           [DI.genTerm
                                                                                              x28]))
                                                                                     (x'xstrict_parseXmlTokens46_35selFP1235xexps
                                                                                        x28)
                                                                         DM.eval
                                                                           (DM.letHook
                                                                              (DI.DebugInfo
                                                                                 (DI.SrcID
                                                                                    "DummyModule"
                                                                                    42)
                                                                                 (DI.DynamicInfo []
                                                                                    []))
                                                                              (do x19 <- do x29 <- Prelude.return
                                                                                                     x17
                                                                                            DM.funcCallHook
                                                                                              "parseXmlTokens._#selFP13#rem_xtokens"
                                                                                              (DI.DebugInfo
                                                                                                 (DI.SrcID
                                                                                                    "XML"
                                                                                                    0)
                                                                                                 (DI.DynamicInfo
                                                                                                    []
                                                                                                    [DI.genTerm
                                                                                                       x29]))
                                                                                              (x'xstrict_parseXmlTokens46_35selFP1335rem_xtokens
                                                                                                 x29)
                                                                                  DM.eval
                                                                                    (do x35 <- do x33 <- do x30 <- Prelude.return
                                                                                                                     x13
                                                                                                            x31 <- Prelude.return
                                                                                                                     x10
                                                                                                            x32 <- Prelude.return
                                                                                                                     x15
                                                                                                            DM.constructorHook
                                                                                                              (DI.DebugInfo
                                                                                                                 (DI.SrcID
                                                                                                                    "XML"
                                                                                                                    0)
                                                                                                                 (DI.DynamicInfo
                                                                                                                    []
                                                                                                                    [DI.genTerm
                                                                                                                       x30,
                                                                                                                     DI.genTerm
                                                                                                                       x31,
                                                                                                                     DI.genTerm
                                                                                                                       x32]))
                                                                                                              (Prelude.return
                                                                                                                 (XElem
                                                                                                                    x30
                                                                                                                    x31
                                                                                                                    x32))
                                                                                                  x34 <- Prelude.return
                                                                                                           x18
                                                                                                  DM.constructorHook
                                                                                                    (DI.DebugInfo
                                                                                                       (DI.SrcID
                                                                                                          "XML"
                                                                                                          0)
                                                                                                       (DI.DynamicInfo
                                                                                                          []
                                                                                                          [DI.genTerm
                                                                                                             x33,
                                                                                                           DI.genTerm
                                                                                                             x34]))
                                                                                                    (Prelude.return
                                                                                                       (Curry.DebugModule.Prelude.Cons
                                                                                                          x33
                                                                                                          x34))
                                                                                        x36 <- Prelude.return
                                                                                                 x19
                                                                                        DM.constructorHook
                                                                                          (DI.DebugInfo
                                                                                             (DI.SrcID
                                                                                                "XML"
                                                                                                0)
                                                                                             (DI.DynamicInfo
                                                                                                []
                                                                                                [DI.genTerm
                                                                                                   x35,
                                                                                                 DI.genTerm
                                                                                                   x36]))
                                                                                          (Prelude.return
                                                                                             (Curry.DebugModule.Prelude.Tuple2
                                                                                                x35
                                                                                                x36))))))))))))))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x44 <- Prelude.return x2
                                  x45 <- Prelude.return x4
                                  x46 <- Prelude.return x10
                                  x47 <- Prelude.return x11
                                  x48 <- Prelude.return x12
                                  x49 <- Prelude.return x13
                                  x50 <- do x42 <- do x37 <- Prelude.return x12
                                                      x38 <- DM.litHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo [] []))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Char
                                                                     '<'))
                                                      DM.funcCallHook "=="
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x37, DI.genTerm x38]))
                                                        (Curry.DebugModule.Prelude.op_EqEq x37 x38)
                                            x43 <- do x40 <- do x39 <- Prelude.return x13
                                                                DM.funcCallHook "head"
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x39]))
                                                                  (Curry.DebugModule.Prelude.strict_head
                                                                     x39)
                                                      x41 <- DM.litHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo [] []))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Char
                                                                     '/'))
                                                      DM.funcCallHook "=="
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x40, DI.genTerm x41]))
                                                        (Curry.DebugModule.Prelude.op_EqEq x40 x41)
                                            DM.funcCallHook "&&"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x42, DI.genTerm x43]))
                                              (Curry.DebugModule.Prelude.op_AndAnd x42 x43)
                                  DM.funcCallHook "_case_61"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x44, DI.genTerm x45, DI.genTerm x46,
                                           DI.genTerm x47, DI.genTerm x48, DI.genTerm x49,
                                           DI.genTerm x50]))
                                    (strict__case_61 x44 x45 x46 x47 x48 x49 x50)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x51])))
                           (strict__case_62 x2 x4 x10 x11 x12 x13)
                           x51)))
term_strict__case_62 x1 = DI.Term "_case_62" (DI.SrcID "XML" 0) x1
strict__case_61 x2 x4 x10 x11 x12 x13 x14
  = DM.eval
      (DM.funcDeclHook "_case_61"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo []
               [DI.genTerm x2, DI.genTerm x4, DI.genTerm x10, DI.genTerm x11,
                DI.genTerm x12, DI.genTerm x13, DI.genTerm x14]))
         (do x34 <- Prelude.return x14
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x34]))
               (case x34 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x21 <- Prelude.return x2
                                  x22 <- Prelude.return x4
                                  x23 <- Prelude.return x10
                                  x24 <- Prelude.return x11
                                  x25 <- Prelude.return x13
                                  x26 <- do x18 <- DM.constructorHook
                                                     (DI.DebugInfo (DI.SrcID "XML" 0)
                                                        (DI.DynamicInfo [] []))
                                                     (Prelude.return
                                                        Curry.DebugModule.Prelude.False)
                                            x19 <- do x16 <- Prelude.return
                                                               (PC.partCall2
                                                                  (Curry.DebugModule.Prelude.term_op_EqEq
                                                                     [])
                                                                  Curry.DebugModule.Prelude.op_EqEq)
                                                      x17 <- do x15 <- Prelude.return x13
                                                                DM.funcCallHook "tail"
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x15]))
                                                                  (Curry.DebugModule.Prelude.strict_tail
                                                                     x15)
                                                      Prelude.return
                                                        (PC.partCall1
                                                           (Curry.DebugModule.Prelude.term_strict_flip
                                                              [DI.genTerm x16, DI.genTerm x17])
                                                           (Curry.DebugModule.Prelude.strict_flip
                                                              x16
                                                              x17))
                                            x20 <- Prelude.return x2
                                            DM.funcCallHook "maybe"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x18, DI.genTerm x19,
                                                     DI.genTerm x20]))
                                              (Curry.DebugModule.Prelude.strict_maybe x18 x19 x20)
                                  DM.funcCallHook "_case_60"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x21, DI.genTerm x22, DI.genTerm x23,
                                           DI.genTerm x24, DI.genTerm x25, DI.genTerm x26]))
                                    (strict__case_60 x21 x22 x23 x24 x25 x26)))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x27 <- Prelude.return x2
                                  x28 <- Prelude.return x4
                                  x29 <- Prelude.return x10
                                  x30 <- Prelude.return x11
                                  x31 <- Prelude.return x12
                                  x32 <- Prelude.return x13
                                  x33 <- DM.funcCallHook "otherwise"
                                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                           Curry.DebugModule.Prelude.strict_otherwise
                                  DM.funcCallHook "_case_59"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x27, DI.genTerm x28, DI.genTerm x29,
                                           DI.genTerm x30, DI.genTerm x31, DI.genTerm x32,
                                           DI.genTerm x33]))
                                    (strict__case_59 x27 x28 x29 x30 x31 x32 x33)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x34])))
                           (strict__case_61 x2 x4 x10 x11 x12 x13)
                           x34)))
term_strict__case_61 x1 = DI.Term "_case_61" (DI.SrcID "XML" 0) x1
strict__case_59 x2 x4 x10 x11 x12 x13 x26
  = DM.eval
      (DM.funcDeclHook "_case_59"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo []
               [DI.genTerm x2, DI.genTerm x4, DI.genTerm x10, DI.genTerm x11,
                DI.genTerm x12, DI.genTerm x13, DI.genTerm x26]))
         (do x40 <- Prelude.return x26
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x40]))
               (case x40 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.letHook
                                 (DI.DebugInfo (DI.SrcID "DummyModule" 42) (DI.DynamicInfo [] []))
                                 (do x23 <- do x27 <- Prelude.return x4
                                               x28 <- Prelude.return x2
                                               DM.funcCallHook "parseXmlTokens"
                                                 (DI.DebugInfo (DI.SrcID "XML" 0)
                                                    (DI.DynamicInfo []
                                                       [DI.genTerm x27, DI.genTerm x28]))
                                                 (strict_parseXmlTokens x27 x28)
                                     DM.eval
                                       (DM.letHook
                                          (DI.DebugInfo (DI.SrcID "DummyModule" 42)
                                             (DI.DynamicInfo [] []))
                                          (do x24 <- do x29 <- Prelude.return x23
                                                        DM.funcCallHook
                                                          "parseXmlTokens._#selFP20#xexps"
                                                          (DI.DebugInfo (DI.SrcID "XML" 0)
                                                             (DI.DynamicInfo [] [DI.genTerm x29]))
                                                          (x'xstrict_parseXmlTokens46_35selFP2035xexps
                                                             x29)
                                              DM.eval
                                                (DM.letHook
                                                   (DI.DebugInfo (DI.SrcID "DummyModule" 42)
                                                      (DI.DynamicInfo [] []))
                                                   (do x25 <- do x30 <- Prelude.return x23
                                                                 DM.funcCallHook
                                                                   "parseXmlTokens._#selFP21#rem_xtokens"
                                                                   (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                      (DI.DynamicInfo []
                                                                         [DI.genTerm x30]))
                                                                   (x'xstrict_parseXmlTokens46_35selFP2135rem_xtokens
                                                                      x30)
                                                       DM.eval
                                                         (do x38 <- do x36 <- do x33 <- do x31 <- Prelude.return
                                                                                                    x12
                                                                                           x32 <- Prelude.return
                                                                                                    x13
                                                                                           DM.constructorHook
                                                                                             (DI.DebugInfo
                                                                                                (DI.SrcID
                                                                                                   "XML"
                                                                                                   0)
                                                                                                (DI.DynamicInfo
                                                                                                   []
                                                                                                   [DI.genTerm
                                                                                                      x31,
                                                                                                    DI.genTerm
                                                                                                      x32]))
                                                                                             (Prelude.return
                                                                                                (Curry.DebugModule.Prelude.Cons
                                                                                                   x31
                                                                                                   x32))
                                                                                 x34 <- Prelude.return
                                                                                          x10
                                                                                 x35 <- Prelude.return
                                                                                          x11
                                                                                 DM.constructorHook
                                                                                   (DI.DebugInfo
                                                                                      (DI.SrcID
                                                                                         "XML"
                                                                                         0)
                                                                                      (DI.DynamicInfo
                                                                                         []
                                                                                         [DI.genTerm
                                                                                            x33,
                                                                                          DI.genTerm
                                                                                            x34,
                                                                                          DI.genTerm
                                                                                            x35]))
                                                                                   (Prelude.return
                                                                                      (XElem x33 x34
                                                                                         x35))
                                                                       x37 <- Prelude.return x24
                                                                       DM.constructorHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo []
                                                                               [DI.genTerm x36,
                                                                                DI.genTerm x37]))
                                                                         (Prelude.return
                                                                            (Curry.DebugModule.Prelude.Cons
                                                                               x36
                                                                               x37))
                                                             x39 <- Prelude.return x25
                                                             DM.constructorHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo []
                                                                     [DI.genTerm x38,
                                                                      DI.genTerm x39]))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Tuple2
                                                                     x38
                                                                     x39))))))))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.funcCallHook "failed"
                                 (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                 Curry.DebugModule.Prelude.strict_failed))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x40])))
                           (strict__case_59 x2 x4 x10 x11 x12 x13)
                           x40)))
term_strict__case_59 x1 = DI.Term "_case_59" (DI.SrcID "XML" 0) x1
strict__case_60 x2 x4 x10 x11 x13 x23
  = DM.eval
      (DM.funcDeclHook "_case_60"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo []
               [DI.genTerm x2, DI.genTerm x4, DI.genTerm x10, DI.genTerm x11,
                DI.genTerm x13, DI.genTerm x23]))
         (do x37 <- Prelude.return x23
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x37]))
               (case x37 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x24 <- DM.constructorHook
                                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                           (Prelude.return Curry.DebugModule.Prelude.Nil)
                                  x25 <- Prelude.return x4
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x24, DI.genTerm x25]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Tuple2 x24 x25))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.letHook
                                 (DI.DebugInfo (DI.SrcID "DummyModule" 42) (DI.DynamicInfo [] []))
                                 (do x20 <- do x26 <- Prelude.return x4
                                               x27 <- Prelude.return x2
                                               DM.funcCallHook "parseXmlTokens"
                                                 (DI.DebugInfo (DI.SrcID "XML" 0)
                                                    (DI.DynamicInfo []
                                                       [DI.genTerm x26, DI.genTerm x27]))
                                                 (strict_parseXmlTokens x26 x27)
                                     DM.eval
                                       (DM.letHook
                                          (DI.DebugInfo (DI.SrcID "DummyModule" 42)
                                             (DI.DynamicInfo [] []))
                                          (do x21 <- do x28 <- Prelude.return x20
                                                        DM.funcCallHook
                                                          "parseXmlTokens._#selFP17#xexps"
                                                          (DI.DebugInfo (DI.SrcID "XML" 0)
                                                             (DI.DynamicInfo [] [DI.genTerm x28]))
                                                          (x'xstrict_parseXmlTokens46_35selFP1735xexps
                                                             x28)
                                              DM.eval
                                                (DM.letHook
                                                   (DI.DebugInfo (DI.SrcID "DummyModule" 42)
                                                      (DI.DynamicInfo [] []))
                                                   (do x22 <- do x29 <- Prelude.return x20
                                                                 DM.funcCallHook
                                                                   "parseXmlTokens._#selFP18#rem_xtokens"
                                                                   (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                      (DI.DynamicInfo []
                                                                         [DI.genTerm x29]))
                                                                   (x'xstrict_parseXmlTokens46_35selFP1835rem_xtokens
                                                                      x29)
                                                       DM.eval
                                                         (do x35 <- do x33 <- do x30 <- Prelude.return
                                                                                          x13
                                                                                 x31 <- Prelude.return
                                                                                          x10
                                                                                 x32 <- Prelude.return
                                                                                          x11
                                                                                 DM.constructorHook
                                                                                   (DI.DebugInfo
                                                                                      (DI.SrcID
                                                                                         "XML"
                                                                                         0)
                                                                                      (DI.DynamicInfo
                                                                                         []
                                                                                         [DI.genTerm
                                                                                            x30,
                                                                                          DI.genTerm
                                                                                            x31,
                                                                                          DI.genTerm
                                                                                            x32]))
                                                                                   (Prelude.return
                                                                                      (XElem x30 x31
                                                                                         x32))
                                                                       x34 <- Prelude.return x21
                                                                       DM.constructorHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo []
                                                                               [DI.genTerm x33,
                                                                                DI.genTerm x34]))
                                                                         (Prelude.return
                                                                            (Curry.DebugModule.Prelude.Cons
                                                                               x33
                                                                               x34))
                                                             x36 <- Prelude.return x22
                                                             DM.constructorHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo []
                                                                     [DI.genTerm x35,
                                                                      DI.genTerm x36]))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Tuple2
                                                                     x35
                                                                     x36))))))))))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x37])))
                           (strict__case_60 x2 x4 x10 x11 x13)
                           x37)))
term_strict__case_60 x1 = DI.Term "_case_60" (DI.SrcID "XML" 0) x1
strict__case_65 x2
  = DM.eval
      (DM.funcDeclHook "_case_65"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x2]))
         (do x5 <- Prelude.return x2
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x5]))
               (case x5 of
                    Curry.DebugModule.Prelude.Nothing
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x3 <- DM.constructorHook
                                          (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                          (Prelude.return Curry.DebugModule.Prelude.Nil)
                                  x4 <- DM.constructorHook
                                          (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                          (Prelude.return Curry.DebugModule.Prelude.Nil)
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x3, DI.genTerm x4]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Tuple2 x3 x4))))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x5])))
                           strict__case_65
                           x5)))
term_strict__case_65 x1 = DI.Term "_case_65" (DI.SrcID "XML" 0) x1
strict__case_68 x1 x3 x4
  = DM.eval
      (DM.funcDeclHook "_case_68"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x3, DI.genTerm x4]))
         (do x78 <- Prelude.return x4
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x78]))
               (case x78 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x71 <- do x69 <- do x13 <- DM.litHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo [] []))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Char
                                                                     'F'))
                                                      x14 <- do x11 <- DM.litHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo [] []))
                                                                         (Prelude.return
                                                                            (Curry.DebugModule.Prelude.Char
                                                                               'i'))
                                                                x12 <- do x9 <- DM.litHook
                                                                                  (DI.DebugInfo
                                                                                     (DI.SrcID "XML"
                                                                                        0)
                                                                                     (DI.DynamicInfo
                                                                                        []
                                                                                        []))
                                                                                  (Prelude.return
                                                                                     (Curry.DebugModule.Prelude.Char
                                                                                        'l'))
                                                                          x10 <- do x7 <- DM.litHook
                                                                                            (DI.DebugInfo
                                                                                               (DI.SrcID
                                                                                                  "XML"
                                                                                                  0)
                                                                                               (DI.DynamicInfo
                                                                                                  []
                                                                                                  []))
                                                                                            (Prelude.return
                                                                                               (Curry.DebugModule.Prelude.Char
                                                                                                  'e'))
                                                                                    x8 <- do x5 <- DM.litHook
                                                                                                     (DI.DebugInfo
                                                                                                        (DI.SrcID
                                                                                                           "XML"
                                                                                                           0)
                                                                                                        (DI.DynamicInfo
                                                                                                           []
                                                                                                           []))
                                                                                                     (Prelude.return
                                                                                                        (Curry.DebugModule.Prelude.Char
                                                                                                           ' '))
                                                                                             x6 <- DM.constructorHook
                                                                                                     (DI.DebugInfo
                                                                                                        (DI.SrcID
                                                                                                           "XML"
                                                                                                           0)
                                                                                                        (DI.DynamicInfo
                                                                                                           []
                                                                                                           []))
                                                                                                     (Prelude.return
                                                                                                        Curry.DebugModule.Prelude.Nil)
                                                                                             DM.constructorHook
                                                                                               (DI.DebugInfo
                                                                                                  (DI.SrcID
                                                                                                     "XML"
                                                                                                     0)
                                                                                                  (DI.DynamicInfo
                                                                                                     []
                                                                                                     [DI.genTerm
                                                                                                        x5,
                                                                                                      DI.genTerm
                                                                                                        x6]))
                                                                                               (Prelude.return
                                                                                                  (Curry.DebugModule.Prelude.Cons
                                                                                                     x5
                                                                                                     x6))
                                                                                    DM.constructorHook
                                                                                      (DI.DebugInfo
                                                                                         (DI.SrcID
                                                                                            "XML"
                                                                                            0)
                                                                                         (DI.DynamicInfo
                                                                                            []
                                                                                            [DI.genTerm
                                                                                               x7,
                                                                                             DI.genTerm
                                                                                               x8]))
                                                                                      (Prelude.return
                                                                                         (Curry.DebugModule.Prelude.Cons
                                                                                            x7
                                                                                            x8))
                                                                          DM.constructorHook
                                                                            (DI.DebugInfo
                                                                               (DI.SrcID "XML" 0)
                                                                               (DI.DynamicInfo []
                                                                                  [DI.genTerm x9,
                                                                                   DI.genTerm x10]))
                                                                            (Prelude.return
                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                  x9
                                                                                  x10))
                                                                DM.constructorHook
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x11,
                                                                         DI.genTerm x12]))
                                                                  (Prelude.return
                                                                     (Curry.DebugModule.Prelude.Cons
                                                                        x11
                                                                        x12))
                                                      DM.constructorHook
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x13, DI.genTerm x14]))
                                                        (Prelude.return
                                                           (Curry.DebugModule.Prelude.Cons x13 x14))
                                            x70 <- do x67 <- Prelude.return x1
                                                      x68 <- do x65 <- DM.litHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo [] []))
                                                                         (Prelude.return
                                                                            (Curry.DebugModule.Prelude.Char
                                                                               ' '))
                                                                x66 <- do x63 <- DM.litHook
                                                                                   (DI.DebugInfo
                                                                                      (DI.SrcID
                                                                                         "XML"
                                                                                         0)
                                                                                      (DI.DynamicInfo
                                                                                         []
                                                                                         []))
                                                                                   (Prelude.return
                                                                                      (Curry.DebugModule.Prelude.Char
                                                                                         'c'))
                                                                          x64 <- do x61 <- DM.litHook
                                                                                             (DI.DebugInfo
                                                                                                (DI.SrcID
                                                                                                   "XML"
                                                                                                   0)
                                                                                                (DI.DynamicInfo
                                                                                                   []
                                                                                                   []))
                                                                                             (Prelude.return
                                                                                                (Curry.DebugModule.Prelude.Char
                                                                                                   'o'))
                                                                                    x62 <- do x59 <- DM.litHook
                                                                                                       (DI.DebugInfo
                                                                                                          (DI.SrcID
                                                                                                             "XML"
                                                                                                             0)
                                                                                                          (DI.DynamicInfo
                                                                                                             []
                                                                                                             []))
                                                                                                       (Prelude.return
                                                                                                          (Curry.DebugModule.Prelude.Char
                                                                                                             'n'))
                                                                                              x60 <- do x57 <- DM.litHook
                                                                                                                 (DI.DebugInfo
                                                                                                                    (DI.SrcID
                                                                                                                       "XML"
                                                                                                                       0)
                                                                                                                    (DI.DynamicInfo
                                                                                                                       []
                                                                                                                       []))
                                                                                                                 (Prelude.return
                                                                                                                    (Curry.DebugModule.Prelude.Char
                                                                                                                       't'))
                                                                                                        x58 <- do x55 <- DM.litHook
                                                                                                                           (DI.DebugInfo
                                                                                                                              (DI.SrcID
                                                                                                                                 "XML"
                                                                                                                                 0)
                                                                                                                              (DI.DynamicInfo
                                                                                                                                 []
                                                                                                                                 []))
                                                                                                                           (Prelude.return
                                                                                                                              (Curry.DebugModule.Prelude.Char
                                                                                                                                 'a'))
                                                                                                                  x56 <- do x53 <- DM.litHook
                                                                                                                                     (DI.DebugInfo
                                                                                                                                        (DI.SrcID
                                                                                                                                           "XML"
                                                                                                                                           0)
                                                                                                                                        (DI.DynamicInfo
                                                                                                                                           []
                                                                                                                                           []))
                                                                                                                                     (Prelude.return
                                                                                                                                        (Curry.DebugModule.Prelude.Char
                                                                                                                                           'i'))
                                                                                                                            x54 <- do x51 <- DM.litHook
                                                                                                                                               (DI.DebugInfo
                                                                                                                                                  (DI.SrcID
                                                                                                                                                     "XML"
                                                                                                                                                     0)
                                                                                                                                                  (DI.DynamicInfo
                                                                                                                                                     []
                                                                                                                                                     []))
                                                                                                                                               (Prelude.return
                                                                                                                                                  (Curry.DebugModule.Prelude.Char
                                                                                                                                                     'n'))
                                                                                                                                      x52 <- do x49 <- DM.litHook
                                                                                                                                                         (DI.DebugInfo
                                                                                                                                                            (DI.SrcID
                                                                                                                                                               "XML"
                                                                                                                                                               0)
                                                                                                                                                            (DI.DynamicInfo
                                                                                                                                                               []
                                                                                                                                                               []))
                                                                                                                                                         (Prelude.return
                                                                                                                                                            (Curry.DebugModule.Prelude.Char
                                                                                                                                                               's'))
                                                                                                                                                x50 <- do x47 <- DM.litHook
                                                                                                                                                                   (DI.DebugInfo
                                                                                                                                                                      (DI.SrcID
                                                                                                                                                                         "XML"
                                                                                                                                                                         0)
                                                                                                                                                                      (DI.DynamicInfo
                                                                                                                                                                         []
                                                                                                                                                                         []))
                                                                                                                                                                   (Prelude.return
                                                                                                                                                                      (Curry.DebugModule.Prelude.Char
                                                                                                                                                                         ' '))
                                                                                                                                                          x48 <- do x45 <- DM.litHook
                                                                                                                                                                             (DI.DebugInfo
                                                                                                                                                                                (DI.SrcID
                                                                                                                                                                                   "XML"
                                                                                                                                                                                   0)
                                                                                                                                                                                (DI.DynamicInfo
                                                                                                                                                                                   []
                                                                                                                                                                                   []))
                                                                                                                                                                             (Prelude.return
                                                                                                                                                                                (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                   'n'))
                                                                                                                                                                    x46 <- do x43 <- DM.litHook
                                                                                                                                                                                       (DI.DebugInfo
                                                                                                                                                                                          (DI.SrcID
                                                                                                                                                                                             "XML"
                                                                                                                                                                                             0)
                                                                                                                                                                                          (DI.DynamicInfo
                                                                                                                                                                                             []
                                                                                                                                                                                             []))
                                                                                                                                                                                       (Prelude.return
                                                                                                                                                                                          (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                             'o'))
                                                                                                                                                                              x44 <- do x41 <- DM.litHook
                                                                                                                                                                                                 (DI.DebugInfo
                                                                                                                                                                                                    (DI.SrcID
                                                                                                                                                                                                       "XML"
                                                                                                                                                                                                       0)
                                                                                                                                                                                                    (DI.DynamicInfo
                                                                                                                                                                                                       []
                                                                                                                                                                                                       []))
                                                                                                                                                                                                 (Prelude.return
                                                                                                                                                                                                    (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                       ' '))
                                                                                                                                                                                        x42 <- do x39 <- DM.litHook
                                                                                                                                                                                                           (DI.DebugInfo
                                                                                                                                                                                                              (DI.SrcID
                                                                                                                                                                                                                 "XML"
                                                                                                                                                                                                                 0)
                                                                                                                                                                                                              (DI.DynamicInfo
                                                                                                                                                                                                                 []
                                                                                                                                                                                                                 []))
                                                                                                                                                                                                           (Prelude.return
                                                                                                                                                                                                              (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                 'X'))
                                                                                                                                                                                                  x40 <- do x37 <- DM.litHook
                                                                                                                                                                                                                     (DI.DebugInfo
                                                                                                                                                                                                                        (DI.SrcID
                                                                                                                                                                                                                           "XML"
                                                                                                                                                                                                                           0)
                                                                                                                                                                                                                        (DI.DynamicInfo
                                                                                                                                                                                                                           []
                                                                                                                                                                                                                           []))
                                                                                                                                                                                                                     (Prelude.return
                                                                                                                                                                                                                        (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                           'M'))
                                                                                                                                                                                                            x38 <- do x35 <- DM.litHook
                                                                                                                                                                                                                               (DI.DebugInfo
                                                                                                                                                                                                                                  (DI.SrcID
                                                                                                                                                                                                                                     "XML"
                                                                                                                                                                                                                                     0)
                                                                                                                                                                                                                                  (DI.DynamicInfo
                                                                                                                                                                                                                                     []
                                                                                                                                                                                                                                     []))
                                                                                                                                                                                                                               (Prelude.return
                                                                                                                                                                                                                                  (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                     'L'))
                                                                                                                                                                                                                      x36 <- do x33 <- DM.litHook
                                                                                                                                                                                                                                         (DI.DebugInfo
                                                                                                                                                                                                                                            (DI.SrcID
                                                                                                                                                                                                                                               "XML"
                                                                                                                                                                                                                                               0)
                                                                                                                                                                                                                                            (DI.DynamicInfo
                                                                                                                                                                                                                                               []
                                                                                                                                                                                                                                               []))
                                                                                                                                                                                                                                         (Prelude.return
                                                                                                                                                                                                                                            (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                               ' '))
                                                                                                                                                                                                                                x34 <- do x31 <- DM.litHook
                                                                                                                                                                                                                                                   (DI.DebugInfo
                                                                                                                                                                                                                                                      (DI.SrcID
                                                                                                                                                                                                                                                         "XML"
                                                                                                                                                                                                                                                         0)
                                                                                                                                                                                                                                                      (DI.DynamicInfo
                                                                                                                                                                                                                                                         []
                                                                                                                                                                                                                                                         []))
                                                                                                                                                                                                                                                   (Prelude.return
                                                                                                                                                                                                                                                      (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                                         'd'))
                                                                                                                                                                                                                                          x32 <- do x29 <- DM.litHook
                                                                                                                                                                                                                                                             (DI.DebugInfo
                                                                                                                                                                                                                                                                (DI.SrcID
                                                                                                                                                                                                                                                                   "XML"
                                                                                                                                                                                                                                                                   0)
                                                                                                                                                                                                                                                                (DI.DynamicInfo
                                                                                                                                                                                                                                                                   []
                                                                                                                                                                                                                                                                   []))
                                                                                                                                                                                                                                                             (Prelude.return
                                                                                                                                                                                                                                                                (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                                                   'o'))
                                                                                                                                                                                                                                                    x30 <- do x27 <- DM.litHook
                                                                                                                                                                                                                                                                       (DI.DebugInfo
                                                                                                                                                                                                                                                                          (DI.SrcID
                                                                                                                                                                                                                                                                             "XML"
                                                                                                                                                                                                                                                                             0)
                                                                                                                                                                                                                                                                          (DI.DynamicInfo
                                                                                                                                                                                                                                                                             []
                                                                                                                                                                                                                                                                             []))
                                                                                                                                                                                                                                                                       (Prelude.return
                                                                                                                                                                                                                                                                          (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                                                             'c'))
                                                                                                                                                                                                                                                              x28 <- do x25 <- DM.litHook
                                                                                                                                                                                                                                                                                 (DI.DebugInfo
                                                                                                                                                                                                                                                                                    (DI.SrcID
                                                                                                                                                                                                                                                                                       "XML"
                                                                                                                                                                                                                                                                                       0)
                                                                                                                                                                                                                                                                                    (DI.DynamicInfo
                                                                                                                                                                                                                                                                                       []
                                                                                                                                                                                                                                                                                       []))
                                                                                                                                                                                                                                                                                 (Prelude.return
                                                                                                                                                                                                                                                                                    (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                                                                       'u'))
                                                                                                                                                                                                                                                                        x26 <- do x23 <- DM.litHook
                                                                                                                                                                                                                                                                                           (DI.DebugInfo
                                                                                                                                                                                                                                                                                              (DI.SrcID
                                                                                                                                                                                                                                                                                                 "XML"
                                                                                                                                                                                                                                                                                                 0)
                                                                                                                                                                                                                                                                                              (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                 []
                                                                                                                                                                                                                                                                                                 []))
                                                                                                                                                                                                                                                                                           (Prelude.return
                                                                                                                                                                                                                                                                                              (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                                                                                 'm'))
                                                                                                                                                                                                                                                                                  x24 <- do x21 <- DM.litHook
                                                                                                                                                                                                                                                                                                     (DI.DebugInfo
                                                                                                                                                                                                                                                                                                        (DI.SrcID
                                                                                                                                                                                                                                                                                                           "XML"
                                                                                                                                                                                                                                                                                                           0)
                                                                                                                                                                                                                                                                                                        (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                           []
                                                                                                                                                                                                                                                                                                           []))
                                                                                                                                                                                                                                                                                                     (Prelude.return
                                                                                                                                                                                                                                                                                                        (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                                                                                           'e'))
                                                                                                                                                                                                                                                                                            x22 <- do x19 <- DM.litHook
                                                                                                                                                                                                                                                                                                               (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                  (DI.SrcID
                                                                                                                                                                                                                                                                                                                     "XML"
                                                                                                                                                                                                                                                                                                                     0)
                                                                                                                                                                                                                                                                                                                  (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                     []
                                                                                                                                                                                                                                                                                                                     []))
                                                                                                                                                                                                                                                                                                               (Prelude.return
                                                                                                                                                                                                                                                                                                                  (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                                                                                                     'n'))
                                                                                                                                                                                                                                                                                                      x20 <- do x17 <- DM.litHook
                                                                                                                                                                                                                                                                                                                         (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                            (DI.SrcID
                                                                                                                                                                                                                                                                                                                               "XML"
                                                                                                                                                                                                                                                                                                                               0)
                                                                                                                                                                                                                                                                                                                            (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                               []
                                                                                                                                                                                                                                                                                                                               []))
                                                                                                                                                                                                                                                                                                                         (Prelude.return
                                                                                                                                                                                                                                                                                                                            (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                                                                                                               't'))
                                                                                                                                                                                                                                                                                                                x18 <- do x15 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                   (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                      (DI.SrcID
                                                                                                                                                                                                                                                                                                                                         "XML"
                                                                                                                                                                                                                                                                                                                                         0)
                                                                                                                                                                                                                                                                                                                                      (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                         []
                                                                                                                                                                                                                                                                                                                                         []))
                                                                                                                                                                                                                                                                                                                                   (Prelude.return
                                                                                                                                                                                                                                                                                                                                      (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                                                                                                                         '!'))
                                                                                                                                                                                                                                                                                                                          x16 <- DM.constructorHook
                                                                                                                                                                                                                                                                                                                                   (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                      (DI.SrcID
                                                                                                                                                                                                                                                                                                                                         "XML"
                                                                                                                                                                                                                                                                                                                                         0)
                                                                                                                                                                                                                                                                                                                                      (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                         []
                                                                                                                                                                                                                                                                                                                                         []))
                                                                                                                                                                                                                                                                                                                                   (Prelude.return
                                                                                                                                                                                                                                                                                                                                      Curry.DebugModule.Prelude.Nil)
                                                                                                                                                                                                                                                                                                                          DM.constructorHook
                                                                                                                                                                                                                                                                                                                            (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                               (DI.SrcID
                                                                                                                                                                                                                                                                                                                                  "XML"
                                                                                                                                                                                                                                                                                                                                  0)
                                                                                                                                                                                                                                                                                                                               (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                  []
                                                                                                                                                                                                                                                                                                                                  [DI.genTerm
                                                                                                                                                                                                                                                                                                                                     x15,
                                                                                                                                                                                                                                                                                                                                   DI.genTerm
                                                                                                                                                                                                                                                                                                                                     x16]))
                                                                                                                                                                                                                                                                                                                            (Prelude.return
                                                                                                                                                                                                                                                                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                  x15
                                                                                                                                                                                                                                                                                                                                  x16))
                                                                                                                                                                                                                                                                                                                DM.constructorHook
                                                                                                                                                                                                                                                                                                                  (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                     (DI.SrcID
                                                                                                                                                                                                                                                                                                                        "XML"
                                                                                                                                                                                                                                                                                                                        0)
                                                                                                                                                                                                                                                                                                                     (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                        []
                                                                                                                                                                                                                                                                                                                        [DI.genTerm
                                                                                                                                                                                                                                                                                                                           x17,
                                                                                                                                                                                                                                                                                                                         DI.genTerm
                                                                                                                                                                                                                                                                                                                           x18]))
                                                                                                                                                                                                                                                                                                                  (Prelude.return
                                                                                                                                                                                                                                                                                                                     (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                        x17
                                                                                                                                                                                                                                                                                                                        x18))
                                                                                                                                                                                                                                                                                                      DM.constructorHook
                                                                                                                                                                                                                                                                                                        (DI.DebugInfo
                                                                                                                                                                                                                                                                                                           (DI.SrcID
                                                                                                                                                                                                                                                                                                              "XML"
                                                                                                                                                                                                                                                                                                              0)
                                                                                                                                                                                                                                                                                                           (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                              []
                                                                                                                                                                                                                                                                                                              [DI.genTerm
                                                                                                                                                                                                                                                                                                                 x19,
                                                                                                                                                                                                                                                                                                               DI.genTerm
                                                                                                                                                                                                                                                                                                                 x20]))
                                                                                                                                                                                                                                                                                                        (Prelude.return
                                                                                                                                                                                                                                                                                                           (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                              x19
                                                                                                                                                                                                                                                                                                              x20))
                                                                                                                                                                                                                                                                                            DM.constructorHook
                                                                                                                                                                                                                                                                                              (DI.DebugInfo
                                                                                                                                                                                                                                                                                                 (DI.SrcID
                                                                                                                                                                                                                                                                                                    "XML"
                                                                                                                                                                                                                                                                                                    0)
                                                                                                                                                                                                                                                                                                 (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                    []
                                                                                                                                                                                                                                                                                                    [DI.genTerm
                                                                                                                                                                                                                                                                                                       x21,
                                                                                                                                                                                                                                                                                                     DI.genTerm
                                                                                                                                                                                                                                                                                                       x22]))
                                                                                                                                                                                                                                                                                              (Prelude.return
                                                                                                                                                                                                                                                                                                 (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                    x21
                                                                                                                                                                                                                                                                                                    x22))
                                                                                                                                                                                                                                                                                  DM.constructorHook
                                                                                                                                                                                                                                                                                    (DI.DebugInfo
                                                                                                                                                                                                                                                                                       (DI.SrcID
                                                                                                                                                                                                                                                                                          "XML"
                                                                                                                                                                                                                                                                                          0)
                                                                                                                                                                                                                                                                                       (DI.DynamicInfo
                                                                                                                                                                                                                                                                                          []
                                                                                                                                                                                                                                                                                          [DI.genTerm
                                                                                                                                                                                                                                                                                             x23,
                                                                                                                                                                                                                                                                                           DI.genTerm
                                                                                                                                                                                                                                                                                             x24]))
                                                                                                                                                                                                                                                                                    (Prelude.return
                                                                                                                                                                                                                                                                                       (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                          x23
                                                                                                                                                                                                                                                                                          x24))
                                                                                                                                                                                                                                                                        DM.constructorHook
                                                                                                                                                                                                                                                                          (DI.DebugInfo
                                                                                                                                                                                                                                                                             (DI.SrcID
                                                                                                                                                                                                                                                                                "XML"
                                                                                                                                                                                                                                                                                0)
                                                                                                                                                                                                                                                                             (DI.DynamicInfo
                                                                                                                                                                                                                                                                                []
                                                                                                                                                                                                                                                                                [DI.genTerm
                                                                                                                                                                                                                                                                                   x25,
                                                                                                                                                                                                                                                                                 DI.genTerm
                                                                                                                                                                                                                                                                                   x26]))
                                                                                                                                                                                                                                                                          (Prelude.return
                                                                                                                                                                                                                                                                             (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                x25
                                                                                                                                                                                                                                                                                x26))
                                                                                                                                                                                                                                                              DM.constructorHook
                                                                                                                                                                                                                                                                (DI.DebugInfo
                                                                                                                                                                                                                                                                   (DI.SrcID
                                                                                                                                                                                                                                                                      "XML"
                                                                                                                                                                                                                                                                      0)
                                                                                                                                                                                                                                                                   (DI.DynamicInfo
                                                                                                                                                                                                                                                                      []
                                                                                                                                                                                                                                                                      [DI.genTerm
                                                                                                                                                                                                                                                                         x27,
                                                                                                                                                                                                                                                                       DI.genTerm
                                                                                                                                                                                                                                                                         x28]))
                                                                                                                                                                                                                                                                (Prelude.return
                                                                                                                                                                                                                                                                   (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                      x27
                                                                                                                                                                                                                                                                      x28))
                                                                                                                                                                                                                                                    DM.constructorHook
                                                                                                                                                                                                                                                      (DI.DebugInfo
                                                                                                                                                                                                                                                         (DI.SrcID
                                                                                                                                                                                                                                                            "XML"
                                                                                                                                                                                                                                                            0)
                                                                                                                                                                                                                                                         (DI.DynamicInfo
                                                                                                                                                                                                                                                            []
                                                                                                                                                                                                                                                            [DI.genTerm
                                                                                                                                                                                                                                                               x29,
                                                                                                                                                                                                                                                             DI.genTerm
                                                                                                                                                                                                                                                               x30]))
                                                                                                                                                                                                                                                      (Prelude.return
                                                                                                                                                                                                                                                         (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                            x29
                                                                                                                                                                                                                                                            x30))
                                                                                                                                                                                                                                          DM.constructorHook
                                                                                                                                                                                                                                            (DI.DebugInfo
                                                                                                                                                                                                                                               (DI.SrcID
                                                                                                                                                                                                                                                  "XML"
                                                                                                                                                                                                                                                  0)
                                                                                                                                                                                                                                               (DI.DynamicInfo
                                                                                                                                                                                                                                                  []
                                                                                                                                                                                                                                                  [DI.genTerm
                                                                                                                                                                                                                                                     x31,
                                                                                                                                                                                                                                                   DI.genTerm
                                                                                                                                                                                                                                                     x32]))
                                                                                                                                                                                                                                            (Prelude.return
                                                                                                                                                                                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                  x31
                                                                                                                                                                                                                                                  x32))
                                                                                                                                                                                                                                DM.constructorHook
                                                                                                                                                                                                                                  (DI.DebugInfo
                                                                                                                                                                                                                                     (DI.SrcID
                                                                                                                                                                                                                                        "XML"
                                                                                                                                                                                                                                        0)
                                                                                                                                                                                                                                     (DI.DynamicInfo
                                                                                                                                                                                                                                        []
                                                                                                                                                                                                                                        [DI.genTerm
                                                                                                                                                                                                                                           x33,
                                                                                                                                                                                                                                         DI.genTerm
                                                                                                                                                                                                                                           x34]))
                                                                                                                                                                                                                                  (Prelude.return
                                                                                                                                                                                                                                     (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                        x33
                                                                                                                                                                                                                                        x34))
                                                                                                                                                                                                                      DM.constructorHook
                                                                                                                                                                                                                        (DI.DebugInfo
                                                                                                                                                                                                                           (DI.SrcID
                                                                                                                                                                                                                              "XML"
                                                                                                                                                                                                                              0)
                                                                                                                                                                                                                           (DI.DynamicInfo
                                                                                                                                                                                                                              []
                                                                                                                                                                                                                              [DI.genTerm
                                                                                                                                                                                                                                 x35,
                                                                                                                                                                                                                               DI.genTerm
                                                                                                                                                                                                                                 x36]))
                                                                                                                                                                                                                        (Prelude.return
                                                                                                                                                                                                                           (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                              x35
                                                                                                                                                                                                                              x36))
                                                                                                                                                                                                            DM.constructorHook
                                                                                                                                                                                                              (DI.DebugInfo
                                                                                                                                                                                                                 (DI.SrcID
                                                                                                                                                                                                                    "XML"
                                                                                                                                                                                                                    0)
                                                                                                                                                                                                                 (DI.DynamicInfo
                                                                                                                                                                                                                    []
                                                                                                                                                                                                                    [DI.genTerm
                                                                                                                                                                                                                       x37,
                                                                                                                                                                                                                     DI.genTerm
                                                                                                                                                                                                                       x38]))
                                                                                                                                                                                                              (Prelude.return
                                                                                                                                                                                                                 (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                    x37
                                                                                                                                                                                                                    x38))
                                                                                                                                                                                                  DM.constructorHook
                                                                                                                                                                                                    (DI.DebugInfo
                                                                                                                                                                                                       (DI.SrcID
                                                                                                                                                                                                          "XML"
                                                                                                                                                                                                          0)
                                                                                                                                                                                                       (DI.DynamicInfo
                                                                                                                                                                                                          []
                                                                                                                                                                                                          [DI.genTerm
                                                                                                                                                                                                             x39,
                                                                                                                                                                                                           DI.genTerm
                                                                                                                                                                                                             x40]))
                                                                                                                                                                                                    (Prelude.return
                                                                                                                                                                                                       (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                          x39
                                                                                                                                                                                                          x40))
                                                                                                                                                                                        DM.constructorHook
                                                                                                                                                                                          (DI.DebugInfo
                                                                                                                                                                                             (DI.SrcID
                                                                                                                                                                                                "XML"
                                                                                                                                                                                                0)
                                                                                                                                                                                             (DI.DynamicInfo
                                                                                                                                                                                                []
                                                                                                                                                                                                [DI.genTerm
                                                                                                                                                                                                   x41,
                                                                                                                                                                                                 DI.genTerm
                                                                                                                                                                                                   x42]))
                                                                                                                                                                                          (Prelude.return
                                                                                                                                                                                             (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                x41
                                                                                                                                                                                                x42))
                                                                                                                                                                              DM.constructorHook
                                                                                                                                                                                (DI.DebugInfo
                                                                                                                                                                                   (DI.SrcID
                                                                                                                                                                                      "XML"
                                                                                                                                                                                      0)
                                                                                                                                                                                   (DI.DynamicInfo
                                                                                                                                                                                      []
                                                                                                                                                                                      [DI.genTerm
                                                                                                                                                                                         x43,
                                                                                                                                                                                       DI.genTerm
                                                                                                                                                                                         x44]))
                                                                                                                                                                                (Prelude.return
                                                                                                                                                                                   (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                      x43
                                                                                                                                                                                      x44))
                                                                                                                                                                    DM.constructorHook
                                                                                                                                                                      (DI.DebugInfo
                                                                                                                                                                         (DI.SrcID
                                                                                                                                                                            "XML"
                                                                                                                                                                            0)
                                                                                                                                                                         (DI.DynamicInfo
                                                                                                                                                                            []
                                                                                                                                                                            [DI.genTerm
                                                                                                                                                                               x45,
                                                                                                                                                                             DI.genTerm
                                                                                                                                                                               x46]))
                                                                                                                                                                      (Prelude.return
                                                                                                                                                                         (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                            x45
                                                                                                                                                                            x46))
                                                                                                                                                          DM.constructorHook
                                                                                                                                                            (DI.DebugInfo
                                                                                                                                                               (DI.SrcID
                                                                                                                                                                  "XML"
                                                                                                                                                                  0)
                                                                                                                                                               (DI.DynamicInfo
                                                                                                                                                                  []
                                                                                                                                                                  [DI.genTerm
                                                                                                                                                                     x47,
                                                                                                                                                                   DI.genTerm
                                                                                                                                                                     x48]))
                                                                                                                                                            (Prelude.return
                                                                                                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                  x47
                                                                                                                                                                  x48))
                                                                                                                                                DM.constructorHook
                                                                                                                                                  (DI.DebugInfo
                                                                                                                                                     (DI.SrcID
                                                                                                                                                        "XML"
                                                                                                                                                        0)
                                                                                                                                                     (DI.DynamicInfo
                                                                                                                                                        []
                                                                                                                                                        [DI.genTerm
                                                                                                                                                           x49,
                                                                                                                                                         DI.genTerm
                                                                                                                                                           x50]))
                                                                                                                                                  (Prelude.return
                                                                                                                                                     (Curry.DebugModule.Prelude.Cons
                                                                                                                                                        x49
                                                                                                                                                        x50))
                                                                                                                                      DM.constructorHook
                                                                                                                                        (DI.DebugInfo
                                                                                                                                           (DI.SrcID
                                                                                                                                              "XML"
                                                                                                                                              0)
                                                                                                                                           (DI.DynamicInfo
                                                                                                                                              []
                                                                                                                                              [DI.genTerm
                                                                                                                                                 x51,
                                                                                                                                               DI.genTerm
                                                                                                                                                 x52]))
                                                                                                                                        (Prelude.return
                                                                                                                                           (Curry.DebugModule.Prelude.Cons
                                                                                                                                              x51
                                                                                                                                              x52))
                                                                                                                            DM.constructorHook
                                                                                                                              (DI.DebugInfo
                                                                                                                                 (DI.SrcID
                                                                                                                                    "XML"
                                                                                                                                    0)
                                                                                                                                 (DI.DynamicInfo
                                                                                                                                    []
                                                                                                                                    [DI.genTerm
                                                                                                                                       x53,
                                                                                                                                     DI.genTerm
                                                                                                                                       x54]))
                                                                                                                              (Prelude.return
                                                                                                                                 (Curry.DebugModule.Prelude.Cons
                                                                                                                                    x53
                                                                                                                                    x54))
                                                                                                                  DM.constructorHook
                                                                                                                    (DI.DebugInfo
                                                                                                                       (DI.SrcID
                                                                                                                          "XML"
                                                                                                                          0)
                                                                                                                       (DI.DynamicInfo
                                                                                                                          []
                                                                                                                          [DI.genTerm
                                                                                                                             x55,
                                                                                                                           DI.genTerm
                                                                                                                             x56]))
                                                                                                                    (Prelude.return
                                                                                                                       (Curry.DebugModule.Prelude.Cons
                                                                                                                          x55
                                                                                                                          x56))
                                                                                                        DM.constructorHook
                                                                                                          (DI.DebugInfo
                                                                                                             (DI.SrcID
                                                                                                                "XML"
                                                                                                                0)
                                                                                                             (DI.DynamicInfo
                                                                                                                []
                                                                                                                [DI.genTerm
                                                                                                                   x57,
                                                                                                                 DI.genTerm
                                                                                                                   x58]))
                                                                                                          (Prelude.return
                                                                                                             (Curry.DebugModule.Prelude.Cons
                                                                                                                x57
                                                                                                                x58))
                                                                                              DM.constructorHook
                                                                                                (DI.DebugInfo
                                                                                                   (DI.SrcID
                                                                                                      "XML"
                                                                                                      0)
                                                                                                   (DI.DynamicInfo
                                                                                                      []
                                                                                                      [DI.genTerm
                                                                                                         x59,
                                                                                                       DI.genTerm
                                                                                                         x60]))
                                                                                                (Prelude.return
                                                                                                   (Curry.DebugModule.Prelude.Cons
                                                                                                      x59
                                                                                                      x60))
                                                                                    DM.constructorHook
                                                                                      (DI.DebugInfo
                                                                                         (DI.SrcID
                                                                                            "XML"
                                                                                            0)
                                                                                         (DI.DynamicInfo
                                                                                            []
                                                                                            [DI.genTerm
                                                                                               x61,
                                                                                             DI.genTerm
                                                                                               x62]))
                                                                                      (Prelude.return
                                                                                         (Curry.DebugModule.Prelude.Cons
                                                                                            x61
                                                                                            x62))
                                                                          DM.constructorHook
                                                                            (DI.DebugInfo
                                                                               (DI.SrcID "XML" 0)
                                                                               (DI.DynamicInfo []
                                                                                  [DI.genTerm x63,
                                                                                   DI.genTerm x64]))
                                                                            (Prelude.return
                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                  x63
                                                                                  x64))
                                                                DM.constructorHook
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x65,
                                                                         DI.genTerm x66]))
                                                                  (Prelude.return
                                                                     (Curry.DebugModule.Prelude.Cons
                                                                        x65
                                                                        x66))
                                                      DM.funcCallHook "++"
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x67, DI.genTerm x68]))
                                                        (Curry.DebugModule.Prelude.op_PlusPlus x67
                                                           x68)
                                            DM.funcCallHook "++"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x69, DI.genTerm x70]))
                                              (Curry.DebugModule.Prelude.op_PlusPlus x69 x70)
                                  DM.funcCallHook "error"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x71]))
                                    (Curry.DebugModule.Prelude.strict_error x71)))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x75 <- Prelude.return x1
                                  x76 <- Prelude.return x3
                                  x77 <- do x73 <- do x72 <- Prelude.return x3
                                                      DM.funcCallHook "tail"
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo [] [DI.genTerm x72]))
                                                        (Curry.DebugModule.Prelude.strict_tail x72)
                                            x74 <- DM.constructorHook
                                                     (DI.DebugInfo (DI.SrcID "XML" 0)
                                                        (DI.DynamicInfo [] []))
                                                     (Prelude.return Curry.DebugModule.Prelude.Nil)
                                            DM.funcCallHook "/="
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x73, DI.genTerm x74]))
                                              (Curry.DebugModule.Prelude.op_SlashEq x73 x74)
                                  DM.funcCallHook "_case_67"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x75, DI.genTerm x76, DI.genTerm x77]))
                                    (strict__case_67 x75 x76 x77)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x78])))
                           (strict__case_68 x1 x3)
                           x78)))
term_strict__case_68 x1 = DI.Term "_case_68" (DI.SrcID "XML" 0) x1
strict__case_67 x1 x3 x4
  = DM.eval
      (DM.funcDeclHook "_case_67"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x3, DI.genTerm x4]))
         (do x96 <- Prelude.return x4
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x96]))
               (case x96 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x93 <- do x91 <- do x13 <- DM.litHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo [] []))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Char
                                                                     'F'))
                                                      x14 <- do x11 <- DM.litHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo [] []))
                                                                         (Prelude.return
                                                                            (Curry.DebugModule.Prelude.Char
                                                                               'i'))
                                                                x12 <- do x9 <- DM.litHook
                                                                                  (DI.DebugInfo
                                                                                     (DI.SrcID "XML"
                                                                                        0)
                                                                                     (DI.DynamicInfo
                                                                                        []
                                                                                        []))
                                                                                  (Prelude.return
                                                                                     (Curry.DebugModule.Prelude.Char
                                                                                        'l'))
                                                                          x10 <- do x7 <- DM.litHook
                                                                                            (DI.DebugInfo
                                                                                               (DI.SrcID
                                                                                                  "XML"
                                                                                                  0)
                                                                                               (DI.DynamicInfo
                                                                                                  []
                                                                                                  []))
                                                                                            (Prelude.return
                                                                                               (Curry.DebugModule.Prelude.Char
                                                                                                  'e'))
                                                                                    x8 <- do x5 <- DM.litHook
                                                                                                     (DI.DebugInfo
                                                                                                        (DI.SrcID
                                                                                                           "XML"
                                                                                                           0)
                                                                                                        (DI.DynamicInfo
                                                                                                           []
                                                                                                           []))
                                                                                                     (Prelude.return
                                                                                                        (Curry.DebugModule.Prelude.Char
                                                                                                           ' '))
                                                                                             x6 <- DM.constructorHook
                                                                                                     (DI.DebugInfo
                                                                                                        (DI.SrcID
                                                                                                           "XML"
                                                                                                           0)
                                                                                                        (DI.DynamicInfo
                                                                                                           []
                                                                                                           []))
                                                                                                     (Prelude.return
                                                                                                        Curry.DebugModule.Prelude.Nil)
                                                                                             DM.constructorHook
                                                                                               (DI.DebugInfo
                                                                                                  (DI.SrcID
                                                                                                     "XML"
                                                                                                     0)
                                                                                                  (DI.DynamicInfo
                                                                                                     []
                                                                                                     [DI.genTerm
                                                                                                        x5,
                                                                                                      DI.genTerm
                                                                                                        x6]))
                                                                                               (Prelude.return
                                                                                                  (Curry.DebugModule.Prelude.Cons
                                                                                                     x5
                                                                                                     x6))
                                                                                    DM.constructorHook
                                                                                      (DI.DebugInfo
                                                                                         (DI.SrcID
                                                                                            "XML"
                                                                                            0)
                                                                                         (DI.DynamicInfo
                                                                                            []
                                                                                            [DI.genTerm
                                                                                               x7,
                                                                                             DI.genTerm
                                                                                               x8]))
                                                                                      (Prelude.return
                                                                                         (Curry.DebugModule.Prelude.Cons
                                                                                            x7
                                                                                            x8))
                                                                          DM.constructorHook
                                                                            (DI.DebugInfo
                                                                               (DI.SrcID "XML" 0)
                                                                               (DI.DynamicInfo []
                                                                                  [DI.genTerm x9,
                                                                                   DI.genTerm x10]))
                                                                            (Prelude.return
                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                  x9
                                                                                  x10))
                                                                DM.constructorHook
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x11,
                                                                         DI.genTerm x12]))
                                                                  (Prelude.return
                                                                     (Curry.DebugModule.Prelude.Cons
                                                                        x11
                                                                        x12))
                                                      DM.constructorHook
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x13, DI.genTerm x14]))
                                                        (Prelude.return
                                                           (Curry.DebugModule.Prelude.Cons x13 x14))
                                            x92 <- do x89 <- Prelude.return x1
                                                      x90 <- do x87 <- DM.litHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo [] []))
                                                                         (Prelude.return
                                                                            (Curry.DebugModule.Prelude.Char
                                                                               ' '))
                                                                x88 <- do x85 <- DM.litHook
                                                                                   (DI.DebugInfo
                                                                                      (DI.SrcID
                                                                                         "XML"
                                                                                         0)
                                                                                      (DI.DynamicInfo
                                                                                         []
                                                                                         []))
                                                                                   (Prelude.return
                                                                                      (Curry.DebugModule.Prelude.Char
                                                                                         'c'))
                                                                          x86 <- do x83 <- DM.litHook
                                                                                             (DI.DebugInfo
                                                                                                (DI.SrcID
                                                                                                   "XML"
                                                                                                   0)
                                                                                                (DI.DynamicInfo
                                                                                                   []
                                                                                                   []))
                                                                                             (Prelude.return
                                                                                                (Curry.DebugModule.Prelude.Char
                                                                                                   'o'))
                                                                                    x84 <- do x81 <- DM.litHook
                                                                                                       (DI.DebugInfo
                                                                                                          (DI.SrcID
                                                                                                             "XML"
                                                                                                             0)
                                                                                                          (DI.DynamicInfo
                                                                                                             []
                                                                                                             []))
                                                                                                       (Prelude.return
                                                                                                          (Curry.DebugModule.Prelude.Char
                                                                                                             'n'))
                                                                                              x82 <- do x79 <- DM.litHook
                                                                                                                 (DI.DebugInfo
                                                                                                                    (DI.SrcID
                                                                                                                       "XML"
                                                                                                                       0)
                                                                                                                    (DI.DynamicInfo
                                                                                                                       []
                                                                                                                       []))
                                                                                                                 (Prelude.return
                                                                                                                    (Curry.DebugModule.Prelude.Char
                                                                                                                       't'))
                                                                                                        x80 <- do x77 <- DM.litHook
                                                                                                                           (DI.DebugInfo
                                                                                                                              (DI.SrcID
                                                                                                                                 "XML"
                                                                                                                                 0)
                                                                                                                              (DI.DynamicInfo
                                                                                                                                 []
                                                                                                                                 []))
                                                                                                                           (Prelude.return
                                                                                                                              (Curry.DebugModule.Prelude.Char
                                                                                                                                 'a'))
                                                                                                                  x78 <- do x75 <- DM.litHook
                                                                                                                                     (DI.DebugInfo
                                                                                                                                        (DI.SrcID
                                                                                                                                           "XML"
                                                                                                                                           0)
                                                                                                                                        (DI.DynamicInfo
                                                                                                                                           []
                                                                                                                                           []))
                                                                                                                                     (Prelude.return
                                                                                                                                        (Curry.DebugModule.Prelude.Char
                                                                                                                                           'i'))
                                                                                                                            x76 <- do x73 <- DM.litHook
                                                                                                                                               (DI.DebugInfo
                                                                                                                                                  (DI.SrcID
                                                                                                                                                     "XML"
                                                                                                                                                     0)
                                                                                                                                                  (DI.DynamicInfo
                                                                                                                                                     []
                                                                                                                                                     []))
                                                                                                                                               (Prelude.return
                                                                                                                                                  (Curry.DebugModule.Prelude.Char
                                                                                                                                                     'n'))
                                                                                                                                      x74 <- do x71 <- DM.litHook
                                                                                                                                                         (DI.DebugInfo
                                                                                                                                                            (DI.SrcID
                                                                                                                                                               "XML"
                                                                                                                                                               0)
                                                                                                                                                            (DI.DynamicInfo
                                                                                                                                                               []
                                                                                                                                                               []))
                                                                                                                                                         (Prelude.return
                                                                                                                                                            (Curry.DebugModule.Prelude.Char
                                                                                                                                                               's'))
                                                                                                                                                x72 <- do x69 <- DM.litHook
                                                                                                                                                                   (DI.DebugInfo
                                                                                                                                                                      (DI.SrcID
                                                                                                                                                                         "XML"
                                                                                                                                                                         0)
                                                                                                                                                                      (DI.DynamicInfo
                                                                                                                                                                         []
                                                                                                                                                                         []))
                                                                                                                                                                   (Prelude.return
                                                                                                                                                                      (Curry.DebugModule.Prelude.Char
                                                                                                                                                                         ' '))
                                                                                                                                                          x70 <- do x67 <- DM.litHook
                                                                                                                                                                             (DI.DebugInfo
                                                                                                                                                                                (DI.SrcID
                                                                                                                                                                                   "XML"
                                                                                                                                                                                   0)
                                                                                                                                                                                (DI.DynamicInfo
                                                                                                                                                                                   []
                                                                                                                                                                                   []))
                                                                                                                                                                             (Prelude.return
                                                                                                                                                                                (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                   'm'))
                                                                                                                                                                    x68 <- do x65 <- DM.litHook
                                                                                                                                                                                       (DI.DebugInfo
                                                                                                                                                                                          (DI.SrcID
                                                                                                                                                                                             "XML"
                                                                                                                                                                                             0)
                                                                                                                                                                                          (DI.DynamicInfo
                                                                                                                                                                                             []
                                                                                                                                                                                             []))
                                                                                                                                                                                       (Prelude.return
                                                                                                                                                                                          (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                             'o'))
                                                                                                                                                                              x66 <- do x63 <- DM.litHook
                                                                                                                                                                                                 (DI.DebugInfo
                                                                                                                                                                                                    (DI.SrcID
                                                                                                                                                                                                       "XML"
                                                                                                                                                                                                       0)
                                                                                                                                                                                                    (DI.DynamicInfo
                                                                                                                                                                                                       []
                                                                                                                                                                                                       []))
                                                                                                                                                                                                 (Prelude.return
                                                                                                                                                                                                    (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                       'r'))
                                                                                                                                                                                        x64 <- do x61 <- DM.litHook
                                                                                                                                                                                                           (DI.DebugInfo
                                                                                                                                                                                                              (DI.SrcID
                                                                                                                                                                                                                 "XML"
                                                                                                                                                                                                                 0)
                                                                                                                                                                                                              (DI.DynamicInfo
                                                                                                                                                                                                                 []
                                                                                                                                                                                                                 []))
                                                                                                                                                                                                           (Prelude.return
                                                                                                                                                                                                              (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                 'e'))
                                                                                                                                                                                                  x62 <- do x59 <- DM.litHook
                                                                                                                                                                                                                     (DI.DebugInfo
                                                                                                                                                                                                                        (DI.SrcID
                                                                                                                                                                                                                           "XML"
                                                                                                                                                                                                                           0)
                                                                                                                                                                                                                        (DI.DynamicInfo
                                                                                                                                                                                                                           []
                                                                                                                                                                                                                           []))
                                                                                                                                                                                                                     (Prelude.return
                                                                                                                                                                                                                        (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                           ' '))
                                                                                                                                                                                                            x60 <- do x57 <- DM.litHook
                                                                                                                                                                                                                               (DI.DebugInfo
                                                                                                                                                                                                                                  (DI.SrcID
                                                                                                                                                                                                                                     "XML"
                                                                                                                                                                                                                                     0)
                                                                                                                                                                                                                                  (DI.DynamicInfo
                                                                                                                                                                                                                                     []
                                                                                                                                                                                                                                     []))
                                                                                                                                                                                                                               (Prelude.return
                                                                                                                                                                                                                                  (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                     't'))
                                                                                                                                                                                                                      x58 <- do x55 <- DM.litHook
                                                                                                                                                                                                                                         (DI.DebugInfo
                                                                                                                                                                                                                                            (DI.SrcID
                                                                                                                                                                                                                                               "XML"
                                                                                                                                                                                                                                               0)
                                                                                                                                                                                                                                            (DI.DynamicInfo
                                                                                                                                                                                                                                               []
                                                                                                                                                                                                                                               []))
                                                                                                                                                                                                                                         (Prelude.return
                                                                                                                                                                                                                                            (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                               'h'))
                                                                                                                                                                                                                                x56 <- do x53 <- DM.litHook
                                                                                                                                                                                                                                                   (DI.DebugInfo
                                                                                                                                                                                                                                                      (DI.SrcID
                                                                                                                                                                                                                                                         "XML"
                                                                                                                                                                                                                                                         0)
                                                                                                                                                                                                                                                      (DI.DynamicInfo
                                                                                                                                                                                                                                                         []
                                                                                                                                                                                                                                                         []))
                                                                                                                                                                                                                                                   (Prelude.return
                                                                                                                                                                                                                                                      (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                                         'a'))
                                                                                                                                                                                                                                          x54 <- do x51 <- DM.litHook
                                                                                                                                                                                                                                                             (DI.DebugInfo
                                                                                                                                                                                                                                                                (DI.SrcID
                                                                                                                                                                                                                                                                   "XML"
                                                                                                                                                                                                                                                                   0)
                                                                                                                                                                                                                                                                (DI.DynamicInfo
                                                                                                                                                                                                                                                                   []
                                                                                                                                                                                                                                                                   []))
                                                                                                                                                                                                                                                             (Prelude.return
                                                                                                                                                                                                                                                                (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                                                   'n'))
                                                                                                                                                                                                                                                    x52 <- do x49 <- DM.litHook
                                                                                                                                                                                                                                                                       (DI.DebugInfo
                                                                                                                                                                                                                                                                          (DI.SrcID
                                                                                                                                                                                                                                                                             "XML"
                                                                                                                                                                                                                                                                             0)
                                                                                                                                                                                                                                                                          (DI.DynamicInfo
                                                                                                                                                                                                                                                                             []
                                                                                                                                                                                                                                                                             []))
                                                                                                                                                                                                                                                                       (Prelude.return
                                                                                                                                                                                                                                                                          (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                                                             ' '))
                                                                                                                                                                                                                                                              x50 <- do x47 <- DM.litHook
                                                                                                                                                                                                                                                                                 (DI.DebugInfo
                                                                                                                                                                                                                                                                                    (DI.SrcID
                                                                                                                                                                                                                                                                                       "XML"
                                                                                                                                                                                                                                                                                       0)
                                                                                                                                                                                                                                                                                    (DI.DynamicInfo
                                                                                                                                                                                                                                                                                       []
                                                                                                                                                                                                                                                                                       []))
                                                                                                                                                                                                                                                                                 (Prelude.return
                                                                                                                                                                                                                                                                                    (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                                                                       'o'))
                                                                                                                                                                                                                                                                        x48 <- do x45 <- DM.litHook
                                                                                                                                                                                                                                                                                           (DI.DebugInfo
                                                                                                                                                                                                                                                                                              (DI.SrcID
                                                                                                                                                                                                                                                                                                 "XML"
                                                                                                                                                                                                                                                                                                 0)
                                                                                                                                                                                                                                                                                              (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                 []
                                                                                                                                                                                                                                                                                                 []))
                                                                                                                                                                                                                                                                                           (Prelude.return
                                                                                                                                                                                                                                                                                              (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                                                                                 'n'))
                                                                                                                                                                                                                                                                                  x46 <- do x43 <- DM.litHook
                                                                                                                                                                                                                                                                                                     (DI.DebugInfo
                                                                                                                                                                                                                                                                                                        (DI.SrcID
                                                                                                                                                                                                                                                                                                           "XML"
                                                                                                                                                                                                                                                                                                           0)
                                                                                                                                                                                                                                                                                                        (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                           []
                                                                                                                                                                                                                                                                                                           []))
                                                                                                                                                                                                                                                                                                     (Prelude.return
                                                                                                                                                                                                                                                                                                        (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                                                                                           'e'))
                                                                                                                                                                                                                                                                                            x44 <- do x41 <- DM.litHook
                                                                                                                                                                                                                                                                                                               (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                  (DI.SrcID
                                                                                                                                                                                                                                                                                                                     "XML"
                                                                                                                                                                                                                                                                                                                     0)
                                                                                                                                                                                                                                                                                                                  (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                     []
                                                                                                                                                                                                                                                                                                                     []))
                                                                                                                                                                                                                                                                                                               (Prelude.return
                                                                                                                                                                                                                                                                                                                  (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                                                                                                     ' '))
                                                                                                                                                                                                                                                                                                      x42 <- do x39 <- DM.litHook
                                                                                                                                                                                                                                                                                                                         (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                            (DI.SrcID
                                                                                                                                                                                                                                                                                                                               "XML"
                                                                                                                                                                                                                                                                                                                               0)
                                                                                                                                                                                                                                                                                                                            (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                               []
                                                                                                                                                                                                                                                                                                                               []))
                                                                                                                                                                                                                                                                                                                         (Prelude.return
                                                                                                                                                                                                                                                                                                                            (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                                                                                                               'X'))
                                                                                                                                                                                                                                                                                                                x40 <- do x37 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                   (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                      (DI.SrcID
                                                                                                                                                                                                                                                                                                                                         "XML"
                                                                                                                                                                                                                                                                                                                                         0)
                                                                                                                                                                                                                                                                                                                                      (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                         []
                                                                                                                                                                                                                                                                                                                                         []))
                                                                                                                                                                                                                                                                                                                                   (Prelude.return
                                                                                                                                                                                                                                                                                                                                      (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                                                                                                                         'M'))
                                                                                                                                                                                                                                                                                                                          x38 <- do x35 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                             (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                   "XML"
                                                                                                                                                                                                                                                                                                                                                   0)
                                                                                                                                                                                                                                                                                                                                                (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                   []
                                                                                                                                                                                                                                                                                                                                                   []))
                                                                                                                                                                                                                                                                                                                                             (Prelude.return
                                                                                                                                                                                                                                                                                                                                                (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                                                                                                                                   'L'))
                                                                                                                                                                                                                                                                                                                                    x36 <- do x33 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                       (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                          (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                             "XML"
                                                                                                                                                                                                                                                                                                                                                             0)
                                                                                                                                                                                                                                                                                                                                                          (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                             []
                                                                                                                                                                                                                                                                                                                                                             []))
                                                                                                                                                                                                                                                                                                                                                       (Prelude.return
                                                                                                                                                                                                                                                                                                                                                          (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                                                                                                                                             ' '))
                                                                                                                                                                                                                                                                                                                                              x34 <- do x31 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                                 (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                    (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                       "XML"
                                                                                                                                                                                                                                                                                                                                                                       0)
                                                                                                                                                                                                                                                                                                                                                                    (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                       []
                                                                                                                                                                                                                                                                                                                                                                       []))
                                                                                                                                                                                                                                                                                                                                                                 (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                    (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                                                                                                                                                       'd'))
                                                                                                                                                                                                                                                                                                                                                        x32 <- do x29 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                                           (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                              (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                 "XML"
                                                                                                                                                                                                                                                                                                                                                                                 0)
                                                                                                                                                                                                                                                                                                                                                                              (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                 []
                                                                                                                                                                                                                                                                                                                                                                                 []))
                                                                                                                                                                                                                                                                                                                                                                           (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                              (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                                                                                                                                                                 'o'))
                                                                                                                                                                                                                                                                                                                                                                  x30 <- do x27 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                                                     (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                        (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                           "XML"
                                                                                                                                                                                                                                                                                                                                                                                           0)
                                                                                                                                                                                                                                                                                                                                                                                        (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                           []
                                                                                                                                                                                                                                                                                                                                                                                           []))
                                                                                                                                                                                                                                                                                                                                                                                     (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                        (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                                                                                                                                                                           'c'))
                                                                                                                                                                                                                                                                                                                                                                            x28 <- do x25 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                                                               (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                  (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                     "XML"
                                                                                                                                                                                                                                                                                                                                                                                                     0)
                                                                                                                                                                                                                                                                                                                                                                                                  (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                     []
                                                                                                                                                                                                                                                                                                                                                                                                     []))
                                                                                                                                                                                                                                                                                                                                                                                               (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                  (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                                                                                                                                                                                     'u'))
                                                                                                                                                                                                                                                                                                                                                                                      x26 <- do x23 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                                                                         (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                            (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                               "XML"
                                                                                                                                                                                                                                                                                                                                                                                                               0)
                                                                                                                                                                                                                                                                                                                                                                                                            (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                               []
                                                                                                                                                                                                                                                                                                                                                                                                               []))
                                                                                                                                                                                                                                                                                                                                                                                                         (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                            (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                                                                                                                                                                                               'm'))
                                                                                                                                                                                                                                                                                                                                                                                                x24 <- do x21 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                                                                                   (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                      (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                         "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                         0)
                                                                                                                                                                                                                                                                                                                                                                                                                      (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                         []
                                                                                                                                                                                                                                                                                                                                                                                                                         []))
                                                                                                                                                                                                                                                                                                                                                                                                                   (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                      (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                                                                                                                                                                                                         'e'))
                                                                                                                                                                                                                                                                                                                                                                                                          x22 <- do x19 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                                                                                             (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                   "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                   0)
                                                                                                                                                                                                                                                                                                                                                                                                                                (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                   []
                                                                                                                                                                                                                                                                                                                                                                                                                                   []))
                                                                                                                                                                                                                                                                                                                                                                                                                             (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                                                                                                                                                                                                                   'n'))
                                                                                                                                                                                                                                                                                                                                                                                                                    x20 <- do x17 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                                                                                                       (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                          (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                             "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                             0)
                                                                                                                                                                                                                                                                                                                                                                                                                                          (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                             []
                                                                                                                                                                                                                                                                                                                                                                                                                                             []))
                                                                                                                                                                                                                                                                                                                                                                                                                                       (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                          (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                                                                                                                                                                                                                             't'))
                                                                                                                                                                                                                                                                                                                                                                                                                              x18 <- do x15 <- DM.litHook
                                                                                                                                                                                                                                                                                                                                                                                                                                                 (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                    (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                       "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                       0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                    (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                       []
                                                                                                                                                                                                                                                                                                                                                                                                                                                       []))
                                                                                                                                                                                                                                                                                                                                                                                                                                                 (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                    (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                                                                                                                                                                                                                                       '!'))
                                                                                                                                                                                                                                                                                                                                                                                                                                        x16 <- DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                                                                                                                 (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                    (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                       "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                       0)
                                                                                                                                                                                                                                                                                                                                                                                                                                                    (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                       []
                                                                                                                                                                                                                                                                                                                                                                                                                                                       []))
                                                                                                                                                                                                                                                                                                                                                                                                                                                 (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                                    Curry.DebugModule.Prelude.Nil)
                                                                                                                                                                                                                                                                                                                                                                                                                                        DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                                                                                                          (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                             (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                                "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                                0)
                                                                                                                                                                                                                                                                                                                                                                                                                                             (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                                []
                                                                                                                                                                                                                                                                                                                                                                                                                                                [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                                   x15,
                                                                                                                                                                                                                                                                                                                                                                                                                                                 DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                                   x16]))
                                                                                                                                                                                                                                                                                                                                                                                                                                          (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                             (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                                                                                                                x15
                                                                                                                                                                                                                                                                                                                                                                                                                                                x16))
                                                                                                                                                                                                                                                                                                                                                                                                                              DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                                                                                                (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                   (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                                      "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                                      0)
                                                                                                                                                                                                                                                                                                                                                                                                                                   (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                                      []
                                                                                                                                                                                                                                                                                                                                                                                                                                      [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                         x17,
                                                                                                                                                                                                                                                                                                                                                                                                                                       DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                                         x18]))
                                                                                                                                                                                                                                                                                                                                                                                                                                (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                                   (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                                                                                                      x17
                                                                                                                                                                                                                                                                                                                                                                                                                                      x18))
                                                                                                                                                                                                                                                                                                                                                                                                                    DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                                                                                      (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                                         (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                            "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                            0)
                                                                                                                                                                                                                                                                                                                                                                                                                         (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                            []
                                                                                                                                                                                                                                                                                                                                                                                                                            [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                               x19,
                                                                                                                                                                                                                                                                                                                                                                                                                             DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                               x20]))
                                                                                                                                                                                                                                                                                                                                                                                                                      (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                                         (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                                                                                            x19
                                                                                                                                                                                                                                                                                                                                                                                                                            x20))
                                                                                                                                                                                                                                                                                                                                                                                                          DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                                                                            (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                               (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                                  "XML"
                                                                                                                                                                                                                                                                                                                                                                                                                  0)
                                                                                                                                                                                                                                                                                                                                                                                                               (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                                  []
                                                                                                                                                                                                                                                                                                                                                                                                                  [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                     x21,
                                                                                                                                                                                                                                                                                                                                                                                                                   DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                                     x22]))
                                                                                                                                                                                                                                                                                                                                                                                                            (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                                                                                  x21
                                                                                                                                                                                                                                                                                                                                                                                                                  x22))
                                                                                                                                                                                                                                                                                                                                                                                                DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                                                                  (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                                     (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                                        "XML"
                                                                                                                                                                                                                                                                                                                                                                                                        0)
                                                                                                                                                                                                                                                                                                                                                                                                     (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                                        []
                                                                                                                                                                                                                                                                                                                                                                                                        [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                           x23,
                                                                                                                                                                                                                                                                                                                                                                                                         DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                           x24]))
                                                                                                                                                                                                                                                                                                                                                                                                  (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                                     (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                                                                        x23
                                                                                                                                                                                                                                                                                                                                                                                                        x24))
                                                                                                                                                                                                                                                                                                                                                                                      DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                                                        (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                           (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                              "XML"
                                                                                                                                                                                                                                                                                                                                                                                              0)
                                                                                                                                                                                                                                                                                                                                                                                           (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                              []
                                                                                                                                                                                                                                                                                                                                                                                              [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                 x25,
                                                                                                                                                                                                                                                                                                                                                                                               DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                                 x26]))
                                                                                                                                                                                                                                                                                                                                                                                        (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                           (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                                                              x25
                                                                                                                                                                                                                                                                                                                                                                                              x26))
                                                                                                                                                                                                                                                                                                                                                                            DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                                              (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                                 (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                                    "XML"
                                                                                                                                                                                                                                                                                                                                                                                    0)
                                                                                                                                                                                                                                                                                                                                                                                 (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                                    []
                                                                                                                                                                                                                                                                                                                                                                                    [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                       x27,
                                                                                                                                                                                                                                                                                                                                                                                     DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                                       x28]))
                                                                                                                                                                                                                                                                                                                                                                              (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                                 (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                                                    x27
                                                                                                                                                                                                                                                                                                                                                                                    x28))
                                                                                                                                                                                                                                                                                                                                                                  DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                                    (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                                       (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                          "XML"
                                                                                                                                                                                                                                                                                                                                                                          0)
                                                                                                                                                                                                                                                                                                                                                                       (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                          []
                                                                                                                                                                                                                                                                                                                                                                          [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                             x29,
                                                                                                                                                                                                                                                                                                                                                                           DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                             x30]))
                                                                                                                                                                                                                                                                                                                                                                    (Prelude.return
                                                                                                                                                                                                                                                                                                                                                                       (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                                          x29
                                                                                                                                                                                                                                                                                                                                                                          x30))
                                                                                                                                                                                                                                                                                                                                                        DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                          (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                             (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                                "XML"
                                                                                                                                                                                                                                                                                                                                                                0)
                                                                                                                                                                                                                                                                                                                                                             (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                                []
                                                                                                                                                                                                                                                                                                                                                                [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                   x31,
                                                                                                                                                                                                                                                                                                                                                                 DI.genTerm
                                                                                                                                                                                                                                                                                                                                                                   x32]))
                                                                                                                                                                                                                                                                                                                                                          (Prelude.return
                                                                                                                                                                                                                                                                                                                                                             (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                                x31
                                                                                                                                                                                                                                                                                                                                                                x32))
                                                                                                                                                                                                                                                                                                                                              DM.constructorHook
                                                                                                                                                                                                                                                                                                                                                (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                                   (DI.SrcID
                                                                                                                                                                                                                                                                                                                                                      "XML"
                                                                                                                                                                                                                                                                                                                                                      0)
                                                                                                                                                                                                                                                                                                                                                   (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                                      []
                                                                                                                                                                                                                                                                                                                                                      [DI.genTerm
                                                                                                                                                                                                                                                                                                                                                         x33,
                                                                                                                                                                                                                                                                                                                                                       DI.genTerm
                                                                                                                                                                                                                                                                                                                                                         x34]))
                                                                                                                                                                                                                                                                                                                                                (Prelude.return
                                                                                                                                                                                                                                                                                                                                                   (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                                      x33
                                                                                                                                                                                                                                                                                                                                                      x34))
                                                                                                                                                                                                                                                                                                                                    DM.constructorHook
                                                                                                                                                                                                                                                                                                                                      (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                                         (DI.SrcID
                                                                                                                                                                                                                                                                                                                                            "XML"
                                                                                                                                                                                                                                                                                                                                            0)
                                                                                                                                                                                                                                                                                                                                         (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                            []
                                                                                                                                                                                                                                                                                                                                            [DI.genTerm
                                                                                                                                                                                                                                                                                                                                               x35,
                                                                                                                                                                                                                                                                                                                                             DI.genTerm
                                                                                                                                                                                                                                                                                                                                               x36]))
                                                                                                                                                                                                                                                                                                                                      (Prelude.return
                                                                                                                                                                                                                                                                                                                                         (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                            x35
                                                                                                                                                                                                                                                                                                                                            x36))
                                                                                                                                                                                                                                                                                                                          DM.constructorHook
                                                                                                                                                                                                                                                                                                                            (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                               (DI.SrcID
                                                                                                                                                                                                                                                                                                                                  "XML"
                                                                                                                                                                                                                                                                                                                                  0)
                                                                                                                                                                                                                                                                                                                               (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                                  []
                                                                                                                                                                                                                                                                                                                                  [DI.genTerm
                                                                                                                                                                                                                                                                                                                                     x37,
                                                                                                                                                                                                                                                                                                                                   DI.genTerm
                                                                                                                                                                                                                                                                                                                                     x38]))
                                                                                                                                                                                                                                                                                                                            (Prelude.return
                                                                                                                                                                                                                                                                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                                  x37
                                                                                                                                                                                                                                                                                                                                  x38))
                                                                                                                                                                                                                                                                                                                DM.constructorHook
                                                                                                                                                                                                                                                                                                                  (DI.DebugInfo
                                                                                                                                                                                                                                                                                                                     (DI.SrcID
                                                                                                                                                                                                                                                                                                                        "XML"
                                                                                                                                                                                                                                                                                                                        0)
                                                                                                                                                                                                                                                                                                                     (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                                        []
                                                                                                                                                                                                                                                                                                                        [DI.genTerm
                                                                                                                                                                                                                                                                                                                           x39,
                                                                                                                                                                                                                                                                                                                         DI.genTerm
                                                                                                                                                                                                                                                                                                                           x40]))
                                                                                                                                                                                                                                                                                                                  (Prelude.return
                                                                                                                                                                                                                                                                                                                     (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                                        x39
                                                                                                                                                                                                                                                                                                                        x40))
                                                                                                                                                                                                                                                                                                      DM.constructorHook
                                                                                                                                                                                                                                                                                                        (DI.DebugInfo
                                                                                                                                                                                                                                                                                                           (DI.SrcID
                                                                                                                                                                                                                                                                                                              "XML"
                                                                                                                                                                                                                                                                                                              0)
                                                                                                                                                                                                                                                                                                           (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                              []
                                                                                                                                                                                                                                                                                                              [DI.genTerm
                                                                                                                                                                                                                                                                                                                 x41,
                                                                                                                                                                                                                                                                                                               DI.genTerm
                                                                                                                                                                                                                                                                                                                 x42]))
                                                                                                                                                                                                                                                                                                        (Prelude.return
                                                                                                                                                                                                                                                                                                           (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                              x41
                                                                                                                                                                                                                                                                                                              x42))
                                                                                                                                                                                                                                                                                            DM.constructorHook
                                                                                                                                                                                                                                                                                              (DI.DebugInfo
                                                                                                                                                                                                                                                                                                 (DI.SrcID
                                                                                                                                                                                                                                                                                                    "XML"
                                                                                                                                                                                                                                                                                                    0)
                                                                                                                                                                                                                                                                                                 (DI.DynamicInfo
                                                                                                                                                                                                                                                                                                    []
                                                                                                                                                                                                                                                                                                    [DI.genTerm
                                                                                                                                                                                                                                                                                                       x43,
                                                                                                                                                                                                                                                                                                     DI.genTerm
                                                                                                                                                                                                                                                                                                       x44]))
                                                                                                                                                                                                                                                                                              (Prelude.return
                                                                                                                                                                                                                                                                                                 (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                                    x43
                                                                                                                                                                                                                                                                                                    x44))
                                                                                                                                                                                                                                                                                  DM.constructorHook
                                                                                                                                                                                                                                                                                    (DI.DebugInfo
                                                                                                                                                                                                                                                                                       (DI.SrcID
                                                                                                                                                                                                                                                                                          "XML"
                                                                                                                                                                                                                                                                                          0)
                                                                                                                                                                                                                                                                                       (DI.DynamicInfo
                                                                                                                                                                                                                                                                                          []
                                                                                                                                                                                                                                                                                          [DI.genTerm
                                                                                                                                                                                                                                                                                             x45,
                                                                                                                                                                                                                                                                                           DI.genTerm
                                                                                                                                                                                                                                                                                             x46]))
                                                                                                                                                                                                                                                                                    (Prelude.return
                                                                                                                                                                                                                                                                                       (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                          x45
                                                                                                                                                                                                                                                                                          x46))
                                                                                                                                                                                                                                                                        DM.constructorHook
                                                                                                                                                                                                                                                                          (DI.DebugInfo
                                                                                                                                                                                                                                                                             (DI.SrcID
                                                                                                                                                                                                                                                                                "XML"
                                                                                                                                                                                                                                                                                0)
                                                                                                                                                                                                                                                                             (DI.DynamicInfo
                                                                                                                                                                                                                                                                                []
                                                                                                                                                                                                                                                                                [DI.genTerm
                                                                                                                                                                                                                                                                                   x47,
                                                                                                                                                                                                                                                                                 DI.genTerm
                                                                                                                                                                                                                                                                                   x48]))
                                                                                                                                                                                                                                                                          (Prelude.return
                                                                                                                                                                                                                                                                             (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                                x47
                                                                                                                                                                                                                                                                                x48))
                                                                                                                                                                                                                                                              DM.constructorHook
                                                                                                                                                                                                                                                                (DI.DebugInfo
                                                                                                                                                                                                                                                                   (DI.SrcID
                                                                                                                                                                                                                                                                      "XML"
                                                                                                                                                                                                                                                                      0)
                                                                                                                                                                                                                                                                   (DI.DynamicInfo
                                                                                                                                                                                                                                                                      []
                                                                                                                                                                                                                                                                      [DI.genTerm
                                                                                                                                                                                                                                                                         x49,
                                                                                                                                                                                                                                                                       DI.genTerm
                                                                                                                                                                                                                                                                         x50]))
                                                                                                                                                                                                                                                                (Prelude.return
                                                                                                                                                                                                                                                                   (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                                      x49
                                                                                                                                                                                                                                                                      x50))
                                                                                                                                                                                                                                                    DM.constructorHook
                                                                                                                                                                                                                                                      (DI.DebugInfo
                                                                                                                                                                                                                                                         (DI.SrcID
                                                                                                                                                                                                                                                            "XML"
                                                                                                                                                                                                                                                            0)
                                                                                                                                                                                                                                                         (DI.DynamicInfo
                                                                                                                                                                                                                                                            []
                                                                                                                                                                                                                                                            [DI.genTerm
                                                                                                                                                                                                                                                               x51,
                                                                                                                                                                                                                                                             DI.genTerm
                                                                                                                                                                                                                                                               x52]))
                                                                                                                                                                                                                                                      (Prelude.return
                                                                                                                                                                                                                                                         (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                            x51
                                                                                                                                                                                                                                                            x52))
                                                                                                                                                                                                                                          DM.constructorHook
                                                                                                                                                                                                                                            (DI.DebugInfo
                                                                                                                                                                                                                                               (DI.SrcID
                                                                                                                                                                                                                                                  "XML"
                                                                                                                                                                                                                                                  0)
                                                                                                                                                                                                                                               (DI.DynamicInfo
                                                                                                                                                                                                                                                  []
                                                                                                                                                                                                                                                  [DI.genTerm
                                                                                                                                                                                                                                                     x53,
                                                                                                                                                                                                                                                   DI.genTerm
                                                                                                                                                                                                                                                     x54]))
                                                                                                                                                                                                                                            (Prelude.return
                                                                                                                                                                                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                  x53
                                                                                                                                                                                                                                                  x54))
                                                                                                                                                                                                                                DM.constructorHook
                                                                                                                                                                                                                                  (DI.DebugInfo
                                                                                                                                                                                                                                     (DI.SrcID
                                                                                                                                                                                                                                        "XML"
                                                                                                                                                                                                                                        0)
                                                                                                                                                                                                                                     (DI.DynamicInfo
                                                                                                                                                                                                                                        []
                                                                                                                                                                                                                                        [DI.genTerm
                                                                                                                                                                                                                                           x55,
                                                                                                                                                                                                                                         DI.genTerm
                                                                                                                                                                                                                                           x56]))
                                                                                                                                                                                                                                  (Prelude.return
                                                                                                                                                                                                                                     (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                        x55
                                                                                                                                                                                                                                        x56))
                                                                                                                                                                                                                      DM.constructorHook
                                                                                                                                                                                                                        (DI.DebugInfo
                                                                                                                                                                                                                           (DI.SrcID
                                                                                                                                                                                                                              "XML"
                                                                                                                                                                                                                              0)
                                                                                                                                                                                                                           (DI.DynamicInfo
                                                                                                                                                                                                                              []
                                                                                                                                                                                                                              [DI.genTerm
                                                                                                                                                                                                                                 x57,
                                                                                                                                                                                                                               DI.genTerm
                                                                                                                                                                                                                                 x58]))
                                                                                                                                                                                                                        (Prelude.return
                                                                                                                                                                                                                           (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                              x57
                                                                                                                                                                                                                              x58))
                                                                                                                                                                                                            DM.constructorHook
                                                                                                                                                                                                              (DI.DebugInfo
                                                                                                                                                                                                                 (DI.SrcID
                                                                                                                                                                                                                    "XML"
                                                                                                                                                                                                                    0)
                                                                                                                                                                                                                 (DI.DynamicInfo
                                                                                                                                                                                                                    []
                                                                                                                                                                                                                    [DI.genTerm
                                                                                                                                                                                                                       x59,
                                                                                                                                                                                                                     DI.genTerm
                                                                                                                                                                                                                       x60]))
                                                                                                                                                                                                              (Prelude.return
                                                                                                                                                                                                                 (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                    x59
                                                                                                                                                                                                                    x60))
                                                                                                                                                                                                  DM.constructorHook
                                                                                                                                                                                                    (DI.DebugInfo
                                                                                                                                                                                                       (DI.SrcID
                                                                                                                                                                                                          "XML"
                                                                                                                                                                                                          0)
                                                                                                                                                                                                       (DI.DynamicInfo
                                                                                                                                                                                                          []
                                                                                                                                                                                                          [DI.genTerm
                                                                                                                                                                                                             x61,
                                                                                                                                                                                                           DI.genTerm
                                                                                                                                                                                                             x62]))
                                                                                                                                                                                                    (Prelude.return
                                                                                                                                                                                                       (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                          x61
                                                                                                                                                                                                          x62))
                                                                                                                                                                                        DM.constructorHook
                                                                                                                                                                                          (DI.DebugInfo
                                                                                                                                                                                             (DI.SrcID
                                                                                                                                                                                                "XML"
                                                                                                                                                                                                0)
                                                                                                                                                                                             (DI.DynamicInfo
                                                                                                                                                                                                []
                                                                                                                                                                                                [DI.genTerm
                                                                                                                                                                                                   x63,
                                                                                                                                                                                                 DI.genTerm
                                                                                                                                                                                                   x64]))
                                                                                                                                                                                          (Prelude.return
                                                                                                                                                                                             (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                x63
                                                                                                                                                                                                x64))
                                                                                                                                                                              DM.constructorHook
                                                                                                                                                                                (DI.DebugInfo
                                                                                                                                                                                   (DI.SrcID
                                                                                                                                                                                      "XML"
                                                                                                                                                                                      0)
                                                                                                                                                                                   (DI.DynamicInfo
                                                                                                                                                                                      []
                                                                                                                                                                                      [DI.genTerm
                                                                                                                                                                                         x65,
                                                                                                                                                                                       DI.genTerm
                                                                                                                                                                                         x66]))
                                                                                                                                                                                (Prelude.return
                                                                                                                                                                                   (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                      x65
                                                                                                                                                                                      x66))
                                                                                                                                                                    DM.constructorHook
                                                                                                                                                                      (DI.DebugInfo
                                                                                                                                                                         (DI.SrcID
                                                                                                                                                                            "XML"
                                                                                                                                                                            0)
                                                                                                                                                                         (DI.DynamicInfo
                                                                                                                                                                            []
                                                                                                                                                                            [DI.genTerm
                                                                                                                                                                               x67,
                                                                                                                                                                             DI.genTerm
                                                                                                                                                                               x68]))
                                                                                                                                                                      (Prelude.return
                                                                                                                                                                         (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                            x67
                                                                                                                                                                            x68))
                                                                                                                                                          DM.constructorHook
                                                                                                                                                            (DI.DebugInfo
                                                                                                                                                               (DI.SrcID
                                                                                                                                                                  "XML"
                                                                                                                                                                  0)
                                                                                                                                                               (DI.DynamicInfo
                                                                                                                                                                  []
                                                                                                                                                                  [DI.genTerm
                                                                                                                                                                     x69,
                                                                                                                                                                   DI.genTerm
                                                                                                                                                                     x70]))
                                                                                                                                                            (Prelude.return
                                                                                                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                  x69
                                                                                                                                                                  x70))
                                                                                                                                                DM.constructorHook
                                                                                                                                                  (DI.DebugInfo
                                                                                                                                                     (DI.SrcID
                                                                                                                                                        "XML"
                                                                                                                                                        0)
                                                                                                                                                     (DI.DynamicInfo
                                                                                                                                                        []
                                                                                                                                                        [DI.genTerm
                                                                                                                                                           x71,
                                                                                                                                                         DI.genTerm
                                                                                                                                                           x72]))
                                                                                                                                                  (Prelude.return
                                                                                                                                                     (Curry.DebugModule.Prelude.Cons
                                                                                                                                                        x71
                                                                                                                                                        x72))
                                                                                                                                      DM.constructorHook
                                                                                                                                        (DI.DebugInfo
                                                                                                                                           (DI.SrcID
                                                                                                                                              "XML"
                                                                                                                                              0)
                                                                                                                                           (DI.DynamicInfo
                                                                                                                                              []
                                                                                                                                              [DI.genTerm
                                                                                                                                                 x73,
                                                                                                                                               DI.genTerm
                                                                                                                                                 x74]))
                                                                                                                                        (Prelude.return
                                                                                                                                           (Curry.DebugModule.Prelude.Cons
                                                                                                                                              x73
                                                                                                                                              x74))
                                                                                                                            DM.constructorHook
                                                                                                                              (DI.DebugInfo
                                                                                                                                 (DI.SrcID
                                                                                                                                    "XML"
                                                                                                                                    0)
                                                                                                                                 (DI.DynamicInfo
                                                                                                                                    []
                                                                                                                                    [DI.genTerm
                                                                                                                                       x75,
                                                                                                                                     DI.genTerm
                                                                                                                                       x76]))
                                                                                                                              (Prelude.return
                                                                                                                                 (Curry.DebugModule.Prelude.Cons
                                                                                                                                    x75
                                                                                                                                    x76))
                                                                                                                  DM.constructorHook
                                                                                                                    (DI.DebugInfo
                                                                                                                       (DI.SrcID
                                                                                                                          "XML"
                                                                                                                          0)
                                                                                                                       (DI.DynamicInfo
                                                                                                                          []
                                                                                                                          [DI.genTerm
                                                                                                                             x77,
                                                                                                                           DI.genTerm
                                                                                                                             x78]))
                                                                                                                    (Prelude.return
                                                                                                                       (Curry.DebugModule.Prelude.Cons
                                                                                                                          x77
                                                                                                                          x78))
                                                                                                        DM.constructorHook
                                                                                                          (DI.DebugInfo
                                                                                                             (DI.SrcID
                                                                                                                "XML"
                                                                                                                0)
                                                                                                             (DI.DynamicInfo
                                                                                                                []
                                                                                                                [DI.genTerm
                                                                                                                   x79,
                                                                                                                 DI.genTerm
                                                                                                                   x80]))
                                                                                                          (Prelude.return
                                                                                                             (Curry.DebugModule.Prelude.Cons
                                                                                                                x79
                                                                                                                x80))
                                                                                              DM.constructorHook
                                                                                                (DI.DebugInfo
                                                                                                   (DI.SrcID
                                                                                                      "XML"
                                                                                                      0)
                                                                                                   (DI.DynamicInfo
                                                                                                      []
                                                                                                      [DI.genTerm
                                                                                                         x81,
                                                                                                       DI.genTerm
                                                                                                         x82]))
                                                                                                (Prelude.return
                                                                                                   (Curry.DebugModule.Prelude.Cons
                                                                                                      x81
                                                                                                      x82))
                                                                                    DM.constructorHook
                                                                                      (DI.DebugInfo
                                                                                         (DI.SrcID
                                                                                            "XML"
                                                                                            0)
                                                                                         (DI.DynamicInfo
                                                                                            []
                                                                                            [DI.genTerm
                                                                                               x83,
                                                                                             DI.genTerm
                                                                                               x84]))
                                                                                      (Prelude.return
                                                                                         (Curry.DebugModule.Prelude.Cons
                                                                                            x83
                                                                                            x84))
                                                                          DM.constructorHook
                                                                            (DI.DebugInfo
                                                                               (DI.SrcID "XML" 0)
                                                                               (DI.DynamicInfo []
                                                                                  [DI.genTerm x85,
                                                                                   DI.genTerm x86]))
                                                                            (Prelude.return
                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                  x85
                                                                                  x86))
                                                                DM.constructorHook
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x87,
                                                                         DI.genTerm x88]))
                                                                  (Prelude.return
                                                                     (Curry.DebugModule.Prelude.Cons
                                                                        x87
                                                                        x88))
                                                      DM.funcCallHook "++"
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x89, DI.genTerm x90]))
                                                        (Curry.DebugModule.Prelude.op_PlusPlus x89
                                                           x90)
                                            DM.funcCallHook "++"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x91, DI.genTerm x92]))
                                              (Curry.DebugModule.Prelude.op_PlusPlus x91 x92)
                                  DM.funcCallHook "error"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x93]))
                                    (Curry.DebugModule.Prelude.strict_error x93)))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x95 <- do x94 <- Prelude.return x3
                                            DM.funcCallHook "head"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo [] [DI.genTerm x94]))
                                              (Curry.DebugModule.Prelude.strict_head x94)
                                  DM.funcCallHook "return"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x95]))
                                    (Curry.DebugModule.Prelude.strict_return x95)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x96])))
                           (strict__case_67 x1 x3)
                           x96)))
term_strict__case_67 x1 = DI.Term "_case_67" (DI.SrcID "XML" 0) x1
strict__case_73 x1
  = DM.eval
      (DM.funcDeclHook "_case_73"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x9 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x9]))
               (case x9 of
                    Curry.DebugModule.Prelude.Nil
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.constructorHook
                                 (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                 (Prelude.return Curry.DebugModule.Prelude.Nil)))
                    Curry.DebugModule.Prelude.Cons x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x6 <- Prelude.return x2
                                  x7 <- Prelude.return x3
                                  x8 <- do x4 <- Prelude.return x2
                                           x5 <- DM.litHook
                                                   (DI.DebugInfo (DI.SrcID "XML" 0)
                                                      (DI.DynamicInfo [] []))
                                                   (Prelude.return
                                                      (Curry.DebugModule.Prelude.Char '#'))
                                           DM.funcCallHook "=="
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x4, DI.genTerm x5]))
                                             (Curry.DebugModule.Prelude.op_EqEq x4 x5)
                                  DM.funcCallHook "_case_72"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x6, DI.genTerm x7, DI.genTerm x8]))
                                    (strict__case_72 x6 x7 x8)))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x9])))
                           strict__case_73
                           x9)))
term_strict__case_73 x1 = DI.Term "_case_73" (DI.SrcID "XML" 0) x1
strict__case_72 x2 x3 x4
  = DM.eval
      (DM.funcDeclHook "_case_72"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x2, DI.genTerm x3, DI.genTerm x4]))
         (do x9 <- Prelude.return x4
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x9]))
               (case x9 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x5 <- Prelude.return x3
                                  DM.funcCallHook "_case_71"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x5]))
                                    (strict__case_71 x5)))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x6 <- Prelude.return x2
                                  x7 <- Prelude.return x3
                                  x8 <- DM.funcCallHook "otherwise"
                                          (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                          Curry.DebugModule.Prelude.strict_otherwise
                                  DM.funcCallHook "_case_69"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x6, DI.genTerm x7, DI.genTerm x8]))
                                    (strict__case_69 x6 x7 x8)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x9])))
                           (strict__case_72 x2 x3)
                           x9)))
term_strict__case_72 x1 = DI.Term "_case_72" (DI.SrcID "XML" 0) x1
strict__case_69 x2 x3 x4
  = DM.eval
      (DM.funcDeclHook "_case_69"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x2, DI.genTerm x3, DI.genTerm x4]))
         (do x13 <- Prelude.return x4
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x13]))
               (case x13 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x11 <- DM.litHook
                                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                           (Prelude.return (Curry.DebugModule.Prelude.Char '&'))
                                  x12 <- do x9 <- do x5 <- Prelude.return x2
                                                     x6 <- Prelude.return x3
                                                     DM.constructorHook
                                                       (DI.DebugInfo (DI.SrcID "XML" 0)
                                                          (DI.DynamicInfo []
                                                             [DI.genTerm x5, DI.genTerm x6]))
                                                       (Prelude.return
                                                          (Curry.DebugModule.Prelude.Cons x5 x6))
                                            x10 <- do x7 <- DM.litHook
                                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                 (DI.DynamicInfo [] []))
                                                              (Prelude.return
                                                                 (Curry.DebugModule.Prelude.Char
                                                                    ';'))
                                                      x8 <- DM.constructorHook
                                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                 (DI.DynamicInfo [] []))
                                                              (Prelude.return
                                                                 Curry.DebugModule.Prelude.Nil)
                                                      DM.constructorHook
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x7, DI.genTerm x8]))
                                                        (Prelude.return
                                                           (Curry.DebugModule.Prelude.Cons x7 x8))
                                            DM.funcCallHook "++"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x9, DI.genTerm x10]))
                                              (Curry.DebugModule.Prelude.op_PlusPlus x9 x10)
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x11, DI.genTerm x12]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Cons x11 x12))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.funcCallHook "failed"
                                 (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                 Curry.DebugModule.Prelude.strict_failed))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x13])))
                           (strict__case_69 x2 x3)
                           x13)))
term_strict__case_69 x1 = DI.Term "_case_69" (DI.SrcID "XML" 0) x1
strict__case_71 x3
  = DM.eval
      (DM.funcDeclHook "_case_71"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x3]))
         (do x16 <- Prelude.return x3
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x16]))
               (case x16 of
                    Curry.DebugModule.Prelude.Cons x4 x5
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x8 <- Prelude.return x3
                                  x9 <- Prelude.return x4
                                  x10 <- Prelude.return x5
                                  x11 <- do x6 <- Prelude.return x4
                                            x7 <- DM.litHook
                                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                                       (DI.DynamicInfo [] []))
                                                    (Prelude.return
                                                       (Curry.DebugModule.Prelude.Char 'x'))
                                            DM.funcCallHook "=="
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo [] [DI.genTerm x6, DI.genTerm x7]))
                                              (Curry.DebugModule.Prelude.op_EqEq x6 x7)
                                  DM.funcCallHook "_case_70"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x8, DI.genTerm x9, DI.genTerm x10,
                                           DI.genTerm x11]))
                                    (strict__case_70 x8 x9 x10 x11)))
                    Curry.DebugModule.Prelude.Nil
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x14 <- do x13 <- do x12 <- Prelude.return x3
                                                      DM.funcCallHook "readInt"
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo [] [DI.genTerm x12]))
                                                        (Curry.DebugModule.Read.strict_readInt x12)
                                            DM.funcCallHook "chr"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo [] [DI.genTerm x13]))
                                              (Curry.DebugModule.Prelude.strict_chr x13)
                                  x15 <- DM.constructorHook
                                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                           (Prelude.return Curry.DebugModule.Prelude.Nil)
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x14, DI.genTerm x15]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Cons x14 x15))))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x16])))
                           strict__case_71
                           x16)))
term_strict__case_71 x1 = DI.Term "_case_71" (DI.SrcID "XML" 0) x1
strict__case_70 x3 x4 x5 x6
  = DM.eval
      (DM.funcDeclHook "_case_70"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo []
               [DI.genTerm x3, DI.genTerm x4, DI.genTerm x5, DI.genTerm x6]))
         (do x15 <- Prelude.return x6
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x15]))
               (case x15 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x9 <- do x8 <- do x7 <- Prelude.return x5
                                                    DM.funcCallHook "readHex"
                                                      (DI.DebugInfo (DI.SrcID "XML" 0)
                                                         (DI.DynamicInfo [] [DI.genTerm x7]))
                                                      (Curry.DebugModule.Read.strict_readHex x7)
                                           DM.funcCallHook "chr"
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x8]))
                                             (Curry.DebugModule.Prelude.strict_chr x8)
                                  x10 <- DM.constructorHook
                                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                           (Prelude.return Curry.DebugModule.Prelude.Nil)
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x9, DI.genTerm x10]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Cons x9 x10))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x13 <- do x12 <- do x11 <- Prelude.return x3
                                                      DM.funcCallHook "readInt"
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo [] [DI.genTerm x11]))
                                                        (Curry.DebugModule.Read.strict_readInt x11)
                                            DM.funcCallHook "chr"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo [] [DI.genTerm x12]))
                                              (Curry.DebugModule.Prelude.strict_chr x12)
                                  x14 <- DM.constructorHook
                                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                           (Prelude.return Curry.DebugModule.Prelude.Nil)
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x13, DI.genTerm x14]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Cons x13 x14))))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x15])))
                           (strict__case_70 x3 x4 x5)
                           x15)))
term_strict__case_70 x1 = DI.Term "_case_70" (DI.SrcID "XML" 0) x1
strict__case_86 x1 x2 x3
  = DM.eval
      (DM.funcDeclHook "_case_86"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x2, DI.genTerm x3]))
         (do x16 <- Prelude.return x3
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x16]))
               (case x16 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x5 <- DM.litHook
                                          (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                          (Prelude.return (Curry.DebugModule.Prelude.Char '<'))
                                  x6 <- do x4 <- Prelude.return x2
                                           DM.funcCallHook "xmlUnquoteSpecials"
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x4]))
                                             (strict_xmlUnquoteSpecials x4)
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x5, DI.genTerm x6]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Cons x5 x6))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x13 <- Prelude.return x1
                                  x14 <- Prelude.return x2
                                  x15 <- do x11 <- Prelude.return x1
                                            x12 <- do x9 <- DM.litHook
                                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                 (DI.DynamicInfo [] []))
                                                              (Prelude.return
                                                                 (Curry.DebugModule.Prelude.Char
                                                                    'g'))
                                                      x10 <- do x7 <- DM.litHook
                                                                        (DI.DebugInfo
                                                                           (DI.SrcID "XML" 0)
                                                                           (DI.DynamicInfo [] []))
                                                                        (Prelude.return
                                                                           (Curry.DebugModule.Prelude.Char
                                                                              't'))
                                                                x8 <- DM.constructorHook
                                                                        (DI.DebugInfo
                                                                           (DI.SrcID "XML" 0)
                                                                           (DI.DynamicInfo [] []))
                                                                        (Prelude.return
                                                                           Curry.DebugModule.Prelude.Nil)
                                                                DM.constructorHook
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x7,
                                                                         DI.genTerm x8]))
                                                                  (Prelude.return
                                                                     (Curry.DebugModule.Prelude.Cons
                                                                        x7
                                                                        x8))
                                                      DM.constructorHook
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x9, DI.genTerm x10]))
                                                        (Prelude.return
                                                           (Curry.DebugModule.Prelude.Cons x9 x10))
                                            DM.funcCallHook "=="
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x11, DI.genTerm x12]))
                                              (Curry.DebugModule.Prelude.op_EqEq x11 x12)
                                  DM.funcCallHook "_case_85"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x13, DI.genTerm x14, DI.genTerm x15]))
                                    (strict__case_85 x13 x14 x15)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x16])))
                           (strict__case_86 x1 x2)
                           x16)))
term_strict__case_86 x1 = DI.Term "_case_86" (DI.SrcID "XML" 0) x1
strict__case_85 x1 x2 x3
  = DM.eval
      (DM.funcDeclHook "_case_85"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x2, DI.genTerm x3]))
         (do x18 <- Prelude.return x3
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x18]))
               (case x18 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x5 <- DM.litHook
                                          (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                          (Prelude.return (Curry.DebugModule.Prelude.Char '>'))
                                  x6 <- do x4 <- Prelude.return x2
                                           DM.funcCallHook "xmlUnquoteSpecials"
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x4]))
                                             (strict_xmlUnquoteSpecials x4)
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x5, DI.genTerm x6]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Cons x5 x6))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x15 <- Prelude.return x1
                                  x16 <- Prelude.return x2
                                  x17 <- do x13 <- Prelude.return x1
                                            x14 <- do x11 <- DM.litHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo [] []))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Char
                                                                     'a'))
                                                      x12 <- do x9 <- DM.litHook
                                                                        (DI.DebugInfo
                                                                           (DI.SrcID "XML" 0)
                                                                           (DI.DynamicInfo [] []))
                                                                        (Prelude.return
                                                                           (Curry.DebugModule.Prelude.Char
                                                                              'm'))
                                                                x10 <- do x7 <- DM.litHook
                                                                                  (DI.DebugInfo
                                                                                     (DI.SrcID "XML"
                                                                                        0)
                                                                                     (DI.DynamicInfo
                                                                                        []
                                                                                        []))
                                                                                  (Prelude.return
                                                                                     (Curry.DebugModule.Prelude.Char
                                                                                        'p'))
                                                                          x8 <- DM.constructorHook
                                                                                  (DI.DebugInfo
                                                                                     (DI.SrcID "XML"
                                                                                        0)
                                                                                     (DI.DynamicInfo
                                                                                        []
                                                                                        []))
                                                                                  (Prelude.return
                                                                                     Curry.DebugModule.Prelude.Nil)
                                                                          DM.constructorHook
                                                                            (DI.DebugInfo
                                                                               (DI.SrcID "XML" 0)
                                                                               (DI.DynamicInfo []
                                                                                  [DI.genTerm x7,
                                                                                   DI.genTerm x8]))
                                                                            (Prelude.return
                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                  x7
                                                                                  x8))
                                                                DM.constructorHook
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x9,
                                                                         DI.genTerm x10]))
                                                                  (Prelude.return
                                                                     (Curry.DebugModule.Prelude.Cons
                                                                        x9
                                                                        x10))
                                                      DM.constructorHook
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x11, DI.genTerm x12]))
                                                        (Prelude.return
                                                           (Curry.DebugModule.Prelude.Cons x11 x12))
                                            DM.funcCallHook "=="
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x13, DI.genTerm x14]))
                                              (Curry.DebugModule.Prelude.op_EqEq x13 x14)
                                  DM.funcCallHook "_case_84"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x15, DI.genTerm x16, DI.genTerm x17]))
                                    (strict__case_84 x15 x16 x17)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x18])))
                           (strict__case_85 x1 x2)
                           x18)))
term_strict__case_85 x1 = DI.Term "_case_85" (DI.SrcID "XML" 0) x1
strict__case_84 x1 x2 x3
  = DM.eval
      (DM.funcDeclHook "_case_84"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x2, DI.genTerm x3]))
         (do x20 <- Prelude.return x3
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x20]))
               (case x20 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x5 <- DM.litHook
                                          (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                          (Prelude.return (Curry.DebugModule.Prelude.Char '&'))
                                  x6 <- do x4 <- Prelude.return x2
                                           DM.funcCallHook "xmlUnquoteSpecials"
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x4]))
                                             (strict_xmlUnquoteSpecials x4)
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x5, DI.genTerm x6]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Cons x5 x6))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x17 <- Prelude.return x1
                                  x18 <- Prelude.return x2
                                  x19 <- do x15 <- Prelude.return x1
                                            x16 <- do x13 <- DM.litHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo [] []))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Char
                                                                     'q'))
                                                      x14 <- do x11 <- DM.litHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo [] []))
                                                                         (Prelude.return
                                                                            (Curry.DebugModule.Prelude.Char
                                                                               'u'))
                                                                x12 <- do x9 <- DM.litHook
                                                                                  (DI.DebugInfo
                                                                                     (DI.SrcID "XML"
                                                                                        0)
                                                                                     (DI.DynamicInfo
                                                                                        []
                                                                                        []))
                                                                                  (Prelude.return
                                                                                     (Curry.DebugModule.Prelude.Char
                                                                                        'o'))
                                                                          x10 <- do x7 <- DM.litHook
                                                                                            (DI.DebugInfo
                                                                                               (DI.SrcID
                                                                                                  "XML"
                                                                                                  0)
                                                                                               (DI.DynamicInfo
                                                                                                  []
                                                                                                  []))
                                                                                            (Prelude.return
                                                                                               (Curry.DebugModule.Prelude.Char
                                                                                                  't'))
                                                                                    x8 <- DM.constructorHook
                                                                                            (DI.DebugInfo
                                                                                               (DI.SrcID
                                                                                                  "XML"
                                                                                                  0)
                                                                                               (DI.DynamicInfo
                                                                                                  []
                                                                                                  []))
                                                                                            (Prelude.return
                                                                                               Curry.DebugModule.Prelude.Nil)
                                                                                    DM.constructorHook
                                                                                      (DI.DebugInfo
                                                                                         (DI.SrcID
                                                                                            "XML"
                                                                                            0)
                                                                                         (DI.DynamicInfo
                                                                                            []
                                                                                            [DI.genTerm
                                                                                               x7,
                                                                                             DI.genTerm
                                                                                               x8]))
                                                                                      (Prelude.return
                                                                                         (Curry.DebugModule.Prelude.Cons
                                                                                            x7
                                                                                            x8))
                                                                          DM.constructorHook
                                                                            (DI.DebugInfo
                                                                               (DI.SrcID "XML" 0)
                                                                               (DI.DynamicInfo []
                                                                                  [DI.genTerm x9,
                                                                                   DI.genTerm x10]))
                                                                            (Prelude.return
                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                  x9
                                                                                  x10))
                                                                DM.constructorHook
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x11,
                                                                         DI.genTerm x12]))
                                                                  (Prelude.return
                                                                     (Curry.DebugModule.Prelude.Cons
                                                                        x11
                                                                        x12))
                                                      DM.constructorHook
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x13, DI.genTerm x14]))
                                                        (Prelude.return
                                                           (Curry.DebugModule.Prelude.Cons x13 x14))
                                            DM.funcCallHook "=="
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x15, DI.genTerm x16]))
                                              (Curry.DebugModule.Prelude.op_EqEq x15 x16)
                                  DM.funcCallHook "_case_83"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x17, DI.genTerm x18, DI.genTerm x19]))
                                    (strict__case_83 x17 x18 x19)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x20])))
                           (strict__case_84 x1 x2)
                           x20)))
term_strict__case_84 x1 = DI.Term "_case_84" (DI.SrcID "XML" 0) x1
strict__case_83 x1 x2 x3
  = DM.eval
      (DM.funcDeclHook "_case_83"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x2, DI.genTerm x3]))
         (do x20 <- Prelude.return x3
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x20]))
               (case x20 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x5 <- DM.litHook
                                          (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                          (Prelude.return (Curry.DebugModule.Prelude.Char '"'))
                                  x6 <- do x4 <- Prelude.return x2
                                           DM.funcCallHook "xmlUnquoteSpecials"
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x4]))
                                             (strict_xmlUnquoteSpecials x4)
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x5, DI.genTerm x6]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Cons x5 x6))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x17 <- Prelude.return x1
                                  x18 <- Prelude.return x2
                                  x19 <- do x15 <- Prelude.return x1
                                            x16 <- do x13 <- DM.litHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo [] []))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Char
                                                                     'a'))
                                                      x14 <- do x11 <- DM.litHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo [] []))
                                                                         (Prelude.return
                                                                            (Curry.DebugModule.Prelude.Char
                                                                               'p'))
                                                                x12 <- do x9 <- DM.litHook
                                                                                  (DI.DebugInfo
                                                                                     (DI.SrcID "XML"
                                                                                        0)
                                                                                     (DI.DynamicInfo
                                                                                        []
                                                                                        []))
                                                                                  (Prelude.return
                                                                                     (Curry.DebugModule.Prelude.Char
                                                                                        'o'))
                                                                          x10 <- do x7 <- DM.litHook
                                                                                            (DI.DebugInfo
                                                                                               (DI.SrcID
                                                                                                  "XML"
                                                                                                  0)
                                                                                               (DI.DynamicInfo
                                                                                                  []
                                                                                                  []))
                                                                                            (Prelude.return
                                                                                               (Curry.DebugModule.Prelude.Char
                                                                                                  's'))
                                                                                    x8 <- DM.constructorHook
                                                                                            (DI.DebugInfo
                                                                                               (DI.SrcID
                                                                                                  "XML"
                                                                                                  0)
                                                                                               (DI.DynamicInfo
                                                                                                  []
                                                                                                  []))
                                                                                            (Prelude.return
                                                                                               Curry.DebugModule.Prelude.Nil)
                                                                                    DM.constructorHook
                                                                                      (DI.DebugInfo
                                                                                         (DI.SrcID
                                                                                            "XML"
                                                                                            0)
                                                                                         (DI.DynamicInfo
                                                                                            []
                                                                                            [DI.genTerm
                                                                                               x7,
                                                                                             DI.genTerm
                                                                                               x8]))
                                                                                      (Prelude.return
                                                                                         (Curry.DebugModule.Prelude.Cons
                                                                                            x7
                                                                                            x8))
                                                                          DM.constructorHook
                                                                            (DI.DebugInfo
                                                                               (DI.SrcID "XML" 0)
                                                                               (DI.DynamicInfo []
                                                                                  [DI.genTerm x9,
                                                                                   DI.genTerm x10]))
                                                                            (Prelude.return
                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                  x9
                                                                                  x10))
                                                                DM.constructorHook
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x11,
                                                                         DI.genTerm x12]))
                                                                  (Prelude.return
                                                                     (Curry.DebugModule.Prelude.Cons
                                                                        x11
                                                                        x12))
                                                      DM.constructorHook
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x13, DI.genTerm x14]))
                                                        (Prelude.return
                                                           (Curry.DebugModule.Prelude.Cons x13 x14))
                                            DM.funcCallHook "=="
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x15, DI.genTerm x16]))
                                              (Curry.DebugModule.Prelude.op_EqEq x15 x16)
                                  DM.funcCallHook "_case_82"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x17, DI.genTerm x18, DI.genTerm x19]))
                                    (strict__case_82 x17 x18 x19)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x20])))
                           (strict__case_83 x1 x2)
                           x20)))
term_strict__case_83 x1 = DI.Term "_case_83" (DI.SrcID "XML" 0) x1
strict__case_82 x1 x2 x3
  = DM.eval
      (DM.funcDeclHook "_case_82"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x2, DI.genTerm x3]))
         (do x20 <- Prelude.return x3
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x20]))
               (case x20 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x5 <- DM.litHook
                                          (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                          (Prelude.return (Curry.DebugModule.Prelude.Char '\''))
                                  x6 <- do x4 <- Prelude.return x2
                                           DM.funcCallHook "xmlUnquoteSpecials"
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x4]))
                                             (strict_xmlUnquoteSpecials x4)
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x5, DI.genTerm x6]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Cons x5 x6))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x17 <- Prelude.return x1
                                  x18 <- Prelude.return x2
                                  x19 <- do x15 <- Prelude.return x1
                                            x16 <- do x13 <- DM.litHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo [] []))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Char
                                                                     'a'))
                                                      x14 <- do x11 <- DM.litHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo [] []))
                                                                         (Prelude.return
                                                                            (Curry.DebugModule.Prelude.Char
                                                                               'u'))
                                                                x12 <- do x9 <- DM.litHook
                                                                                  (DI.DebugInfo
                                                                                     (DI.SrcID "XML"
                                                                                        0)
                                                                                     (DI.DynamicInfo
                                                                                        []
                                                                                        []))
                                                                                  (Prelude.return
                                                                                     (Curry.DebugModule.Prelude.Char
                                                                                        'm'))
                                                                          x10 <- do x7 <- DM.litHook
                                                                                            (DI.DebugInfo
                                                                                               (DI.SrcID
                                                                                                  "XML"
                                                                                                  0)
                                                                                               (DI.DynamicInfo
                                                                                                  []
                                                                                                  []))
                                                                                            (Prelude.return
                                                                                               (Curry.DebugModule.Prelude.Char
                                                                                                  'l'))
                                                                                    x8 <- DM.constructorHook
                                                                                            (DI.DebugInfo
                                                                                               (DI.SrcID
                                                                                                  "XML"
                                                                                                  0)
                                                                                               (DI.DynamicInfo
                                                                                                  []
                                                                                                  []))
                                                                                            (Prelude.return
                                                                                               Curry.DebugModule.Prelude.Nil)
                                                                                    DM.constructorHook
                                                                                      (DI.DebugInfo
                                                                                         (DI.SrcID
                                                                                            "XML"
                                                                                            0)
                                                                                         (DI.DynamicInfo
                                                                                            []
                                                                                            [DI.genTerm
                                                                                               x7,
                                                                                             DI.genTerm
                                                                                               x8]))
                                                                                      (Prelude.return
                                                                                         (Curry.DebugModule.Prelude.Cons
                                                                                            x7
                                                                                            x8))
                                                                          DM.constructorHook
                                                                            (DI.DebugInfo
                                                                               (DI.SrcID "XML" 0)
                                                                               (DI.DynamicInfo []
                                                                                  [DI.genTerm x9,
                                                                                   DI.genTerm x10]))
                                                                            (Prelude.return
                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                  x9
                                                                                  x10))
                                                                DM.constructorHook
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x11,
                                                                         DI.genTerm x12]))
                                                                  (Prelude.return
                                                                     (Curry.DebugModule.Prelude.Cons
                                                                        x11
                                                                        x12))
                                                      DM.constructorHook
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x13, DI.genTerm x14]))
                                                        (Prelude.return
                                                           (Curry.DebugModule.Prelude.Cons x13 x14))
                                            DM.funcCallHook "=="
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x15, DI.genTerm x16]))
                                              (Curry.DebugModule.Prelude.op_EqEq x15 x16)
                                  DM.funcCallHook "_case_81"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x17, DI.genTerm x18, DI.genTerm x19]))
                                    (strict__case_81 x17 x18 x19)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x20])))
                           (strict__case_82 x1 x2)
                           x20)))
term_strict__case_82 x1 = DI.Term "_case_82" (DI.SrcID "XML" 0) x1
strict__case_81 x1 x2 x3
  = DM.eval
      (DM.funcDeclHook "_case_81"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x2, DI.genTerm x3]))
         (do x21 <- Prelude.return x3
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x21]))
               (case x21 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x6 <- do x4 <- DM.litHook
                                                   (DI.DebugInfo (DI.SrcID "XML" 0)
                                                      (DI.DynamicInfo [] []))
                                                   (Prelude.return
                                                      (Curry.DebugModule.Prelude.Pos
                                                         (Curry.DebugModule.Prelude.O
                                                            (Curry.DebugModule.Prelude.O
                                                               (Curry.DebugModule.Prelude.I
                                                                  (Curry.DebugModule.Prelude.O
                                                                     (Curry.DebugModule.Prelude.O
                                                                        (Curry.DebugModule.Prelude.I
                                                                           (Curry.DebugModule.Prelude.I
                                                                              Curry.DebugModule.Prelude.IHi)))))))))
                                           DM.funcCallHook "chr"
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x4]))
                                             (Curry.DebugModule.Prelude.strict_chr x4)
                                  x7 <- do x5 <- Prelude.return x2
                                           DM.funcCallHook "xmlUnquoteSpecials"
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x5]))
                                             (strict_xmlUnquoteSpecials x5)
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x6, DI.genTerm x7]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Cons x6 x7))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x18 <- Prelude.return x1
                                  x19 <- Prelude.return x2
                                  x20 <- do x16 <- Prelude.return x1
                                            x17 <- do x14 <- DM.litHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo [] []))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Char
                                                                     'o'))
                                                      x15 <- do x12 <- DM.litHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo [] []))
                                                                         (Prelude.return
                                                                            (Curry.DebugModule.Prelude.Char
                                                                               'u'))
                                                                x13 <- do x10 <- DM.litHook
                                                                                   (DI.DebugInfo
                                                                                      (DI.SrcID
                                                                                         "XML"
                                                                                         0)
                                                                                      (DI.DynamicInfo
                                                                                         []
                                                                                         []))
                                                                                   (Prelude.return
                                                                                      (Curry.DebugModule.Prelude.Char
                                                                                         'm'))
                                                                          x11 <- do x8 <- DM.litHook
                                                                                            (DI.DebugInfo
                                                                                               (DI.SrcID
                                                                                                  "XML"
                                                                                                  0)
                                                                                               (DI.DynamicInfo
                                                                                                  []
                                                                                                  []))
                                                                                            (Prelude.return
                                                                                               (Curry.DebugModule.Prelude.Char
                                                                                                  'l'))
                                                                                    x9 <- DM.constructorHook
                                                                                            (DI.DebugInfo
                                                                                               (DI.SrcID
                                                                                                  "XML"
                                                                                                  0)
                                                                                               (DI.DynamicInfo
                                                                                                  []
                                                                                                  []))
                                                                                            (Prelude.return
                                                                                               Curry.DebugModule.Prelude.Nil)
                                                                                    DM.constructorHook
                                                                                      (DI.DebugInfo
                                                                                         (DI.SrcID
                                                                                            "XML"
                                                                                            0)
                                                                                         (DI.DynamicInfo
                                                                                            []
                                                                                            [DI.genTerm
                                                                                               x8,
                                                                                             DI.genTerm
                                                                                               x9]))
                                                                                      (Prelude.return
                                                                                         (Curry.DebugModule.Prelude.Cons
                                                                                            x8
                                                                                            x9))
                                                                          DM.constructorHook
                                                                            (DI.DebugInfo
                                                                               (DI.SrcID "XML" 0)
                                                                               (DI.DynamicInfo []
                                                                                  [DI.genTerm x10,
                                                                                   DI.genTerm x11]))
                                                                            (Prelude.return
                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                  x10
                                                                                  x11))
                                                                DM.constructorHook
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x12,
                                                                         DI.genTerm x13]))
                                                                  (Prelude.return
                                                                     (Curry.DebugModule.Prelude.Cons
                                                                        x12
                                                                        x13))
                                                      DM.constructorHook
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x14, DI.genTerm x15]))
                                                        (Prelude.return
                                                           (Curry.DebugModule.Prelude.Cons x14 x15))
                                            DM.funcCallHook "=="
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x16, DI.genTerm x17]))
                                              (Curry.DebugModule.Prelude.op_EqEq x16 x17)
                                  DM.funcCallHook "_case_80"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x18, DI.genTerm x19, DI.genTerm x20]))
                                    (strict__case_80 x18 x19 x20)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x21])))
                           (strict__case_81 x1 x2)
                           x21)))
term_strict__case_81 x1 = DI.Term "_case_81" (DI.SrcID "XML" 0) x1
strict__case_80 x1 x2 x3
  = DM.eval
      (DM.funcDeclHook "_case_80"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x2, DI.genTerm x3]))
         (do x21 <- Prelude.return x3
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x21]))
               (case x21 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x6 <- do x4 <- DM.litHook
                                                   (DI.DebugInfo (DI.SrcID "XML" 0)
                                                      (DI.DynamicInfo [] []))
                                                   (Prelude.return
                                                      (Curry.DebugModule.Prelude.Pos
                                                         (Curry.DebugModule.Prelude.O
                                                            (Curry.DebugModule.Prelude.I
                                                               (Curry.DebugModule.Prelude.I
                                                                  (Curry.DebugModule.Prelude.O
                                                                     (Curry.DebugModule.Prelude.I
                                                                        (Curry.DebugModule.Prelude.I
                                                                           (Curry.DebugModule.Prelude.I
                                                                              Curry.DebugModule.Prelude.IHi)))))))))
                                           DM.funcCallHook "chr"
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x4]))
                                             (Curry.DebugModule.Prelude.strict_chr x4)
                                  x7 <- do x5 <- Prelude.return x2
                                           DM.funcCallHook "xmlUnquoteSpecials"
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x5]))
                                             (strict_xmlUnquoteSpecials x5)
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x6, DI.genTerm x7]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Cons x6 x7))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x18 <- Prelude.return x1
                                  x19 <- Prelude.return x2
                                  x20 <- do x16 <- Prelude.return x1
                                            x17 <- do x14 <- DM.litHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo [] []))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Char
                                                                     'u'))
                                                      x15 <- do x12 <- DM.litHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo [] []))
                                                                         (Prelude.return
                                                                            (Curry.DebugModule.Prelude.Char
                                                                               'u'))
                                                                x13 <- do x10 <- DM.litHook
                                                                                   (DI.DebugInfo
                                                                                      (DI.SrcID
                                                                                         "XML"
                                                                                         0)
                                                                                      (DI.DynamicInfo
                                                                                         []
                                                                                         []))
                                                                                   (Prelude.return
                                                                                      (Curry.DebugModule.Prelude.Char
                                                                                         'm'))
                                                                          x11 <- do x8 <- DM.litHook
                                                                                            (DI.DebugInfo
                                                                                               (DI.SrcID
                                                                                                  "XML"
                                                                                                  0)
                                                                                               (DI.DynamicInfo
                                                                                                  []
                                                                                                  []))
                                                                                            (Prelude.return
                                                                                               (Curry.DebugModule.Prelude.Char
                                                                                                  'l'))
                                                                                    x9 <- DM.constructorHook
                                                                                            (DI.DebugInfo
                                                                                               (DI.SrcID
                                                                                                  "XML"
                                                                                                  0)
                                                                                               (DI.DynamicInfo
                                                                                                  []
                                                                                                  []))
                                                                                            (Prelude.return
                                                                                               Curry.DebugModule.Prelude.Nil)
                                                                                    DM.constructorHook
                                                                                      (DI.DebugInfo
                                                                                         (DI.SrcID
                                                                                            "XML"
                                                                                            0)
                                                                                         (DI.DynamicInfo
                                                                                            []
                                                                                            [DI.genTerm
                                                                                               x8,
                                                                                             DI.genTerm
                                                                                               x9]))
                                                                                      (Prelude.return
                                                                                         (Curry.DebugModule.Prelude.Cons
                                                                                            x8
                                                                                            x9))
                                                                          DM.constructorHook
                                                                            (DI.DebugInfo
                                                                               (DI.SrcID "XML" 0)
                                                                               (DI.DynamicInfo []
                                                                                  [DI.genTerm x10,
                                                                                   DI.genTerm x11]))
                                                                            (Prelude.return
                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                  x10
                                                                                  x11))
                                                                DM.constructorHook
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x12,
                                                                         DI.genTerm x13]))
                                                                  (Prelude.return
                                                                     (Curry.DebugModule.Prelude.Cons
                                                                        x12
                                                                        x13))
                                                      DM.constructorHook
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x14, DI.genTerm x15]))
                                                        (Prelude.return
                                                           (Curry.DebugModule.Prelude.Cons x14 x15))
                                            DM.funcCallHook "=="
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x16, DI.genTerm x17]))
                                              (Curry.DebugModule.Prelude.op_EqEq x16 x17)
                                  DM.funcCallHook "_case_79"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x18, DI.genTerm x19, DI.genTerm x20]))
                                    (strict__case_79 x18 x19 x20)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x21])))
                           (strict__case_80 x1 x2)
                           x21)))
term_strict__case_80 x1 = DI.Term "_case_80" (DI.SrcID "XML" 0) x1
strict__case_79 x1 x2 x3
  = DM.eval
      (DM.funcDeclHook "_case_79"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x2, DI.genTerm x3]))
         (do x21 <- Prelude.return x3
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x21]))
               (case x21 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x6 <- do x4 <- DM.litHook
                                                   (DI.DebugInfo (DI.SrcID "XML" 0)
                                                      (DI.DynamicInfo [] []))
                                                   (Prelude.return
                                                      (Curry.DebugModule.Prelude.Pos
                                                         (Curry.DebugModule.Prelude.O
                                                            (Curry.DebugModule.Prelude.O
                                                               (Curry.DebugModule.Prelude.I
                                                                  (Curry.DebugModule.Prelude.I
                                                                     (Curry.DebugModule.Prelude.I
                                                                        (Curry.DebugModule.Prelude.I
                                                                           (Curry.DebugModule.Prelude.I
                                                                              Curry.DebugModule.Prelude.IHi)))))))))
                                           DM.funcCallHook "chr"
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x4]))
                                             (Curry.DebugModule.Prelude.strict_chr x4)
                                  x7 <- do x5 <- Prelude.return x2
                                           DM.funcCallHook "xmlUnquoteSpecials"
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x5]))
                                             (strict_xmlUnquoteSpecials x5)
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x6, DI.genTerm x7]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Cons x6 x7))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x18 <- Prelude.return x1
                                  x19 <- Prelude.return x2
                                  x20 <- do x16 <- Prelude.return x1
                                            x17 <- do x14 <- DM.litHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo [] []))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Char
                                                                     'A'))
                                                      x15 <- do x12 <- DM.litHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo [] []))
                                                                         (Prelude.return
                                                                            (Curry.DebugModule.Prelude.Char
                                                                               'u'))
                                                                x13 <- do x10 <- DM.litHook
                                                                                   (DI.DebugInfo
                                                                                      (DI.SrcID
                                                                                         "XML"
                                                                                         0)
                                                                                      (DI.DynamicInfo
                                                                                         []
                                                                                         []))
                                                                                   (Prelude.return
                                                                                      (Curry.DebugModule.Prelude.Char
                                                                                         'm'))
                                                                          x11 <- do x8 <- DM.litHook
                                                                                            (DI.DebugInfo
                                                                                               (DI.SrcID
                                                                                                  "XML"
                                                                                                  0)
                                                                                               (DI.DynamicInfo
                                                                                                  []
                                                                                                  []))
                                                                                            (Prelude.return
                                                                                               (Curry.DebugModule.Prelude.Char
                                                                                                  'l'))
                                                                                    x9 <- DM.constructorHook
                                                                                            (DI.DebugInfo
                                                                                               (DI.SrcID
                                                                                                  "XML"
                                                                                                  0)
                                                                                               (DI.DynamicInfo
                                                                                                  []
                                                                                                  []))
                                                                                            (Prelude.return
                                                                                               Curry.DebugModule.Prelude.Nil)
                                                                                    DM.constructorHook
                                                                                      (DI.DebugInfo
                                                                                         (DI.SrcID
                                                                                            "XML"
                                                                                            0)
                                                                                         (DI.DynamicInfo
                                                                                            []
                                                                                            [DI.genTerm
                                                                                               x8,
                                                                                             DI.genTerm
                                                                                               x9]))
                                                                                      (Prelude.return
                                                                                         (Curry.DebugModule.Prelude.Cons
                                                                                            x8
                                                                                            x9))
                                                                          DM.constructorHook
                                                                            (DI.DebugInfo
                                                                               (DI.SrcID "XML" 0)
                                                                               (DI.DynamicInfo []
                                                                                  [DI.genTerm x10,
                                                                                   DI.genTerm x11]))
                                                                            (Prelude.return
                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                  x10
                                                                                  x11))
                                                                DM.constructorHook
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x12,
                                                                         DI.genTerm x13]))
                                                                  (Prelude.return
                                                                     (Curry.DebugModule.Prelude.Cons
                                                                        x12
                                                                        x13))
                                                      DM.constructorHook
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x14, DI.genTerm x15]))
                                                        (Prelude.return
                                                           (Curry.DebugModule.Prelude.Cons x14 x15))
                                            DM.funcCallHook "=="
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x16, DI.genTerm x17]))
                                              (Curry.DebugModule.Prelude.op_EqEq x16 x17)
                                  DM.funcCallHook "_case_78"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x18, DI.genTerm x19, DI.genTerm x20]))
                                    (strict__case_78 x18 x19 x20)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x21])))
                           (strict__case_79 x1 x2)
                           x21)))
term_strict__case_79 x1 = DI.Term "_case_79" (DI.SrcID "XML" 0) x1
strict__case_78 x1 x2 x3
  = DM.eval
      (DM.funcDeclHook "_case_78"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x2, DI.genTerm x3]))
         (do x21 <- Prelude.return x3
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x21]))
               (case x21 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x6 <- do x4 <- DM.litHook
                                                   (DI.DebugInfo (DI.SrcID "XML" 0)
                                                      (DI.DynamicInfo [] []))
                                                   (Prelude.return
                                                      (Curry.DebugModule.Prelude.Pos
                                                         (Curry.DebugModule.Prelude.O
                                                            (Curry.DebugModule.Prelude.O
                                                               (Curry.DebugModule.Prelude.I
                                                                  (Curry.DebugModule.Prelude.O
                                                                     (Curry.DebugModule.Prelude.O
                                                                        (Curry.DebugModule.Prelude.O
                                                                           (Curry.DebugModule.Prelude.I
                                                                              Curry.DebugModule.Prelude.IHi)))))))))
                                           DM.funcCallHook "chr"
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x4]))
                                             (Curry.DebugModule.Prelude.strict_chr x4)
                                  x7 <- do x5 <- Prelude.return x2
                                           DM.funcCallHook "xmlUnquoteSpecials"
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x5]))
                                             (strict_xmlUnquoteSpecials x5)
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x6, DI.genTerm x7]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Cons x6 x7))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x18 <- Prelude.return x1
                                  x19 <- Prelude.return x2
                                  x20 <- do x16 <- Prelude.return x1
                                            x17 <- do x14 <- DM.litHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo [] []))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Char
                                                                     'O'))
                                                      x15 <- do x12 <- DM.litHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo [] []))
                                                                         (Prelude.return
                                                                            (Curry.DebugModule.Prelude.Char
                                                                               'u'))
                                                                x13 <- do x10 <- DM.litHook
                                                                                   (DI.DebugInfo
                                                                                      (DI.SrcID
                                                                                         "XML"
                                                                                         0)
                                                                                      (DI.DynamicInfo
                                                                                         []
                                                                                         []))
                                                                                   (Prelude.return
                                                                                      (Curry.DebugModule.Prelude.Char
                                                                                         'm'))
                                                                          x11 <- do x8 <- DM.litHook
                                                                                            (DI.DebugInfo
                                                                                               (DI.SrcID
                                                                                                  "XML"
                                                                                                  0)
                                                                                               (DI.DynamicInfo
                                                                                                  []
                                                                                                  []))
                                                                                            (Prelude.return
                                                                                               (Curry.DebugModule.Prelude.Char
                                                                                                  'l'))
                                                                                    x9 <- DM.constructorHook
                                                                                            (DI.DebugInfo
                                                                                               (DI.SrcID
                                                                                                  "XML"
                                                                                                  0)
                                                                                               (DI.DynamicInfo
                                                                                                  []
                                                                                                  []))
                                                                                            (Prelude.return
                                                                                               Curry.DebugModule.Prelude.Nil)
                                                                                    DM.constructorHook
                                                                                      (DI.DebugInfo
                                                                                         (DI.SrcID
                                                                                            "XML"
                                                                                            0)
                                                                                         (DI.DynamicInfo
                                                                                            []
                                                                                            [DI.genTerm
                                                                                               x8,
                                                                                             DI.genTerm
                                                                                               x9]))
                                                                                      (Prelude.return
                                                                                         (Curry.DebugModule.Prelude.Cons
                                                                                            x8
                                                                                            x9))
                                                                          DM.constructorHook
                                                                            (DI.DebugInfo
                                                                               (DI.SrcID "XML" 0)
                                                                               (DI.DynamicInfo []
                                                                                  [DI.genTerm x10,
                                                                                   DI.genTerm x11]))
                                                                            (Prelude.return
                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                  x10
                                                                                  x11))
                                                                DM.constructorHook
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x12,
                                                                         DI.genTerm x13]))
                                                                  (Prelude.return
                                                                     (Curry.DebugModule.Prelude.Cons
                                                                        x12
                                                                        x13))
                                                      DM.constructorHook
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x14, DI.genTerm x15]))
                                                        (Prelude.return
                                                           (Curry.DebugModule.Prelude.Cons x14 x15))
                                            DM.funcCallHook "=="
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x16, DI.genTerm x17]))
                                              (Curry.DebugModule.Prelude.op_EqEq x16 x17)
                                  DM.funcCallHook "_case_77"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x18, DI.genTerm x19, DI.genTerm x20]))
                                    (strict__case_77 x18 x19 x20)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x21])))
                           (strict__case_78 x1 x2)
                           x21)))
term_strict__case_78 x1 = DI.Term "_case_78" (DI.SrcID "XML" 0) x1
strict__case_77 x1 x2 x3
  = DM.eval
      (DM.funcDeclHook "_case_77"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x2, DI.genTerm x3]))
         (do x21 <- Prelude.return x3
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x21]))
               (case x21 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x6 <- do x4 <- DM.litHook
                                                   (DI.DebugInfo (DI.SrcID "XML" 0)
                                                      (DI.DynamicInfo [] []))
                                                   (Prelude.return
                                                      (Curry.DebugModule.Prelude.Pos
                                                         (Curry.DebugModule.Prelude.O
                                                            (Curry.DebugModule.Prelude.I
                                                               (Curry.DebugModule.Prelude.I
                                                                  (Curry.DebugModule.Prelude.O
                                                                     (Curry.DebugModule.Prelude.I
                                                                        (Curry.DebugModule.Prelude.O
                                                                           (Curry.DebugModule.Prelude.I
                                                                              Curry.DebugModule.Prelude.IHi)))))))))
                                           DM.funcCallHook "chr"
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x4]))
                                             (Curry.DebugModule.Prelude.strict_chr x4)
                                  x7 <- do x5 <- Prelude.return x2
                                           DM.funcCallHook "xmlUnquoteSpecials"
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x5]))
                                             (strict_xmlUnquoteSpecials x5)
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x6, DI.genTerm x7]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Cons x6 x7))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x18 <- Prelude.return x1
                                  x19 <- Prelude.return x2
                                  x20 <- do x16 <- Prelude.return x1
                                            x17 <- do x14 <- DM.litHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo [] []))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Char
                                                                     'U'))
                                                      x15 <- do x12 <- DM.litHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo [] []))
                                                                         (Prelude.return
                                                                            (Curry.DebugModule.Prelude.Char
                                                                               'u'))
                                                                x13 <- do x10 <- DM.litHook
                                                                                   (DI.DebugInfo
                                                                                      (DI.SrcID
                                                                                         "XML"
                                                                                         0)
                                                                                      (DI.DynamicInfo
                                                                                         []
                                                                                         []))
                                                                                   (Prelude.return
                                                                                      (Curry.DebugModule.Prelude.Char
                                                                                         'm'))
                                                                          x11 <- do x8 <- DM.litHook
                                                                                            (DI.DebugInfo
                                                                                               (DI.SrcID
                                                                                                  "XML"
                                                                                                  0)
                                                                                               (DI.DynamicInfo
                                                                                                  []
                                                                                                  []))
                                                                                            (Prelude.return
                                                                                               (Curry.DebugModule.Prelude.Char
                                                                                                  'l'))
                                                                                    x9 <- DM.constructorHook
                                                                                            (DI.DebugInfo
                                                                                               (DI.SrcID
                                                                                                  "XML"
                                                                                                  0)
                                                                                               (DI.DynamicInfo
                                                                                                  []
                                                                                                  []))
                                                                                            (Prelude.return
                                                                                               Curry.DebugModule.Prelude.Nil)
                                                                                    DM.constructorHook
                                                                                      (DI.DebugInfo
                                                                                         (DI.SrcID
                                                                                            "XML"
                                                                                            0)
                                                                                         (DI.DynamicInfo
                                                                                            []
                                                                                            [DI.genTerm
                                                                                               x8,
                                                                                             DI.genTerm
                                                                                               x9]))
                                                                                      (Prelude.return
                                                                                         (Curry.DebugModule.Prelude.Cons
                                                                                            x8
                                                                                            x9))
                                                                          DM.constructorHook
                                                                            (DI.DebugInfo
                                                                               (DI.SrcID "XML" 0)
                                                                               (DI.DynamicInfo []
                                                                                  [DI.genTerm x10,
                                                                                   DI.genTerm x11]))
                                                                            (Prelude.return
                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                  x10
                                                                                  x11))
                                                                DM.constructorHook
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x12,
                                                                         DI.genTerm x13]))
                                                                  (Prelude.return
                                                                     (Curry.DebugModule.Prelude.Cons
                                                                        x12
                                                                        x13))
                                                      DM.constructorHook
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x14, DI.genTerm x15]))
                                                        (Prelude.return
                                                           (Curry.DebugModule.Prelude.Cons x14 x15))
                                            DM.funcCallHook "=="
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x16, DI.genTerm x17]))
                                              (Curry.DebugModule.Prelude.op_EqEq x16 x17)
                                  DM.funcCallHook "_case_76"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x18, DI.genTerm x19, DI.genTerm x20]))
                                    (strict__case_76 x18 x19 x20)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x21])))
                           (strict__case_77 x1 x2)
                           x21)))
term_strict__case_77 x1 = DI.Term "_case_77" (DI.SrcID "XML" 0) x1
strict__case_76 x1 x2 x3
  = DM.eval
      (DM.funcDeclHook "_case_76"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x2, DI.genTerm x3]))
         (do x23 <- Prelude.return x3
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x23]))
               (case x23 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x6 <- do x4 <- DM.litHook
                                                   (DI.DebugInfo (DI.SrcID "XML" 0)
                                                      (DI.DynamicInfo [] []))
                                                   (Prelude.return
                                                      (Curry.DebugModule.Prelude.Pos
                                                         (Curry.DebugModule.Prelude.O
                                                            (Curry.DebugModule.Prelude.O
                                                               (Curry.DebugModule.Prelude.I
                                                                  (Curry.DebugModule.Prelude.I
                                                                     (Curry.DebugModule.Prelude.I
                                                                        (Curry.DebugModule.Prelude.O
                                                                           (Curry.DebugModule.Prelude.I
                                                                              Curry.DebugModule.Prelude.IHi)))))))))
                                           DM.funcCallHook "chr"
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x4]))
                                             (Curry.DebugModule.Prelude.strict_chr x4)
                                  x7 <- do x5 <- Prelude.return x2
                                           DM.funcCallHook "xmlUnquoteSpecials"
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x5]))
                                             (strict_xmlUnquoteSpecials x5)
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x6, DI.genTerm x7]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Cons x6 x7))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x20 <- Prelude.return x1
                                  x21 <- Prelude.return x2
                                  x22 <- do x18 <- Prelude.return x1
                                            x19 <- do x16 <- DM.litHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo [] []))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Char
                                                                     's'))
                                                      x17 <- do x14 <- DM.litHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo [] []))
                                                                         (Prelude.return
                                                                            (Curry.DebugModule.Prelude.Char
                                                                               'z'))
                                                                x15 <- do x12 <- DM.litHook
                                                                                   (DI.DebugInfo
                                                                                      (DI.SrcID
                                                                                         "XML"
                                                                                         0)
                                                                                      (DI.DynamicInfo
                                                                                         []
                                                                                         []))
                                                                                   (Prelude.return
                                                                                      (Curry.DebugModule.Prelude.Char
                                                                                         'l'))
                                                                          x13 <- do x10 <- DM.litHook
                                                                                             (DI.DebugInfo
                                                                                                (DI.SrcID
                                                                                                   "XML"
                                                                                                   0)
                                                                                                (DI.DynamicInfo
                                                                                                   []
                                                                                                   []))
                                                                                             (Prelude.return
                                                                                                (Curry.DebugModule.Prelude.Char
                                                                                                   'i'))
                                                                                    x11 <- do x8 <- DM.litHook
                                                                                                      (DI.DebugInfo
                                                                                                         (DI.SrcID
                                                                                                            "XML"
                                                                                                            0)
                                                                                                         (DI.DynamicInfo
                                                                                                            []
                                                                                                            []))
                                                                                                      (Prelude.return
                                                                                                         (Curry.DebugModule.Prelude.Char
                                                                                                            'g'))
                                                                                              x9 <- DM.constructorHook
                                                                                                      (DI.DebugInfo
                                                                                                         (DI.SrcID
                                                                                                            "XML"
                                                                                                            0)
                                                                                                         (DI.DynamicInfo
                                                                                                            []
                                                                                                            []))
                                                                                                      (Prelude.return
                                                                                                         Curry.DebugModule.Prelude.Nil)
                                                                                              DM.constructorHook
                                                                                                (DI.DebugInfo
                                                                                                   (DI.SrcID
                                                                                                      "XML"
                                                                                                      0)
                                                                                                   (DI.DynamicInfo
                                                                                                      []
                                                                                                      [DI.genTerm
                                                                                                         x8,
                                                                                                       DI.genTerm
                                                                                                         x9]))
                                                                                                (Prelude.return
                                                                                                   (Curry.DebugModule.Prelude.Cons
                                                                                                      x8
                                                                                                      x9))
                                                                                    DM.constructorHook
                                                                                      (DI.DebugInfo
                                                                                         (DI.SrcID
                                                                                            "XML"
                                                                                            0)
                                                                                         (DI.DynamicInfo
                                                                                            []
                                                                                            [DI.genTerm
                                                                                               x10,
                                                                                             DI.genTerm
                                                                                               x11]))
                                                                                      (Prelude.return
                                                                                         (Curry.DebugModule.Prelude.Cons
                                                                                            x10
                                                                                            x11))
                                                                          DM.constructorHook
                                                                            (DI.DebugInfo
                                                                               (DI.SrcID "XML" 0)
                                                                               (DI.DynamicInfo []
                                                                                  [DI.genTerm x12,
                                                                                   DI.genTerm x13]))
                                                                            (Prelude.return
                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                  x12
                                                                                  x13))
                                                                DM.constructorHook
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x14,
                                                                         DI.genTerm x15]))
                                                                  (Prelude.return
                                                                     (Curry.DebugModule.Prelude.Cons
                                                                        x14
                                                                        x15))
                                                      DM.constructorHook
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x16, DI.genTerm x17]))
                                                        (Prelude.return
                                                           (Curry.DebugModule.Prelude.Cons x16 x17))
                                            DM.funcCallHook "=="
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x18, DI.genTerm x19]))
                                              (Curry.DebugModule.Prelude.op_EqEq x18 x19)
                                  DM.funcCallHook "_case_75"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x20, DI.genTerm x21, DI.genTerm x22]))
                                    (strict__case_75 x20 x21 x22)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x23])))
                           (strict__case_76 x1 x2)
                           x23)))
term_strict__case_76 x1 = DI.Term "_case_76" (DI.SrcID "XML" 0) x1
strict__case_75 x1 x2 x3
  = DM.eval
      (DM.funcDeclHook "_case_75"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x2, DI.genTerm x3]))
         (do x11 <- Prelude.return x3
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x11]))
               (case x11 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x6 <- do x4 <- DM.litHook
                                                   (DI.DebugInfo (DI.SrcID "XML" 0)
                                                      (DI.DynamicInfo [] []))
                                                   (Prelude.return
                                                      (Curry.DebugModule.Prelude.Pos
                                                         (Curry.DebugModule.Prelude.I
                                                            (Curry.DebugModule.Prelude.I
                                                               (Curry.DebugModule.Prelude.I
                                                                  (Curry.DebugModule.Prelude.I
                                                                     (Curry.DebugModule.Prelude.I
                                                                        (Curry.DebugModule.Prelude.O
                                                                           (Curry.DebugModule.Prelude.I
                                                                              Curry.DebugModule.Prelude.IHi)))))))))
                                           DM.funcCallHook "chr"
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x4]))
                                             (Curry.DebugModule.Prelude.strict_chr x4)
                                  x7 <- do x5 <- Prelude.return x2
                                           DM.funcCallHook "xmlUnquoteSpecials"
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x5]))
                                             (strict_xmlUnquoteSpecials x5)
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x6, DI.genTerm x7]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Cons x6 x7))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x8 <- Prelude.return x1
                                  x9 <- Prelude.return x2
                                  x10 <- DM.funcCallHook "otherwise"
                                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                           Curry.DebugModule.Prelude.strict_otherwise
                                  DM.funcCallHook "_case_74"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x8, DI.genTerm x9, DI.genTerm x10]))
                                    (strict__case_74 x8 x9 x10)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x11])))
                           (strict__case_75 x1 x2)
                           x11)))
term_strict__case_75 x1 = DI.Term "_case_75" (DI.SrcID "XML" 0) x1
strict__case_74 x1 x2 x3
  = DM.eval
      (DM.funcDeclHook "_case_74"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x2, DI.genTerm x3]))
         (do x8 <- Prelude.return x3
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x8]))
               (case x8 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x6 <- do x4 <- Prelude.return x1
                                           DM.funcCallHook "unquoteUnicode"
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x4]))
                                             (strict_unquoteUnicode x4)
                                  x7 <- do x5 <- Prelude.return x2
                                           DM.funcCallHook "xmlUnquoteSpecials"
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x5]))
                                             (strict_xmlUnquoteSpecials x5)
                                  DM.funcCallHook "++"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x6, DI.genTerm x7]))
                                    (Curry.DebugModule.Prelude.op_PlusPlus x6 x7)))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.funcCallHook "failed"
                                 (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                 Curry.DebugModule.Prelude.strict_failed))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x8])))
                           (strict__case_74 x1 x2)
                           x8)))
term_strict__case_74 x1 = DI.Term "_case_74" (DI.SrcID "XML" 0) x1
strict__case_87 x1
  = DM.eval
      (DM.funcDeclHook "_case_87"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x4 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x4]))
               (case x4 of
                    Curry.DebugModule.Prelude.Tuple2 x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x3))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x4])))
                           strict__case_87
                           x4)))
term_strict__case_87 x1 = DI.Term "_case_87" (DI.SrcID "XML" 0) x1
strict__case_88 x1
  = DM.eval
      (DM.funcDeclHook "_case_88"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x4 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x4]))
               (case x4 of
                    Curry.DebugModule.Prelude.Tuple2 x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x2))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x4])))
                           strict__case_88
                           x4)))
term_strict__case_88 x1 = DI.Term "_case_88" (DI.SrcID "XML" 0) x1
strict__case_91 x1
  = DM.eval
      (DM.funcDeclHook "_case_91"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x9 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x9]))
               (case x9 of
                    Curry.DebugModule.Prelude.Nil
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.constructorHook
                                 (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                 (Prelude.return Curry.DebugModule.Prelude.Nil)))
                    Curry.DebugModule.Prelude.Cons x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x6 <- Prelude.return x2
                                  x7 <- Prelude.return x3
                                  x8 <- do x4 <- Prelude.return x2
                                           x5 <- DM.litHook
                                                   (DI.DebugInfo (DI.SrcID "XML" 0)
                                                      (DI.DynamicInfo [] []))
                                                   (Prelude.return
                                                      (Curry.DebugModule.Prelude.Char '&'))
                                           DM.funcCallHook "=="
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x4, DI.genTerm x5]))
                                             (Curry.DebugModule.Prelude.op_EqEq x4 x5)
                                  DM.funcCallHook "_case_90"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x6, DI.genTerm x7, DI.genTerm x8]))
                                    (strict__case_90 x6 x7 x8)))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x9])))
                           strict__case_91
                           x9)))
term_strict__case_91 x1 = DI.Term "_case_91" (DI.SrcID "XML" 0) x1
strict__case_90 x2 x3 x7
  = DM.eval
      (DM.funcDeclHook "_case_90"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x2, DI.genTerm x3, DI.genTerm x7]))
         (do x17 <- Prelude.return x7
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x17]))
               (case x17 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.letHook
                                 (DI.DebugInfo (DI.SrcID "DummyModule" 42) (DI.DynamicInfo [] []))
                                 (do x4 <- do x8 <- DM.litHook
                                                      (DI.DebugInfo (DI.SrcID "XML" 0)
                                                         (DI.DynamicInfo [] []))
                                                      (Prelude.return
                                                         (Curry.DebugModule.Prelude.Char ';'))
                                              x9 <- Prelude.return x3
                                              DM.funcCallHook "splitAtChar"
                                                (DI.DebugInfo (DI.SrcID "XML" 0)
                                                   (DI.DynamicInfo []
                                                      [DI.genTerm x8, DI.genTerm x9]))
                                                (strict_splitAtChar x8 x9)
                                     DM.eval
                                       (DM.letHook
                                          (DI.DebugInfo (DI.SrcID "DummyModule" 42)
                                             (DI.DynamicInfo [] []))
                                          (do x5 <- do x10 <- Prelude.return x4
                                                       DM.funcCallHook
                                                         "xmlUnquoteSpecials._#selFP5#special"
                                                         (DI.DebugInfo (DI.SrcID "XML" 0)
                                                            (DI.DynamicInfo [] [DI.genTerm x10]))
                                                         (x'xstrict_xmlUnquoteSpecials46_35selFP535special
                                                            x10)
                                              DM.eval
                                                (DM.letHook
                                                   (DI.DebugInfo (DI.SrcID "DummyModule" 42)
                                                      (DI.DynamicInfo [] []))
                                                   (do x6 <- do x11 <- Prelude.return x4
                                                                DM.funcCallHook
                                                                  "xmlUnquoteSpecials._#selFP6#rest"
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x11]))
                                                                  (x'xstrict_xmlUnquoteSpecials46_35selFP635rest
                                                                     x11)
                                                       DM.eval
                                                         (do x12 <- Prelude.return x5
                                                             x13 <- Prelude.return x6
                                                             DM.funcCallHook "xmlUnquoteSpecial"
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo []
                                                                     [DI.genTerm x12,
                                                                      DI.genTerm x13]))
                                                               (strict_xmlUnquoteSpecial x12
                                                                  x13)))))))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x14 <- Prelude.return x2
                                  x15 <- Prelude.return x3
                                  x16 <- DM.funcCallHook "otherwise"
                                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                           Curry.DebugModule.Prelude.strict_otherwise
                                  DM.funcCallHook "_case_89"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x14, DI.genTerm x15, DI.genTerm x16]))
                                    (strict__case_89 x14 x15 x16)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x17])))
                           (strict__case_90 x2 x3)
                           x17)))
term_strict__case_90 x1 = DI.Term "_case_90" (DI.SrcID "XML" 0) x1
strict__case_89 x2 x3 x4
  = DM.eval
      (DM.funcDeclHook "_case_89"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x2, DI.genTerm x3, DI.genTerm x4]))
         (do x8 <- Prelude.return x4
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x8]))
               (case x8 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x6 <- Prelude.return x2
                                  x7 <- do x5 <- Prelude.return x3
                                           DM.funcCallHook "xmlUnquoteSpecials"
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x5]))
                                             (strict_xmlUnquoteSpecials x5)
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x6, DI.genTerm x7]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Cons x6 x7))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.funcCallHook "failed"
                                 (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                 Curry.DebugModule.Prelude.strict_failed))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x8])))
                           (strict__case_89 x2 x3)
                           x8)))
term_strict__case_89 x1 = DI.Term "_case_89" (DI.SrcID "XML" 0) x1
strict__case_92 x1
  = DM.eval
      (DM.funcDeclHook "_case_92"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x6 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x6]))
               (case x6 of
                    XText x2
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.constructorHook
                                 (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                 (Prelude.return Curry.DebugModule.Prelude.True)))
                    XElem x3 x4 x5
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.constructorHook
                                 (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                 (Prelude.return Curry.DebugModule.Prelude.False)))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x6])))
                           strict__case_92
                           x6)))
term_strict__case_92 x1 = DI.Term "_case_92" (DI.SrcID "XML" 0) x1
strict__case_93 x1 x2
  = DM.eval
      (DM.funcDeclHook "_case_93"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x2]))
         (do x19 <- Prelude.return x2
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x19]))
               (case x19 of
                    Curry.DebugModule.Prelude.Tuple2 x3 x4
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x17 <- Prelude.return x3
                                  x18 <- do x15 <- do x7 <- DM.litHook
                                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                 (DI.DynamicInfo [] []))
                                                              (Prelude.return
                                                                 (Curry.DebugModule.Prelude.Char
                                                                    '='))
                                                      x8 <- do x5 <- DM.litHook
                                                                       (DI.DebugInfo
                                                                          (DI.SrcID "XML" 0)
                                                                          (DI.DynamicInfo [] []))
                                                                       (Prelude.return
                                                                          (Curry.DebugModule.Prelude.Char
                                                                             '"'))
                                                               x6 <- DM.constructorHook
                                                                       (DI.DebugInfo
                                                                          (DI.SrcID "XML" 0)
                                                                          (DI.DynamicInfo [] []))
                                                                       (Prelude.return
                                                                          Curry.DebugModule.Prelude.Nil)
                                                               DM.constructorHook
                                                                 (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                    (DI.DynamicInfo []
                                                                       [DI.genTerm x5,
                                                                        DI.genTerm x6]))
                                                                 (Prelude.return
                                                                    (Curry.DebugModule.Prelude.Cons
                                                                       x5
                                                                       x6))
                                                      DM.constructorHook
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x7, DI.genTerm x8]))
                                                        (Prelude.return
                                                           (Curry.DebugModule.Prelude.Cons x7 x8))
                                            x16 <- do x13 <- do x9 <- Prelude.return x1
                                                                x10 <- Prelude.return x4
                                                                DM.funcCallHook "apply"
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x9,
                                                                         DI.genTerm x10]))
                                                                  (Curry.DebugModule.Prelude.strict_apply
                                                                     x9
                                                                     x10)
                                                      x14 <- do x11 <- DM.litHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo [] []))
                                                                         (Prelude.return
                                                                            (Curry.DebugModule.Prelude.Char
                                                                               '"'))
                                                                x12 <- DM.constructorHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo [] []))
                                                                         (Prelude.return
                                                                            Curry.DebugModule.Prelude.Nil)
                                                                DM.constructorHook
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x11,
                                                                         DI.genTerm x12]))
                                                                  (Prelude.return
                                                                     (Curry.DebugModule.Prelude.Cons
                                                                        x11
                                                                        x12))
                                                      DM.funcCallHook "++"
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x13, DI.genTerm x14]))
                                                        (Curry.DebugModule.Prelude.op_PlusPlus x13
                                                           x14)
                                            DM.funcCallHook "++"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x15, DI.genTerm x16]))
                                              (Curry.DebugModule.Prelude.op_PlusPlus x15 x16)
                                  DM.funcCallHook "++"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x17, DI.genTerm x18]))
                                    (Curry.DebugModule.Prelude.op_PlusPlus x17 x18)))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x19])))
                           (strict__case_93 x1)
                           x19)))
term_strict__case_93 x1 = DI.Term "_case_93" (DI.SrcID "XML" 0) x1
strict__case_96 x1
  = DM.eval
      (DM.funcDeclHook "_case_96"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x6 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x6]))
               (case x6 of
                    Curry.DebugModule.Prelude.Cons x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x4 <- Prelude.return x3
                                  x5 <- Prelude.return x2
                                  DM.funcCallHook "_case_95"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x4, DI.genTerm x5]))
                                    (strict__case_95 x4 x5)))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x6])))
                           strict__case_96
                           x6)))
term_strict__case_96 x1 = DI.Term "_case_96" (DI.SrcID "XML" 0) x1
strict__case_95 x3 x2
  = DM.eval
      (DM.funcDeclHook "_case_95"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x3, DI.genTerm x2]))
         (do x7 <- Prelude.return x2
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x7]))
               (case x7 of
                    XText x4
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x5 <- Prelude.return x4
                                  x6 <- Prelude.return x3
                                  DM.funcCallHook "_case_94"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x5, DI.genTerm x6]))
                                    (strict__case_94 x5 x6)))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x7])))
                           (strict__case_95 x3)
                           x7)))
term_strict__case_95 x1 = DI.Term "_case_95" (DI.SrcID "XML" 0) x1
strict__case_94 x4 x3
  = DM.eval
      (DM.funcDeclHook "_case_94"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x4, DI.genTerm x3]))
         (do x5 <- Prelude.return x3
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x5]))
               (case x5 of
                    Curry.DebugModule.Prelude.Nil
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x4))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x5])))
                           (strict__case_94 x4)
                           x5)))
term_strict__case_94 x1 = DI.Term "_case_94" (DI.SrcID "XML" 0) x1
strict__case_99 x1 x2 x3
  = DM.eval
      (DM.funcDeclHook "_case_99"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x2, DI.genTerm x3]))
         (do x32 <- Prelude.return x3
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x32]))
               (case x32 of
                    XText x4
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x15 <- do x8 <- Prelude.return x1
                                            DM.funcCallHook "xtab"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo [] [DI.genTerm x8]))
                                              (strict_xtab x8)
                                  x16 <- do x13 <- do x9 <- Prelude.return x2
                                                      x10 <- Prelude.return x4
                                                      DM.funcCallHook "apply"
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x9, DI.genTerm x10]))
                                                        (Curry.DebugModule.Prelude.strict_apply x9
                                                           x10)
                                            x14 <- do x11 <- DM.litHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo [] []))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Char
                                                                     '\n'))
                                                      x12 <- DM.constructorHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo [] []))
                                                               (Prelude.return
                                                                  Curry.DebugModule.Prelude.Nil)
                                                      DM.constructorHook
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x11, DI.genTerm x12]))
                                                        (Prelude.return
                                                           (Curry.DebugModule.Prelude.Cons x11 x12))
                                            DM.funcCallHook "++"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x13, DI.genTerm x14]))
                                              (Curry.DebugModule.Prelude.op_PlusPlus x13 x14)
                                  DM.funcCallHook "++"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x15, DI.genTerm x16]))
                                    (Curry.DebugModule.Prelude.op_PlusPlus x15 x16)))
                    XElem x5 x6 x7
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x30 <- do x17 <- Prelude.return x1
                                            DM.funcCallHook "xtab"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo [] [DI.genTerm x17]))
                                              (strict_xtab x17)
                                  x31 <- do x28 <- do x18 <- Prelude.return x5
                                                      x19 <- Prelude.return x6
                                                      x20 <- Prelude.return x2
                                                      DM.funcCallHook "showXmlOpenTag"
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x18, DI.genTerm x19,
                                                               DI.genTerm x20]))
                                                        (strict_showXmlOpenTag x18 x19 x20)
                                            x29 <- do x23 <- Prelude.return x1
                                                      x24 <- Prelude.return x2
                                                      x25 <- Prelude.return x5
                                                      x26 <- Prelude.return x7
                                                      x27 <- do x21 <- Prelude.return x7
                                                                x22 <- DM.constructorHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo [] []))
                                                                         (Prelude.return
                                                                            Curry.DebugModule.Prelude.Nil)
                                                                DM.funcCallHook "=="
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x21,
                                                                         DI.genTerm x22]))
                                                                  (Curry.DebugModule.Prelude.op_EqEq
                                                                     x21
                                                                     x22)
                                                      DM.funcCallHook "_case_98"
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x23, DI.genTerm x24,
                                                               DI.genTerm x25, DI.genTerm x26,
                                                               DI.genTerm x27]))
                                                        (strict__case_98 x23 x24 x25 x26 x27)
                                            DM.funcCallHook "++"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x28, DI.genTerm x29]))
                                              (Curry.DebugModule.Prelude.op_PlusPlus x28 x29)
                                  DM.funcCallHook "++"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x30, DI.genTerm x31]))
                                    (Curry.DebugModule.Prelude.op_PlusPlus x30 x31)))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x32])))
                           (strict__case_99 x1 x2)
                           x32)))
term_strict__case_99 x1 = DI.Term "_case_99" (DI.SrcID "XML" 0) x1
strict__case_98 x1 x2 x5 x7 x8
  = DM.eval
      (DM.funcDeclHook "_case_98"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo []
               [DI.genTerm x1, DI.genTerm x2, DI.genTerm x5, DI.genTerm x7,
                DI.genTerm x8]))
         (do x29 <- Prelude.return x8
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x29]))
               (case x29 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x15 <- DM.litHook
                                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                           (Prelude.return (Curry.DebugModule.Prelude.Char ' '))
                                  x16 <- do x13 <- DM.litHook
                                                     (DI.DebugInfo (DI.SrcID "XML" 0)
                                                        (DI.DynamicInfo [] []))
                                                     (Prelude.return
                                                        (Curry.DebugModule.Prelude.Char '/'))
                                            x14 <- do x11 <- DM.litHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo [] []))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Char
                                                                     '>'))
                                                      x12 <- do x9 <- DM.litHook
                                                                        (DI.DebugInfo
                                                                           (DI.SrcID "XML" 0)
                                                                           (DI.DynamicInfo [] []))
                                                                        (Prelude.return
                                                                           (Curry.DebugModule.Prelude.Char
                                                                              '\n'))
                                                                x10 <- DM.constructorHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo [] []))
                                                                         (Prelude.return
                                                                            Curry.DebugModule.Prelude.Nil)
                                                                DM.constructorHook
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x9,
                                                                         DI.genTerm x10]))
                                                                  (Prelude.return
                                                                     (Curry.DebugModule.Prelude.Cons
                                                                        x9
                                                                        x10))
                                                      DM.constructorHook
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x11, DI.genTerm x12]))
                                                        (Prelude.return
                                                           (Curry.DebugModule.Prelude.Cons x11 x12))
                                            DM.constructorHook
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x13, DI.genTerm x14]))
                                              (Prelude.return
                                                 (Curry.DebugModule.Prelude.Cons x13 x14))
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x15, DI.genTerm x16]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Cons x15 x16))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x24 <- Prelude.return x1
                                  x25 <- Prelude.return x2
                                  x26 <- Prelude.return x5
                                  x27 <- Prelude.return x7
                                  x28 <- do x22 <- do x18 <- do x17 <- Prelude.return x7
                                                                DM.funcCallHook "length"
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x17]))
                                                                  (Curry.DebugModule.Prelude.strict_length
                                                                     x17)
                                                      x19 <- DM.litHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo [] []))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Pos
                                                                     Curry.DebugModule.Prelude.IHi))
                                                      DM.funcCallHook "=="
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x18, DI.genTerm x19]))
                                                        (Curry.DebugModule.Prelude.op_EqEq x18 x19)
                                            x23 <- do x21 <- do x20 <- Prelude.return x7
                                                                DM.funcCallHook "head"
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x20]))
                                                                  (Curry.DebugModule.Prelude.strict_head
                                                                     x20)
                                                      DM.funcCallHook "isXText"
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo [] [DI.genTerm x21]))
                                                        (strict_isXText x21)
                                            DM.funcCallHook "&&"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x22, DI.genTerm x23]))
                                              (Curry.DebugModule.Prelude.op_AndAnd x22 x23)
                                  DM.funcCallHook "_case_97"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x24, DI.genTerm x25, DI.genTerm x26,
                                           DI.genTerm x27, DI.genTerm x28]))
                                    (strict__case_97 x24 x25 x26 x27 x28)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x29])))
                           (strict__case_98 x1 x2 x5 x7)
                           x29)))
term_strict__case_98 x1 = DI.Term "_case_98" (DI.SrcID "XML" 0) x1
strict__case_97 x1 x2 x5 x7 x10
  = DM.eval
      (DM.funcDeclHook "_case_97"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo []
               [DI.genTerm x1, DI.genTerm x2, DI.genTerm x5, DI.genTerm x7,
                DI.genTerm x10]))
         (do x60 <- Prelude.return x10
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x60]))
               (case x60 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.letHook
                                 (DI.DebugInfo (DI.SrcID "DummyModule" 42) (DI.DynamicInfo [] []))
                                 (do x8 <- Prelude.return x7
                                     DM.eval
                                       (DM.letHook
                                          (DI.DebugInfo (DI.SrcID "DummyModule" 42)
                                             (DI.DynamicInfo [] []))
                                          (do x9 <- do x11 <- Prelude.return x8
                                                       DM.funcCallHook "showXmlExp._#selFP3#s"
                                                         (DI.DebugInfo (DI.SrcID "XML" 0)
                                                            (DI.DynamicInfo [] [DI.genTerm x11]))
                                                         (x'xstrict_showXmlExp46_35selFP335s x11)
                                              DM.eval
                                                (do x30 <- do x12 <- DM.litHook
                                                                       (DI.DebugInfo
                                                                          (DI.SrcID "XML" 0)
                                                                          (DI.DynamicInfo [] []))
                                                                       (Prelude.return
                                                                          (Curry.DebugModule.Prelude.Char
                                                                             '>'))
                                                              x13 <- DM.constructorHook
                                                                       (DI.DebugInfo
                                                                          (DI.SrcID "XML" 0)
                                                                          (DI.DynamicInfo [] []))
                                                                       (Prelude.return
                                                                          Curry.DebugModule.Prelude.Nil)
                                                              DM.constructorHook
                                                                (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                   (DI.DynamicInfo []
                                                                      [DI.genTerm x12,
                                                                       DI.genTerm x13]))
                                                                (Prelude.return
                                                                   (Curry.DebugModule.Prelude.Cons
                                                                      x12
                                                                      x13))
                                                    x31 <- do x28 <- do x14 <- Prelude.return x2
                                                                        x15 <- Prelude.return x9
                                                                        DM.funcCallHook "apply"
                                                                          (DI.DebugInfo
                                                                             (DI.SrcID "XML" 0)
                                                                             (DI.DynamicInfo []
                                                                                [DI.genTerm x14,
                                                                                 DI.genTerm x15]))
                                                                          (Curry.DebugModule.Prelude.strict_apply
                                                                             x14
                                                                             x15)
                                                              x29 <- do x26 <- do x18 <- DM.litHook
                                                                                           (DI.DebugInfo
                                                                                              (DI.SrcID
                                                                                                 "XML"
                                                                                                 0)
                                                                                              (DI.DynamicInfo
                                                                                                 []
                                                                                                 []))
                                                                                           (Prelude.return
                                                                                              (Curry.DebugModule.Prelude.Char
                                                                                                 '<'))
                                                                                  x19 <- do x16 <- DM.litHook
                                                                                                     (DI.DebugInfo
                                                                                                        (DI.SrcID
                                                                                                           "XML"
                                                                                                           0)
                                                                                                        (DI.DynamicInfo
                                                                                                           []
                                                                                                           []))
                                                                                                     (Prelude.return
                                                                                                        (Curry.DebugModule.Prelude.Char
                                                                                                           '/'))
                                                                                            x17 <- DM.constructorHook
                                                                                                     (DI.DebugInfo
                                                                                                        (DI.SrcID
                                                                                                           "XML"
                                                                                                           0)
                                                                                                        (DI.DynamicInfo
                                                                                                           []
                                                                                                           []))
                                                                                                     (Prelude.return
                                                                                                        Curry.DebugModule.Prelude.Nil)
                                                                                            DM.constructorHook
                                                                                              (DI.DebugInfo
                                                                                                 (DI.SrcID
                                                                                                    "XML"
                                                                                                    0)
                                                                                                 (DI.DynamicInfo
                                                                                                    []
                                                                                                    [DI.genTerm
                                                                                                       x16,
                                                                                                     DI.genTerm
                                                                                                       x17]))
                                                                                              (Prelude.return
                                                                                                 (Curry.DebugModule.Prelude.Cons
                                                                                                    x16
                                                                                                    x17))
                                                                                  DM.constructorHook
                                                                                    (DI.DebugInfo
                                                                                       (DI.SrcID
                                                                                          "XML"
                                                                                          0)
                                                                                       (DI.DynamicInfo
                                                                                          []
                                                                                          [DI.genTerm
                                                                                             x18,
                                                                                           DI.genTerm
                                                                                             x19]))
                                                                                    (Prelude.return
                                                                                       (Curry.DebugModule.Prelude.Cons
                                                                                          x18
                                                                                          x19))
                                                                        x27 <- do x24 <- Prelude.return
                                                                                           x5
                                                                                  x25 <- do x22 <- DM.litHook
                                                                                                     (DI.DebugInfo
                                                                                                        (DI.SrcID
                                                                                                           "XML"
                                                                                                           0)
                                                                                                        (DI.DynamicInfo
                                                                                                           []
                                                                                                           []))
                                                                                                     (Prelude.return
                                                                                                        (Curry.DebugModule.Prelude.Char
                                                                                                           '>'))
                                                                                            x23 <- do x20 <- DM.litHook
                                                                                                               (DI.DebugInfo
                                                                                                                  (DI.SrcID
                                                                                                                     "XML"
                                                                                                                     0)
                                                                                                                  (DI.DynamicInfo
                                                                                                                     []
                                                                                                                     []))
                                                                                                               (Prelude.return
                                                                                                                  (Curry.DebugModule.Prelude.Char
                                                                                                                     '\n'))
                                                                                                      x21 <- DM.constructorHook
                                                                                                               (DI.DebugInfo
                                                                                                                  (DI.SrcID
                                                                                                                     "XML"
                                                                                                                     0)
                                                                                                                  (DI.DynamicInfo
                                                                                                                     []
                                                                                                                     []))
                                                                                                               (Prelude.return
                                                                                                                  Curry.DebugModule.Prelude.Nil)
                                                                                                      DM.constructorHook
                                                                                                        (DI.DebugInfo
                                                                                                           (DI.SrcID
                                                                                                              "XML"
                                                                                                              0)
                                                                                                           (DI.DynamicInfo
                                                                                                              []
                                                                                                              [DI.genTerm
                                                                                                                 x20,
                                                                                                               DI.genTerm
                                                                                                                 x21]))
                                                                                                        (Prelude.return
                                                                                                           (Curry.DebugModule.Prelude.Cons
                                                                                                              x20
                                                                                                              x21))
                                                                                            DM.constructorHook
                                                                                              (DI.DebugInfo
                                                                                                 (DI.SrcID
                                                                                                    "XML"
                                                                                                    0)
                                                                                                 (DI.DynamicInfo
                                                                                                    []
                                                                                                    [DI.genTerm
                                                                                                       x22,
                                                                                                     DI.genTerm
                                                                                                       x23]))
                                                                                              (Prelude.return
                                                                                                 (Curry.DebugModule.Prelude.Cons
                                                                                                    x22
                                                                                                    x23))
                                                                                  DM.funcCallHook
                                                                                    "++"
                                                                                    (DI.DebugInfo
                                                                                       (DI.SrcID
                                                                                          "XML"
                                                                                          0)
                                                                                       (DI.DynamicInfo
                                                                                          []
                                                                                          [DI.genTerm
                                                                                             x24,
                                                                                           DI.genTerm
                                                                                             x25]))
                                                                                    (Curry.DebugModule.Prelude.op_PlusPlus
                                                                                       x24
                                                                                       x25)
                                                                        DM.funcCallHook "++"
                                                                          (DI.DebugInfo
                                                                             (DI.SrcID "XML" 0)
                                                                             (DI.DynamicInfo []
                                                                                [DI.genTerm x26,
                                                                                 DI.genTerm x27]))
                                                                          (Curry.DebugModule.Prelude.op_PlusPlus
                                                                             x26
                                                                             x27)
                                                              DM.funcCallHook "++"
                                                                (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                   (DI.DynamicInfo []
                                                                      [DI.genTerm x28,
                                                                       DI.genTerm x29]))
                                                                (Curry.DebugModule.Prelude.op_PlusPlus
                                                                   x28
                                                                   x29)
                                                    DM.funcCallHook "++"
                                                      (DI.DebugInfo (DI.SrcID "XML" 0)
                                                         (DI.DynamicInfo []
                                                            [DI.genTerm x30, DI.genTerm x31]))
                                                      (Curry.DebugModule.Prelude.op_PlusPlus x30
                                                         x31)))))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x58 <- do x34 <- DM.litHook
                                                     (DI.DebugInfo (DI.SrcID "XML" 0)
                                                        (DI.DynamicInfo [] []))
                                                     (Prelude.return
                                                        (Curry.DebugModule.Prelude.Char '>'))
                                            x35 <- do x32 <- DM.litHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo [] []))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Char
                                                                     '\n'))
                                                      x33 <- DM.constructorHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo [] []))
                                                               (Prelude.return
                                                                  Curry.DebugModule.Prelude.Nil)
                                                      DM.constructorHook
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x32, DI.genTerm x33]))
                                                        (Prelude.return
                                                           (Curry.DebugModule.Prelude.Cons x32 x33))
                                            DM.constructorHook
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x34, DI.genTerm x35]))
                                              (Prelude.return
                                                 (Curry.DebugModule.Prelude.Cons x34 x35))
                                  x59 <- do x56 <- do x38 <- do x36 <- Prelude.return x1
                                                                x37 <- DM.litHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo [] []))
                                                                         (Prelude.return
                                                                            (Curry.DebugModule.Prelude.Pos
                                                                               (Curry.DebugModule.Prelude.O
                                                                                  Curry.DebugModule.Prelude.IHi)))
                                                                DM.funcCallHook "+"
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x36,
                                                                         DI.genTerm x37]))
                                                                  (Curry.DebugModule.Prelude.op_Plus
                                                                     x36
                                                                     x37)
                                                      x39 <- Prelude.return x7
                                                      x40 <- Prelude.return x2
                                                      DM.funcCallHook "showXmlExps"
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x38, DI.genTerm x39,
                                                               DI.genTerm x40]))
                                                        (strict_showXmlExps x38 x39 x40)
                                            x57 <- do x54 <- do x41 <- Prelude.return x1
                                                                DM.funcCallHook "xtab"
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x41]))
                                                                  (strict_xtab x41)
                                                      x55 <- do x52 <- do x44 <- DM.litHook
                                                                                   (DI.DebugInfo
                                                                                      (DI.SrcID
                                                                                         "XML"
                                                                                         0)
                                                                                      (DI.DynamicInfo
                                                                                         []
                                                                                         []))
                                                                                   (Prelude.return
                                                                                      (Curry.DebugModule.Prelude.Char
                                                                                         '<'))
                                                                          x45 <- do x42 <- DM.litHook
                                                                                             (DI.DebugInfo
                                                                                                (DI.SrcID
                                                                                                   "XML"
                                                                                                   0)
                                                                                                (DI.DynamicInfo
                                                                                                   []
                                                                                                   []))
                                                                                             (Prelude.return
                                                                                                (Curry.DebugModule.Prelude.Char
                                                                                                   '/'))
                                                                                    x43 <- DM.constructorHook
                                                                                             (DI.DebugInfo
                                                                                                (DI.SrcID
                                                                                                   "XML"
                                                                                                   0)
                                                                                                (DI.DynamicInfo
                                                                                                   []
                                                                                                   []))
                                                                                             (Prelude.return
                                                                                                Curry.DebugModule.Prelude.Nil)
                                                                                    DM.constructorHook
                                                                                      (DI.DebugInfo
                                                                                         (DI.SrcID
                                                                                            "XML"
                                                                                            0)
                                                                                         (DI.DynamicInfo
                                                                                            []
                                                                                            [DI.genTerm
                                                                                               x42,
                                                                                             DI.genTerm
                                                                                               x43]))
                                                                                      (Prelude.return
                                                                                         (Curry.DebugModule.Prelude.Cons
                                                                                            x42
                                                                                            x43))
                                                                          DM.constructorHook
                                                                            (DI.DebugInfo
                                                                               (DI.SrcID "XML" 0)
                                                                               (DI.DynamicInfo []
                                                                                  [DI.genTerm x44,
                                                                                   DI.genTerm x45]))
                                                                            (Prelude.return
                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                  x44
                                                                                  x45))
                                                                x53 <- do x50 <- Prelude.return x5
                                                                          x51 <- do x48 <- DM.litHook
                                                                                             (DI.DebugInfo
                                                                                                (DI.SrcID
                                                                                                   "XML"
                                                                                                   0)
                                                                                                (DI.DynamicInfo
                                                                                                   []
                                                                                                   []))
                                                                                             (Prelude.return
                                                                                                (Curry.DebugModule.Prelude.Char
                                                                                                   '>'))
                                                                                    x49 <- do x46 <- DM.litHook
                                                                                                       (DI.DebugInfo
                                                                                                          (DI.SrcID
                                                                                                             "XML"
                                                                                                             0)
                                                                                                          (DI.DynamicInfo
                                                                                                             []
                                                                                                             []))
                                                                                                       (Prelude.return
                                                                                                          (Curry.DebugModule.Prelude.Char
                                                                                                             '\n'))
                                                                                              x47 <- DM.constructorHook
                                                                                                       (DI.DebugInfo
                                                                                                          (DI.SrcID
                                                                                                             "XML"
                                                                                                             0)
                                                                                                          (DI.DynamicInfo
                                                                                                             []
                                                                                                             []))
                                                                                                       (Prelude.return
                                                                                                          Curry.DebugModule.Prelude.Nil)
                                                                                              DM.constructorHook
                                                                                                (DI.DebugInfo
                                                                                                   (DI.SrcID
                                                                                                      "XML"
                                                                                                      0)
                                                                                                   (DI.DynamicInfo
                                                                                                      []
                                                                                                      [DI.genTerm
                                                                                                         x46,
                                                                                                       DI.genTerm
                                                                                                         x47]))
                                                                                                (Prelude.return
                                                                                                   (Curry.DebugModule.Prelude.Cons
                                                                                                      x46
                                                                                                      x47))
                                                                                    DM.constructorHook
                                                                                      (DI.DebugInfo
                                                                                         (DI.SrcID
                                                                                            "XML"
                                                                                            0)
                                                                                         (DI.DynamicInfo
                                                                                            []
                                                                                            [DI.genTerm
                                                                                               x48,
                                                                                             DI.genTerm
                                                                                               x49]))
                                                                                      (Prelude.return
                                                                                         (Curry.DebugModule.Prelude.Cons
                                                                                            x48
                                                                                            x49))
                                                                          DM.funcCallHook "++"
                                                                            (DI.DebugInfo
                                                                               (DI.SrcID "XML" 0)
                                                                               (DI.DynamicInfo []
                                                                                  [DI.genTerm x50,
                                                                                   DI.genTerm x51]))
                                                                            (Curry.DebugModule.Prelude.op_PlusPlus
                                                                               x50
                                                                               x51)
                                                                DM.funcCallHook "++"
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x52,
                                                                         DI.genTerm x53]))
                                                                  (Curry.DebugModule.Prelude.op_PlusPlus
                                                                     x52
                                                                     x53)
                                                      DM.funcCallHook "++"
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x54, DI.genTerm x55]))
                                                        (Curry.DebugModule.Prelude.op_PlusPlus x54
                                                           x55)
                                            DM.funcCallHook "++"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x56, DI.genTerm x57]))
                                              (Curry.DebugModule.Prelude.op_PlusPlus x56 x57)
                                  DM.funcCallHook "++"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x58, DI.genTerm x59]))
                                    (Curry.DebugModule.Prelude.op_PlusPlus x58 x59)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x60])))
                           (strict__case_97 x1 x2 x5 x7)
                           x60)))
term_strict__case_97 x1 = DI.Term "_case_97" (DI.SrcID "XML" 0) x1
strict__case_102 x1 x2
  = DM.eval
      (DM.funcDeclHook "_case_102"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x2]))
         (do x109 <- Prelude.return x2
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x109]))
               (case x109 of
                    XElem x3 x4 x5
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x107 <- do x44 <- DM.litHook
                                                      (DI.DebugInfo (DI.SrcID "XML" 0)
                                                         (DI.DynamicInfo [] []))
                                                      (Prelude.return
                                                         (Curry.DebugModule.Prelude.Char '<'))
                                             x45 <- do x42 <- DM.litHook
                                                                (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                   (DI.DynamicInfo [] []))
                                                                (Prelude.return
                                                                   (Curry.DebugModule.Prelude.Char
                                                                      '?'))
                                                       x43 <- do x40 <- DM.litHook
                                                                          (DI.DebugInfo
                                                                             (DI.SrcID "XML" 0)
                                                                             (DI.DynamicInfo [] []))
                                                                          (Prelude.return
                                                                             (Curry.DebugModule.Prelude.Char
                                                                                'x'))
                                                                 x41 <- do x38 <- DM.litHook
                                                                                    (DI.DebugInfo
                                                                                       (DI.SrcID
                                                                                          "XML"
                                                                                          0)
                                                                                       (DI.DynamicInfo
                                                                                          []
                                                                                          []))
                                                                                    (Prelude.return
                                                                                       (Curry.DebugModule.Prelude.Char
                                                                                          'm'))
                                                                           x39 <- do x36 <- DM.litHook
                                                                                              (DI.DebugInfo
                                                                                                 (DI.SrcID
                                                                                                    "XML"
                                                                                                    0)
                                                                                                 (DI.DynamicInfo
                                                                                                    []
                                                                                                    []))
                                                                                              (Prelude.return
                                                                                                 (Curry.DebugModule.Prelude.Char
                                                                                                    'l'))
                                                                                     x37 <- do x34 <- DM.litHook
                                                                                                        (DI.DebugInfo
                                                                                                           (DI.SrcID
                                                                                                              "XML"
                                                                                                              0)
                                                                                                           (DI.DynamicInfo
                                                                                                              []
                                                                                                              []))
                                                                                                        (Prelude.return
                                                                                                           (Curry.DebugModule.Prelude.Char
                                                                                                              ' '))
                                                                                               x35 <- do x32 <- DM.litHook
                                                                                                                  (DI.DebugInfo
                                                                                                                     (DI.SrcID
                                                                                                                        "XML"
                                                                                                                        0)
                                                                                                                     (DI.DynamicInfo
                                                                                                                        []
                                                                                                                        []))
                                                                                                                  (Prelude.return
                                                                                                                     (Curry.DebugModule.Prelude.Char
                                                                                                                        'v'))
                                                                                                         x33 <- do x30 <- DM.litHook
                                                                                                                            (DI.DebugInfo
                                                                                                                               (DI.SrcID
                                                                                                                                  "XML"
                                                                                                                                  0)
                                                                                                                               (DI.DynamicInfo
                                                                                                                                  []
                                                                                                                                  []))
                                                                                                                            (Prelude.return
                                                                                                                               (Curry.DebugModule.Prelude.Char
                                                                                                                                  'e'))
                                                                                                                   x31 <- do x28 <- DM.litHook
                                                                                                                                      (DI.DebugInfo
                                                                                                                                         (DI.SrcID
                                                                                                                                            "XML"
                                                                                                                                            0)
                                                                                                                                         (DI.DynamicInfo
                                                                                                                                            []
                                                                                                                                            []))
                                                                                                                                      (Prelude.return
                                                                                                                                         (Curry.DebugModule.Prelude.Char
                                                                                                                                            'r'))
                                                                                                                             x29 <- do x26 <- DM.litHook
                                                                                                                                                (DI.DebugInfo
                                                                                                                                                   (DI.SrcID
                                                                                                                                                      "XML"
                                                                                                                                                      0)
                                                                                                                                                   (DI.DynamicInfo
                                                                                                                                                      []
                                                                                                                                                      []))
                                                                                                                                                (Prelude.return
                                                                                                                                                   (Curry.DebugModule.Prelude.Char
                                                                                                                                                      's'))
                                                                                                                                       x27 <- do x24 <- DM.litHook
                                                                                                                                                          (DI.DebugInfo
                                                                                                                                                             (DI.SrcID
                                                                                                                                                                "XML"
                                                                                                                                                                0)
                                                                                                                                                             (DI.DynamicInfo
                                                                                                                                                                []
                                                                                                                                                                []))
                                                                                                                                                          (Prelude.return
                                                                                                                                                             (Curry.DebugModule.Prelude.Char
                                                                                                                                                                'i'))
                                                                                                                                                 x25 <- do x22 <- DM.litHook
                                                                                                                                                                    (DI.DebugInfo
                                                                                                                                                                       (DI.SrcID
                                                                                                                                                                          "XML"
                                                                                                                                                                          0)
                                                                                                                                                                       (DI.DynamicInfo
                                                                                                                                                                          []
                                                                                                                                                                          []))
                                                                                                                                                                    (Prelude.return
                                                                                                                                                                       (Curry.DebugModule.Prelude.Char
                                                                                                                                                                          'o'))
                                                                                                                                                           x23 <- do x20 <- DM.litHook
                                                                                                                                                                              (DI.DebugInfo
                                                                                                                                                                                 (DI.SrcID
                                                                                                                                                                                    "XML"
                                                                                                                                                                                    0)
                                                                                                                                                                                 (DI.DynamicInfo
                                                                                                                                                                                    []
                                                                                                                                                                                    []))
                                                                                                                                                                              (Prelude.return
                                                                                                                                                                                 (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                    'n'))
                                                                                                                                                                     x21 <- do x18 <- DM.litHook
                                                                                                                                                                                        (DI.DebugInfo
                                                                                                                                                                                           (DI.SrcID
                                                                                                                                                                                              "XML"
                                                                                                                                                                                              0)
                                                                                                                                                                                           (DI.DynamicInfo
                                                                                                                                                                                              []
                                                                                                                                                                                              []))
                                                                                                                                                                                        (Prelude.return
                                                                                                                                                                                           (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                              '='))
                                                                                                                                                                               x19 <- do x16 <- DM.litHook
                                                                                                                                                                                                  (DI.DebugInfo
                                                                                                                                                                                                     (DI.SrcID
                                                                                                                                                                                                        "XML"
                                                                                                                                                                                                        0)
                                                                                                                                                                                                     (DI.DynamicInfo
                                                                                                                                                                                                        []
                                                                                                                                                                                                        []))
                                                                                                                                                                                                  (Prelude.return
                                                                                                                                                                                                     (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                        '"'))
                                                                                                                                                                                         x17 <- do x14 <- DM.litHook
                                                                                                                                                                                                            (DI.DebugInfo
                                                                                                                                                                                                               (DI.SrcID
                                                                                                                                                                                                                  "XML"
                                                                                                                                                                                                                  0)
                                                                                                                                                                                                               (DI.DynamicInfo
                                                                                                                                                                                                                  []
                                                                                                                                                                                                                  []))
                                                                                                                                                                                                            (Prelude.return
                                                                                                                                                                                                               (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                  '1'))
                                                                                                                                                                                                   x15 <- do x12 <- DM.litHook
                                                                                                                                                                                                                      (DI.DebugInfo
                                                                                                                                                                                                                         (DI.SrcID
                                                                                                                                                                                                                            "XML"
                                                                                                                                                                                                                            0)
                                                                                                                                                                                                                         (DI.DynamicInfo
                                                                                                                                                                                                                            []
                                                                                                                                                                                                                            []))
                                                                                                                                                                                                                      (Prelude.return
                                                                                                                                                                                                                         (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                            '.'))
                                                                                                                                                                                                             x13 <- do x10 <- DM.litHook
                                                                                                                                                                                                                                (DI.DebugInfo
                                                                                                                                                                                                                                   (DI.SrcID
                                                                                                                                                                                                                                      "XML"
                                                                                                                                                                                                                                      0)
                                                                                                                                                                                                                                   (DI.DynamicInfo
                                                                                                                                                                                                                                      []
                                                                                                                                                                                                                                      []))
                                                                                                                                                                                                                                (Prelude.return
                                                                                                                                                                                                                                   (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                      '0'))
                                                                                                                                                                                                                       x11 <- do x8 <- DM.litHook
                                                                                                                                                                                                                                         (DI.DebugInfo
                                                                                                                                                                                                                                            (DI.SrcID
                                                                                                                                                                                                                                               "XML"
                                                                                                                                                                                                                                               0)
                                                                                                                                                                                                                                            (DI.DynamicInfo
                                                                                                                                                                                                                                               []
                                                                                                                                                                                                                                               []))
                                                                                                                                                                                                                                         (Prelude.return
                                                                                                                                                                                                                                            (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                               '"'))
                                                                                                                                                                                                                                 x9 <- do x6 <- DM.litHook
                                                                                                                                                                                                                                                  (DI.DebugInfo
                                                                                                                                                                                                                                                     (DI.SrcID
                                                                                                                                                                                                                                                        "XML"
                                                                                                                                                                                                                                                        0)
                                                                                                                                                                                                                                                     (DI.DynamicInfo
                                                                                                                                                                                                                                                        []
                                                                                                                                                                                                                                                        []))
                                                                                                                                                                                                                                                  (Prelude.return
                                                                                                                                                                                                                                                     (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                                        ' '))
                                                                                                                                                                                                                                          x7 <- DM.constructorHook
                                                                                                                                                                                                                                                  (DI.DebugInfo
                                                                                                                                                                                                                                                     (DI.SrcID
                                                                                                                                                                                                                                                        "XML"
                                                                                                                                                                                                                                                        0)
                                                                                                                                                                                                                                                     (DI.DynamicInfo
                                                                                                                                                                                                                                                        []
                                                                                                                                                                                                                                                        []))
                                                                                                                                                                                                                                                  (Prelude.return
                                                                                                                                                                                                                                                     Curry.DebugModule.Prelude.Nil)
                                                                                                                                                                                                                                          DM.constructorHook
                                                                                                                                                                                                                                            (DI.DebugInfo
                                                                                                                                                                                                                                               (DI.SrcID
                                                                                                                                                                                                                                                  "XML"
                                                                                                                                                                                                                                                  0)
                                                                                                                                                                                                                                               (DI.DynamicInfo
                                                                                                                                                                                                                                                  []
                                                                                                                                                                                                                                                  [DI.genTerm
                                                                                                                                                                                                                                                     x6,
                                                                                                                                                                                                                                                   DI.genTerm
                                                                                                                                                                                                                                                     x7]))
                                                                                                                                                                                                                                            (Prelude.return
                                                                                                                                                                                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                  x6
                                                                                                                                                                                                                                                  x7))
                                                                                                                                                                                                                                 DM.constructorHook
                                                                                                                                                                                                                                   (DI.DebugInfo
                                                                                                                                                                                                                                      (DI.SrcID
                                                                                                                                                                                                                                         "XML"
                                                                                                                                                                                                                                         0)
                                                                                                                                                                                                                                      (DI.DynamicInfo
                                                                                                                                                                                                                                         []
                                                                                                                                                                                                                                         [DI.genTerm
                                                                                                                                                                                                                                            x8,
                                                                                                                                                                                                                                          DI.genTerm
                                                                                                                                                                                                                                            x9]))
                                                                                                                                                                                                                                   (Prelude.return
                                                                                                                                                                                                                                      (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                         x8
                                                                                                                                                                                                                                         x9))
                                                                                                                                                                                                                       DM.constructorHook
                                                                                                                                                                                                                         (DI.DebugInfo
                                                                                                                                                                                                                            (DI.SrcID
                                                                                                                                                                                                                               "XML"
                                                                                                                                                                                                                               0)
                                                                                                                                                                                                                            (DI.DynamicInfo
                                                                                                                                                                                                                               []
                                                                                                                                                                                                                               [DI.genTerm
                                                                                                                                                                                                                                  x10,
                                                                                                                                                                                                                                DI.genTerm
                                                                                                                                                                                                                                  x11]))
                                                                                                                                                                                                                         (Prelude.return
                                                                                                                                                                                                                            (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                               x10
                                                                                                                                                                                                                               x11))
                                                                                                                                                                                                             DM.constructorHook
                                                                                                                                                                                                               (DI.DebugInfo
                                                                                                                                                                                                                  (DI.SrcID
                                                                                                                                                                                                                     "XML"
                                                                                                                                                                                                                     0)
                                                                                                                                                                                                                  (DI.DynamicInfo
                                                                                                                                                                                                                     []
                                                                                                                                                                                                                     [DI.genTerm
                                                                                                                                                                                                                        x12,
                                                                                                                                                                                                                      DI.genTerm
                                                                                                                                                                                                                        x13]))
                                                                                                                                                                                                               (Prelude.return
                                                                                                                                                                                                                  (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                     x12
                                                                                                                                                                                                                     x13))
                                                                                                                                                                                                   DM.constructorHook
                                                                                                                                                                                                     (DI.DebugInfo
                                                                                                                                                                                                        (DI.SrcID
                                                                                                                                                                                                           "XML"
                                                                                                                                                                                                           0)
                                                                                                                                                                                                        (DI.DynamicInfo
                                                                                                                                                                                                           []
                                                                                                                                                                                                           [DI.genTerm
                                                                                                                                                                                                              x14,
                                                                                                                                                                                                            DI.genTerm
                                                                                                                                                                                                              x15]))
                                                                                                                                                                                                     (Prelude.return
                                                                                                                                                                                                        (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                           x14
                                                                                                                                                                                                           x15))
                                                                                                                                                                                         DM.constructorHook
                                                                                                                                                                                           (DI.DebugInfo
                                                                                                                                                                                              (DI.SrcID
                                                                                                                                                                                                 "XML"
                                                                                                                                                                                                 0)
                                                                                                                                                                                              (DI.DynamicInfo
                                                                                                                                                                                                 []
                                                                                                                                                                                                 [DI.genTerm
                                                                                                                                                                                                    x16,
                                                                                                                                                                                                  DI.genTerm
                                                                                                                                                                                                    x17]))
                                                                                                                                                                                           (Prelude.return
                                                                                                                                                                                              (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                 x16
                                                                                                                                                                                                 x17))
                                                                                                                                                                               DM.constructorHook
                                                                                                                                                                                 (DI.DebugInfo
                                                                                                                                                                                    (DI.SrcID
                                                                                                                                                                                       "XML"
                                                                                                                                                                                       0)
                                                                                                                                                                                    (DI.DynamicInfo
                                                                                                                                                                                       []
                                                                                                                                                                                       [DI.genTerm
                                                                                                                                                                                          x18,
                                                                                                                                                                                        DI.genTerm
                                                                                                                                                                                          x19]))
                                                                                                                                                                                 (Prelude.return
                                                                                                                                                                                    (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                       x18
                                                                                                                                                                                       x19))
                                                                                                                                                                     DM.constructorHook
                                                                                                                                                                       (DI.DebugInfo
                                                                                                                                                                          (DI.SrcID
                                                                                                                                                                             "XML"
                                                                                                                                                                             0)
                                                                                                                                                                          (DI.DynamicInfo
                                                                                                                                                                             []
                                                                                                                                                                             [DI.genTerm
                                                                                                                                                                                x20,
                                                                                                                                                                              DI.genTerm
                                                                                                                                                                                x21]))
                                                                                                                                                                       (Prelude.return
                                                                                                                                                                          (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                             x20
                                                                                                                                                                             x21))
                                                                                                                                                           DM.constructorHook
                                                                                                                                                             (DI.DebugInfo
                                                                                                                                                                (DI.SrcID
                                                                                                                                                                   "XML"
                                                                                                                                                                   0)
                                                                                                                                                                (DI.DynamicInfo
                                                                                                                                                                   []
                                                                                                                                                                   [DI.genTerm
                                                                                                                                                                      x22,
                                                                                                                                                                    DI.genTerm
                                                                                                                                                                      x23]))
                                                                                                                                                             (Prelude.return
                                                                                                                                                                (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                   x22
                                                                                                                                                                   x23))
                                                                                                                                                 DM.constructorHook
                                                                                                                                                   (DI.DebugInfo
                                                                                                                                                      (DI.SrcID
                                                                                                                                                         "XML"
                                                                                                                                                         0)
                                                                                                                                                      (DI.DynamicInfo
                                                                                                                                                         []
                                                                                                                                                         [DI.genTerm
                                                                                                                                                            x24,
                                                                                                                                                          DI.genTerm
                                                                                                                                                            x25]))
                                                                                                                                                   (Prelude.return
                                                                                                                                                      (Curry.DebugModule.Prelude.Cons
                                                                                                                                                         x24
                                                                                                                                                         x25))
                                                                                                                                       DM.constructorHook
                                                                                                                                         (DI.DebugInfo
                                                                                                                                            (DI.SrcID
                                                                                                                                               "XML"
                                                                                                                                               0)
                                                                                                                                            (DI.DynamicInfo
                                                                                                                                               []
                                                                                                                                               [DI.genTerm
                                                                                                                                                  x26,
                                                                                                                                                DI.genTerm
                                                                                                                                                  x27]))
                                                                                                                                         (Prelude.return
                                                                                                                                            (Curry.DebugModule.Prelude.Cons
                                                                                                                                               x26
                                                                                                                                               x27))
                                                                                                                             DM.constructorHook
                                                                                                                               (DI.DebugInfo
                                                                                                                                  (DI.SrcID
                                                                                                                                     "XML"
                                                                                                                                     0)
                                                                                                                                  (DI.DynamicInfo
                                                                                                                                     []
                                                                                                                                     [DI.genTerm
                                                                                                                                        x28,
                                                                                                                                      DI.genTerm
                                                                                                                                        x29]))
                                                                                                                               (Prelude.return
                                                                                                                                  (Curry.DebugModule.Prelude.Cons
                                                                                                                                     x28
                                                                                                                                     x29))
                                                                                                                   DM.constructorHook
                                                                                                                     (DI.DebugInfo
                                                                                                                        (DI.SrcID
                                                                                                                           "XML"
                                                                                                                           0)
                                                                                                                        (DI.DynamicInfo
                                                                                                                           []
                                                                                                                           [DI.genTerm
                                                                                                                              x30,
                                                                                                                            DI.genTerm
                                                                                                                              x31]))
                                                                                                                     (Prelude.return
                                                                                                                        (Curry.DebugModule.Prelude.Cons
                                                                                                                           x30
                                                                                                                           x31))
                                                                                                         DM.constructorHook
                                                                                                           (DI.DebugInfo
                                                                                                              (DI.SrcID
                                                                                                                 "XML"
                                                                                                                 0)
                                                                                                              (DI.DynamicInfo
                                                                                                                 []
                                                                                                                 [DI.genTerm
                                                                                                                    x32,
                                                                                                                  DI.genTerm
                                                                                                                    x33]))
                                                                                                           (Prelude.return
                                                                                                              (Curry.DebugModule.Prelude.Cons
                                                                                                                 x32
                                                                                                                 x33))
                                                                                               DM.constructorHook
                                                                                                 (DI.DebugInfo
                                                                                                    (DI.SrcID
                                                                                                       "XML"
                                                                                                       0)
                                                                                                    (DI.DynamicInfo
                                                                                                       []
                                                                                                       [DI.genTerm
                                                                                                          x34,
                                                                                                        DI.genTerm
                                                                                                          x35]))
                                                                                                 (Prelude.return
                                                                                                    (Curry.DebugModule.Prelude.Cons
                                                                                                       x34
                                                                                                       x35))
                                                                                     DM.constructorHook
                                                                                       (DI.DebugInfo
                                                                                          (DI.SrcID
                                                                                             "XML"
                                                                                             0)
                                                                                          (DI.DynamicInfo
                                                                                             []
                                                                                             [DI.genTerm
                                                                                                x36,
                                                                                              DI.genTerm
                                                                                                x37]))
                                                                                       (Prelude.return
                                                                                          (Curry.DebugModule.Prelude.Cons
                                                                                             x36
                                                                                             x37))
                                                                           DM.constructorHook
                                                                             (DI.DebugInfo
                                                                                (DI.SrcID "XML" 0)
                                                                                (DI.DynamicInfo []
                                                                                   [DI.genTerm x38,
                                                                                    DI.genTerm
                                                                                      x39]))
                                                                             (Prelude.return
                                                                                (Curry.DebugModule.Prelude.Cons
                                                                                   x38
                                                                                   x39))
                                                                 DM.constructorHook
                                                                   (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                      (DI.DynamicInfo []
                                                                         [DI.genTerm x40,
                                                                          DI.genTerm x41]))
                                                                   (Prelude.return
                                                                      (Curry.DebugModule.Prelude.Cons
                                                                         x40
                                                                         x41))
                                                       DM.constructorHook
                                                         (DI.DebugInfo (DI.SrcID "XML" 0)
                                                            (DI.DynamicInfo []
                                                               [DI.genTerm x42, DI.genTerm x43]))
                                                         (Prelude.return
                                                            (Curry.DebugModule.Prelude.Cons x42
                                                               x43))
                                             DM.constructorHook
                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                  (DI.DynamicInfo []
                                                     [DI.genTerm x44, DI.genTerm x45]))
                                               (Prelude.return
                                                  (Curry.DebugModule.Prelude.Cons x44 x45))
                                  x108 <- do x105 <- do x47 <- do x46 <- Prelude.return x1
                                                                  DM.funcCallHook "lookupEncoding"
                                                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                       (DI.DynamicInfo []
                                                                          [DI.genTerm x46]))
                                                                    (strict_lookupEncoding x46)
                                                        DM.funcCallHook "encoding2Attribute"
                                                          (DI.DebugInfo (DI.SrcID "XML" 0)
                                                             (DI.DynamicInfo [] [DI.genTerm x47]))
                                                          (strict_encoding2Attribute x47)
                                             x106 <- do x103 <- do x70 <- DM.litHook
                                                                            (DI.DebugInfo
                                                                               (DI.SrcID "XML" 0)
                                                                               (DI.DynamicInfo []
                                                                                  []))
                                                                            (Prelude.return
                                                                               (Curry.DebugModule.Prelude.Char
                                                                                  's'))
                                                                   x71 <- do x68 <- DM.litHook
                                                                                      (DI.DebugInfo
                                                                                         (DI.SrcID
                                                                                            "XML"
                                                                                            0)
                                                                                         (DI.DynamicInfo
                                                                                            []
                                                                                            []))
                                                                                      (Prelude.return
                                                                                         (Curry.DebugModule.Prelude.Char
                                                                                            't'))
                                                                             x69 <- do x66 <- DM.litHook
                                                                                                (DI.DebugInfo
                                                                                                   (DI.SrcID
                                                                                                      "XML"
                                                                                                      0)
                                                                                                   (DI.DynamicInfo
                                                                                                      []
                                                                                                      []))
                                                                                                (Prelude.return
                                                                                                   (Curry.DebugModule.Prelude.Char
                                                                                                      'a'))
                                                                                       x67 <- do x64 <- DM.litHook
                                                                                                          (DI.DebugInfo
                                                                                                             (DI.SrcID
                                                                                                                "XML"
                                                                                                                0)
                                                                                                             (DI.DynamicInfo
                                                                                                                []
                                                                                                                []))
                                                                                                          (Prelude.return
                                                                                                             (Curry.DebugModule.Prelude.Char
                                                                                                                'n'))
                                                                                                 x65 <- do x62 <- DM.litHook
                                                                                                                    (DI.DebugInfo
                                                                                                                       (DI.SrcID
                                                                                                                          "XML"
                                                                                                                          0)
                                                                                                                       (DI.DynamicInfo
                                                                                                                          []
                                                                                                                          []))
                                                                                                                    (Prelude.return
                                                                                                                       (Curry.DebugModule.Prelude.Char
                                                                                                                          'd'))
                                                                                                           x63 <- do x60 <- DM.litHook
                                                                                                                              (DI.DebugInfo
                                                                                                                                 (DI.SrcID
                                                                                                                                    "XML"
                                                                                                                                    0)
                                                                                                                                 (DI.DynamicInfo
                                                                                                                                    []
                                                                                                                                    []))
                                                                                                                              (Prelude.return
                                                                                                                                 (Curry.DebugModule.Prelude.Char
                                                                                                                                    'a'))
                                                                                                                     x61 <- do x58 <- DM.litHook
                                                                                                                                        (DI.DebugInfo
                                                                                                                                           (DI.SrcID
                                                                                                                                              "XML"
                                                                                                                                              0)
                                                                                                                                           (DI.DynamicInfo
                                                                                                                                              []
                                                                                                                                              []))
                                                                                                                                        (Prelude.return
                                                                                                                                           (Curry.DebugModule.Prelude.Char
                                                                                                                                              'l'))
                                                                                                                               x59 <- do x56 <- DM.litHook
                                                                                                                                                  (DI.DebugInfo
                                                                                                                                                     (DI.SrcID
                                                                                                                                                        "XML"
                                                                                                                                                        0)
                                                                                                                                                     (DI.DynamicInfo
                                                                                                                                                        []
                                                                                                                                                        []))
                                                                                                                                                  (Prelude.return
                                                                                                                                                     (Curry.DebugModule.Prelude.Char
                                                                                                                                                        'o'))
                                                                                                                                         x57 <- do x54 <- DM.litHook
                                                                                                                                                            (DI.DebugInfo
                                                                                                                                                               (DI.SrcID
                                                                                                                                                                  "XML"
                                                                                                                                                                  0)
                                                                                                                                                               (DI.DynamicInfo
                                                                                                                                                                  []
                                                                                                                                                                  []))
                                                                                                                                                            (Prelude.return
                                                                                                                                                               (Curry.DebugModule.Prelude.Char
                                                                                                                                                                  'n'))
                                                                                                                                                   x55 <- do x52 <- DM.litHook
                                                                                                                                                                      (DI.DebugInfo
                                                                                                                                                                         (DI.SrcID
                                                                                                                                                                            "XML"
                                                                                                                                                                            0)
                                                                                                                                                                         (DI.DynamicInfo
                                                                                                                                                                            []
                                                                                                                                                                            []))
                                                                                                                                                                      (Prelude.return
                                                                                                                                                                         (Curry.DebugModule.Prelude.Char
                                                                                                                                                                            'e'))
                                                                                                                                                             x53 <- do x50 <- DM.litHook
                                                                                                                                                                                (DI.DebugInfo
                                                                                                                                                                                   (DI.SrcID
                                                                                                                                                                                      "XML"
                                                                                                                                                                                      0)
                                                                                                                                                                                   (DI.DynamicInfo
                                                                                                                                                                                      []
                                                                                                                                                                                      []))
                                                                                                                                                                                (Prelude.return
                                                                                                                                                                                   (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                      '='))
                                                                                                                                                                       x51 <- do x48 <- DM.litHook
                                                                                                                                                                                          (DI.DebugInfo
                                                                                                                                                                                             (DI.SrcID
                                                                                                                                                                                                "XML"
                                                                                                                                                                                                0)
                                                                                                                                                                                             (DI.DynamicInfo
                                                                                                                                                                                                []
                                                                                                                                                                                                []))
                                                                                                                                                                                          (Prelude.return
                                                                                                                                                                                             (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                '"'))
                                                                                                                                                                                 x49 <- DM.constructorHook
                                                                                                                                                                                          (DI.DebugInfo
                                                                                                                                                                                             (DI.SrcID
                                                                                                                                                                                                "XML"
                                                                                                                                                                                                0)
                                                                                                                                                                                             (DI.DynamicInfo
                                                                                                                                                                                                []
                                                                                                                                                                                                []))
                                                                                                                                                                                          (Prelude.return
                                                                                                                                                                                             Curry.DebugModule.Prelude.Nil)
                                                                                                                                                                                 DM.constructorHook
                                                                                                                                                                                   (DI.DebugInfo
                                                                                                                                                                                      (DI.SrcID
                                                                                                                                                                                         "XML"
                                                                                                                                                                                         0)
                                                                                                                                                                                      (DI.DynamicInfo
                                                                                                                                                                                         []
                                                                                                                                                                                         [DI.genTerm
                                                                                                                                                                                            x48,
                                                                                                                                                                                          DI.genTerm
                                                                                                                                                                                            x49]))
                                                                                                                                                                                   (Prelude.return
                                                                                                                                                                                      (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                         x48
                                                                                                                                                                                         x49))
                                                                                                                                                                       DM.constructorHook
                                                                                                                                                                         (DI.DebugInfo
                                                                                                                                                                            (DI.SrcID
                                                                                                                                                                               "XML"
                                                                                                                                                                               0)
                                                                                                                                                                            (DI.DynamicInfo
                                                                                                                                                                               []
                                                                                                                                                                               [DI.genTerm
                                                                                                                                                                                  x50,
                                                                                                                                                                                DI.genTerm
                                                                                                                                                                                  x51]))
                                                                                                                                                                         (Prelude.return
                                                                                                                                                                            (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                               x50
                                                                                                                                                                               x51))
                                                                                                                                                             DM.constructorHook
                                                                                                                                                               (DI.DebugInfo
                                                                                                                                                                  (DI.SrcID
                                                                                                                                                                     "XML"
                                                                                                                                                                     0)
                                                                                                                                                                  (DI.DynamicInfo
                                                                                                                                                                     []
                                                                                                                                                                     [DI.genTerm
                                                                                                                                                                        x52,
                                                                                                                                                                      DI.genTerm
                                                                                                                                                                        x53]))
                                                                                                                                                               (Prelude.return
                                                                                                                                                                  (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                     x52
                                                                                                                                                                     x53))
                                                                                                                                                   DM.constructorHook
                                                                                                                                                     (DI.DebugInfo
                                                                                                                                                        (DI.SrcID
                                                                                                                                                           "XML"
                                                                                                                                                           0)
                                                                                                                                                        (DI.DynamicInfo
                                                                                                                                                           []
                                                                                                                                                           [DI.genTerm
                                                                                                                                                              x54,
                                                                                                                                                            DI.genTerm
                                                                                                                                                              x55]))
                                                                                                                                                     (Prelude.return
                                                                                                                                                        (Curry.DebugModule.Prelude.Cons
                                                                                                                                                           x54
                                                                                                                                                           x55))
                                                                                                                                         DM.constructorHook
                                                                                                                                           (DI.DebugInfo
                                                                                                                                              (DI.SrcID
                                                                                                                                                 "XML"
                                                                                                                                                 0)
                                                                                                                                              (DI.DynamicInfo
                                                                                                                                                 []
                                                                                                                                                 [DI.genTerm
                                                                                                                                                    x56,
                                                                                                                                                  DI.genTerm
                                                                                                                                                    x57]))
                                                                                                                                           (Prelude.return
                                                                                                                                              (Curry.DebugModule.Prelude.Cons
                                                                                                                                                 x56
                                                                                                                                                 x57))
                                                                                                                               DM.constructorHook
                                                                                                                                 (DI.DebugInfo
                                                                                                                                    (DI.SrcID
                                                                                                                                       "XML"
                                                                                                                                       0)
                                                                                                                                    (DI.DynamicInfo
                                                                                                                                       []
                                                                                                                                       [DI.genTerm
                                                                                                                                          x58,
                                                                                                                                        DI.genTerm
                                                                                                                                          x59]))
                                                                                                                                 (Prelude.return
                                                                                                                                    (Curry.DebugModule.Prelude.Cons
                                                                                                                                       x58
                                                                                                                                       x59))
                                                                                                                     DM.constructorHook
                                                                                                                       (DI.DebugInfo
                                                                                                                          (DI.SrcID
                                                                                                                             "XML"
                                                                                                                             0)
                                                                                                                          (DI.DynamicInfo
                                                                                                                             []
                                                                                                                             [DI.genTerm
                                                                                                                                x60,
                                                                                                                              DI.genTerm
                                                                                                                                x61]))
                                                                                                                       (Prelude.return
                                                                                                                          (Curry.DebugModule.Prelude.Cons
                                                                                                                             x60
                                                                                                                             x61))
                                                                                                           DM.constructorHook
                                                                                                             (DI.DebugInfo
                                                                                                                (DI.SrcID
                                                                                                                   "XML"
                                                                                                                   0)
                                                                                                                (DI.DynamicInfo
                                                                                                                   []
                                                                                                                   [DI.genTerm
                                                                                                                      x62,
                                                                                                                    DI.genTerm
                                                                                                                      x63]))
                                                                                                             (Prelude.return
                                                                                                                (Curry.DebugModule.Prelude.Cons
                                                                                                                   x62
                                                                                                                   x63))
                                                                                                 DM.constructorHook
                                                                                                   (DI.DebugInfo
                                                                                                      (DI.SrcID
                                                                                                         "XML"
                                                                                                         0)
                                                                                                      (DI.DynamicInfo
                                                                                                         []
                                                                                                         [DI.genTerm
                                                                                                            x64,
                                                                                                          DI.genTerm
                                                                                                            x65]))
                                                                                                   (Prelude.return
                                                                                                      (Curry.DebugModule.Prelude.Cons
                                                                                                         x64
                                                                                                         x65))
                                                                                       DM.constructorHook
                                                                                         (DI.DebugInfo
                                                                                            (DI.SrcID
                                                                                               "XML"
                                                                                               0)
                                                                                            (DI.DynamicInfo
                                                                                               []
                                                                                               [DI.genTerm
                                                                                                  x66,
                                                                                                DI.genTerm
                                                                                                  x67]))
                                                                                         (Prelude.return
                                                                                            (Curry.DebugModule.Prelude.Cons
                                                                                               x66
                                                                                               x67))
                                                                             DM.constructorHook
                                                                               (DI.DebugInfo
                                                                                  (DI.SrcID "XML" 0)
                                                                                  (DI.DynamicInfo []
                                                                                     [DI.genTerm
                                                                                        x68,
                                                                                      DI.genTerm
                                                                                        x69]))
                                                                               (Prelude.return
                                                                                  (Curry.DebugModule.Prelude.Cons
                                                                                     x68
                                                                                     x69))
                                                                   DM.constructorHook
                                                                     (DI.DebugInfo
                                                                        (DI.SrcID "XML" 0)
                                                                        (DI.DynamicInfo []
                                                                           [DI.genTerm x70,
                                                                            DI.genTerm x71]))
                                                                     (Prelude.return
                                                                        (Curry.DebugModule.Prelude.Cons
                                                                           x70
                                                                           x71))
                                                        x104 <- do x101 <- do x73 <- Prelude.return
                                                                                       x1
                                                                              x74 <- do x72 <- Prelude.return
                                                                                                 x1
                                                                                        DM.funcCallHook
                                                                                          "hasDtdUrl"
                                                                                          (DI.DebugInfo
                                                                                             (DI.SrcID
                                                                                                "XML"
                                                                                                0)
                                                                                             (DI.DynamicInfo
                                                                                                []
                                                                                                [DI.genTerm
                                                                                                   x72]))
                                                                                          (strict_hasDtdUrl
                                                                                             x72)
                                                                              DM.funcCallHook
                                                                                "_case_101"
                                                                                (DI.DebugInfo
                                                                                   (DI.SrcID "XML"
                                                                                      0)
                                                                                   (DI.DynamicInfo
                                                                                      []
                                                                                      [DI.genTerm
                                                                                         x73,
                                                                                       DI.genTerm
                                                                                         x74]))
                                                                                (strict__case_101
                                                                                   x73
                                                                                   x74)
                                                                   x102 <- do x99 <- do x83 <- DM.litHook
                                                                                                 (DI.DebugInfo
                                                                                                    (DI.SrcID
                                                                                                       "XML"
                                                                                                       0)
                                                                                                    (DI.DynamicInfo
                                                                                                       []
                                                                                                       []))
                                                                                                 (Prelude.return
                                                                                                    (Curry.DebugModule.Prelude.Char
                                                                                                       '"'))
                                                                                        x84 <- do x81 <- DM.litHook
                                                                                                           (DI.DebugInfo
                                                                                                              (DI.SrcID
                                                                                                                 "XML"
                                                                                                                 0)
                                                                                                              (DI.DynamicInfo
                                                                                                                 []
                                                                                                                 []))
                                                                                                           (Prelude.return
                                                                                                              (Curry.DebugModule.Prelude.Char
                                                                                                                 '?'))
                                                                                                  x82 <- do x79 <- DM.litHook
                                                                                                                     (DI.DebugInfo
                                                                                                                        (DI.SrcID
                                                                                                                           "XML"
                                                                                                                           0)
                                                                                                                        (DI.DynamicInfo
                                                                                                                           []
                                                                                                                           []))
                                                                                                                     (Prelude.return
                                                                                                                        (Curry.DebugModule.Prelude.Char
                                                                                                                           '>'))
                                                                                                            x80 <- do x77 <- DM.litHook
                                                                                                                               (DI.DebugInfo
                                                                                                                                  (DI.SrcID
                                                                                                                                     "XML"
                                                                                                                                     0)
                                                                                                                                  (DI.DynamicInfo
                                                                                                                                     []
                                                                                                                                     []))
                                                                                                                               (Prelude.return
                                                                                                                                  (Curry.DebugModule.Prelude.Char
                                                                                                                                     '\n'))
                                                                                                                      x78 <- do x75 <- DM.litHook
                                                                                                                                         (DI.DebugInfo
                                                                                                                                            (DI.SrcID
                                                                                                                                               "XML"
                                                                                                                                               0)
                                                                                                                                            (DI.DynamicInfo
                                                                                                                                               []
                                                                                                                                               []))
                                                                                                                                         (Prelude.return
                                                                                                                                            (Curry.DebugModule.Prelude.Char
                                                                                                                                               '\n'))
                                                                                                                                x76 <- DM.constructorHook
                                                                                                                                         (DI.DebugInfo
                                                                                                                                            (DI.SrcID
                                                                                                                                               "XML"
                                                                                                                                               0)
                                                                                                                                            (DI.DynamicInfo
                                                                                                                                               []
                                                                                                                                               []))
                                                                                                                                         (Prelude.return
                                                                                                                                            Curry.DebugModule.Prelude.Nil)
                                                                                                                                DM.constructorHook
                                                                                                                                  (DI.DebugInfo
                                                                                                                                     (DI.SrcID
                                                                                                                                        "XML"
                                                                                                                                        0)
                                                                                                                                     (DI.DynamicInfo
                                                                                                                                        []
                                                                                                                                        [DI.genTerm
                                                                                                                                           x75,
                                                                                                                                         DI.genTerm
                                                                                                                                           x76]))
                                                                                                                                  (Prelude.return
                                                                                                                                     (Curry.DebugModule.Prelude.Cons
                                                                                                                                        x75
                                                                                                                                        x76))
                                                                                                                      DM.constructorHook
                                                                                                                        (DI.DebugInfo
                                                                                                                           (DI.SrcID
                                                                                                                              "XML"
                                                                                                                              0)
                                                                                                                           (DI.DynamicInfo
                                                                                                                              []
                                                                                                                              [DI.genTerm
                                                                                                                                 x77,
                                                                                                                               DI.genTerm
                                                                                                                                 x78]))
                                                                                                                        (Prelude.return
                                                                                                                           (Curry.DebugModule.Prelude.Cons
                                                                                                                              x77
                                                                                                                              x78))
                                                                                                            DM.constructorHook
                                                                                                              (DI.DebugInfo
                                                                                                                 (DI.SrcID
                                                                                                                    "XML"
                                                                                                                    0)
                                                                                                                 (DI.DynamicInfo
                                                                                                                    []
                                                                                                                    [DI.genTerm
                                                                                                                       x79,
                                                                                                                     DI.genTerm
                                                                                                                       x80]))
                                                                                                              (Prelude.return
                                                                                                                 (Curry.DebugModule.Prelude.Cons
                                                                                                                    x79
                                                                                                                    x80))
                                                                                                  DM.constructorHook
                                                                                                    (DI.DebugInfo
                                                                                                       (DI.SrcID
                                                                                                          "XML"
                                                                                                          0)
                                                                                                       (DI.DynamicInfo
                                                                                                          []
                                                                                                          [DI.genTerm
                                                                                                             x81,
                                                                                                           DI.genTerm
                                                                                                             x82]))
                                                                                                    (Prelude.return
                                                                                                       (Curry.DebugModule.Prelude.Cons
                                                                                                          x81
                                                                                                          x82))
                                                                                        DM.constructorHook
                                                                                          (DI.DebugInfo
                                                                                             (DI.SrcID
                                                                                                "XML"
                                                                                                0)
                                                                                             (DI.DynamicInfo
                                                                                                []
                                                                                                [DI.genTerm
                                                                                                   x83,
                                                                                                 DI.genTerm
                                                                                                   x84]))
                                                                                          (Prelude.return
                                                                                             (Curry.DebugModule.Prelude.Cons
                                                                                                x83
                                                                                                x84))
                                                                              x100 <- do x97 <- do x86 <- Prelude.return
                                                                                                            x1
                                                                                                   x87 <- Prelude.return
                                                                                                            x3
                                                                                                   x88 <- do x85 <- Prelude.return
                                                                                                                      x1
                                                                                                             DM.funcCallHook
                                                                                                               "hasDtdUrl"
                                                                                                               (DI.DebugInfo
                                                                                                                  (DI.SrcID
                                                                                                                     "XML"
                                                                                                                     0)
                                                                                                                  (DI.DynamicInfo
                                                                                                                     []
                                                                                                                     [DI.genTerm
                                                                                                                        x85]))
                                                                                                               (strict_hasDtdUrl
                                                                                                                  x85)
                                                                                                   DM.funcCallHook
                                                                                                     "_case_100"
                                                                                                     (DI.DebugInfo
                                                                                                        (DI.SrcID
                                                                                                           "XML"
                                                                                                           0)
                                                                                                        (DI.DynamicInfo
                                                                                                           []
                                                                                                           [DI.genTerm
                                                                                                              x86,
                                                                                                            DI.genTerm
                                                                                                              x87,
                                                                                                            DI.genTerm
                                                                                                              x88]))
                                                                                                     (strict__case_100
                                                                                                        x86
                                                                                                        x87
                                                                                                        x88)
                                                                                         x98 <- do x94 <- DM.litHook
                                                                                                            (DI.DebugInfo
                                                                                                               (DI.SrcID
                                                                                                                  "XML"
                                                                                                                  0)
                                                                                                               (DI.DynamicInfo
                                                                                                                  []
                                                                                                                  []))
                                                                                                            (Prelude.return
                                                                                                               Curry.DebugModule.Prelude.Zero)
                                                                                                   x95 <- do x90 <- do x89 <- Prelude.return
                                                                                                                                x1
                                                                                                                       DM.funcCallHook
                                                                                                                         "lookupEncoding"
                                                                                                                         (DI.DebugInfo
                                                                                                                            (DI.SrcID
                                                                                                                               "XML"
                                                                                                                               0)
                                                                                                                            (DI.DynamicInfo
                                                                                                                               []
                                                                                                                               [DI.genTerm
                                                                                                                                  x89]))
                                                                                                                         (strict_lookupEncoding
                                                                                                                            x89)
                                                                                                             DM.funcCallHook
                                                                                                               "encoding2EncFunc"
                                                                                                               (DI.DebugInfo
                                                                                                                  (DI.SrcID
                                                                                                                     "XML"
                                                                                                                     0)
                                                                                                                  (DI.DynamicInfo
                                                                                                                     []
                                                                                                                     [DI.genTerm
                                                                                                                        x90]))
                                                                                                               (strict_encoding2EncFunc
                                                                                                                  x90)
                                                                                                   x96 <- do x91 <- Prelude.return
                                                                                                                      x3
                                                                                                             x92 <- Prelude.return
                                                                                                                      x4
                                                                                                             x93 <- Prelude.return
                                                                                                                      x5
                                                                                                             DM.constructorHook
                                                                                                               (DI.DebugInfo
                                                                                                                  (DI.SrcID
                                                                                                                     "XML"
                                                                                                                     0)
                                                                                                                  (DI.DynamicInfo
                                                                                                                     []
                                                                                                                     [DI.genTerm
                                                                                                                        x91,
                                                                                                                      DI.genTerm
                                                                                                                        x92,
                                                                                                                      DI.genTerm
                                                                                                                        x93]))
                                                                                                               (Prelude.return
                                                                                                                  (XElem
                                                                                                                     x91
                                                                                                                     x92
                                                                                                                     x93))
                                                                                                   DM.funcCallHook
                                                                                                     "showXmlExp"
                                                                                                     (DI.DebugInfo
                                                                                                        (DI.SrcID
                                                                                                           "XML"
                                                                                                           0)
                                                                                                        (DI.DynamicInfo
                                                                                                           []
                                                                                                           [DI.genTerm
                                                                                                              x94,
                                                                                                            DI.genTerm
                                                                                                              x95,
                                                                                                            DI.genTerm
                                                                                                              x96]))
                                                                                                     (strict_showXmlExp
                                                                                                        x94
                                                                                                        x95
                                                                                                        x96)
                                                                                         DM.funcCallHook
                                                                                           "++"
                                                                                           (DI.DebugInfo
                                                                                              (DI.SrcID
                                                                                                 "XML"
                                                                                                 0)
                                                                                              (DI.DynamicInfo
                                                                                                 []
                                                                                                 [DI.genTerm
                                                                                                    x97,
                                                                                                  DI.genTerm
                                                                                                    x98]))
                                                                                           (Curry.DebugModule.Prelude.op_PlusPlus
                                                                                              x97
                                                                                              x98)
                                                                              DM.funcCallHook "++"
                                                                                (DI.DebugInfo
                                                                                   (DI.SrcID "XML"
                                                                                      0)
                                                                                   (DI.DynamicInfo
                                                                                      []
                                                                                      [DI.genTerm
                                                                                         x99,
                                                                                       DI.genTerm
                                                                                         x100]))
                                                                                (Curry.DebugModule.Prelude.op_PlusPlus
                                                                                   x99
                                                                                   x100)
                                                                   DM.funcCallHook "++"
                                                                     (DI.DebugInfo
                                                                        (DI.SrcID "XML" 0)
                                                                        (DI.DynamicInfo []
                                                                           [DI.genTerm x101,
                                                                            DI.genTerm x102]))
                                                                     (Curry.DebugModule.Prelude.op_PlusPlus
                                                                        x101
                                                                        x102)
                                                        DM.funcCallHook "++"
                                                          (DI.DebugInfo (DI.SrcID "XML" 0)
                                                             (DI.DynamicInfo []
                                                                [DI.genTerm x103, DI.genTerm x104]))
                                                          (Curry.DebugModule.Prelude.op_PlusPlus
                                                             x103
                                                             x104)
                                             DM.funcCallHook "++"
                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                  (DI.DynamicInfo []
                                                     [DI.genTerm x105, DI.genTerm x106]))
                                               (Curry.DebugModule.Prelude.op_PlusPlus x105 x106)
                                  DM.funcCallHook "++"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x107, DI.genTerm x108]))
                                    (Curry.DebugModule.Prelude.op_PlusPlus x107 x108)))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x109])))
                           (strict__case_102 x1)
                           x109)))
term_strict__case_102 x1
  = DI.Term "_case_102" (DI.SrcID "XML" 0) x1
strict__case_100 x1 x3 x4
  = DM.eval
      (DM.funcDeclHook "_case_100"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x3, DI.genTerm x4]))
         (do x60 <- Prelude.return x4
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x60]))
               (case x60 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x58 <- do x23 <- DM.litHook
                                                     (DI.DebugInfo (DI.SrcID "XML" 0)
                                                        (DI.DynamicInfo [] []))
                                                     (Prelude.return
                                                        (Curry.DebugModule.Prelude.Char '<'))
                                            x24 <- do x21 <- DM.litHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo [] []))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Char
                                                                     '!'))
                                                      x22 <- do x19 <- DM.litHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo [] []))
                                                                         (Prelude.return
                                                                            (Curry.DebugModule.Prelude.Char
                                                                               'D'))
                                                                x20 <- do x17 <- DM.litHook
                                                                                   (DI.DebugInfo
                                                                                      (DI.SrcID
                                                                                         "XML"
                                                                                         0)
                                                                                      (DI.DynamicInfo
                                                                                         []
                                                                                         []))
                                                                                   (Prelude.return
                                                                                      (Curry.DebugModule.Prelude.Char
                                                                                         'O'))
                                                                          x18 <- do x15 <- DM.litHook
                                                                                             (DI.DebugInfo
                                                                                                (DI.SrcID
                                                                                                   "XML"
                                                                                                   0)
                                                                                                (DI.DynamicInfo
                                                                                                   []
                                                                                                   []))
                                                                                             (Prelude.return
                                                                                                (Curry.DebugModule.Prelude.Char
                                                                                                   'C'))
                                                                                    x16 <- do x13 <- DM.litHook
                                                                                                       (DI.DebugInfo
                                                                                                          (DI.SrcID
                                                                                                             "XML"
                                                                                                             0)
                                                                                                          (DI.DynamicInfo
                                                                                                             []
                                                                                                             []))
                                                                                                       (Prelude.return
                                                                                                          (Curry.DebugModule.Prelude.Char
                                                                                                             'T'))
                                                                                              x14 <- do x11 <- DM.litHook
                                                                                                                 (DI.DebugInfo
                                                                                                                    (DI.SrcID
                                                                                                                       "XML"
                                                                                                                       0)
                                                                                                                    (DI.DynamicInfo
                                                                                                                       []
                                                                                                                       []))
                                                                                                                 (Prelude.return
                                                                                                                    (Curry.DebugModule.Prelude.Char
                                                                                                                       'Y'))
                                                                                                        x12 <- do x9 <- DM.litHook
                                                                                                                          (DI.DebugInfo
                                                                                                                             (DI.SrcID
                                                                                                                                "XML"
                                                                                                                                0)
                                                                                                                             (DI.DynamicInfo
                                                                                                                                []
                                                                                                                                []))
                                                                                                                          (Prelude.return
                                                                                                                             (Curry.DebugModule.Prelude.Char
                                                                                                                                'P'))
                                                                                                                  x10 <- do x7 <- DM.litHook
                                                                                                                                    (DI.DebugInfo
                                                                                                                                       (DI.SrcID
                                                                                                                                          "XML"
                                                                                                                                          0)
                                                                                                                                       (DI.DynamicInfo
                                                                                                                                          []
                                                                                                                                          []))
                                                                                                                                    (Prelude.return
                                                                                                                                       (Curry.DebugModule.Prelude.Char
                                                                                                                                          'E'))
                                                                                                                            x8 <- do x5 <- DM.litHook
                                                                                                                                             (DI.DebugInfo
                                                                                                                                                (DI.SrcID
                                                                                                                                                   "XML"
                                                                                                                                                   0)
                                                                                                                                                (DI.DynamicInfo
                                                                                                                                                   []
                                                                                                                                                   []))
                                                                                                                                             (Prelude.return
                                                                                                                                                (Curry.DebugModule.Prelude.Char
                                                                                                                                                   ' '))
                                                                                                                                     x6 <- DM.constructorHook
                                                                                                                                             (DI.DebugInfo
                                                                                                                                                (DI.SrcID
                                                                                                                                                   "XML"
                                                                                                                                                   0)
                                                                                                                                                (DI.DynamicInfo
                                                                                                                                                   []
                                                                                                                                                   []))
                                                                                                                                             (Prelude.return
                                                                                                                                                Curry.DebugModule.Prelude.Nil)
                                                                                                                                     DM.constructorHook
                                                                                                                                       (DI.DebugInfo
                                                                                                                                          (DI.SrcID
                                                                                                                                             "XML"
                                                                                                                                             0)
                                                                                                                                          (DI.DynamicInfo
                                                                                                                                             []
                                                                                                                                             [DI.genTerm
                                                                                                                                                x5,
                                                                                                                                              DI.genTerm
                                                                                                                                                x6]))
                                                                                                                                       (Prelude.return
                                                                                                                                          (Curry.DebugModule.Prelude.Cons
                                                                                                                                             x5
                                                                                                                                             x6))
                                                                                                                            DM.constructorHook
                                                                                                                              (DI.DebugInfo
                                                                                                                                 (DI.SrcID
                                                                                                                                    "XML"
                                                                                                                                    0)
                                                                                                                                 (DI.DynamicInfo
                                                                                                                                    []
                                                                                                                                    [DI.genTerm
                                                                                                                                       x7,
                                                                                                                                     DI.genTerm
                                                                                                                                       x8]))
                                                                                                                              (Prelude.return
                                                                                                                                 (Curry.DebugModule.Prelude.Cons
                                                                                                                                    x7
                                                                                                                                    x8))
                                                                                                                  DM.constructorHook
                                                                                                                    (DI.DebugInfo
                                                                                                                       (DI.SrcID
                                                                                                                          "XML"
                                                                                                                          0)
                                                                                                                       (DI.DynamicInfo
                                                                                                                          []
                                                                                                                          [DI.genTerm
                                                                                                                             x9,
                                                                                                                           DI.genTerm
                                                                                                                             x10]))
                                                                                                                    (Prelude.return
                                                                                                                       (Curry.DebugModule.Prelude.Cons
                                                                                                                          x9
                                                                                                                          x10))
                                                                                                        DM.constructorHook
                                                                                                          (DI.DebugInfo
                                                                                                             (DI.SrcID
                                                                                                                "XML"
                                                                                                                0)
                                                                                                             (DI.DynamicInfo
                                                                                                                []
                                                                                                                [DI.genTerm
                                                                                                                   x11,
                                                                                                                 DI.genTerm
                                                                                                                   x12]))
                                                                                                          (Prelude.return
                                                                                                             (Curry.DebugModule.Prelude.Cons
                                                                                                                x11
                                                                                                                x12))
                                                                                              DM.constructorHook
                                                                                                (DI.DebugInfo
                                                                                                   (DI.SrcID
                                                                                                      "XML"
                                                                                                      0)
                                                                                                   (DI.DynamicInfo
                                                                                                      []
                                                                                                      [DI.genTerm
                                                                                                         x13,
                                                                                                       DI.genTerm
                                                                                                         x14]))
                                                                                                (Prelude.return
                                                                                                   (Curry.DebugModule.Prelude.Cons
                                                                                                      x13
                                                                                                      x14))
                                                                                    DM.constructorHook
                                                                                      (DI.DebugInfo
                                                                                         (DI.SrcID
                                                                                            "XML"
                                                                                            0)
                                                                                         (DI.DynamicInfo
                                                                                            []
                                                                                            [DI.genTerm
                                                                                               x15,
                                                                                             DI.genTerm
                                                                                               x16]))
                                                                                      (Prelude.return
                                                                                         (Curry.DebugModule.Prelude.Cons
                                                                                            x15
                                                                                            x16))
                                                                          DM.constructorHook
                                                                            (DI.DebugInfo
                                                                               (DI.SrcID "XML" 0)
                                                                               (DI.DynamicInfo []
                                                                                  [DI.genTerm x17,
                                                                                   DI.genTerm x18]))
                                                                            (Prelude.return
                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                  x17
                                                                                  x18))
                                                                DM.constructorHook
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x19,
                                                                         DI.genTerm x20]))
                                                                  (Prelude.return
                                                                     (Curry.DebugModule.Prelude.Cons
                                                                        x19
                                                                        x20))
                                                      DM.constructorHook
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x21, DI.genTerm x22]))
                                                        (Prelude.return
                                                           (Curry.DebugModule.Prelude.Cons x21 x22))
                                            DM.constructorHook
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x23, DI.genTerm x24]))
                                              (Prelude.return
                                                 (Curry.DebugModule.Prelude.Cons x23 x24))
                                  x59 <- do x56 <- Prelude.return x3
                                            x57 <- do x54 <- do x41 <- DM.litHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo [] []))
                                                                         (Prelude.return
                                                                            (Curry.DebugModule.Prelude.Char
                                                                               ' '))
                                                                x42 <- do x39 <- DM.litHook
                                                                                   (DI.DebugInfo
                                                                                      (DI.SrcID
                                                                                         "XML"
                                                                                         0)
                                                                                      (DI.DynamicInfo
                                                                                         []
                                                                                         []))
                                                                                   (Prelude.return
                                                                                      (Curry.DebugModule.Prelude.Char
                                                                                         'S'))
                                                                          x40 <- do x37 <- DM.litHook
                                                                                             (DI.DebugInfo
                                                                                                (DI.SrcID
                                                                                                   "XML"
                                                                                                   0)
                                                                                                (DI.DynamicInfo
                                                                                                   []
                                                                                                   []))
                                                                                             (Prelude.return
                                                                                                (Curry.DebugModule.Prelude.Char
                                                                                                   'Y'))
                                                                                    x38 <- do x35 <- DM.litHook
                                                                                                       (DI.DebugInfo
                                                                                                          (DI.SrcID
                                                                                                             "XML"
                                                                                                             0)
                                                                                                          (DI.DynamicInfo
                                                                                                             []
                                                                                                             []))
                                                                                                       (Prelude.return
                                                                                                          (Curry.DebugModule.Prelude.Char
                                                                                                             'S'))
                                                                                              x36 <- do x33 <- DM.litHook
                                                                                                                 (DI.DebugInfo
                                                                                                                    (DI.SrcID
                                                                                                                       "XML"
                                                                                                                       0)
                                                                                                                    (DI.DynamicInfo
                                                                                                                       []
                                                                                                                       []))
                                                                                                                 (Prelude.return
                                                                                                                    (Curry.DebugModule.Prelude.Char
                                                                                                                       'T'))
                                                                                                        x34 <- do x31 <- DM.litHook
                                                                                                                           (DI.DebugInfo
                                                                                                                              (DI.SrcID
                                                                                                                                 "XML"
                                                                                                                                 0)
                                                                                                                              (DI.DynamicInfo
                                                                                                                                 []
                                                                                                                                 []))
                                                                                                                           (Prelude.return
                                                                                                                              (Curry.DebugModule.Prelude.Char
                                                                                                                                 'E'))
                                                                                                                  x32 <- do x29 <- DM.litHook
                                                                                                                                     (DI.DebugInfo
                                                                                                                                        (DI.SrcID
                                                                                                                                           "XML"
                                                                                                                                           0)
                                                                                                                                        (DI.DynamicInfo
                                                                                                                                           []
                                                                                                                                           []))
                                                                                                                                     (Prelude.return
                                                                                                                                        (Curry.DebugModule.Prelude.Char
                                                                                                                                           'M'))
                                                                                                                            x30 <- do x27 <- DM.litHook
                                                                                                                                               (DI.DebugInfo
                                                                                                                                                  (DI.SrcID
                                                                                                                                                     "XML"
                                                                                                                                                     0)
                                                                                                                                                  (DI.DynamicInfo
                                                                                                                                                     []
                                                                                                                                                     []))
                                                                                                                                               (Prelude.return
                                                                                                                                                  (Curry.DebugModule.Prelude.Char
                                                                                                                                                     ' '))
                                                                                                                                      x28 <- do x25 <- DM.litHook
                                                                                                                                                         (DI.DebugInfo
                                                                                                                                                            (DI.SrcID
                                                                                                                                                               "XML"
                                                                                                                                                               0)
                                                                                                                                                            (DI.DynamicInfo
                                                                                                                                                               []
                                                                                                                                                               []))
                                                                                                                                                         (Prelude.return
                                                                                                                                                            (Curry.DebugModule.Prelude.Char
                                                                                                                                                               '"'))
                                                                                                                                                x26 <- DM.constructorHook
                                                                                                                                                         (DI.DebugInfo
                                                                                                                                                            (DI.SrcID
                                                                                                                                                               "XML"
                                                                                                                                                               0)
                                                                                                                                                            (DI.DynamicInfo
                                                                                                                                                               []
                                                                                                                                                               []))
                                                                                                                                                         (Prelude.return
                                                                                                                                                            Curry.DebugModule.Prelude.Nil)
                                                                                                                                                DM.constructorHook
                                                                                                                                                  (DI.DebugInfo
                                                                                                                                                     (DI.SrcID
                                                                                                                                                        "XML"
                                                                                                                                                        0)
                                                                                                                                                     (DI.DynamicInfo
                                                                                                                                                        []
                                                                                                                                                        [DI.genTerm
                                                                                                                                                           x25,
                                                                                                                                                         DI.genTerm
                                                                                                                                                           x26]))
                                                                                                                                                  (Prelude.return
                                                                                                                                                     (Curry.DebugModule.Prelude.Cons
                                                                                                                                                        x25
                                                                                                                                                        x26))
                                                                                                                                      DM.constructorHook
                                                                                                                                        (DI.DebugInfo
                                                                                                                                           (DI.SrcID
                                                                                                                                              "XML"
                                                                                                                                              0)
                                                                                                                                           (DI.DynamicInfo
                                                                                                                                              []
                                                                                                                                              [DI.genTerm
                                                                                                                                                 x27,
                                                                                                                                               DI.genTerm
                                                                                                                                                 x28]))
                                                                                                                                        (Prelude.return
                                                                                                                                           (Curry.DebugModule.Prelude.Cons
                                                                                                                                              x27
                                                                                                                                              x28))
                                                                                                                            DM.constructorHook
                                                                                                                              (DI.DebugInfo
                                                                                                                                 (DI.SrcID
                                                                                                                                    "XML"
                                                                                                                                    0)
                                                                                                                                 (DI.DynamicInfo
                                                                                                                                    []
                                                                                                                                    [DI.genTerm
                                                                                                                                       x29,
                                                                                                                                     DI.genTerm
                                                                                                                                       x30]))
                                                                                                                              (Prelude.return
                                                                                                                                 (Curry.DebugModule.Prelude.Cons
                                                                                                                                    x29
                                                                                                                                    x30))
                                                                                                                  DM.constructorHook
                                                                                                                    (DI.DebugInfo
                                                                                                                       (DI.SrcID
                                                                                                                          "XML"
                                                                                                                          0)
                                                                                                                       (DI.DynamicInfo
                                                                                                                          []
                                                                                                                          [DI.genTerm
                                                                                                                             x31,
                                                                                                                           DI.genTerm
                                                                                                                             x32]))
                                                                                                                    (Prelude.return
                                                                                                                       (Curry.DebugModule.Prelude.Cons
                                                                                                                          x31
                                                                                                                          x32))
                                                                                                        DM.constructorHook
                                                                                                          (DI.DebugInfo
                                                                                                             (DI.SrcID
                                                                                                                "XML"
                                                                                                                0)
                                                                                                             (DI.DynamicInfo
                                                                                                                []
                                                                                                                [DI.genTerm
                                                                                                                   x33,
                                                                                                                 DI.genTerm
                                                                                                                   x34]))
                                                                                                          (Prelude.return
                                                                                                             (Curry.DebugModule.Prelude.Cons
                                                                                                                x33
                                                                                                                x34))
                                                                                              DM.constructorHook
                                                                                                (DI.DebugInfo
                                                                                                   (DI.SrcID
                                                                                                      "XML"
                                                                                                      0)
                                                                                                   (DI.DynamicInfo
                                                                                                      []
                                                                                                      [DI.genTerm
                                                                                                         x35,
                                                                                                       DI.genTerm
                                                                                                         x36]))
                                                                                                (Prelude.return
                                                                                                   (Curry.DebugModule.Prelude.Cons
                                                                                                      x35
                                                                                                      x36))
                                                                                    DM.constructorHook
                                                                                      (DI.DebugInfo
                                                                                         (DI.SrcID
                                                                                            "XML"
                                                                                            0)
                                                                                         (DI.DynamicInfo
                                                                                            []
                                                                                            [DI.genTerm
                                                                                               x37,
                                                                                             DI.genTerm
                                                                                               x38]))
                                                                                      (Prelude.return
                                                                                         (Curry.DebugModule.Prelude.Cons
                                                                                            x37
                                                                                            x38))
                                                                          DM.constructorHook
                                                                            (DI.DebugInfo
                                                                               (DI.SrcID "XML" 0)
                                                                               (DI.DynamicInfo []
                                                                                  [DI.genTerm x39,
                                                                                   DI.genTerm x40]))
                                                                            (Prelude.return
                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                  x39
                                                                                  x40))
                                                                DM.constructorHook
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x41,
                                                                         DI.genTerm x42]))
                                                                  (Prelude.return
                                                                     (Curry.DebugModule.Prelude.Cons
                                                                        x41
                                                                        x42))
                                                      x55 <- do x52 <- do x43 <- Prelude.return x1
                                                                          DM.funcCallHook
                                                                            "lookupDtdUrl"
                                                                            (DI.DebugInfo
                                                                               (DI.SrcID "XML" 0)
                                                                               (DI.DynamicInfo []
                                                                                  [DI.genTerm x43]))
                                                                            (strict_lookupDtdUrl
                                                                               x43)
                                                                x53 <- do x50 <- DM.litHook
                                                                                   (DI.DebugInfo
                                                                                      (DI.SrcID
                                                                                         "XML"
                                                                                         0)
                                                                                      (DI.DynamicInfo
                                                                                         []
                                                                                         []))
                                                                                   (Prelude.return
                                                                                      (Curry.DebugModule.Prelude.Char
                                                                                         '"'))
                                                                          x51 <- do x48 <- DM.litHook
                                                                                             (DI.DebugInfo
                                                                                                (DI.SrcID
                                                                                                   "XML"
                                                                                                   0)
                                                                                                (DI.DynamicInfo
                                                                                                   []
                                                                                                   []))
                                                                                             (Prelude.return
                                                                                                (Curry.DebugModule.Prelude.Char
                                                                                                   '>'))
                                                                                    x49 <- do x46 <- DM.litHook
                                                                                                       (DI.DebugInfo
                                                                                                          (DI.SrcID
                                                                                                             "XML"
                                                                                                             0)
                                                                                                          (DI.DynamicInfo
                                                                                                             []
                                                                                                             []))
                                                                                                       (Prelude.return
                                                                                                          (Curry.DebugModule.Prelude.Char
                                                                                                             '\n'))
                                                                                              x47 <- do x44 <- DM.litHook
                                                                                                                 (DI.DebugInfo
                                                                                                                    (DI.SrcID
                                                                                                                       "XML"
                                                                                                                       0)
                                                                                                                    (DI.DynamicInfo
                                                                                                                       []
                                                                                                                       []))
                                                                                                                 (Prelude.return
                                                                                                                    (Curry.DebugModule.Prelude.Char
                                                                                                                       '\n'))
                                                                                                        x45 <- DM.constructorHook
                                                                                                                 (DI.DebugInfo
                                                                                                                    (DI.SrcID
                                                                                                                       "XML"
                                                                                                                       0)
                                                                                                                    (DI.DynamicInfo
                                                                                                                       []
                                                                                                                       []))
                                                                                                                 (Prelude.return
                                                                                                                    Curry.DebugModule.Prelude.Nil)
                                                                                                        DM.constructorHook
                                                                                                          (DI.DebugInfo
                                                                                                             (DI.SrcID
                                                                                                                "XML"
                                                                                                                0)
                                                                                                             (DI.DynamicInfo
                                                                                                                []
                                                                                                                [DI.genTerm
                                                                                                                   x44,
                                                                                                                 DI.genTerm
                                                                                                                   x45]))
                                                                                                          (Prelude.return
                                                                                                             (Curry.DebugModule.Prelude.Cons
                                                                                                                x44
                                                                                                                x45))
                                                                                              DM.constructorHook
                                                                                                (DI.DebugInfo
                                                                                                   (DI.SrcID
                                                                                                      "XML"
                                                                                                      0)
                                                                                                   (DI.DynamicInfo
                                                                                                      []
                                                                                                      [DI.genTerm
                                                                                                         x46,
                                                                                                       DI.genTerm
                                                                                                         x47]))
                                                                                                (Prelude.return
                                                                                                   (Curry.DebugModule.Prelude.Cons
                                                                                                      x46
                                                                                                      x47))
                                                                                    DM.constructorHook
                                                                                      (DI.DebugInfo
                                                                                         (DI.SrcID
                                                                                            "XML"
                                                                                            0)
                                                                                         (DI.DynamicInfo
                                                                                            []
                                                                                            [DI.genTerm
                                                                                               x48,
                                                                                             DI.genTerm
                                                                                               x49]))
                                                                                      (Prelude.return
                                                                                         (Curry.DebugModule.Prelude.Cons
                                                                                            x48
                                                                                            x49))
                                                                          DM.constructorHook
                                                                            (DI.DebugInfo
                                                                               (DI.SrcID "XML" 0)
                                                                               (DI.DynamicInfo []
                                                                                  [DI.genTerm x50,
                                                                                   DI.genTerm x51]))
                                                                            (Prelude.return
                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                  x50
                                                                                  x51))
                                                                DM.funcCallHook "++"
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x52,
                                                                         DI.genTerm x53]))
                                                                  (Curry.DebugModule.Prelude.op_PlusPlus
                                                                     x52
                                                                     x53)
                                                      DM.funcCallHook "++"
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x54, DI.genTerm x55]))
                                                        (Curry.DebugModule.Prelude.op_PlusPlus x54
                                                           x55)
                                            DM.funcCallHook "++"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x56, DI.genTerm x57]))
                                              (Curry.DebugModule.Prelude.op_PlusPlus x56 x57)
                                  DM.funcCallHook "++"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x58, DI.genTerm x59]))
                                    (Curry.DebugModule.Prelude.op_PlusPlus x58 x59)))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.constructorHook
                                 (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                 (Prelude.return Curry.DebugModule.Prelude.Nil)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x60])))
                           (strict__case_100 x1 x3)
                           x60)))
term_strict__case_100 x1
  = DI.Term "_case_100" (DI.SrcID "XML" 0) x1
strict__case_101 x1 x2
  = DM.eval
      (DM.funcDeclHook "_case_101"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1, DI.genTerm x2]))
         (do x13 <- Prelude.return x2
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x13]))
               (case x13 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x5 <- DM.litHook
                                          (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                          (Prelude.return (Curry.DebugModule.Prelude.Char 'n'))
                                  x6 <- do x3 <- DM.litHook
                                                   (DI.DebugInfo (DI.SrcID "XML" 0)
                                                      (DI.DynamicInfo [] []))
                                                   (Prelude.return
                                                      (Curry.DebugModule.Prelude.Char 'o'))
                                           x4 <- DM.constructorHook
                                                   (DI.DebugInfo (DI.SrcID "XML" 0)
                                                      (DI.DynamicInfo [] []))
                                                   (Prelude.return Curry.DebugModule.Prelude.Nil)
                                           DM.constructorHook
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x3, DI.genTerm x4]))
                                             (Prelude.return (Curry.DebugModule.Prelude.Cons x3 x4))
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x5, DI.genTerm x6]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Cons x5 x6))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x11 <- DM.litHook
                                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                           (Prelude.return (Curry.DebugModule.Prelude.Char 'y'))
                                  x12 <- do x9 <- DM.litHook
                                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                                       (DI.DynamicInfo [] []))
                                                    (Prelude.return
                                                       (Curry.DebugModule.Prelude.Char 'e'))
                                            x10 <- do x7 <- DM.litHook
                                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                 (DI.DynamicInfo [] []))
                                                              (Prelude.return
                                                                 (Curry.DebugModule.Prelude.Char
                                                                    's'))
                                                      x8 <- DM.constructorHook
                                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                 (DI.DynamicInfo [] []))
                                                              (Prelude.return
                                                                 Curry.DebugModule.Prelude.Nil)
                                                      DM.constructorHook
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x7, DI.genTerm x8]))
                                                        (Prelude.return
                                                           (Curry.DebugModule.Prelude.Cons x7 x8))
                                            DM.constructorHook
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x9, DI.genTerm x10]))
                                              (Prelude.return
                                                 (Curry.DebugModule.Prelude.Cons x9 x10))
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x11, DI.genTerm x12]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Cons x11 x12))))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x13])))
                           (strict__case_101 x1)
                           x13)))
term_strict__case_101 x1
  = DI.Term "_case_101" (DI.SrcID "XML" 0) x1
strict__case_104 x1
  = DM.eval
      (DM.funcDeclHook "_case_104"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x6 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x6]))
               (case x6 of
                    Curry.DebugModule.Prelude.Nil
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.constructorHook
                                 (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                 (Prelude.return Curry.DebugModule.Prelude.False)))
                    Curry.DebugModule.Prelude.Cons x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x4 <- Prelude.return x3
                                  x5 <- Prelude.return x2
                                  DM.funcCallHook "_case_103"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x4, DI.genTerm x5]))
                                    (strict__case_103 x4 x5)))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x6])))
                           strict__case_104
                           x6)))
term_strict__case_104 x1
  = DI.Term "_case_104" (DI.SrcID "XML" 0) x1
strict__case_103 x3 x2
  = DM.eval
      (DM.funcDeclHook "_case_103"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x3, DI.genTerm x2]))
         (do x7 <- Prelude.return x2
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x7]))
               (case x7 of
                    DtdUrl x4
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.constructorHook
                                 (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                 (Prelude.return Curry.DebugModule.Prelude.True)))
                    Enc x5
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x6 <- Prelude.return x3
                                  DM.funcCallHook "hasDtdUrl"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x6]))
                                    (strict_hasDtdUrl x6)))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x7])))
                           (strict__case_103 x3)
                           x7)))
term_strict__case_103 x1
  = DI.Term "_case_103" (DI.SrcID "XML" 0) x1
strict__case_106 x1
  = DM.eval
      (DM.funcDeclHook "_case_106"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x6 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x6]))
               (case x6 of
                    Curry.DebugModule.Prelude.Cons x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x4 <- Prelude.return x3
                                  x5 <- Prelude.return x2
                                  DM.funcCallHook "_case_105"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x4, DI.genTerm x5]))
                                    (strict__case_105 x4 x5)))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x6])))
                           strict__case_106
                           x6)))
term_strict__case_106 x1
  = DI.Term "_case_106" (DI.SrcID "XML" 0) x1
strict__case_105 x3 x2
  = DM.eval
      (DM.funcDeclHook "_case_105"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x3, DI.genTerm x2]))
         (do x7 <- Prelude.return x2
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x7]))
               (case x7 of
                    Enc x4
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x6 <- Prelude.return x3
                                  DM.funcCallHook "lookupDtdUrl"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x6]))
                                    (strict_lookupDtdUrl x6)))
                    DtdUrl x5
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x5))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x7])))
                           (strict__case_105 x3)
                           x7)))
term_strict__case_105 x1
  = DI.Term "_case_105" (DI.SrcID "XML" 0) x1
strict__case_108 x1
  = DM.eval
      (DM.funcDeclHook "_case_108"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x6 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x6]))
               (case x6 of
                    Curry.DebugModule.Prelude.Cons x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x4 <- Prelude.return x3
                                  x5 <- Prelude.return x2
                                  DM.funcCallHook "_case_107"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x4, DI.genTerm x5]))
                                    (strict__case_107 x4 x5)))
                    Curry.DebugModule.Prelude.Nil
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.constructorHook
                                 (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                 (Prelude.return StandardEnc)))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x6])))
                           strict__case_108
                           x6)))
term_strict__case_108 x1
  = DI.Term "_case_108" (DI.SrcID "XML" 0) x1
strict__case_107 x3 x2
  = DM.eval
      (DM.funcDeclHook "_case_107"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x3, DI.genTerm x2]))
         (do x7 <- Prelude.return x2
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x7]))
               (case x7 of
                    Enc x4
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval (Prelude.return x4))
                    DtdUrl x5
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x6 <- Prelude.return x3
                                  DM.funcCallHook "lookupEncoding"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x6]))
                                    (strict_lookupEncoding x6)))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x7])))
                           (strict__case_107 x3)
                           x7)))
term_strict__case_107 x1
  = DI.Term "_case_107" (DI.SrcID "XML" 0) x1
strict__case_110 x1
  = DM.eval
      (DM.funcDeclHook "_case_110"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x11 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x11]))
               (case x11 of
                    Curry.DebugModule.Prelude.Nil
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.constructorHook
                                 (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                 (Prelude.return Curry.DebugModule.Prelude.Nil)))
                    Curry.DebugModule.Prelude.Cons x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x8 <- Prelude.return x2
                                  x9 <- Prelude.return x3
                                  x10 <- do x6 <- do x5 <- do x4 <- Prelude.return x2
                                                              DM.funcCallHook "ord"
                                                                (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                   (DI.DynamicInfo []
                                                                      [DI.genTerm x4]))
                                                                (Curry.DebugModule.Prelude.strict_ord
                                                                   x4)
                                                     DM.funcCallHook "elem"
                                                       (DI.DebugInfo (DI.SrcID "XML" 0)
                                                          (DI.DynamicInfo [] [DI.genTerm x5]))
                                                       (Curry.DebugModule.Prelude.strict_elem x5)
                                            x7 <- DM.funcCallHook "iso88591list"
                                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                                       (DI.DynamicInfo [] []))
                                                    strict_iso88591list
                                            DM.funcCallHook "apply"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo [] [DI.genTerm x6, DI.genTerm x7]))
                                              (Curry.DebugModule.Prelude.strict_apply x6 x7)
                                  DM.funcCallHook "_case_109"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x8, DI.genTerm x9, DI.genTerm x10]))
                                    (strict__case_109 x8 x9 x10)))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x11])))
                           strict__case_110
                           x11)))
term_strict__case_110 x1
  = DI.Term "_case_110" (DI.SrcID "XML" 0) x1
strict__case_109 x2 x3 x4
  = DM.eval
      (DM.funcDeclHook "_case_109"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x2, DI.genTerm x3, DI.genTerm x4]))
         (do x14 <- Prelude.return x4
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x14]))
               (case x14 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x6 <- Prelude.return x2
                                  x7 <- do x5 <- Prelude.return x3
                                           DM.funcCallHook "iso88591Encoding"
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x5]))
                                             (strict_iso88591Encoding x5)
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x6, DI.genTerm x7]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Cons x6 x7))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x12 <- do x10 <- do x8 <- Prelude.return x2
                                                      x9 <- DM.constructorHook
                                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                 (DI.DynamicInfo [] []))
                                                              (Prelude.return
                                                                 Curry.DebugModule.Prelude.Nil)
                                                      DM.constructorHook
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x8, DI.genTerm x9]))
                                                        (Prelude.return
                                                           (Curry.DebugModule.Prelude.Cons x8 x9))
                                            DM.funcCallHook "standardEncoding"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo [] [DI.genTerm x10]))
                                              (strict_standardEncoding x10)
                                  x13 <- do x11 <- Prelude.return x3
                                            DM.funcCallHook "iso88591Encoding"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo [] [DI.genTerm x11]))
                                              (strict_iso88591Encoding x11)
                                  DM.funcCallHook "++"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x12, DI.genTerm x13]))
                                    (Curry.DebugModule.Prelude.op_PlusPlus x12 x13)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x14])))
                           (strict__case_109 x2 x3)
                           x14)))
term_strict__case_109 x1
  = DI.Term "_case_109" (DI.SrcID "XML" 0) x1
strict__case_119 x1
  = DM.eval
      (DM.funcDeclHook "_case_119"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x9 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x9]))
               (case x9 of
                    Curry.DebugModule.Prelude.Nil
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.constructorHook
                                 (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                 (Prelude.return Curry.DebugModule.Prelude.Nil)))
                    Curry.DebugModule.Prelude.Cons x2 x3
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x6 <- Prelude.return x2
                                  x7 <- Prelude.return x3
                                  x8 <- do x4 <- Prelude.return x2
                                           x5 <- DM.litHook
                                                   (DI.DebugInfo (DI.SrcID "XML" 0)
                                                      (DI.DynamicInfo [] []))
                                                   (Prelude.return
                                                      (Curry.DebugModule.Prelude.Char '<'))
                                           DM.funcCallHook "=="
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x4, DI.genTerm x5]))
                                             (Curry.DebugModule.Prelude.op_EqEq x4 x5)
                                  DM.funcCallHook "_case_118"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x6, DI.genTerm x7, DI.genTerm x8]))
                                    (strict__case_118 x6 x7 x8)))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x9])))
                           strict__case_119
                           x9)))
term_strict__case_119 x1
  = DI.Term "_case_119" (DI.SrcID "XML" 0) x1
strict__case_118 x2 x3 x4
  = DM.eval
      (DM.funcDeclHook "_case_118"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x2, DI.genTerm x3, DI.genTerm x4]))
         (do x21 <- Prelude.return x4
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x21]))
               (case x21 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x14 <- do x11 <- DM.litHook
                                                     (DI.DebugInfo (DI.SrcID "XML" 0)
                                                        (DI.DynamicInfo [] []))
                                                     (Prelude.return
                                                        (Curry.DebugModule.Prelude.Char '&'))
                                            x12 <- do x9 <- DM.litHook
                                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                 (DI.DynamicInfo [] []))
                                                              (Prelude.return
                                                                 (Curry.DebugModule.Prelude.Char
                                                                    'l'))
                                                      x10 <- do x7 <- DM.litHook
                                                                        (DI.DebugInfo
                                                                           (DI.SrcID "XML" 0)
                                                                           (DI.DynamicInfo [] []))
                                                                        (Prelude.return
                                                                           (Curry.DebugModule.Prelude.Char
                                                                              't'))
                                                                x8 <- do x5 <- DM.litHook
                                                                                 (DI.DebugInfo
                                                                                    (DI.SrcID "XML"
                                                                                       0)
                                                                                    (DI.DynamicInfo
                                                                                       []
                                                                                       []))
                                                                                 (Prelude.return
                                                                                    (Curry.DebugModule.Prelude.Char
                                                                                       ';'))
                                                                         x6 <- DM.constructorHook
                                                                                 (DI.DebugInfo
                                                                                    (DI.SrcID "XML"
                                                                                       0)
                                                                                    (DI.DynamicInfo
                                                                                       []
                                                                                       []))
                                                                                 (Prelude.return
                                                                                    Curry.DebugModule.Prelude.Nil)
                                                                         DM.constructorHook
                                                                           (DI.DebugInfo
                                                                              (DI.SrcID "XML" 0)
                                                                              (DI.DynamicInfo []
                                                                                 [DI.genTerm x5,
                                                                                  DI.genTerm x6]))
                                                                           (Prelude.return
                                                                              (Curry.DebugModule.Prelude.Cons
                                                                                 x5
                                                                                 x6))
                                                                DM.constructorHook
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x7,
                                                                         DI.genTerm x8]))
                                                                  (Prelude.return
                                                                     (Curry.DebugModule.Prelude.Cons
                                                                        x7
                                                                        x8))
                                                      DM.constructorHook
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x9, DI.genTerm x10]))
                                                        (Prelude.return
                                                           (Curry.DebugModule.Prelude.Cons x9 x10))
                                            DM.constructorHook
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x11, DI.genTerm x12]))
                                              (Prelude.return
                                                 (Curry.DebugModule.Prelude.Cons x11 x12))
                                  x15 <- do x13 <- Prelude.return x3
                                            DM.funcCallHook "standardEncoding"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo [] [DI.genTerm x13]))
                                              (strict_standardEncoding x13)
                                  DM.funcCallHook "++"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x14, DI.genTerm x15]))
                                    (Curry.DebugModule.Prelude.op_PlusPlus x14 x15)))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x18 <- Prelude.return x2
                                  x19 <- Prelude.return x3
                                  x20 <- do x16 <- Prelude.return x2
                                            x17 <- DM.litHook
                                                     (DI.DebugInfo (DI.SrcID "XML" 0)
                                                        (DI.DynamicInfo [] []))
                                                     (Prelude.return
                                                        (Curry.DebugModule.Prelude.Char '>'))
                                            DM.funcCallHook "=="
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x16, DI.genTerm x17]))
                                              (Curry.DebugModule.Prelude.op_EqEq x16 x17)
                                  DM.funcCallHook "_case_117"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x18, DI.genTerm x19, DI.genTerm x20]))
                                    (strict__case_117 x18 x19 x20)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x21])))
                           (strict__case_118 x2 x3)
                           x21)))
term_strict__case_118 x1
  = DI.Term "_case_118" (DI.SrcID "XML" 0) x1
strict__case_117 x2 x3 x4
  = DM.eval
      (DM.funcDeclHook "_case_117"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x2, DI.genTerm x3, DI.genTerm x4]))
         (do x21 <- Prelude.return x4
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x21]))
               (case x21 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x14 <- do x11 <- DM.litHook
                                                     (DI.DebugInfo (DI.SrcID "XML" 0)
                                                        (DI.DynamicInfo [] []))
                                                     (Prelude.return
                                                        (Curry.DebugModule.Prelude.Char '&'))
                                            x12 <- do x9 <- DM.litHook
                                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                 (DI.DynamicInfo [] []))
                                                              (Prelude.return
                                                                 (Curry.DebugModule.Prelude.Char
                                                                    'g'))
                                                      x10 <- do x7 <- DM.litHook
                                                                        (DI.DebugInfo
                                                                           (DI.SrcID "XML" 0)
                                                                           (DI.DynamicInfo [] []))
                                                                        (Prelude.return
                                                                           (Curry.DebugModule.Prelude.Char
                                                                              't'))
                                                                x8 <- do x5 <- DM.litHook
                                                                                 (DI.DebugInfo
                                                                                    (DI.SrcID "XML"
                                                                                       0)
                                                                                    (DI.DynamicInfo
                                                                                       []
                                                                                       []))
                                                                                 (Prelude.return
                                                                                    (Curry.DebugModule.Prelude.Char
                                                                                       ';'))
                                                                         x6 <- DM.constructorHook
                                                                                 (DI.DebugInfo
                                                                                    (DI.SrcID "XML"
                                                                                       0)
                                                                                    (DI.DynamicInfo
                                                                                       []
                                                                                       []))
                                                                                 (Prelude.return
                                                                                    Curry.DebugModule.Prelude.Nil)
                                                                         DM.constructorHook
                                                                           (DI.DebugInfo
                                                                              (DI.SrcID "XML" 0)
                                                                              (DI.DynamicInfo []
                                                                                 [DI.genTerm x5,
                                                                                  DI.genTerm x6]))
                                                                           (Prelude.return
                                                                              (Curry.DebugModule.Prelude.Cons
                                                                                 x5
                                                                                 x6))
                                                                DM.constructorHook
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x7,
                                                                         DI.genTerm x8]))
                                                                  (Prelude.return
                                                                     (Curry.DebugModule.Prelude.Cons
                                                                        x7
                                                                        x8))
                                                      DM.constructorHook
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x9, DI.genTerm x10]))
                                                        (Prelude.return
                                                           (Curry.DebugModule.Prelude.Cons x9 x10))
                                            DM.constructorHook
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x11, DI.genTerm x12]))
                                              (Prelude.return
                                                 (Curry.DebugModule.Prelude.Cons x11 x12))
                                  x15 <- do x13 <- Prelude.return x3
                                            DM.funcCallHook "standardEncoding"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo [] [DI.genTerm x13]))
                                              (strict_standardEncoding x13)
                                  DM.funcCallHook "++"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x14, DI.genTerm x15]))
                                    (Curry.DebugModule.Prelude.op_PlusPlus x14 x15)))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x18 <- Prelude.return x2
                                  x19 <- Prelude.return x3
                                  x20 <- do x16 <- Prelude.return x2
                                            x17 <- DM.litHook
                                                     (DI.DebugInfo (DI.SrcID "XML" 0)
                                                        (DI.DynamicInfo [] []))
                                                     (Prelude.return
                                                        (Curry.DebugModule.Prelude.Char '&'))
                                            DM.funcCallHook "=="
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x16, DI.genTerm x17]))
                                              (Curry.DebugModule.Prelude.op_EqEq x16 x17)
                                  DM.funcCallHook "_case_116"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x18, DI.genTerm x19, DI.genTerm x20]))
                                    (strict__case_116 x18 x19 x20)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x21])))
                           (strict__case_117 x2 x3)
                           x21)))
term_strict__case_117 x1
  = DI.Term "_case_117" (DI.SrcID "XML" 0) x1
strict__case_116 x2 x3 x4
  = DM.eval
      (DM.funcDeclHook "_case_116"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x2, DI.genTerm x3, DI.genTerm x4]))
         (do x23 <- Prelude.return x4
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x23]))
               (case x23 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x16 <- do x13 <- DM.litHook
                                                     (DI.DebugInfo (DI.SrcID "XML" 0)
                                                        (DI.DynamicInfo [] []))
                                                     (Prelude.return
                                                        (Curry.DebugModule.Prelude.Char '&'))
                                            x14 <- do x11 <- DM.litHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo [] []))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Char
                                                                     'a'))
                                                      x12 <- do x9 <- DM.litHook
                                                                        (DI.DebugInfo
                                                                           (DI.SrcID "XML" 0)
                                                                           (DI.DynamicInfo [] []))
                                                                        (Prelude.return
                                                                           (Curry.DebugModule.Prelude.Char
                                                                              'm'))
                                                                x10 <- do x7 <- DM.litHook
                                                                                  (DI.DebugInfo
                                                                                     (DI.SrcID "XML"
                                                                                        0)
                                                                                     (DI.DynamicInfo
                                                                                        []
                                                                                        []))
                                                                                  (Prelude.return
                                                                                     (Curry.DebugModule.Prelude.Char
                                                                                        'p'))
                                                                          x8 <- do x5 <- DM.litHook
                                                                                           (DI.DebugInfo
                                                                                              (DI.SrcID
                                                                                                 "XML"
                                                                                                 0)
                                                                                              (DI.DynamicInfo
                                                                                                 []
                                                                                                 []))
                                                                                           (Prelude.return
                                                                                              (Curry.DebugModule.Prelude.Char
                                                                                                 ';'))
                                                                                   x6 <- DM.constructorHook
                                                                                           (DI.DebugInfo
                                                                                              (DI.SrcID
                                                                                                 "XML"
                                                                                                 0)
                                                                                              (DI.DynamicInfo
                                                                                                 []
                                                                                                 []))
                                                                                           (Prelude.return
                                                                                              Curry.DebugModule.Prelude.Nil)
                                                                                   DM.constructorHook
                                                                                     (DI.DebugInfo
                                                                                        (DI.SrcID
                                                                                           "XML"
                                                                                           0)
                                                                                        (DI.DynamicInfo
                                                                                           []
                                                                                           [DI.genTerm
                                                                                              x5,
                                                                                            DI.genTerm
                                                                                              x6]))
                                                                                     (Prelude.return
                                                                                        (Curry.DebugModule.Prelude.Cons
                                                                                           x5
                                                                                           x6))
                                                                          DM.constructorHook
                                                                            (DI.DebugInfo
                                                                               (DI.SrcID "XML" 0)
                                                                               (DI.DynamicInfo []
                                                                                  [DI.genTerm x7,
                                                                                   DI.genTerm x8]))
                                                                            (Prelude.return
                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                  x7
                                                                                  x8))
                                                                DM.constructorHook
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x9,
                                                                         DI.genTerm x10]))
                                                                  (Prelude.return
                                                                     (Curry.DebugModule.Prelude.Cons
                                                                        x9
                                                                        x10))
                                                      DM.constructorHook
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x11, DI.genTerm x12]))
                                                        (Prelude.return
                                                           (Curry.DebugModule.Prelude.Cons x11 x12))
                                            DM.constructorHook
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x13, DI.genTerm x14]))
                                              (Prelude.return
                                                 (Curry.DebugModule.Prelude.Cons x13 x14))
                                  x17 <- do x15 <- Prelude.return x3
                                            DM.funcCallHook "standardEncoding"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo [] [DI.genTerm x15]))
                                              (strict_standardEncoding x15)
                                  DM.funcCallHook "++"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x16, DI.genTerm x17]))
                                    (Curry.DebugModule.Prelude.op_PlusPlus x16 x17)))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x20 <- Prelude.return x2
                                  x21 <- Prelude.return x3
                                  x22 <- do x18 <- Prelude.return x2
                                            x19 <- DM.litHook
                                                     (DI.DebugInfo (DI.SrcID "XML" 0)
                                                        (DI.DynamicInfo [] []))
                                                     (Prelude.return
                                                        (Curry.DebugModule.Prelude.Char '"'))
                                            DM.funcCallHook "=="
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x18, DI.genTerm x19]))
                                              (Curry.DebugModule.Prelude.op_EqEq x18 x19)
                                  DM.funcCallHook "_case_115"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x20, DI.genTerm x21, DI.genTerm x22]))
                                    (strict__case_115 x20 x21 x22)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x23])))
                           (strict__case_116 x2 x3)
                           x23)))
term_strict__case_116 x1
  = DI.Term "_case_116" (DI.SrcID "XML" 0) x1
strict__case_115 x2 x3 x4
  = DM.eval
      (DM.funcDeclHook "_case_115"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x2, DI.genTerm x3, DI.genTerm x4]))
         (do x25 <- Prelude.return x4
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x25]))
               (case x25 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x18 <- do x15 <- DM.litHook
                                                     (DI.DebugInfo (DI.SrcID "XML" 0)
                                                        (DI.DynamicInfo [] []))
                                                     (Prelude.return
                                                        (Curry.DebugModule.Prelude.Char '&'))
                                            x16 <- do x13 <- DM.litHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo [] []))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Char
                                                                     'q'))
                                                      x14 <- do x11 <- DM.litHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo [] []))
                                                                         (Prelude.return
                                                                            (Curry.DebugModule.Prelude.Char
                                                                               'u'))
                                                                x12 <- do x9 <- DM.litHook
                                                                                  (DI.DebugInfo
                                                                                     (DI.SrcID "XML"
                                                                                        0)
                                                                                     (DI.DynamicInfo
                                                                                        []
                                                                                        []))
                                                                                  (Prelude.return
                                                                                     (Curry.DebugModule.Prelude.Char
                                                                                        'o'))
                                                                          x10 <- do x7 <- DM.litHook
                                                                                            (DI.DebugInfo
                                                                                               (DI.SrcID
                                                                                                  "XML"
                                                                                                  0)
                                                                                               (DI.DynamicInfo
                                                                                                  []
                                                                                                  []))
                                                                                            (Prelude.return
                                                                                               (Curry.DebugModule.Prelude.Char
                                                                                                  't'))
                                                                                    x8 <- do x5 <- DM.litHook
                                                                                                     (DI.DebugInfo
                                                                                                        (DI.SrcID
                                                                                                           "XML"
                                                                                                           0)
                                                                                                        (DI.DynamicInfo
                                                                                                           []
                                                                                                           []))
                                                                                                     (Prelude.return
                                                                                                        (Curry.DebugModule.Prelude.Char
                                                                                                           ';'))
                                                                                             x6 <- DM.constructorHook
                                                                                                     (DI.DebugInfo
                                                                                                        (DI.SrcID
                                                                                                           "XML"
                                                                                                           0)
                                                                                                        (DI.DynamicInfo
                                                                                                           []
                                                                                                           []))
                                                                                                     (Prelude.return
                                                                                                        Curry.DebugModule.Prelude.Nil)
                                                                                             DM.constructorHook
                                                                                               (DI.DebugInfo
                                                                                                  (DI.SrcID
                                                                                                     "XML"
                                                                                                     0)
                                                                                                  (DI.DynamicInfo
                                                                                                     []
                                                                                                     [DI.genTerm
                                                                                                        x5,
                                                                                                      DI.genTerm
                                                                                                        x6]))
                                                                                               (Prelude.return
                                                                                                  (Curry.DebugModule.Prelude.Cons
                                                                                                     x5
                                                                                                     x6))
                                                                                    DM.constructorHook
                                                                                      (DI.DebugInfo
                                                                                         (DI.SrcID
                                                                                            "XML"
                                                                                            0)
                                                                                         (DI.DynamicInfo
                                                                                            []
                                                                                            [DI.genTerm
                                                                                               x7,
                                                                                             DI.genTerm
                                                                                               x8]))
                                                                                      (Prelude.return
                                                                                         (Curry.DebugModule.Prelude.Cons
                                                                                            x7
                                                                                            x8))
                                                                          DM.constructorHook
                                                                            (DI.DebugInfo
                                                                               (DI.SrcID "XML" 0)
                                                                               (DI.DynamicInfo []
                                                                                  [DI.genTerm x9,
                                                                                   DI.genTerm x10]))
                                                                            (Prelude.return
                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                  x9
                                                                                  x10))
                                                                DM.constructorHook
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x11,
                                                                         DI.genTerm x12]))
                                                                  (Prelude.return
                                                                     (Curry.DebugModule.Prelude.Cons
                                                                        x11
                                                                        x12))
                                                      DM.constructorHook
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x13, DI.genTerm x14]))
                                                        (Prelude.return
                                                           (Curry.DebugModule.Prelude.Cons x13 x14))
                                            DM.constructorHook
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x15, DI.genTerm x16]))
                                              (Prelude.return
                                                 (Curry.DebugModule.Prelude.Cons x15 x16))
                                  x19 <- do x17 <- Prelude.return x3
                                            DM.funcCallHook "standardEncoding"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo [] [DI.genTerm x17]))
                                              (strict_standardEncoding x17)
                                  DM.funcCallHook "++"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x18, DI.genTerm x19]))
                                    (Curry.DebugModule.Prelude.op_PlusPlus x18 x19)))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x22 <- Prelude.return x2
                                  x23 <- Prelude.return x3
                                  x24 <- do x20 <- Prelude.return x2
                                            x21 <- DM.litHook
                                                     (DI.DebugInfo (DI.SrcID "XML" 0)
                                                        (DI.DynamicInfo [] []))
                                                     (Prelude.return
                                                        (Curry.DebugModule.Prelude.Char '\''))
                                            DM.funcCallHook "=="
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x20, DI.genTerm x21]))
                                              (Curry.DebugModule.Prelude.op_EqEq x20 x21)
                                  DM.funcCallHook "_case_114"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x22, DI.genTerm x23, DI.genTerm x24]))
                                    (strict__case_114 x22 x23 x24)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x25])))
                           (strict__case_115 x2 x3)
                           x25)))
term_strict__case_115 x1
  = DI.Term "_case_115" (DI.SrcID "XML" 0) x1
strict__case_114 x2 x3 x4
  = DM.eval
      (DM.funcDeclHook "_case_114"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x2, DI.genTerm x3, DI.genTerm x4]))
         (do x26 <- Prelude.return x4
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x26]))
               (case x26 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x18 <- do x15 <- DM.litHook
                                                     (DI.DebugInfo (DI.SrcID "XML" 0)
                                                        (DI.DynamicInfo [] []))
                                                     (Prelude.return
                                                        (Curry.DebugModule.Prelude.Char '&'))
                                            x16 <- do x13 <- DM.litHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo [] []))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Char
                                                                     'a'))
                                                      x14 <- do x11 <- DM.litHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo [] []))
                                                                         (Prelude.return
                                                                            (Curry.DebugModule.Prelude.Char
                                                                               'p'))
                                                                x12 <- do x9 <- DM.litHook
                                                                                  (DI.DebugInfo
                                                                                     (DI.SrcID "XML"
                                                                                        0)
                                                                                     (DI.DynamicInfo
                                                                                        []
                                                                                        []))
                                                                                  (Prelude.return
                                                                                     (Curry.DebugModule.Prelude.Char
                                                                                        'o'))
                                                                          x10 <- do x7 <- DM.litHook
                                                                                            (DI.DebugInfo
                                                                                               (DI.SrcID
                                                                                                  "XML"
                                                                                                  0)
                                                                                               (DI.DynamicInfo
                                                                                                  []
                                                                                                  []))
                                                                                            (Prelude.return
                                                                                               (Curry.DebugModule.Prelude.Char
                                                                                                  's'))
                                                                                    x8 <- do x5 <- DM.litHook
                                                                                                     (DI.DebugInfo
                                                                                                        (DI.SrcID
                                                                                                           "XML"
                                                                                                           0)
                                                                                                        (DI.DynamicInfo
                                                                                                           []
                                                                                                           []))
                                                                                                     (Prelude.return
                                                                                                        (Curry.DebugModule.Prelude.Char
                                                                                                           ';'))
                                                                                             x6 <- DM.constructorHook
                                                                                                     (DI.DebugInfo
                                                                                                        (DI.SrcID
                                                                                                           "XML"
                                                                                                           0)
                                                                                                        (DI.DynamicInfo
                                                                                                           []
                                                                                                           []))
                                                                                                     (Prelude.return
                                                                                                        Curry.DebugModule.Prelude.Nil)
                                                                                             DM.constructorHook
                                                                                               (DI.DebugInfo
                                                                                                  (DI.SrcID
                                                                                                     "XML"
                                                                                                     0)
                                                                                                  (DI.DynamicInfo
                                                                                                     []
                                                                                                     [DI.genTerm
                                                                                                        x5,
                                                                                                      DI.genTerm
                                                                                                        x6]))
                                                                                               (Prelude.return
                                                                                                  (Curry.DebugModule.Prelude.Cons
                                                                                                     x5
                                                                                                     x6))
                                                                                    DM.constructorHook
                                                                                      (DI.DebugInfo
                                                                                         (DI.SrcID
                                                                                            "XML"
                                                                                            0)
                                                                                         (DI.DynamicInfo
                                                                                            []
                                                                                            [DI.genTerm
                                                                                               x7,
                                                                                             DI.genTerm
                                                                                               x8]))
                                                                                      (Prelude.return
                                                                                         (Curry.DebugModule.Prelude.Cons
                                                                                            x7
                                                                                            x8))
                                                                          DM.constructorHook
                                                                            (DI.DebugInfo
                                                                               (DI.SrcID "XML" 0)
                                                                               (DI.DynamicInfo []
                                                                                  [DI.genTerm x9,
                                                                                   DI.genTerm x10]))
                                                                            (Prelude.return
                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                  x9
                                                                                  x10))
                                                                DM.constructorHook
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x11,
                                                                         DI.genTerm x12]))
                                                                  (Prelude.return
                                                                     (Curry.DebugModule.Prelude.Cons
                                                                        x11
                                                                        x12))
                                                      DM.constructorHook
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x13, DI.genTerm x14]))
                                                        (Prelude.return
                                                           (Curry.DebugModule.Prelude.Cons x13 x14))
                                            DM.constructorHook
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x15, DI.genTerm x16]))
                                              (Prelude.return
                                                 (Curry.DebugModule.Prelude.Cons x15 x16))
                                  x19 <- do x17 <- Prelude.return x3
                                            DM.funcCallHook "standardEncoding"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo [] [DI.genTerm x17]))
                                              (strict_standardEncoding x17)
                                  DM.funcCallHook "++"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x18, DI.genTerm x19]))
                                    (Curry.DebugModule.Prelude.op_PlusPlus x18 x19)))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x23 <- Prelude.return x2
                                  x24 <- Prelude.return x3
                                  x25 <- do x21 <- do x20 <- Prelude.return x2
                                                      DM.funcCallHook "ord"
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo [] [DI.genTerm x20]))
                                                        (Curry.DebugModule.Prelude.strict_ord x20)
                                            x22 <- DM.litHook
                                                     (DI.DebugInfo (DI.SrcID "XML" 0)
                                                        (DI.DynamicInfo [] []))
                                                     (Prelude.return
                                                        (Curry.DebugModule.Prelude.Pos
                                                           (Curry.DebugModule.Prelude.O
                                                              (Curry.DebugModule.Prelude.O
                                                                 (Curry.DebugModule.Prelude.O
                                                                    (Curry.DebugModule.Prelude.O
                                                                       (Curry.DebugModule.Prelude.O
                                                                          Curry.DebugModule.Prelude.IHi)))))))
                                            DM.funcCallHook "<"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x21, DI.genTerm x22]))
                                              (Curry.DebugModule.Prelude.op_Lt x21 x22)
                                  DM.funcCallHook "_case_113"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x23, DI.genTerm x24, DI.genTerm x25]))
                                    (strict__case_113 x23 x24 x25)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x26])))
                           (strict__case_114 x2 x3)
                           x26)))
term_strict__case_114 x1
  = DI.Term "_case_114" (DI.SrcID "XML" 0) x1
strict__case_113 x2 x3 x4
  = DM.eval
      (DM.funcDeclHook "_case_113"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x2, DI.genTerm x3, DI.genTerm x4]))
         (do x26 <- Prelude.return x4
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x26]))
               (case x26 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x18 <- do x7 <- DM.litHook
                                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                                       (DI.DynamicInfo [] []))
                                                    (Prelude.return
                                                       (Curry.DebugModule.Prelude.Char '&'))
                                            x8 <- do x5 <- DM.litHook
                                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                (DI.DynamicInfo [] []))
                                                             (Prelude.return
                                                                (Curry.DebugModule.Prelude.Char
                                                                   '#'))
                                                     x6 <- DM.constructorHook
                                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                (DI.DynamicInfo [] []))
                                                             (Prelude.return
                                                                Curry.DebugModule.Prelude.Nil)
                                                     DM.constructorHook
                                                       (DI.DebugInfo (DI.SrcID "XML" 0)
                                                          (DI.DynamicInfo []
                                                             [DI.genTerm x5, DI.genTerm x6]))
                                                       (Prelude.return
                                                          (Curry.DebugModule.Prelude.Cons x5 x6))
                                            DM.constructorHook
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo [] [DI.genTerm x7, DI.genTerm x8]))
                                              (Prelude.return
                                                 (Curry.DebugModule.Prelude.Cons x7 x8))
                                  x19 <- do x16 <- do x10 <- do x9 <- Prelude.return x2
                                                                DM.funcCallHook "ord"
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x9]))
                                                                  (Curry.DebugModule.Prelude.strict_ord
                                                                     x9)
                                                      DM.funcCallHook "show"
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo [] [DI.genTerm x10]))
                                                        (Curry.DebugModule.Prelude.strict_show x10)
                                            x17 <- do x14 <- do x11 <- DM.litHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo [] []))
                                                                         (Prelude.return
                                                                            (Curry.DebugModule.Prelude.Char
                                                                               ';'))
                                                                x12 <- DM.constructorHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo [] []))
                                                                         (Prelude.return
                                                                            Curry.DebugModule.Prelude.Nil)
                                                                DM.constructorHook
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x11,
                                                                         DI.genTerm x12]))
                                                                  (Prelude.return
                                                                     (Curry.DebugModule.Prelude.Cons
                                                                        x11
                                                                        x12))
                                                      x15 <- do x13 <- Prelude.return x3
                                                                DM.funcCallHook "standardEncoding"
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x13]))
                                                                  (strict_standardEncoding x13)
                                                      DM.funcCallHook "++"
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x14, DI.genTerm x15]))
                                                        (Curry.DebugModule.Prelude.op_PlusPlus x14
                                                           x15)
                                            DM.funcCallHook "++"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x16, DI.genTerm x17]))
                                              (Curry.DebugModule.Prelude.op_PlusPlus x16 x17)
                                  DM.funcCallHook "++"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x18, DI.genTerm x19]))
                                    (Curry.DebugModule.Prelude.op_PlusPlus x18 x19)))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x23 <- Prelude.return x2
                                  x24 <- Prelude.return x3
                                  x25 <- do x21 <- do x20 <- Prelude.return x2
                                                      DM.funcCallHook "ord"
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo [] [DI.genTerm x20]))
                                                        (Curry.DebugModule.Prelude.strict_ord x20)
                                            x22 <- DM.litHook
                                                     (DI.DebugInfo (DI.SrcID "XML" 0)
                                                        (DI.DynamicInfo [] []))
                                                     (Prelude.return
                                                        (Curry.DebugModule.Prelude.Pos
                                                           (Curry.DebugModule.Prelude.I
                                                              (Curry.DebugModule.Prelude.I
                                                                 (Curry.DebugModule.Prelude.I
                                                                    (Curry.DebugModule.Prelude.I
                                                                       (Curry.DebugModule.Prelude.I
                                                                          (Curry.DebugModule.Prelude.I
                                                                             Curry.DebugModule.Prelude.IHi))))))))
                                            DM.funcCallHook ">"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x21, DI.genTerm x22]))
                                              (Curry.DebugModule.Prelude.op_Gt x21 x22)
                                  DM.funcCallHook "_case_112"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x23, DI.genTerm x24, DI.genTerm x25]))
                                    (strict__case_112 x23 x24 x25)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x26])))
                           (strict__case_113 x2 x3)
                           x26)))
term_strict__case_113 x1
  = DI.Term "_case_113" (DI.SrcID "XML" 0) x1
strict__case_112 x2 x3 x4
  = DM.eval
      (DM.funcDeclHook "_case_112"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x2, DI.genTerm x3, DI.genTerm x4]))
         (do x23 <- Prelude.return x4
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x23]))
               (case x23 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x18 <- do x7 <- DM.litHook
                                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                                       (DI.DynamicInfo [] []))
                                                    (Prelude.return
                                                       (Curry.DebugModule.Prelude.Char '&'))
                                            x8 <- do x5 <- DM.litHook
                                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                (DI.DynamicInfo [] []))
                                                             (Prelude.return
                                                                (Curry.DebugModule.Prelude.Char
                                                                   '#'))
                                                     x6 <- DM.constructorHook
                                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                (DI.DynamicInfo [] []))
                                                             (Prelude.return
                                                                Curry.DebugModule.Prelude.Nil)
                                                     DM.constructorHook
                                                       (DI.DebugInfo (DI.SrcID "XML" 0)
                                                          (DI.DynamicInfo []
                                                             [DI.genTerm x5, DI.genTerm x6]))
                                                       (Prelude.return
                                                          (Curry.DebugModule.Prelude.Cons x5 x6))
                                            DM.constructorHook
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo [] [DI.genTerm x7, DI.genTerm x8]))
                                              (Prelude.return
                                                 (Curry.DebugModule.Prelude.Cons x7 x8))
                                  x19 <- do x16 <- do x10 <- do x9 <- Prelude.return x2
                                                                DM.funcCallHook "ord"
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x9]))
                                                                  (Curry.DebugModule.Prelude.strict_ord
                                                                     x9)
                                                      DM.funcCallHook "show"
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo [] [DI.genTerm x10]))
                                                        (Curry.DebugModule.Prelude.strict_show x10)
                                            x17 <- do x14 <- do x11 <- DM.litHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo [] []))
                                                                         (Prelude.return
                                                                            (Curry.DebugModule.Prelude.Char
                                                                               ';'))
                                                                x12 <- DM.constructorHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo [] []))
                                                                         (Prelude.return
                                                                            Curry.DebugModule.Prelude.Nil)
                                                                DM.constructorHook
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x11,
                                                                         DI.genTerm x12]))
                                                                  (Prelude.return
                                                                     (Curry.DebugModule.Prelude.Cons
                                                                        x11
                                                                        x12))
                                                      x15 <- do x13 <- Prelude.return x3
                                                                DM.funcCallHook "standardEncoding"
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x13]))
                                                                  (strict_standardEncoding x13)
                                                      DM.funcCallHook "++"
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x14, DI.genTerm x15]))
                                                        (Curry.DebugModule.Prelude.op_PlusPlus x14
                                                           x15)
                                            DM.funcCallHook "++"
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x16, DI.genTerm x17]))
                                              (Curry.DebugModule.Prelude.op_PlusPlus x16 x17)
                                  DM.funcCallHook "++"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x18, DI.genTerm x19]))
                                    (Curry.DebugModule.Prelude.op_PlusPlus x18 x19)))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x20 <- Prelude.return x2
                                  x21 <- Prelude.return x3
                                  x22 <- DM.funcCallHook "otherwise"
                                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                           Curry.DebugModule.Prelude.strict_otherwise
                                  DM.funcCallHook "_case_111"
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo []
                                          [DI.genTerm x20, DI.genTerm x21, DI.genTerm x22]))
                                    (strict__case_111 x20 x21 x22)))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x23])))
                           (strict__case_112 x2 x3)
                           x23)))
term_strict__case_112 x1
  = DI.Term "_case_112" (DI.SrcID "XML" 0) x1
strict__case_111 x2 x3 x4
  = DM.eval
      (DM.funcDeclHook "_case_111"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x2, DI.genTerm x3, DI.genTerm x4]))
         (do x8 <- Prelude.return x4
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" 0)
                  (DI.DynamicInfo [] [DI.genTerm x8]))
               (case x8 of
                    Curry.DebugModule.Prelude.True
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x6 <- Prelude.return x2
                                  x7 <- do x5 <- Prelude.return x3
                                           DM.funcCallHook "standardEncoding"
                                             (DI.DebugInfo (DI.SrcID "XML" 0)
                                                (DI.DynamicInfo [] [DI.genTerm x5]))
                                             (strict_standardEncoding x5)
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x6, DI.genTerm x7]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Cons x6 x7))))
                    Curry.DebugModule.Prelude.False
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.funcCallHook "failed"
                                 (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                 Curry.DebugModule.Prelude.strict_failed))
                    _
                      -> DM.treatCase
                           (DM.nepCaseHook
                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                 (DI.DynamicInfo [] [DI.genTerm x8])))
                           (strict__case_111 x2 x3)
                           x8)))
term_strict__case_111 x1
  = DI.Term "_case_111" (DI.SrcID "XML" 0) x1
strict__case_120 x1
  = DM.eval
      (DM.funcDeclHook "_case_120"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x2 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x2]))
               (case x2 of
                    StandardEnc
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (Prelude.return
                                 (PC.partCall1 (term_strict_standardEncoding [])
                                    strict_standardEncoding)))
                    Iso88591Enc
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (Prelude.return
                                 (PC.partCall1 (term_strict_iso88591Encoding [])
                                    strict_iso88591Encoding)))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x2])))
                           strict__case_120
                           x2)))
term_strict__case_120 x1
  = DI.Term "_case_120" (DI.SrcID "XML" 0) x1
strict__case_121 x1
  = DM.eval
      (DM.funcDeclHook "_case_121"
         (DI.DebugInfo (DI.SrcID "XML" 0)
            (DI.DynamicInfo [] [DI.genTerm x1]))
         (do x46 <- Prelude.return x1
             DM.caseHook
               (DI.DebugInfo (DI.SrcID "XML" (- 1))
                  (DI.DynamicInfo [] [DI.genTerm x46]))
               (case x46 of
                    StandardEnc
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (DM.constructorHook
                                 (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                 (Prelude.return Curry.DebugModule.Prelude.Nil)))
                    Iso88591Enc
                      -> DM.branchHook
                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                           (DM.eval
                              (do x44 <- DM.litHook
                                           (DI.DebugInfo (DI.SrcID "XML" 0) (DI.DynamicInfo [] []))
                                           (Prelude.return (Curry.DebugModule.Prelude.Char 'e'))
                                  x45 <- do x42 <- DM.litHook
                                                     (DI.DebugInfo (DI.SrcID "XML" 0)
                                                        (DI.DynamicInfo [] []))
                                                     (Prelude.return
                                                        (Curry.DebugModule.Prelude.Char 'n'))
                                            x43 <- do x40 <- DM.litHook
                                                               (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                  (DI.DynamicInfo [] []))
                                                               (Prelude.return
                                                                  (Curry.DebugModule.Prelude.Char
                                                                     'c'))
                                                      x41 <- do x38 <- DM.litHook
                                                                         (DI.DebugInfo
                                                                            (DI.SrcID "XML" 0)
                                                                            (DI.DynamicInfo [] []))
                                                                         (Prelude.return
                                                                            (Curry.DebugModule.Prelude.Char
                                                                               'o'))
                                                                x39 <- do x36 <- DM.litHook
                                                                                   (DI.DebugInfo
                                                                                      (DI.SrcID
                                                                                         "XML"
                                                                                         0)
                                                                                      (DI.DynamicInfo
                                                                                         []
                                                                                         []))
                                                                                   (Prelude.return
                                                                                      (Curry.DebugModule.Prelude.Char
                                                                                         'd'))
                                                                          x37 <- do x34 <- DM.litHook
                                                                                             (DI.DebugInfo
                                                                                                (DI.SrcID
                                                                                                   "XML"
                                                                                                   0)
                                                                                                (DI.DynamicInfo
                                                                                                   []
                                                                                                   []))
                                                                                             (Prelude.return
                                                                                                (Curry.DebugModule.Prelude.Char
                                                                                                   'i'))
                                                                                    x35 <- do x32 <- DM.litHook
                                                                                                       (DI.DebugInfo
                                                                                                          (DI.SrcID
                                                                                                             "XML"
                                                                                                             0)
                                                                                                          (DI.DynamicInfo
                                                                                                             []
                                                                                                             []))
                                                                                                       (Prelude.return
                                                                                                          (Curry.DebugModule.Prelude.Char
                                                                                                             'n'))
                                                                                              x33 <- do x30 <- DM.litHook
                                                                                                                 (DI.DebugInfo
                                                                                                                    (DI.SrcID
                                                                                                                       "XML"
                                                                                                                       0)
                                                                                                                    (DI.DynamicInfo
                                                                                                                       []
                                                                                                                       []))
                                                                                                                 (Prelude.return
                                                                                                                    (Curry.DebugModule.Prelude.Char
                                                                                                                       'g'))
                                                                                                        x31 <- do x28 <- DM.litHook
                                                                                                                           (DI.DebugInfo
                                                                                                                              (DI.SrcID
                                                                                                                                 "XML"
                                                                                                                                 0)
                                                                                                                              (DI.DynamicInfo
                                                                                                                                 []
                                                                                                                                 []))
                                                                                                                           (Prelude.return
                                                                                                                              (Curry.DebugModule.Prelude.Char
                                                                                                                                 '='))
                                                                                                                  x29 <- do x26 <- DM.litHook
                                                                                                                                     (DI.DebugInfo
                                                                                                                                        (DI.SrcID
                                                                                                                                           "XML"
                                                                                                                                           0)
                                                                                                                                        (DI.DynamicInfo
                                                                                                                                           []
                                                                                                                                           []))
                                                                                                                                     (Prelude.return
                                                                                                                                        (Curry.DebugModule.Prelude.Char
                                                                                                                                           '"'))
                                                                                                                            x27 <- do x24 <- DM.litHook
                                                                                                                                               (DI.DebugInfo
                                                                                                                                                  (DI.SrcID
                                                                                                                                                     "XML"
                                                                                                                                                     0)
                                                                                                                                                  (DI.DynamicInfo
                                                                                                                                                     []
                                                                                                                                                     []))
                                                                                                                                               (Prelude.return
                                                                                                                                                  (Curry.DebugModule.Prelude.Char
                                                                                                                                                     'i'))
                                                                                                                                      x25 <- do x22 <- DM.litHook
                                                                                                                                                         (DI.DebugInfo
                                                                                                                                                            (DI.SrcID
                                                                                                                                                               "XML"
                                                                                                                                                               0)
                                                                                                                                                            (DI.DynamicInfo
                                                                                                                                                               []
                                                                                                                                                               []))
                                                                                                                                                         (Prelude.return
                                                                                                                                                            (Curry.DebugModule.Prelude.Char
                                                                                                                                                               's'))
                                                                                                                                                x23 <- do x20 <- DM.litHook
                                                                                                                                                                   (DI.DebugInfo
                                                                                                                                                                      (DI.SrcID
                                                                                                                                                                         "XML"
                                                                                                                                                                         0)
                                                                                                                                                                      (DI.DynamicInfo
                                                                                                                                                                         []
                                                                                                                                                                         []))
                                                                                                                                                                   (Prelude.return
                                                                                                                                                                      (Curry.DebugModule.Prelude.Char
                                                                                                                                                                         'o'))
                                                                                                                                                          x21 <- do x18 <- DM.litHook
                                                                                                                                                                             (DI.DebugInfo
                                                                                                                                                                                (DI.SrcID
                                                                                                                                                                                   "XML"
                                                                                                                                                                                   0)
                                                                                                                                                                                (DI.DynamicInfo
                                                                                                                                                                                   []
                                                                                                                                                                                   []))
                                                                                                                                                                             (Prelude.return
                                                                                                                                                                                (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                   '-'))
                                                                                                                                                                    x19 <- do x16 <- DM.litHook
                                                                                                                                                                                       (DI.DebugInfo
                                                                                                                                                                                          (DI.SrcID
                                                                                                                                                                                             "XML"
                                                                                                                                                                                             0)
                                                                                                                                                                                          (DI.DynamicInfo
                                                                                                                                                                                             []
                                                                                                                                                                                             []))
                                                                                                                                                                                       (Prelude.return
                                                                                                                                                                                          (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                             '8'))
                                                                                                                                                                              x17 <- do x14 <- DM.litHook
                                                                                                                                                                                                 (DI.DebugInfo
                                                                                                                                                                                                    (DI.SrcID
                                                                                                                                                                                                       "XML"
                                                                                                                                                                                                       0)
                                                                                                                                                                                                    (DI.DynamicInfo
                                                                                                                                                                                                       []
                                                                                                                                                                                                       []))
                                                                                                                                                                                                 (Prelude.return
                                                                                                                                                                                                    (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                       '8'))
                                                                                                                                                                                        x15 <- do x12 <- DM.litHook
                                                                                                                                                                                                           (DI.DebugInfo
                                                                                                                                                                                                              (DI.SrcID
                                                                                                                                                                                                                 "XML"
                                                                                                                                                                                                                 0)
                                                                                                                                                                                                              (DI.DynamicInfo
                                                                                                                                                                                                                 []
                                                                                                                                                                                                                 []))
                                                                                                                                                                                                           (Prelude.return
                                                                                                                                                                                                              (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                 '5'))
                                                                                                                                                                                                  x13 <- do x10 <- DM.litHook
                                                                                                                                                                                                                     (DI.DebugInfo
                                                                                                                                                                                                                        (DI.SrcID
                                                                                                                                                                                                                           "XML"
                                                                                                                                                                                                                           0)
                                                                                                                                                                                                                        (DI.DynamicInfo
                                                                                                                                                                                                                           []
                                                                                                                                                                                                                           []))
                                                                                                                                                                                                                     (Prelude.return
                                                                                                                                                                                                                        (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                           '9'))
                                                                                                                                                                                                            x11 <- do x8 <- DM.litHook
                                                                                                                                                                                                                              (DI.DebugInfo
                                                                                                                                                                                                                                 (DI.SrcID
                                                                                                                                                                                                                                    "XML"
                                                                                                                                                                                                                                    0)
                                                                                                                                                                                                                                 (DI.DynamicInfo
                                                                                                                                                                                                                                    []
                                                                                                                                                                                                                                    []))
                                                                                                                                                                                                                              (Prelude.return
                                                                                                                                                                                                                                 (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                    '-'))
                                                                                                                                                                                                                      x9 <- do x6 <- DM.litHook
                                                                                                                                                                                                                                       (DI.DebugInfo
                                                                                                                                                                                                                                          (DI.SrcID
                                                                                                                                                                                                                                             "XML"
                                                                                                                                                                                                                                             0)
                                                                                                                                                                                                                                          (DI.DynamicInfo
                                                                                                                                                                                                                                             []
                                                                                                                                                                                                                                             []))
                                                                                                                                                                                                                                       (Prelude.return
                                                                                                                                                                                                                                          (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                             '1'))
                                                                                                                                                                                                                               x7 <- do x4 <- DM.litHook
                                                                                                                                                                                                                                                (DI.DebugInfo
                                                                                                                                                                                                                                                   (DI.SrcID
                                                                                                                                                                                                                                                      "XML"
                                                                                                                                                                                                                                                      0)
                                                                                                                                                                                                                                                   (DI.DynamicInfo
                                                                                                                                                                                                                                                      []
                                                                                                                                                                                                                                                      []))
                                                                                                                                                                                                                                                (Prelude.return
                                                                                                                                                                                                                                                   (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                                      '"'))
                                                                                                                                                                                                                                        x5 <- do x2 <- DM.litHook
                                                                                                                                                                                                                                                         (DI.DebugInfo
                                                                                                                                                                                                                                                            (DI.SrcID
                                                                                                                                                                                                                                                               "XML"
                                                                                                                                                                                                                                                               0)
                                                                                                                                                                                                                                                            (DI.DynamicInfo
                                                                                                                                                                                                                                                               []
                                                                                                                                                                                                                                                               []))
                                                                                                                                                                                                                                                         (Prelude.return
                                                                                                                                                                                                                                                            (Curry.DebugModule.Prelude.Char
                                                                                                                                                                                                                                                               ' '))
                                                                                                                                                                                                                                                 x3 <- DM.constructorHook
                                                                                                                                                                                                                                                         (DI.DebugInfo
                                                                                                                                                                                                                                                            (DI.SrcID
                                                                                                                                                                                                                                                               "XML"
                                                                                                                                                                                                                                                               0)
                                                                                                                                                                                                                                                            (DI.DynamicInfo
                                                                                                                                                                                                                                                               []
                                                                                                                                                                                                                                                               []))
                                                                                                                                                                                                                                                         (Prelude.return
                                                                                                                                                                                                                                                            Curry.DebugModule.Prelude.Nil)
                                                                                                                                                                                                                                                 DM.constructorHook
                                                                                                                                                                                                                                                   (DI.DebugInfo
                                                                                                                                                                                                                                                      (DI.SrcID
                                                                                                                                                                                                                                                         "XML"
                                                                                                                                                                                                                                                         0)
                                                                                                                                                                                                                                                      (DI.DynamicInfo
                                                                                                                                                                                                                                                         []
                                                                                                                                                                                                                                                         [DI.genTerm
                                                                                                                                                                                                                                                            x2,
                                                                                                                                                                                                                                                          DI.genTerm
                                                                                                                                                                                                                                                            x3]))
                                                                                                                                                                                                                                                   (Prelude.return
                                                                                                                                                                                                                                                      (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                         x2
                                                                                                                                                                                                                                                         x3))
                                                                                                                                                                                                                                        DM.constructorHook
                                                                                                                                                                                                                                          (DI.DebugInfo
                                                                                                                                                                                                                                             (DI.SrcID
                                                                                                                                                                                                                                                "XML"
                                                                                                                                                                                                                                                0)
                                                                                                                                                                                                                                             (DI.DynamicInfo
                                                                                                                                                                                                                                                []
                                                                                                                                                                                                                                                [DI.genTerm
                                                                                                                                                                                                                                                   x4,
                                                                                                                                                                                                                                                 DI.genTerm
                                                                                                                                                                                                                                                   x5]))
                                                                                                                                                                                                                                          (Prelude.return
                                                                                                                                                                                                                                             (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                                x4
                                                                                                                                                                                                                                                x5))
                                                                                                                                                                                                                               DM.constructorHook
                                                                                                                                                                                                                                 (DI.DebugInfo
                                                                                                                                                                                                                                    (DI.SrcID
                                                                                                                                                                                                                                       "XML"
                                                                                                                                                                                                                                       0)
                                                                                                                                                                                                                                    (DI.DynamicInfo
                                                                                                                                                                                                                                       []
                                                                                                                                                                                                                                       [DI.genTerm
                                                                                                                                                                                                                                          x6,
                                                                                                                                                                                                                                        DI.genTerm
                                                                                                                                                                                                                                          x7]))
                                                                                                                                                                                                                                 (Prelude.return
                                                                                                                                                                                                                                    (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                                       x6
                                                                                                                                                                                                                                       x7))
                                                                                                                                                                                                                      DM.constructorHook
                                                                                                                                                                                                                        (DI.DebugInfo
                                                                                                                                                                                                                           (DI.SrcID
                                                                                                                                                                                                                              "XML"
                                                                                                                                                                                                                              0)
                                                                                                                                                                                                                           (DI.DynamicInfo
                                                                                                                                                                                                                              []
                                                                                                                                                                                                                              [DI.genTerm
                                                                                                                                                                                                                                 x8,
                                                                                                                                                                                                                               DI.genTerm
                                                                                                                                                                                                                                 x9]))
                                                                                                                                                                                                                        (Prelude.return
                                                                                                                                                                                                                           (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                              x8
                                                                                                                                                                                                                              x9))
                                                                                                                                                                                                            DM.constructorHook
                                                                                                                                                                                                              (DI.DebugInfo
                                                                                                                                                                                                                 (DI.SrcID
                                                                                                                                                                                                                    "XML"
                                                                                                                                                                                                                    0)
                                                                                                                                                                                                                 (DI.DynamicInfo
                                                                                                                                                                                                                    []
                                                                                                                                                                                                                    [DI.genTerm
                                                                                                                                                                                                                       x10,
                                                                                                                                                                                                                     DI.genTerm
                                                                                                                                                                                                                       x11]))
                                                                                                                                                                                                              (Prelude.return
                                                                                                                                                                                                                 (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                                    x10
                                                                                                                                                                                                                    x11))
                                                                                                                                                                                                  DM.constructorHook
                                                                                                                                                                                                    (DI.DebugInfo
                                                                                                                                                                                                       (DI.SrcID
                                                                                                                                                                                                          "XML"
                                                                                                                                                                                                          0)
                                                                                                                                                                                                       (DI.DynamicInfo
                                                                                                                                                                                                          []
                                                                                                                                                                                                          [DI.genTerm
                                                                                                                                                                                                             x12,
                                                                                                                                                                                                           DI.genTerm
                                                                                                                                                                                                             x13]))
                                                                                                                                                                                                    (Prelude.return
                                                                                                                                                                                                       (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                          x12
                                                                                                                                                                                                          x13))
                                                                                                                                                                                        DM.constructorHook
                                                                                                                                                                                          (DI.DebugInfo
                                                                                                                                                                                             (DI.SrcID
                                                                                                                                                                                                "XML"
                                                                                                                                                                                                0)
                                                                                                                                                                                             (DI.DynamicInfo
                                                                                                                                                                                                []
                                                                                                                                                                                                [DI.genTerm
                                                                                                                                                                                                   x14,
                                                                                                                                                                                                 DI.genTerm
                                                                                                                                                                                                   x15]))
                                                                                                                                                                                          (Prelude.return
                                                                                                                                                                                             (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                                x14
                                                                                                                                                                                                x15))
                                                                                                                                                                              DM.constructorHook
                                                                                                                                                                                (DI.DebugInfo
                                                                                                                                                                                   (DI.SrcID
                                                                                                                                                                                      "XML"
                                                                                                                                                                                      0)
                                                                                                                                                                                   (DI.DynamicInfo
                                                                                                                                                                                      []
                                                                                                                                                                                      [DI.genTerm
                                                                                                                                                                                         x16,
                                                                                                                                                                                       DI.genTerm
                                                                                                                                                                                         x17]))
                                                                                                                                                                                (Prelude.return
                                                                                                                                                                                   (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                                      x16
                                                                                                                                                                                      x17))
                                                                                                                                                                    DM.constructorHook
                                                                                                                                                                      (DI.DebugInfo
                                                                                                                                                                         (DI.SrcID
                                                                                                                                                                            "XML"
                                                                                                                                                                            0)
                                                                                                                                                                         (DI.DynamicInfo
                                                                                                                                                                            []
                                                                                                                                                                            [DI.genTerm
                                                                                                                                                                               x18,
                                                                                                                                                                             DI.genTerm
                                                                                                                                                                               x19]))
                                                                                                                                                                      (Prelude.return
                                                                                                                                                                         (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                            x18
                                                                                                                                                                            x19))
                                                                                                                                                          DM.constructorHook
                                                                                                                                                            (DI.DebugInfo
                                                                                                                                                               (DI.SrcID
                                                                                                                                                                  "XML"
                                                                                                                                                                  0)
                                                                                                                                                               (DI.DynamicInfo
                                                                                                                                                                  []
                                                                                                                                                                  [DI.genTerm
                                                                                                                                                                     x20,
                                                                                                                                                                   DI.genTerm
                                                                                                                                                                     x21]))
                                                                                                                                                            (Prelude.return
                                                                                                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                                                                                                  x20
                                                                                                                                                                  x21))
                                                                                                                                                DM.constructorHook
                                                                                                                                                  (DI.DebugInfo
                                                                                                                                                     (DI.SrcID
                                                                                                                                                        "XML"
                                                                                                                                                        0)
                                                                                                                                                     (DI.DynamicInfo
                                                                                                                                                        []
                                                                                                                                                        [DI.genTerm
                                                                                                                                                           x22,
                                                                                                                                                         DI.genTerm
                                                                                                                                                           x23]))
                                                                                                                                                  (Prelude.return
                                                                                                                                                     (Curry.DebugModule.Prelude.Cons
                                                                                                                                                        x22
                                                                                                                                                        x23))
                                                                                                                                      DM.constructorHook
                                                                                                                                        (DI.DebugInfo
                                                                                                                                           (DI.SrcID
                                                                                                                                              "XML"
                                                                                                                                              0)
                                                                                                                                           (DI.DynamicInfo
                                                                                                                                              []
                                                                                                                                              [DI.genTerm
                                                                                                                                                 x24,
                                                                                                                                               DI.genTerm
                                                                                                                                                 x25]))
                                                                                                                                        (Prelude.return
                                                                                                                                           (Curry.DebugModule.Prelude.Cons
                                                                                                                                              x24
                                                                                                                                              x25))
                                                                                                                            DM.constructorHook
                                                                                                                              (DI.DebugInfo
                                                                                                                                 (DI.SrcID
                                                                                                                                    "XML"
                                                                                                                                    0)
                                                                                                                                 (DI.DynamicInfo
                                                                                                                                    []
                                                                                                                                    [DI.genTerm
                                                                                                                                       x26,
                                                                                                                                     DI.genTerm
                                                                                                                                       x27]))
                                                                                                                              (Prelude.return
                                                                                                                                 (Curry.DebugModule.Prelude.Cons
                                                                                                                                    x26
                                                                                                                                    x27))
                                                                                                                  DM.constructorHook
                                                                                                                    (DI.DebugInfo
                                                                                                                       (DI.SrcID
                                                                                                                          "XML"
                                                                                                                          0)
                                                                                                                       (DI.DynamicInfo
                                                                                                                          []
                                                                                                                          [DI.genTerm
                                                                                                                             x28,
                                                                                                                           DI.genTerm
                                                                                                                             x29]))
                                                                                                                    (Prelude.return
                                                                                                                       (Curry.DebugModule.Prelude.Cons
                                                                                                                          x28
                                                                                                                          x29))
                                                                                                        DM.constructorHook
                                                                                                          (DI.DebugInfo
                                                                                                             (DI.SrcID
                                                                                                                "XML"
                                                                                                                0)
                                                                                                             (DI.DynamicInfo
                                                                                                                []
                                                                                                                [DI.genTerm
                                                                                                                   x30,
                                                                                                                 DI.genTerm
                                                                                                                   x31]))
                                                                                                          (Prelude.return
                                                                                                             (Curry.DebugModule.Prelude.Cons
                                                                                                                x30
                                                                                                                x31))
                                                                                              DM.constructorHook
                                                                                                (DI.DebugInfo
                                                                                                   (DI.SrcID
                                                                                                      "XML"
                                                                                                      0)
                                                                                                   (DI.DynamicInfo
                                                                                                      []
                                                                                                      [DI.genTerm
                                                                                                         x32,
                                                                                                       DI.genTerm
                                                                                                         x33]))
                                                                                                (Prelude.return
                                                                                                   (Curry.DebugModule.Prelude.Cons
                                                                                                      x32
                                                                                                      x33))
                                                                                    DM.constructorHook
                                                                                      (DI.DebugInfo
                                                                                         (DI.SrcID
                                                                                            "XML"
                                                                                            0)
                                                                                         (DI.DynamicInfo
                                                                                            []
                                                                                            [DI.genTerm
                                                                                               x34,
                                                                                             DI.genTerm
                                                                                               x35]))
                                                                                      (Prelude.return
                                                                                         (Curry.DebugModule.Prelude.Cons
                                                                                            x34
                                                                                            x35))
                                                                          DM.constructorHook
                                                                            (DI.DebugInfo
                                                                               (DI.SrcID "XML" 0)
                                                                               (DI.DynamicInfo []
                                                                                  [DI.genTerm x36,
                                                                                   DI.genTerm x37]))
                                                                            (Prelude.return
                                                                               (Curry.DebugModule.Prelude.Cons
                                                                                  x36
                                                                                  x37))
                                                                DM.constructorHook
                                                                  (DI.DebugInfo (DI.SrcID "XML" 0)
                                                                     (DI.DynamicInfo []
                                                                        [DI.genTerm x38,
                                                                         DI.genTerm x39]))
                                                                  (Prelude.return
                                                                     (Curry.DebugModule.Prelude.Cons
                                                                        x38
                                                                        x39))
                                                      DM.constructorHook
                                                        (DI.DebugInfo (DI.SrcID "XML" 0)
                                                           (DI.DynamicInfo []
                                                              [DI.genTerm x40, DI.genTerm x41]))
                                                        (Prelude.return
                                                           (Curry.DebugModule.Prelude.Cons x40 x41))
                                            DM.constructorHook
                                              (DI.DebugInfo (DI.SrcID "XML" 0)
                                                 (DI.DynamicInfo []
                                                    [DI.genTerm x42, DI.genTerm x43]))
                                              (Prelude.return
                                                 (Curry.DebugModule.Prelude.Cons x42 x43))
                                  DM.constructorHook
                                    (DI.DebugInfo (DI.SrcID "XML" 0)
                                       (DI.DynamicInfo [] [DI.genTerm x44, DI.genTerm x45]))
                                    (Prelude.return (Curry.DebugModule.Prelude.Cons x44 x45))))
                    _
                      -> DM.treatCase
                           (DM.nepRulesHook
                              (DI.DebugInfo (DI.SrcID "XML" (- 1))
                                 (DI.DynamicInfo [] [DI.genTerm x46])))
                           strict__case_121
                           x46)))
term_strict__case_121 x1
  = DI.Term "_case_121" (DI.SrcID "XML" 0) x1
term_XText x1 = DI.Term "XText" (DI.SrcID "XML" 0) x1
term_XElem x1 = DI.Term "XElem" (DI.SrcID "XML" 0) x1
term_Enc x1 = DI.Term "Enc" (DI.SrcID "XML" 0) x1
term_DtdUrl x1 = DI.Term "DtdUrl" (DI.SrcID "XML" 0) x1